
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
int testFileModifTime(int ii) {
        struct stat fst;
        int res;
        time_t t0;
        { if (!(s_fileTab.tab[ii] != NULL)) internalCheckFail("s_fileTab.tab[ii] != NULL", "caching.c", 26);};
        t0 = time(NULL);
        if (s_fileTab.tab[ii]->lastInspect >= s_fileProcessStartTime
                && s_fileTab.tab[ii]->lastInspect <= t0) {
                res = 1;
                goto fini;
        }
        if (statb(s_fileTab.tab[ii]->name, &fst)) {
                res = 0;
                goto fini;
        }
        s_fileTab.tab[ii]->lastInspect = t0;
        if (fst.st_mtime == s_fileTab.tab[ii]->lastModif) {
                res = 1;
        } else {
                s_fileTab.tab[ii]->lastModif = fst.st_mtime;
                res = 0;
        }
fini:
        return(res);
}
static void deleteReferencesOutOfMemory(S_reference **rr) {
        while (*rr!=NULL) {
                if (( ((char*)*rr) >= ((char*)&cxMemory->b) + (cxMemory->i) && ((char*)*rr) < ((char*)&cxMemory->b) + (cxMemory->size) )) {
                        *rr = (*rr)->next;
                        continue;
                }
                rr= &(*rr)->next;
        }
}
static void cxrefTabDeleteOutOfMemory(int i) {
        S_symbolRefItem **pp;
        pp = &s_cxrefTab.tab[i];
        while (*pp!=NULL) {
                if (( ((char*)*pp) >= ((char*)&cxMemory->b) + (cxMemory->i) && ((char*)*pp) < ((char*)&cxMemory->b) + (cxMemory->size) )) {
                        *pp = (*pp)->next;
                        continue;
                } else {
                        deleteReferencesOutOfMemory(&(*pp)->refs);
                }
                pp= &(*pp)->next;
        }
}
static void fileTabDeleteOutOfMemory(S_fileItem *p, int i) {
        S_chReference **hh;
        hh = &p->sups;
        while (*hh!=NULL) {
                if (( ((char*)*hh) >= ((char*)&cxMemory->b) + (cxMemory->i) && ((char*)*hh) < ((char*)&cxMemory->b) + (cxMemory->size) )) {
            *hh = (*hh)->next;
            goto contlabel;
                }
                hh= &(*hh)->next;
        contlabel:;
        }
        hh = &p->infs;
        while (*hh!=NULL) {
                if (( ((char*)*hh) >= ((char*)&cxMemory->b) + (cxMemory->i) && ((char*)*hh) < ((char*)&cxMemory->b) + (cxMemory->size) )) {
            *hh = (*hh)->next;
            goto contlabel2;
                }
                hh= &(*hh)->next;
        contlabel2:;
        }
}
static void structCachingFree(S_symbol *pp) {
        S_symbolList **tp;
        { if (!(pp->u.s)) internalCheckFail("pp->u.s", "caching.c", 114);};
        if (( ((char*)pp->u.s->records) >= memory+s_topBlock->firstFreeIndex && ((char*)pp->u.s->records) < memory+SIZE_workMemory) ||
                ( ((char*)pp->u.s->records) >= ppmMemory + ppmMemoryi && ((char*)pp->u.s->records) < ppmMemory + SIZE_ppmMemory )) {
                pp->u.s->records = NULL;
        }
        if (( ((char*)pp->u.s->casts.node) >= memory+s_topBlock->firstFreeIndex && ((char*)pp->u.s->casts.node) < memory+SIZE_workMemory) ||
                ( ((char*)pp->u.s->casts.node) >= ppmMemory + ppmMemoryi && ((char*)pp->u.s->casts.node) < ppmMemory + SIZE_ppmMemory )) {
                pp->u.s->casts.node = NULL;
        }
        if (( ((char*)pp->u.s->casts.sub) >= memory+s_topBlock->firstFreeIndex && ((char*)pp->u.s->casts.sub) < memory+SIZE_workMemory) ||
                ( ((char*)pp->u.s->casts.sub) >= ppmMemory + ppmMemoryi && ((char*)pp->u.s->casts.sub) < ppmMemory + SIZE_ppmMemory )) {
                pp->u.s->casts.sub = NULL;
        }
        tp = &pp->u.s->super;
        while (*tp!=NULL) {
                if (( ((char*)*tp) >= memory+s_topBlock->firstFreeIndex && ((char*)*tp) < memory+SIZE_workMemory) ||
                        ( ((char*)*tp) >= ppmMemory + ppmMemoryi && ((char*)*tp) < ppmMemory + SIZE_ppmMemory )) {
                        *tp = (*tp)->next;
            goto contlabel;
                }
                tp = &(*tp)->next;
        contlabel:;
        }
}
static void symTabDeleteOutOfMemory(int i) {
        S_symbol **pp;
        pp = &s_symTab->tab[i];
        while (*pp!=NULL) {
                switch ((*pp)->b.symType) {
                case TypeMacro:
                        if (( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                        }
                        break;
                case TypeStruct: case TypeUnion:
                        if (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory) || ( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                        } else {
                                structCachingFree(*pp);
                        }
                        break;
                case TypeEnum:
                        if (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory)) {
                                *pp = (*pp)->next; continue;
                        } else if (( ((char*)(*pp)->u.enums) >= memory+s_topBlock->firstFreeIndex && ((char*)(*pp)->u.enums) < memory+SIZE_workMemory)) {
                                (*pp)->u.enums = NULL;
                        }
                        break;
                default:
                        if (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory)) {
                                *pp = (*pp)->next; continue;
                        }
                        break;
                }
                pp= &(*pp)->next;
        }
}
static void javaFqtTabDeleteOutOfMemory(int i) {
        S_symbolList **pp;
        pp = &s_javaFqtTab.tab[i];
        while (*pp!=NULL) {
                if (( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                } else if (( ((char*)(*pp)->d) >= memory+s_topBlock->firstFreeIndex && ((char*)(*pp)->d) < memory+SIZE_workMemory)
                                        || ( ((char*)(*pp)->d) >= ppmMemory + ppmMemoryi && ((char*)(*pp)->d) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                } else {
                        structCachingFree((*pp)->d);
                }
                pp= &(*pp)->next;
        }
}
static void trailDeleteOutOfMemory() {
        S_freeTrail **pp;
        pp = & s_topBlock->trail;
        while (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory)) {
                *pp = (*pp)->next;
        }
}
static void includeListDeleteOutOfMemory() {
        S_stringList **pp;
        pp = & s_opt.includeDirs;
        while (*pp!=NULL) {
                if (( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                        *pp = (*pp)->next; continue;
                }
                pp= &(*pp)->next;
        }
}
static int cachedIncludedFilePass(int cpi) {
        int i,mi,mt;
        { if (!(cpi > 0)) internalCheckFail("cpi > 0", "caching.c", 216);};
        mi = s_cache.cp[cpi].ibi;
        for(i=s_cache.cp[cpi-1].ibi; i<mi; i++) {
                mt = testFileModifTime(s_cache.ib[i]);
                if (mt == 0) return(0);
        }
        return(1);
}
void recoverCxMemory(char *cxMemFreeBase) {
        {{ { if (!((cxMemFreeBase)>= ((char*)&cxMemory->b) && (cxMemFreeBase)<= ((char*)&cxMemory->b)+cxMemory->i)) internalCheckFail("(cxMemFreeBase)>= ((char*)&cxMemory->b) && (cxMemFreeBase)<= ((char*)&cxMemory->b)+cxMemory->i", "caching.c", 230);}; cxMemory->i = ((char*)(cxMemFreeBase)) - ((char*)&cxMemory->b);};};
        idTabMap3(&s_fileTab, fileTabDeleteOutOfMemory);
        refTabMap3(&s_cxrefTab, cxrefTabDeleteOutOfMemory);
}
void recoverCachePointZero() {
                ppmMemoryi = s_cache.cp[0].ppmMemoryi;
        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
}
void recoverMemoriesAfterOverflow(char *cxMemFreeBase) {
        recoverCxMemory(cxMemFreeBase);
        initAllInputs();
        recoverCachePointZero();
}
void recoverCachePoint(int i, char *readedUntil, int activeCaching) {
        S_cachePoint *cp;
        cp = &s_cache.cp[i];
        if (! ( 1 && ((s_language & (4)) != 0) && (s_opt.taskRegime == RegimeXref || s_opt.taskRegime == RegimeHtmlGenerate) && ppmMemoryi < (SIZE_ppmMemory/3)*2)) {
                ppmMemoryi = cp->ppmMemoryi;
        }
        mbMemoryi = cp->mbMemoryi;
        s_topBlock = cp->topBlock;
        tmpWorkMemoryi = 0;
        *s_topBlock = cp->starTopBlock;
        s_javaStat = cp->javaCached;
        s_count = cp->counts;
        trailDeleteOutOfMemory();
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "caching.c", 273);};
        if (s_opt.taskRegime==RegimeEditServer && s_currCppPass==1) {
                cxMemory->i = cp->cxMemoryi;
                refTabMap3(&s_cxrefTab, cxrefTabDeleteOutOfMemory);
                idTabMap3(&s_fileTab, fileTabDeleteOutOfMemory);
        }
        symTabMap3(s_symTab, symTabDeleteOutOfMemory);
        javaFqtTabMap3(&s_javaFqtTab, javaFqtTabDeleteOutOfMemory);
        includeListDeleteOutOfMemory();
        cFile.lineNumber = cp->lineNumber;
        cFile.ifDeep = cp->ifDeep;
        cFile.ifstack = cp->ifstack;
        { (&cInput)->cc = cp->lbcc; (&cInput)->fin = readedUntil; (&cInput)->a = s_cache.lb; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_CACHE;};
        { (&s_cache)->activeCache = activeCaching; (&s_cache)->cpi = i+1; (&s_cache)->ibi = cp->ibi; (&s_cache)->lbcc = cp->lbcc; (&s_cache)->lexcc = cInput.cc; (&s_cache)->cc = cInput.cc; (&s_cache)->cfin = cInput.fin;};
}
void recoverFromCache() {
        int i;
        char *readedUntil;
        { if (!(s_cache.cpi >= 1)) internalCheckFail("s_cache.cpi >= 1", "caching.c", 313);};
        s_cache.activeCache = 0;
        { if (s_opt.debug) {fprintf(dumpOut,": reading from cache\n");fflush(dumpOut);}};
        readedUntil = s_cache.cp[0].lbcc;
        for(i=1; i<s_cache.cpi; i++) {
                if (cachedInputPass(i,&readedUntil) == 0) break;
                if (cachedIncludedFilePass(i) == 0) break;
        }
        { if (!(i > 1)) internalCheckFail("i > 1", "caching.c", 323);};
        { if (s_opt.debug) {fprintf(dumpOut,"recovering cache point %d\n",i-1);fflush(dumpOut);}};
        recoverCachePoint(i-1, readedUntil, 1);
}
void initCaching() {
        { (&s_cache)->activeCache = 1; (&s_cache)->cpi = 0; (&s_cache)->ibi = 0; (&s_cache)->lbcc = s_cache.lb; (&s_cache)->lexcc = cFile.lb.cc; (&s_cache)->cc = NULL; (&s_cache)->cfin = NULL;};
        poseCachePoint(0);
        s_cache.activeCache = 0;
}
void cacheInput() {
        int size;
        if (s_cache.activeCache == 0) return;
        if (inStacki != 0 || macStacki != 0) return;
        size = cInput.cc - s_cache.lexcc;
        if ( s_cache.lbcc - s_cache.lb + size >= LEX_BUF_CACHE_SIZE) {
                s_cache.activeCache = 0;
                return;
        }
        if (cInput.margExpFlag != II_CACHE) memcpy(s_cache.lbcc, s_cache.lexcc, size);
        s_cache.lbcc += size;
        s_cache.lexcc = cInput.cc;
}
void cacheInclude(int fileNum) {
        if (s_cache.activeCache == 0) return;
        testFileModifTime(fileNum);
        { if (!(s_cache.ibi < INCLUDE_CACHE_SIZE)) internalCheckFail("s_cache.ibi < INCLUDE_CACHE_SIZE", "caching.c", 362);};
        s_cache.ib[s_cache.ibi] = fileNum;
        s_cache.ibi ++;
        if (s_cache.ibi >= INCLUDE_CACHE_SIZE) s_cache.activeCache = 0;
}
void poseCachePoint(int inputCaching) {
        struct cachePoint *pp;
        if (s_cache.activeCache == 0) return;
        if (inStacki != 0 || macStacki != 0) return;
        if (s_cache.cpi >= MAX_CACHE_POINTS) {
                s_cache.activeCache = 0;
                return;
        }
        if (inputCaching) cacheInput();
        if (s_cache.activeCache == 0) return;
        if (tmpWorkMemoryi != 0) return;
        pp = &s_cache.cp[s_cache.cpi];
        { if (s_opt.debug) {fprintf(dumpOut,"posing cache point %d \n",s_cache.cpi);fflush(dumpOut);}};
        { (pp)->topBlock = s_topBlock; (pp)->starTopBlock = *s_topBlock; (pp)->ppmMemoryi = ppmMemoryi; (pp)->cxMemoryi = cxMemory->i; (pp)->mbMemoryi = mbMemoryi; (pp)->lbcc = s_cache.lbcc; (pp)->ibi = s_cache.ibi; (pp)->lineNumber = cFile.lineNumber; (pp)->ifDeep = cFile.ifDeep; (pp)->ifstack = cFile.ifstack; (pp)->javaCached = s_javaStat; (pp)->counts = s_count;};
        s_cache.cpi ++;
}
