
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
        S_extRecFindStr *erfs;
        S_bb_int bbinteger;
        S_bb_unsigned bbunsign;
        S_bb_symbol bbsymbol;
        S_bb_symbolList bbsymbolList;
        S_bb_typeModifiers bbtypeModif;
        S_bb_typeModifiersList bbtypeModifList;
        S_bb_freeTrail bbtrail;
        S_bb_idIdent bbidIdent;
        S_bb_idIdentList bbidlist;
        S_bb_exprTokenType bbexprType;
        S_bb_intPair bbintpair;
        S_bb_whileExtractData bbwhiledata;
        S_bb_position bbposition;
        S_bb_unsPositionPair bbunsPositionPair;
        S_bb_symbolPositionPair bbsymbolPositionPair;
        S_bb_symbolPositionLstPair bbsymbolPositionLstPair;
        S_bb_positionLst bbpositionLst;
        S_bb_typeModifiersListPositionLstPair bbtypeModifiersListPositionLstPair;
        S_bb_nestedConstrTokenType bbnestedConstrTokenType;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
static void initTokensFromTab(S_tokenNameIni *tokenTabIni) {
        char *nn;
        int tok, ii, i, tlan;
        S_symbol *pp;
        for(i=0; tokenTabIni[i].name!=NULL; i++) {
                nn = tokenTabIni[i].name;
                tok = tokenTabIni[i].token;
                tlan = tokenTabIni[i].languages;
                s_tokenName[tok] = nn;
                s_tokenLength[tok] = strlen(nn);
                if ((isalpha(*nn) || *nn=='_') && (tlan & s_language)) {
                        {pp = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
                        { (&pp->b)->record = 0; (&pp->b)->isSingleImported = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeKeyword; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
                        { (pp)->name = nn; (pp)->linkName = nn; (pp)->pos = s_noPos; (pp)->b = pp->b; (pp)->u.keyWordVal = tok; (pp)->next = NULL;};
                        pp->u.keyWordVal = tok;
                        symTabAdd(s_symTab,pp,&ii);
                }
        }
}
static char *autoDetectJavaVersion() {
        int i;
        char *res;
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                if (stringContainsSubstring(s_zipArchivTab[i].fn, "rt.jar")) {
                        if (stringContainsSubstring(s_zipArchivTab[i].fn, "1.4")) {
                                res = "1.4";
                                goto fini;
                        }
                }
        }
        res = "1.3";
 fini:
        return(res);
}
void initTokenNameTab() {
        char *nn,*jv;
        int tok,ii,i,tlan;
        S_symbol *pp;
        static int messageWritten=0;
        if (! s_opt.strictAnsi) {
                initTokensFromTab(s_tokenNameIniTab2);
        }
        jv = s_opt.javaVersion;
        if (strcmp(jv, "auto")==0) jv = autoDetectJavaVersion();
        if (s_opt.taskRegime!=RegimeEditServer
                && s_opt.taskRegime!=RegimeGenerate
                && messageWritten==0) {
                if (s_opt.xref2) {
                        sprintf(tmpBuff,"java version == %s", jv);
                        ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                } else {
                        fprintf(dumpOut,"java version == %s\n", jv);
                }
                messageWritten=1;
        }
        if (strcmp(jv, "1.4")==0) {
                initTokensFromTab(s_tokenNameIniTab3);
        }
        initTokensFromTab(s_tokenNameIniTab);
        {pp = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
        { (&pp->b)->record = 0; (&pp->b)->isSingleImported = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeDefinedOp; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
        { (pp)->name = "defined"; (pp)->linkName = "defined"; (pp)->pos = s_noPos; (pp)->b = pp->b; (pp)->u.type = NULL; (pp)->next = NULL;};
        symTabAdd(s_symTab,pp,&ii);
}
void initTypeModifiersTabs() {
        int i,t;
        for(i=0; i<MAX_TYPE; i++) {
                typeShortChange[i] = i;
                typeLongChange[i] = i;
                typeSignedChange[i] = i;
                typeUnsignedChange[i] = i;
        }
        for(i=0; s_typeModificationsInit[i].type >= 0; i++) {
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modShort; if (tmp>=0) typeShortChange[t] = tmp;};
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modLong; if (tmp>=0) typeLongChange[t] = tmp;};
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modSigned; if (tmp>=0) typeSignedChange[t] = tmp;};
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modUnsigned; if (tmp>=0) typeUnsignedChange[t] = tmp;};
        }
}
void initJavaTypePCTIConvertIniTab() {
        int i;
        S_javaTypePCTIConvertIni *s;
        for (i=0; s_javaTypePCTIConvertIniTab[i].symType != -1; i++) {
                s = &s_javaTypePCTIConvertIniTab[i];
                { if (!(s->symType >= 0 && s->symType < MAX_TYPE)) internalCheckFail("s->symType >= 0 && s->symType < MAX_TYPE", "init.c", 124);};
                s_javaTypePCTIConvert[s->symType] = s->PCTIndex;
        }
}
void initTypeCharCodeTab() {
        int i;
        S_typeCharCodeIni *s;
        for (i=0; s_baseTypeCharCodesIniTab[i].symType != -1; i++) {
                s = &s_baseTypeCharCodesIniTab[i];
                { if (!(s->symType >= 0 && s->symType < MAX_TYPE)) internalCheckFail("s->symType >= 0 && s->symType < MAX_TYPE", "init.c", 134);};
                s_javaBaseTypeCharCodes[s->symType] = s->code;
                { if (!(s->code >= 0 && s->code < 127)) internalCheckFail("s->code >= 0 && s->code < 127", "init.c", 136);};
                s_javaCharCodeBaseTypes[s->code] = s->symType;
        }
}
void initTypesNamesTab() {
        int i;
        S_intStringTab *s;
        for (i=0; s_typesNamesInitTab[i].i != -1; i++) {
                s = &s_typesNamesInitTab[i];
                { if (!(s->i >= 0 && s->i < MAX_TYPE)) internalCheckFail("s->i >= 0 && s->i < MAX_TYPE", "init.c", 146);};
                typesName[s->i] = s->s;
        }
}
void initExtractStoragesNameTab() {
        int i;
        S_intStringTab *s;
        for(i=0; i<MAX_STORAGE; i++) s_extractStorageName[i]="";
        for (i=0; s_extractStoragesNamesInitTab[i].i != -1; i++) {
                s = &s_extractStoragesNamesInitTab[i];
                { if (!(s->i >= 0 && s->i < MAX_TYPE)) internalCheckFail("s->i >= 0 && s->i < MAX_TYPE", "init.c", 157);};
                s_extractStorageName[s->i] = s->s;
        }
}
void initArchaicTypes() {
        { (&s_defaultIntModifier)->m = TypeInt; { (&((&(&s_defaultIntModifier)->u)->f))->args = NULL; (&((&(&s_defaultIntModifier)->u)->f))->thisFunList = NULL;}; (&s_defaultIntModifier)->typedefin = NULL; (&s_defaultIntModifier)->next = NULL;};
        { (&s_defaultIntDefinition.b)->record = 0; (&s_defaultIntDefinition.b)->isSingleImported = 0; (&s_defaultIntDefinition.b)->accessFlags = 0; (&s_defaultIntDefinition.b)->javaSourceLoaded = 0; (&s_defaultIntDefinition.b)->javaFileLoaded = 0; (&s_defaultIntDefinition.b)->symType = TypeDefault; (&s_defaultIntDefinition.b)->storage = StorageDefault; (&s_defaultIntDefinition.b)->npointers = 0;};
        { (&s_defaultIntDefinition)->name = NULL; (&s_defaultIntDefinition)->linkName = NULL; (&s_defaultIntDefinition)->pos = s_noPos; (&s_defaultIntDefinition)->b = s_defaultIntDefinition.b; (&s_defaultIntDefinition)->u.type = &s_defaultIntModifier; (&s_defaultIntDefinition)->next = NULL;};
        s_defaultIntDefinition.u.type = &s_defaultIntModifier;
        { (&s_defaultPackedTypeModifier)->m = TypePackedType; { (&((&(&s_defaultPackedTypeModifier)->u)->f))->args = NULL; (&((&(&s_defaultPackedTypeModifier)->u)->f))->thisFunList = NULL;}; (&s_defaultPackedTypeModifier)->typedefin = NULL; (&s_defaultPackedTypeModifier)->next = NULL;};
        { (&s_defaultVoidModifier)->m = TypeVoid; { (&((&(&s_defaultVoidModifier)->u)->f))->args = NULL; (&((&(&s_defaultVoidModifier)->u)->f))->thisFunList = NULL;}; (&s_defaultVoidModifier)->typedefin = NULL; (&s_defaultVoidModifier)->next = NULL;};
        { (&s_defaultVoidDefinition.b)->record = 0; (&s_defaultVoidDefinition.b)->isSingleImported = 0; (&s_defaultVoidDefinition.b)->accessFlags = 0; (&s_defaultVoidDefinition.b)->javaSourceLoaded = 0; (&s_defaultVoidDefinition.b)->javaFileLoaded = 0; (&s_defaultVoidDefinition.b)->symType = TypeDefault; (&s_defaultVoidDefinition.b)->storage = StorageDefault; (&s_defaultVoidDefinition.b)->npointers = 0;};
        { (&s_defaultVoidDefinition)->name = NULL; (&s_defaultVoidDefinition)->linkName = NULL; (&s_defaultVoidDefinition)->pos = s_noPos; (&s_defaultVoidDefinition)->b = s_defaultVoidDefinition.b; (&s_defaultVoidDefinition)->u.type = &s_defaultVoidModifier; (&s_defaultVoidDefinition)->next = NULL;};
        s_defaultVoidDefinition.u.type = &s_defaultVoidModifier;
        { (&s_errorModifier)->m = TypeError; { (&((&(&s_errorModifier)->u)->f))->args = NULL; (&((&(&s_errorModifier)->u)->f))->thisFunList = NULL;}; (&s_errorModifier)->typedefin = NULL; (&s_errorModifier)->next = NULL;};
        { (&s_errorSymbol.b)->record = 0; (&s_errorSymbol.b)->isSingleImported = 0; (&s_errorSymbol.b)->accessFlags = 0; (&s_errorSymbol.b)->javaSourceLoaded = 0; (&s_errorSymbol.b)->javaFileLoaded = 0; (&s_errorSymbol.b)->symType = TypeError; (&s_errorSymbol.b)->storage = StorageNone; (&s_errorSymbol.b)->npointers = 0;};
        { (&s_errorSymbol)->name = "__ERROR__"; (&s_errorSymbol)->linkName = "__ERROR__"; (&s_errorSymbol)->pos = s_noPos; (&s_errorSymbol)->b = s_errorSymbol.b; (&s_errorSymbol)->u.type = &s_errorModifier; (&s_errorSymbol)->next = NULL;};
        s_errorSymbol.u.type = &s_errorModifier;
}
void initPreCreatedTypes() {
        int i,t;
        S_typeModifiers *tt;
        for(i=0; i<MAX_TYPE; i++) {
                s_preCrTypesTab[i] = NULL;
                s_preCrPtr1TypesTab[i] = NULL;
        }
        for(i=0; ; i++) {
                t = s_preCrTypesIniTab[i];
                if (t<0) break;
                {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (tt)->m = t; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = NULL;};
                { if (!(t>=0 && t<MAX_TYPE)) internalCheckFail("t>=0 && t<MAX_TYPE", "init.c", 198);};
                s_preCrTypesTab[t] = tt;
                {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (tt)->m = TypePointer; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = s_preCrTypesTab[t];};
                s_preCrPtr1TypesTab[t] = tt;
                {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (tt)->m = TypePointer; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = s_preCrPtr1TypesTab[t];};
                s_preCrPtr2TypesTab[t] = tt;
        }
}
