
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
typedef unsigned char bitArray;
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
static bitArray tmpChRelevant[(((MAX_FILES)+(8 -1))/8)];
static bitArray tmpChProcessed[(((MAX_FILES)+(8 -1))/8)];
static bitArray tmpChMarkProcessed[(((MAX_FILES)+(8 -1))/8)];
static S_olSymbolsMenu *tmpVApplClassBackPointersToMenu[MAX_FILES];
static int s_symbolListOutputCurrentLine =0;
static void clearTmpChRelevant() {
        memset(tmpChRelevant, 0, sizeof(tmpChRelevant));
}
static void clearTmpChProcessed() {
        memset(tmpChProcessed, 0, sizeof(tmpChProcessed));
}
static void clearTmpChMarkProcessed() {
        memset(tmpChMarkProcessed, 0, sizeof(tmpChMarkProcessed));
}
static void clearTmpClassBackPointersToMenu() {
        memset(tmpVApplClassBackPointersToMenu, 0, sizeof(tmpVApplClassBackPointersToMenu));
}
int classHierarchyClassNameLess(int c1, int c2) {
        char *n2, *nn;
        S_fileItem *fi1, *fi2;
        int ccc;
        char ttt[MAX_FILE_NAME_SIZE];
        fi1 = s_fileTab.tab[c1];
        fi2 = s_fileTab.tab[c2];
        { if (!(fi1 && fi2)) internalCheckFail("fi1 && fi2", "classh.c", 54);};
        if (fi2->b.isInterface && ! fi1->b.isInterface) return(1);
        if (fi1->b.isInterface && ! fi2->b.isInterface) return(0);
        nn = fi1->name;
        nn = javaGetNudePreTypeName_st(getRealFileNameStatic(nn),s_opt.nestedClassDisplaying);
        strcpy(ttt,nn);
        nn = fi2->name;
    nn = javaGetNudePreTypeName_st(getRealFileNameStatic(nn),s_opt.nestedClassDisplaying);
        ccc = strcmp(ttt,nn);
        if (ccc!=0) return(ccc<0);
        ccc = strcmp(fi1->name, fi2->name);
        return(ccc<0);
}
int classHierarchySupClassNameLess(S_chReference *c1, S_chReference *c2) {
        return(classHierarchyClassNameLess(c1->clas, c2->clas));
}
static int markTransitiveRelevantSubsRec(int cind, int pass) {
        S_fileItem *fi, *tt;
        S_chReference *s;
        int res;
        fi = s_fileTab.tab[cind];
        if (((tmpChMarkProcessed[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0)) return(((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0));
        {tmpChMarkProcessed[(((cind) & ~(((8 -1))))>> 3)] |= (1<<((cind) & ((8 -1))));};
        res = 0;
        for(s=fi->infs; s!=NULL; s=s->next) {
                tt = s_fileTab.tab[s->clas];
                { if (!(tt)) internalCheckFail("tt", "classh.c", 83);};
                if (markTransitiveRelevantSubsRec(s->clas, pass)) {
                        {tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] |= (1<<((cind) & ((8 -1))));};
                }
        }
        return(((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0));
}
static void markTransitiveRelevantSubs(int cind, int pass) {
        S_fileItem *fi;
        fi = s_fileTab.tab[cind];
        if (((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0)==0) return;
        markTransitiveRelevantSubsRec(cind, pass);
}
void classHierarchyGenInit() {
        clearTmpChRelevant();
        clearTmpChProcessed();
}
void setTmpClassBackPointersToMenu(S_olSymbolsMenu *menu) {
        S_olSymbolsMenu *ss;
        clearTmpClassBackPointersToMenu();
        for(ss=menu; ss!=NULL; ss=ss->next) {
                tmpVApplClassBackPointersToMenu[ss->s.vApplClass] = ss;
        }
}
static void genClassHierarchyVerticalBars( FILE *ff, S_intlist *nextbars,
                                                                                   int secondpass) {
        S_intlist *nn;
        if (s_opt.xref2 && s_opt.taskRegime!=RegimeHtmlGenerate) {
                fprintf(ff," %s=\"", PPCA_TREE_DEPS);
        }
        if (nextbars!=NULL) {
                { register S_intlist *list,*tmp,*revlist; list = nextbars; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } nextbars = revlist;};
                for(nn = nextbars; nn!=NULL; nn=nn->next) {
                        if (nn->next==NULL) {
                                if (secondpass) fprintf(ff,"  +- ");
                                else fprintf(ff,"  |  ");
                        }
                        else if (nn->i) fprintf(ff,"  | ");
                        else fprintf(ff,"    ");
                }
                { register S_intlist *list,*tmp,*revlist; list = nextbars; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } nextbars = revlist;};
        }
        if (s_opt.xref2 && s_opt.taskRegime!=RegimeHtmlGenerate) {
                fprintf(ff,"\"");
        }
}
static S_olSymbolsMenu *htmlItemInOriginalList(S_olSymbolsMenu *orr, int fInd) {
        S_olSymbolsMenu *rr;
        if (fInd == -1) return(NULL);
        { if (!(fInd>=0 && fInd<MAX_FILES)) internalCheckFail("fInd>=0 && fInd<MAX_FILES", "classh.c", 150);};
        rr = tmpVApplClassBackPointersToMenu[fInd];
        return(rr);
}
static void htmlCHEmptyIndent( FILE *ff ) {
  fprintf(ff,"    ");
}
static void htmlPrintClassHierarchyLine( FILE *ff, int fInd,
                                                                                 S_intlist *nextbars,
                                                                                 int virtFlag,
                                                                                 S_olSymbolsMenu *itt ) {
        char *cname, *pref1, *pref2, *suf1, *suf2;
        S_fileItem *fi;
        int cnt;
        fi = s_fileTab.tab[fInd];
        htmlCHEmptyIndent( ff);
        genClassHierarchyVerticalBars( ff, nextbars, 0);
        fprintf(ff,"\n");
        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(fi->name),
                                                                          s_opt.nestedClassDisplaying);
        pref1 = pref2 = suf1 = suf2 = "";
        if (fi->b.isInterface) {
                pref2 = "<em>"; suf2 = "</em>";
        }
        if (itt!=NULL && ((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) {
                { if (!(itt)) internalCheckFail("itt", "classh.c", 181);};
                genClassHierarchyItemLinks( ff, itt, virtFlag);
                genClassHierarchyVerticalBars( ff, nextbars, 1);
                if (itt->s.vApplClass == itt->s.vFunClass) {
                        pref1 = "<B>"; suf1 = "</B>";
                }
                fprintf(ff,"%s%s%s%s%s", pref1, pref2, cname, suf2, suf1);
                cnt = itt->defRefn+itt->refn;
                if (cnt > 0) {
                        fprintf(ff,"\t\t(%d)", cnt);
                }
        } else {
            htmlCHEmptyIndent( ff);
            genClassHierarchyVerticalBars( ff, nextbars, 1);
                fprintf(ff,"%s%s%s%s%s", pref1, pref2, cname, suf2, suf1);
        }
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==1) {
                fprintf(ff, " ---> up");
        }
        fprintf(ff,"\n");
}
static void olcxPrintMenuItemPrefix(FILE *ff, S_olSymbolsMenu *itt,
                                                                   int selectable) {
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "classh.c", 206);};
        if (s_opt.cxrefs==OLO_CLASS_TREE || s_opt.cxrefs==OLO_SHOW_CLASS_TREE) {
                fprintf(ff,"");
        } else if (! selectable) {
                if (s_opt.xref2) fprintf(ff, " %s=2", PPCA_SELECTED);
                else fprintf(ff,"- ");
        } else if (itt!=NULL && itt->selected) {
                if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_SELECTED);
                else fprintf(ff,"+ ");
        } else {
                if (s_opt.xref2) fprintf(ff, " %s=0", PPCA_SELECTED);
                else fprintf(ff,"  ");
        }
        if (itt!=NULL
                && itt->vlevel==1
                && ooBitsGreaterOrEqual(itt->ooBits, 02000)) {
                if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_BASE);
                else fprintf(ff,">>");
        } else {
                if (s_opt.xref2) fprintf(ff, " %s=0", PPCA_BASE);
                else fprintf(ff,"  ");
        }
        if (! s_opt.xref2) fprintf(ff," ");
        if (s_opt.cxrefs==OLO_CLASS_TREE || s_opt.cxrefs==OLO_SHOW_CLASS_TREE) {
                fprintf(ff, "");
        } else if (itt==NULL || (itt->defRefn==0 && itt->refn==0) || !selectable) {
                if (s_opt.xref2) fprintf(ff, " %s=0 %s=0", PPCA_DEF_REFN, PPCA_REFN);
                else fprintf(ff, "  -/-  ");
        } else if (itt->defRefn==0) {
                if (s_opt.xref2) fprintf(ff, " %s=0 %s=%d", PPCA_DEF_REFN, PPCA_REFN, itt->refn);
                else fprintf(ff, "  -/%-3d", itt->refn);
        } else if (itt->refn==0) {
                if (s_opt.xref2) fprintf(ff, " %s=%d %s=0", PPCA_DEF_REFN, itt->defRefn, PPCA_REFN);
                else fprintf(ff, "%3d/-  ", itt->defRefn);
        } else {
                if (s_opt.xref2) fprintf(ff, " %s=%d %s=%d", PPCA_DEF_REFN, itt->defRefn, PPCA_REFN, itt->refn);
                else fprintf(ff, "%3d/%-3d", itt->defRefn, itt->refn);
        }
        if (! s_opt.xref2) fprintf(ff,"    ");
}
static void olcxMenuGenNonVirtualGlobSymList( FILE *ff, S_olSymbolsMenu *ss) {
        int ii;
        char ttt[MAX_CX_SYMBOL_SIZE];
        if (s_symbolListOutputCurrentLine == 1) s_symbolListOutputCurrentLine++;
        ss->outOnLine = s_symbolListOutputCurrentLine;
        s_symbolListOutputCurrentLine ++ ;
        if (s_opt.xref2) {
                ppcIndentOffset();
                fprintf(ff,"<%s %s=%d", PPC_SYMBOL, PPCA_LINE, ss->outOnLine+0);
                if (ss->s.b.symType!=TypeDefault) {
                        fprintf(ff," %s=%s", PPCA_TYPE, typesName[ss->s.b.symType]);
                }
                olcxPrintMenuItemPrefix(ff, ss, 1);
                sprintfSymbolLinkName(ttt, ss);
                fprintf(ff," %s=%d>%s</%s>\n", PPCA_LEN, strlen(ttt), ttt, PPC_SYMBOL);
        } else {
                fprintf(ff,"\n");
                olcxPrintMenuItemPrefix(ff, ss, 1);
                printSymbolLinkName(ff, ss);
                if (ss->s.b.symType != TypeDefault) {
                        fprintf(ff,"\t(%s)", typesName[ss->s.b.symType]);
                }
        }
}
static void olcxMenuPrintClassHierarchyLine( FILE *ff, int fInd,
                                                                                 S_intlist *nextbars,
                                                                                 int virtFlag,
                                                                                 S_olSymbolsMenu *itt ) {
        char *cname;
        S_fileItem *fi;
        int yetProcesed, indent;
        yetProcesed = ((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0);
        if (s_opt.xref2) {
                ppcIndentOffset();
                fprintf(ff, "<%s %s=%d", PPC_CLASS, PPCA_LINE,
                                itt->outOnLine+0);
        }
        olcxPrintMenuItemPrefix(ff, itt, ! yetProcesed);
        if (s_opt.xref2) {
                { register S_intlist *tmp; register int co=0; tmp = nextbars; while (tmp!=NULL) {++co; tmp = tmp->next; } indent = co; };
                fprintf(ff, " %s=%d", PPCA_INDENT, indent);
        }
        genClassHierarchyVerticalBars( ff, nextbars, 1);
        fi = s_fileTab.tab[fInd];
        if (itt!=NULL) {
                { if (!(itt)) internalCheckFail("itt", "classh.c", 295);};
                if (itt->s.vApplClass == itt->s.vFunClass && s_opt.cxrefs!=OLO_CLASS_TREE) {
                        if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_DEFINITION);
                        else fprintf(ff,"*");
                }
                itt->visible = 1;
        }
        if (fi->b.isInterface) {
                if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_INTERFACE);
                else fprintf(ff,"~");
        }
        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(fi->name),
                                                                          s_opt.nestedClassDisplaying);
        if (s_opt.xref2) {
                if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) fprintf(ff," %s=1", PPCA_TREE_UP);
                fprintf(ff, " %s=%d>%s</%s>\n", PPCA_LEN, strlen(cname), cname, PPC_CLASS);
        } else {
                if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) fprintf(ff,"(%s) -> up", cname);
                else fprintf(ff,"%s", cname);
                fprintf(ff,"\n");
        }
}
static void descendTheClassHierarchy( FILE *ff,
                                                                                int vApplCl, int oldvFunCl,
                                                                                S_olSymbolsMenu *rrr,
                                                                                int level,
                                                                                S_intlist *nextbars,
                                                                                int virtFlag,
                                                                                int pass
        ) {
        S_intlist snextbar,*nn;
        S_fileItem *tt, *fi;
        S_chReference *s,*ol,*snext;
        S_olSymbolsMenu *itt;
        S_symbolRefItem *ri;
        char *cname,*pref1,*pref2,*suf1,*suf2;
        int i, vFunCl;
        fi = s_fileTab.tab[vApplCl];
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "classh.c", 336);};
        if (((tmpChRelevant[(((vApplCl) & ~(((8 -1))))>> 3)] & (1<<((vApplCl) & ((8 -1)))))!=0)==0) return;
        itt = htmlItemInOriginalList(rrr, vApplCl);
        if (itt == NULL) {
                { if (!(rrr)) internalCheckFail("rrr", "classh.c", 341);};
                vFunCl = oldvFunCl;
                itt = olCreateNewMenuItem(&rrr->s, vApplCl, vFunCl, &s_noPos, UsageNone,
                                                                  0, 1, 0, UsageNone, 0);
                itt->next = rrr->next;
                rrr->next = itt;
                tmpVApplClassBackPointersToMenu[vApplCl] = itt;
        } else {
                vFunCl = itt->s.vFunClass;
        }
        if (s_symbolListOutputCurrentLine == 1) s_symbolListOutputCurrentLine++;
        if (itt!=NULL && itt->outOnLine==0) itt->outOnLine = s_symbolListOutputCurrentLine;
        s_symbolListOutputCurrentLine ++;
        if (s_opt.taskRegime==RegimeHtmlGenerate) {
                htmlPrintClassHierarchyLine( ff, vApplCl, nextbars, virtFlag, itt);
        } else {
                olcxMenuPrintClassHierarchyLine( ff, vApplCl, nextbars, virtFlag, itt);
        }
        if (((tmpChProcessed[(((vApplCl) & ~(((8 -1))))>> 3)] & (1<<((vApplCl) & ((8 -1)))))!=0)==1) return;
        {tmpChProcessed[(((vApplCl) & ~(((8 -1))))>> 3)] |= (1<<((vApplCl) & ((8 -1))));};
        { S_chReference *_macrores; _macrores = (fi->infs); { S_chReference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (classHierarchySupClassNameLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (fi->infs) = _macrores;};
        s=fi->infs;
        while (s!=NULL) {
                { if (!(s_fileTab.tab[s->clas])) internalCheckFail("s_fileTab.tab[s->clas]", "classh.c", 374);};
                snext = s->next;
                while (snext!=NULL && ((tmpChRelevant[(((snext->clas) & ~(((8 -1))))>> 3)] & (1<<((snext->clas) & ((8 -1)))))!=0)==0) {
                        snext = snext->next;
                }
                { (&snextbar)->i = (snext!=NULL); (&snextbar)->next = nextbars;}
                descendTheClassHierarchy(ff, s->clas, vFunCl, rrr, level+1,
                                                                         &snextbar, virtFlag, pass);
                s = snext;
        }
}
static int genThisClassHierarchy(int vApplCl, int oldvFunCl,
                                                                 FILE *ff,
                                                                 S_olSymbolsMenu *rrr,
                                                                 int virtFlag,
                                                                 int pass) {
        S_fileItem *top,*tt,*fi;
        S_chReference *s;
        fi = s_fileTab.tab[vApplCl];
        if (fi==NULL) return(0);
        if (((tmpChProcessed[(((vApplCl) & ~(((8 -1))))>> 3)] & (1<<((vApplCl) & ((8 -1)))))!=0)) return(0);
        if (((tmpChRelevant[(((vApplCl) & ~(((8 -1))))>> 3)] & (1<<((vApplCl) & ((8 -1)))))!=0)==0) return(0);
        for(s=fi->sups; s!=NULL; s=s->next) {
                tt = s_fileTab.tab[s->clas];
                { if (!(tt)) internalCheckFail("tt", "classh.c", 400);};
                if (((tmpChRelevant[(((s->clas) & ~(((8 -1))))>> 3)] & (1<<((s->clas) & ((8 -1)))))!=0) && ((tmpChProcessed[(((s->clas) & ~(((8 -1))))>> 3)] & (1<<((s->clas) & ((8 -1)))))!=0)==0) return(0);
        }
        if (pass==FIRST_PASS && fi->b.isInterface) return(0);
        descendTheClassHierarchy(ff, vApplCl, oldvFunCl, rrr, 0, NULL, virtFlag, pass);
        return(1);
}
void genClassHierarchies( FILE *ff, S_olSymbolsMenu *rrr,
                                                                                int virtFlag, int pass ) {
        S_olSymbolsMenu *ss;
        int i,rr;
        S_fileItem *fi;
        clearTmpChRelevant();
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                { if (!(s_fileTab.tab[ss->s.vApplClass])) internalCheckFail("s_fileTab.tab[ss->s.vApplClass]", "classh.c", 419);};
                if (ss->visible) {
                        {tmpChRelevant[(((ss->s.vApplClass) & ~(((8 -1))))>> 3)] |= (1<<((ss->s.vApplClass) & ((8 -1))));};
                        {tmpChRelevant[(((ss->s.vFunClass) & ~(((8 -1))))>> 3)] |= (1<<((ss->s.vFunClass) & ((8 -1))));};
                }
        }
        clearTmpChMarkProcessed();
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                markTransitiveRelevantSubs(ss->s.vFunClass, pass);
                markTransitiveRelevantSubs(ss->s.vApplClass, pass);
        }
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                genThisClassHierarchy(ss->s.vFunClass, s_noneFileIndex,ff,rrr,virtFlag,pass);
                genThisClassHierarchy(ss->s.vApplClass, s_noneFileIndex,ff,rrr,virtFlag,pass);
        }
}
static int isInterface(int fnum) {
        S_fileItem *fi;
        fi = s_fileTab.tab[fnum];
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "classh.c", 441);};
        return(fi->b.isInterface);
}
static int htmlRefItemsClassNameLess(S_olSymbolsMenu *ss1,
                                                                         S_olSymbolsMenu *ss2) {
        return(classHierarchyClassNameLess(ss1->s.vApplClass,ss2->s.vApplClass));
}
int chLineOrderLess(S_olSymbolsMenu *r1, S_olSymbolsMenu *r2) {
        return(r1->outOnLine < r2->outOnLine);
}
void olcxMenuGenGlobRefsForVirtMethod(FILE *ff, S_olSymbolsMenu *rrr) {
        char ln[MAX_HTML_REF_LEN];
        int virtFlag;
        linkNamePrettyPrint(ln,rrr->s.name,MAX_HTML_REF_LEN,SHORT_NAME);
        if (strcmp(rrr->s.name, " [classTree]")==0) {
        } else {
                if (s_opt.xref2) ppcGenRecord(PPC_VIRTUAL_SYMBOL, ln, "\n");
                else fprintf(ff, "\n== %s\n", ln);
                s_symbolListOutputCurrentLine += 2 ;
        }
        classHierarchyGenInit();
        setTmpClassBackPointersToMenu(rrr);
        genClassHierarchies( ff, rrr, SINGLE_VIRT_ITEM, FIRST_PASS);
        setTmpClassBackPointersToMenu(rrr);
        genClassHierarchies( ff, rrr, SINGLE_VIRT_ITEM, SECOND_PASS);
}
static void htmlMarkVisibleAllClassesHavingDefinition( S_olSymbolsMenu *rrr ) {
        S_olSymbolsMenu *rr;
        for(rr=rrr; rr!=NULL; rr=rr->next) {
                if (rr->s.vApplClass==rr->s.vFunClass) rr->visible = 1;
        }
}
static int isVirtualMenuItem(S_symbolRefItem *p) {
        return (p->b.storage == StorageField
                        || p->b.storage == StorageMethod
                        || p->b.storage == StorageConstructor);
}
static void genVirtualsGlobRefLists( S_olSymbolsMenu *rrr,
                                                                                FILE *ff,
                                                                                char *fn
        ) {
        S_olSymbolsMenu *rr,*ss;
        int i,olen,nlen,count,virtFlag;
        S_symbolRefItem *p;
        S_fileItem *fi;
        count = 0;
        for(ss=rrr; ss!=NULL && ss->visible==0; ss=ss->next) ;
        if (ss == NULL) return;
        { if (!(rrr!=NULL)) internalCheckFail("rrr!=NULL", "classh.c", 504);};
        p = &rrr->s;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "classh.c", 506);};
        if (isVirtualMenuItem(p)) {
                if (s_opt.taskRegime==RegimeHtmlGenerate) {
                        htmlMarkVisibleAllClassesHavingDefinition( rrr);
                        htmlGenGlobRefsForVirtMethod( ff, fn, rrr);
                } else {
                        olcxMenuGenGlobRefsForVirtMethod( ff, rrr);
                }
        }
}
static void genNonVirtualsGlobRefLists( S_olSymbolsMenu *rrr,
                                                                                FILE *ff,
                                                                                char *fn
        ) {
        S_olSymbolsMenu *rr,*ss;
        int i,olen,nlen,count,virtFlag;
        S_symbolRefItem *p;
        S_fileItem *fi;
        count = 0;
        for(ss=rrr; ss!=NULL && ss->visible==0; ss=ss->next) ;
        if (ss == NULL) return;
        { if (!(rrr!=NULL)) internalCheckFail("rrr!=NULL", "classh.c", 530);};
        p = &rrr->s;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "classh.c", 532);};
        if (! isVirtualMenuItem(p)) {
                for(ss=rrr; ss!=NULL; ss=ss->next) {
                        p = &ss->s;
                        if (s_opt.taskRegime==RegimeHtmlGenerate) {
                                htmlGenNonVirtualGlobSymList( ff, fn, p);
                        } else {
                                olcxMenuGenNonVirtualGlobSymList( ff, ss);
                        }
                }
        }
}
void splitMenuPerSymbolsAndMap(S_olSymbolsMenu *rrr,
                                                         void (*fun)(S_olSymbolsMenu *, void *, void *),
                                                         void *p1,
                                                         char *p2
        ) {
        S_olSymbolsMenu *rr, *mp, **ss, *cc, *all;
        S_symbolRefItem *cs;
        all = NULL;
        rr = rrr;
        while (rr!=NULL) {
                mp = NULL;
                ss= &rr; cs= &rr->s;
                while (*ss!=NULL) {
                        cc = *ss;
                        if (itIsSameCxSymbol(&cc->s, cs)) {
                                *ss = (*ss)->next;
                                cc->next = mp;
                                mp = cc;
                                goto contlab;
                        }
                        ss= &(*ss)->next;
                contlab:;
                }
                (*fun)(mp, p1, p2);
                { if ((mp)==NULL) mp = all; else { register S_olSymbolsMenu *tempnsl; tempnsl = mp; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = all; } };
                all = mp;
        }
        if (all!=rrr) {
                ss = &all;
                while (*ss!=rrr && *ss!=NULL) ss = &(*ss)->next;
                { if (!(*ss!=NULL)) internalCheckFail("*ss!=NULL", "classh.c", 603);};
                { if (!(*ss != all)) internalCheckFail("*ss != all", "classh.c", 604);};
                *ss = rrr->next;
                rrr->next = all;
        }
}
void htmlGenGlobRefLists(S_olSymbolsMenu *rrr, FILE *ff, char *fn) {
        S_olSymbolsMenu *rr,*ss,*nextl;
        int i,n;
        static int counter;
        S_symbolRefItem *p;
        for(rr=rrr; rr!=NULL; rr=rr->next) rr->outOnLine = 0;
        s_symbolListOutputCurrentLine = 1;
        splitMenuPerSymbolsAndMap(
                rrr, (void (*)(S_olSymbolsMenu *, void *, void *))genNonVirtualsGlobRefLists, ff, fn
                );
        splitMenuPerSymbolsAndMap(
                rrr, (void (*)(S_olSymbolsMenu *, void *, void *))genVirtualsGlobRefLists, ff, fn
                );
}
