
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
FILE *dumpOut=NULL, *errOut=NULL;
char tmpBuff[TMP_BUFF_SIZE];
void initCwd() {
        char *rr;
        char nid[MAX_FILE_NAME_SIZE];
        rr = getcwd(s_cwd, MAX_FILE_NAME_SIZE);
        if (rr==NULL) {
                rr = getenv("PWD");
                if (rr==NULL) {
                        error(ERR_ST, "can't get current working directory");
                        sprintf(s_cwd, ".");
                } else {
                        { if (!(strlen(rr) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(rr) < MAX_FILE_NAME_SIZE", "commons.c", 38);};
                        strcpy(s_cwd, rr);
                }
        }
#if defined (__WIN32__) || defined (__OS2__)
        if (strlen(s_cwd)<=2 || s_cwd[1]!=':') {
#if defined (__OS2__)
                sprintf(nid,"%c:",_getdrive());
#else
                sprintf(nid,"%c:",tolower('c'));
#endif
                if (strlen(nid)+strlen(s_cwd) < MAX_FILE_NAME_SIZE-1) {
                        strcpy(nid+strlen(nid),s_cwd);
                        strcpy(s_cwd,nid);
                }
        }
        strcpy(s_cwd, normalizeFileName(s_cwd, "c:\\"));
#else
        strcpy(s_cwd, normalizeFileName(s_cwd, "/"));
#endif
}
void reInitCwd(char *dffname, char *dffsect) {
        int ii;
        if (dffname[0]!=0) {
                copyDir(s_cwd, dffname, &ii);
        }
        if (dffsect[0]!=0
#if defined (__WIN32__) || defined (__OS2__)
                && dffsect[1]==':' && dffsect[2]==SLASH
#else
                && dffsect[0]==SLASH
#endif
                ) {
                strcpy(s_cwd, dffsect);
        }
}
char *normalizeFileName(char *name, char *relativeto) {
        static char res[MAX_FILE_NAME_SIZE];
        int l1,l2,i,j,s1,inzip=0;
        char *ss;
        l1 = strlen(relativeto);
        l2 = strlen(name);
        s1 = 0;
        if (name[0] == ';') {
                l1 = -1;
                inzip = 1;
#if defined (__WIN32__) || defined (__OS2__)
        } else if (name[0]=='\\' || name[0]=='/') {
                res[0] = relativeto[0]; res[1] = ':';
                l1 = 1;
        } else if (name[0]!=0 && name[1]==':') {
                res[0] = tolower(name[0]);
                res[1] = ':';
                l1 = 1;
                s1 = 2;
#else
        } else if (name[0] == SLASH) {
                l1 = -1;
#endif
        } else {
                if (l1+l2+2 >= MAX_FILE_NAME_SIZE) {
                        l1 = -1;
                } else {
                        strcpy(res,relativeto);
                        if (! s_opt.fileNamesCaseSensitive) {
                                for(ss=res; *ss; ss++) *ss = tolower(*ss);
                        }
                        if (l1>0 && res[l1-1] == SLASH) l1--;
                        else res[l1]=SLASH;
                }
        }
        for(i=s1, j=l1+1; i<l2+1; ) {
                if (name[i]=='.' && (name[i+1]==SLASH||name[i+1]=='/')) {i+=2;
                } else if (name[i]=='.' && name[i+1]=='.' && (name[i+2]==SLASH||name[i+2]=='/')) {
                                for(j-=2; j>=0 && res[j]!=SLASH && res[j]!='/'; j--) ;
                                i+=3; j++;
                                if (j==0) j++;
                } else {
                        for(; name[i]!=0 && name[i]!=SLASH && name[i]!='/'; i++,j++) {
                                res[j]=name[i];
                                if (res[j]==';') inzip=1;
                                if ((!inzip) && ! s_opt.fileNamesCaseSensitive) {
                                        res[j]=tolower(res[j]);
                                }
                        }
                        res[j]=name[i];
                        if (res[j]=='/' && !inzip) res[j]=SLASH;
                        i++; j++;
                        if (i<l2+1 && (name[i]=='/' || name[i]==SLASH) && !inzip) i++;
                }
        }
        if (j>=2 && res[j-2]==SLASH && !inzip) res[j-2]=0;
        if (strlen(res) >= MAX_FILE_NAME_SIZE) {
                sprintf(tmpBuff, "file name %s is too long", res);
                fatalError(ERR_ST, tmpBuff, 65);
        }
        return(res);
}
char *crTmpFileName_st() {
        static char ttt[MAX_FILE_NAME_SIZE];
        char *tmp;
        static int count =0;
#if defined (__WIN32__) || defined (__OS2__)
        tmp = getenv("TEMP");
        if (tmp==NULL) {
                tmp = tmpnam(NULL);
                strcpy(ttt,tmp);
        } else {
                sprintf(ttt,"%s\\xrefu%d.tmp", tmp, count++);
                strcpy(ttt, normalizeFileName(ttt, s_cwd));
        }
#else
        tmp = tmpnam(NULL);
        strcpy(ttt,tmp);
#endif
        if (ttt == NULL) fatalError(ERR_ST, "can't create temporary file", 65);
        { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "commons.c", 165);};
        return(ttt);
}
void copyFile(char *src, char *dest) {
        FILE *fs,*fd;
        int n,nn;
        fs = fopen(src,"r");
        if (fs==NULL) {
                error(ERR_CANT_OPEN, src);
                return;
        }
        fd = fopen(dest,"w");
        if (fd==NULL) {
                error(ERR_CANT_OPEN, dest);
                fclose(fs);
                return;
        }
        do {
                n = fread(tmpBuff,1,TMP_BUFF_SIZE,fs);
                nn = fwrite(tmpBuff,1,n,fd);
                if (n!=nn) error(ERR_ST,"problem with writing to a file.");
        } while (n > 0);
        fclose(fd);
        fclose(fs);
}
void createDir(char *dirname) {
#ifdef __WIN32__
        mkdir(dirname);
#else
        mkdir(dirname,0777);
#endif
}
void removeFile(char *dirname) {
        unlink(dirname);
}
void copyDir(char *dest, char *s, int *i) {
        int ii;
        *i = 0;
        for(ii=0; s[ii]!=0; ii++) {
                dest[ii] = s[ii];
                if (s[ii]=='/' || s[ii]=='\\') *i = ii+1;
        }
        dest[*i] = 0;
}
static void errorMessage(char *out, int errCode, char *mess) {
        if (s_opt.taskRegime != RegimeEditServer) {
                sprintf(out,"%s ", placeIdent());
                out += strlen(out);
        }
        switch (errCode) {
        case ERR_CANT_OPEN:
                sprintf(out,"can't open file %s\n",mess);
                out += strlen(out);
                break;
        case ERR_CANT_EXECUTE:
                sprintf(out,"can't execute the command %s\n",mess);
                out += strlen(out);
                break;
        case ERR_NO_MEMORY:
                sprintf(out,"sorry, memory %s overflowed over borne\n",mess);
                out += strlen(out);
                sprintf(out,"\tread the TROUBLES section of the README file.\n");
                out += strlen(out);
                break;
        case ERR_INTERNAL:
                sprintf(out,"internal error, %s\n",mess);
                out += strlen(out);
                break;
        case ERR_INTERNAL_CHECK:
                sprintf(out,"internal check %s\n",mess);
                out += strlen(out);
                break;
        case ERR_CFG:
                sprintf(out,"a problem while reading config record %s\n",mess);
                out += strlen(out);
                break;
        case ERR_LICENSE:
                sprintf(out,"You are using Xrefactory beyond its free evaluation period.\nXrefactory is a shareware. You can purchase legal user license\nat the address: http://www.xref-tech.com/xrefactory\n");
                out += strlen(out);
                break;
        case ERR_BIN_LICENSE:
                sprintf(out,"You are using Xrefactory beyond its free evaluation period.\nXrefactory is a shareware. You can purchase legal user license\nfor $29 at the address: http://www.xref-tech.com/xrefactory\n");
                out += strlen(out);
                break;
        default:
                sprintf(out,"%s\n",mess);
                out += strlen(out);
                break;
        }
        { if (!(strlen(ppcTmpBuff) < MAX_PPC_RECORD_SIZE-1)) internalCheckFail("strlen(ppcTmpBuff) < MAX_PPC_RECORD_SIZE-1", "commons.c", 271);};
}
void warning(int errCode, char *mess) {
        if ((! s_opt.noErrors) && (! s_javaPreScanOnly)) {
                if (! s_opt.xref2) fprintf(errOut,"![warning] ");
                errorMessage(ppcTmpBuff,errCode, mess);
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_WARNING, ppcTmpBuff,"\n");
                } else {
                        fprintf(errOut, "%s", ppcTmpBuff);
                        fflush(errOut);
                }
        }
}
static void writeErrorMessage(int errCode, char *mess) {
        if (! s_opt.xref2) fprintf(errOut,"![error] ");
        errorMessage(ppcTmpBuff,errCode, mess);
        if (s_opt.xref2) {
                ppcGenRecord(PPC_ERROR, ppcTmpBuff,"\n");
        } else {
                fprintf(errOut, "%s", ppcTmpBuff);
                fflush(errOut);
        }
}
void error(int errCode, char *mess) {
        if ((! s_opt.noErrors) && (! s_javaPreScanOnly)) {
                writeErrorMessage(errCode, mess);
        }
}
void emergencyExit(int exitStatus) {
        mainCloseOutputFile();
        if (s_opt.xref2) {
                ppcGenSynchroRecord();
        }
        exit(exitStatus);
}
void fatalError(int errCode, char *mess, int exitStatus) {
        if (! s_opt.xref2) fprintf(errOut,"![error] ");
        errorMessage(ppcTmpBuff, errCode, mess);
        if (s_opt.xref2) {
                ppcGenRecord(PPC_FATAL_ERROR, ppcTmpBuff,"\n");
        } else {
                fprintf(errOut, "%s", ppcTmpBuff);
                fprintf(errOut,"\t exiting\n");
                fflush(errOut);
        }
        emergencyExit(exitStatus);
}
void internalCheckFail(char *expr, char *file, int line) {
        if (errOut == NULL) errOut = stderr;
        sprintf(tmpBuff,"'%s' is not valid in '%s:%d'",expr,file,line);
        writeErrorMessage(ERR_INTERNAL_CHECK,tmpBuff);
        if (s_opt.taskRegime == RegimeEditServer || s_opt.refactoringRegime == RegimeRefactory) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_INFORMATION,"Exiting","\n");
                        mainCloseOutputFile();
                        ppcGenSynchroRecord();
                } else {
                        fprintf(errOut, "\t exiting!\n"); fflush(stderr);
                }
        }
        if (s_opt.taskRegime == RegimeEditServer
                || s_opt.refactoringRegime == RegimeRefactory
                || s_fileAbortionEnabled == 0
                ) {
                emergencyExit(65);
        }
        fprintf(errOut, "\t file aborted!\n"); fflush(errOut);
        longjmp(cxmemOverflow,MESS_FILE_ABORT);
}
