
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
        S_extRecFindStr *erfs;
        S_bb_int bbinteger;
        S_bb_unsigned bbunsign;
        S_bb_symbol bbsymbol;
        S_bb_symbolList bbsymbolList;
        S_bb_typeModifiers bbtypeModif;
        S_bb_typeModifiersList bbtypeModifList;
        S_bb_freeTrail bbtrail;
        S_bb_idIdent bbidIdent;
        S_bb_idIdentList bbidlist;
        S_bb_exprTokenType bbexprType;
        S_bb_intPair bbintpair;
        S_bb_whileExtractData bbwhiledata;
        S_bb_position bbposition;
        S_bb_unsPositionPair bbunsPositionPair;
        S_bb_symbolPositionPair bbsymbolPositionPair;
        S_bb_symbolPositionLstPair bbsymbolPositionLstPair;
        S_bb_positionLst bbpositionLst;
        S_bb_typeModifiersListPositionLstPair bbtypeModifiersListPositionLstPair;
        S_bb_nestedConstrTokenType bbnestedConstrTokenType;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
static void formatFullCompletions(char *tt, int indent, int inipos) {
        int pos;
        char *nlpos,*p;
        pos = inipos; nlpos=NULL;
        p = tt;
        for(;;) {
                while (pos<s_opt.olineLen || nlpos==NULL) {
                        p++; pos++;
                        if (*p == 0) goto formatFullCompletionsEnd;
                        if (*p ==' ' && pos>indent) nlpos = p;
                }
                *nlpos = '\n'; pos = indent+(p-nlpos); nlpos=NULL;
        }
 formatFullCompletionsEnd:
}
void formatOutputLine(char *tt, int startingColumn) {
        int pos, n;
        char *nlp,*p;
        pos = startingColumn; nlp=NULL;
        { if (!(s_opt.tabulator>1)) internalCheckFail("s_opt.tabulator>1", "complet.c", 48);};
        p = tt;
        for(;;) {
                while (pos<s_opt.olineLen || nlp==NULL) {
                        if (*p == 0) return;
                        if (*p == ' ') nlp = p;
                        if (*p == '\t') {
                                nlp = p;
                                n = s_opt.tabulator-(pos-1)%s_opt.tabulator-1;
                                pos += n;
                        } else {
                                pos++;
                        }
                        p++;
                }
                *nlp = '\n'; p = nlp+1; nlp=NULL; pos = 0;
        }
}
static int printJavaModifiers(char *buf, int *size, unsigned acc) {
        int i;
        i = 0;
        if (1 || (s_opt.ooChecksBits & 00002)==0) {
                if (acc & 0x001) {
                        sprintf(buf+i,"public "); i+=strlen(buf+i);
                        { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 73);};
                }
                if (acc & 0x002) {
                        sprintf(buf+i,"private "); i+=strlen(buf+i);
                        { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 77);};
                }
                if (acc & 0x004) {
                        sprintf(buf+i,"protected "); i+=strlen(buf+i);
                        { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 81);};
                }
        }
        if (acc & 0x008) {
                sprintf(buf+i,"static "); i+=strlen(buf+i);
                { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 92);};
        }
        if (acc & 0x010) {
                sprintf(buf+i,"final "); i+=strlen(buf+i);
                { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 96);};
        }
        *size -= i;
        return(i);
}
static char *getCompletionClassFieldString( S_cline *cl) {
        char *cname;
        if (cl->vFunClass!=NULL) {
                cname = javaGetShortClassName(cl->vFunClass->linkName);
        } else {
                { if (!(cl->t)) internalCheckFail("cl->t", "complet.c", 112);};
                cname = javaGetNudePreTypeName_st(cl->t->linkName,CUT_OUTERS);
        }
        return(cname);
}
static void sprintFullCompletionInfo(S_completions* c, int ii, int indent) {
        int size,ll,i,tdexpFlag,vFunCl,cindent, ttlen;
        char tt[COMPLETION_STRING_SIZE];
        char ttt[TMP_STRING_SIZE];
        char *pname,*cname;
        char *ppc;
        ppc = ppcTmpBuff;
        if (c->a[ii].symType == TypeUndefMacro) return;
        strcpy(tt, c->a[ii].s);
        ttlen = strlen(tt);
        if (ttlen>0 && tt[ttlen-1]==')' && c->a[ii].symType!=TypeInheritedFullMethod) {
                ttlen--;
                tt[ttlen]=0;
        }
        if (ttlen>0 && tt[ttlen-1]=='(') {
                ttlen--;
                tt[ttlen]=0;
        }
        sprintf(ppc, "%-*s:", indent+2, tt);
        cindent = strlen(ppc);
        ppc += strlen(ppc);
        vFunCl = s_noneFileIndex;
        size = COMPLETION_STRING_SIZE;
        ll = 0;
        if (c->a[ii].symType==TypeDefault) {
                { if (!(c->a[ii].t && c->a[ii].t->u.type)) internalCheckFail("c->a[ii].t && c->a[ii].t->u.type", "complet.c", 146);};
                if (((s_language & (4)) != 0)) {
                        cname = getCompletionClassFieldString(&c->a[ii]);
                        if (c->a[ii].virtLevel>1000) {
                                sprintf(tmpBuff,"(%d.%d)%s: ",
                                                c->a[ii].virtLevel/1000,
                                                c->a[ii].virtLevel%1000,
                                                cname);
                        } else if (c->a[ii].virtLevel>0) {
                                sprintf(tmpBuff,"(%d)%s: ", c->a[ii].virtLevel, cname);
                        } else {
                                sprintf(tmpBuff,"   : ");
                        }
                        cindent += strlen(tmpBuff);
                        sprintf(ppc,"%s", tmpBuff);
                        ppc += strlen(ppc);
                }
                tdexpFlag = 1;
                if (c->a[ii].t->b.storage == StorageTypedef) {
                        sprintf(tt,"typedef ");
                        ll = strlen(tt);
                        size -= ll;
                        tdexpFlag = 0;
                }
                pname = c->a[ii].t->name;
                if (((s_language & (4)) != 0)) {
                        ll += printJavaModifiers(tt+ll, &size, c->a[ii].t->b.accessFlags);
                        if (c->a[ii].vFunClass!=NULL) {
                                vFunCl = c->a[ii].vFunClass->u.s->classFile;
                                if (vFunCl == -1) vFunCl = s_noneFileIndex;
                        }
                }
                typeSPrint(tt+ll, &size, c->a[ii].t->u.type, pname,' ', 0, tdexpFlag,SHORT_NAME, NULL);
                if (((s_language & (4)) != 0)
                        && (c->a[ii].t->b.storage == StorageMethod
                                || c->a[ii].t->b.storage == StorageConstructor)) {
                        throwsSprintf(tt+ll+size, COMPLETION_STRING_SIZE-ll-size, c->a[ii].t->u.type->u.m.exceptions);
                }
        } else if (c->a[ii].symType==TypeMacro) {
                macDefSPrintf(tt, &size, "", c->a[ii].s,
                                          c->a[ii].margn, c->a[ii].margs, NULL);
        } else if (((s_language & (4)) != 0) && c->a[ii].symType==TypeStruct ) {
                if (c->a[ii].t!=NULL) {
                        ll += printJavaModifiers(tt+ll, &size, c->a[ii].t->b.accessFlags);
                        if (c->a[ii].t->b.accessFlags & 0x200) {
                                sprintf(tt+ll,"interface ");
                        } else {
                                sprintf(tt+ll,"class ");
                        }
                        ll = strlen(tt);
                        javaTypeStringSPrint(tt+ll, c->a[ii].t->linkName,LONG_NAME, NULL);
                } else {
                        sprintf(tt,"class ");
                }
        } else if (c->a[ii].symType == TypeInheritedFullMethod) {
                if (c->a[ii].vFunClass!=NULL) {
                        sprintf(tt,"%s \t:%s", c->a[ii].vFunClass->name, typesName[c->a[ii].symType]);
                        vFunCl = c->a[ii].vFunClass->u.s->classFile;
                        if (vFunCl == -1) vFunCl = s_noneFileIndex;
                } else {
                        sprintf(tt,"%s", typesName[c->a[ii].symType]);
                }
        } else {
                { if (!(c->a[ii].symType>=0 && c->a[ii].symType<MAX_TYPE)) internalCheckFail("c->a[ii].symType>=0 && c->a[ii].symType<MAX_TYPE", "complet.c", 214);};
                sprintf(tt,"%s", typesName[c->a[ii].symType]);
        }
        formatFullCompletions(tt, indent+2 +2, cindent);
        for(i=0; tt[i]; i++) {
                sprintf(ppc,"%c",tt[i]);
                ppc += strlen(ppc);
                if (tt[i] == '\n') {
                        sprintf(ppc,"%-*s ",indent+2, " ");
                        ppc += strlen(ppc);
                }
        }
}
static void sprintFullJeditCompletionInfo(S_completions* c, int ii, int *nindent, char **vclass) {
        int size,ll,i,tdexpFlag,cindent;
        char *pname,*cname;
        static char vlevelBuff[TMP_STRING_SIZE];
        size = COMPLETION_STRING_SIZE;
        ll = 0;
        sprintf(vlevelBuff," ");
        if (vclass != NULL) *vclass = vlevelBuff;
        if (c->a[ii].symType==TypeDefault) {
                { if (!(c->a[ii].t && c->a[ii].t->u.type)) internalCheckFail("c->a[ii].t && c->a[ii].t->u.type", "complet.c", 237);};
                if (((s_language & (4)) != 0)) {
                        cname = getCompletionClassFieldString(&c->a[ii]);
                        if (c->a[ii].virtLevel>1000) {
                                sprintf(vlevelBuff,"  : (%d.%d) %s ",
                                                c->a[ii].virtLevel/1000,
                                                c->a[ii].virtLevel%1000,
                                                cname);
                        } else if (c->a[ii].virtLevel>0) {
                                sprintf(vlevelBuff,"  : (%d) %s ", c->a[ii].virtLevel, cname);
                        }
                }
                tdexpFlag = 1;
                if (c->a[ii].t->b.storage == StorageTypedef) {
                        sprintf(ppcTmpBuff,"typedef ");
                        ll = strlen(ppcTmpBuff);
                        size -= ll;
                        tdexpFlag = 0;
                }
                pname = c->a[ii].t->name;
                if (((s_language & (4)) != 0)) {
                        ll += printJavaModifiers(ppcTmpBuff+ll, &size, c->a[ii].t->b.accessFlags);
                }
                typeSPrint(ppcTmpBuff+ll, &size, c->a[ii].t->u.type, pname,' ', 0, tdexpFlag,SHORT_NAME, nindent);
                *nindent += ll;
                if (((s_language & (4)) != 0)
                        && (c->a[ii].t->b.storage == StorageMethod
                                || c->a[ii].t->b.storage == StorageConstructor)) {
                        throwsSprintf(ppcTmpBuff+ll+size, COMPLETION_STRING_SIZE-ll-size, c->a[ii].t->u.type->u.m.exceptions);
                }
        } else if (c->a[ii].symType==TypeMacro) {
                macDefSPrintf(ppcTmpBuff, &size, "", c->a[ii].s,
                                          c->a[ii].margn, c->a[ii].margs, nindent);
        } else if (((s_language & (4)) != 0) && c->a[ii].symType==TypeStruct ) {
                if (c->a[ii].t!=NULL) {
                        ll += printJavaModifiers(ppcTmpBuff+ll, &size, c->a[ii].t->b.accessFlags);
                        if (c->a[ii].t->b.accessFlags & 0x200) {
                                sprintf(ppcTmpBuff+ll,"interface ");
                        } else {
                                sprintf(ppcTmpBuff+ll,"class ");
                        }
                        ll = strlen(ppcTmpBuff);
                        javaTypeStringSPrint(ppcTmpBuff+ll, c->a[ii].t->linkName, LONG_NAME, nindent);
                        *nindent += ll;
                } else {
                        sprintf(ppcTmpBuff,"class ");
                        ll = strlen(ppcTmpBuff);
                        *nindent = ll;
                        sprintf(ppcTmpBuff+ll,"%s", c->a[ii].s);
                }
        } else if (c->a[ii].symType == TypeInheritedFullMethod) {
                sprintf(ppcTmpBuff,"%s", c->a[ii].s);
                if (c->a[ii].vFunClass!=NULL) {
                        sprintf(vlevelBuff,"  : %s ", c->a[ii].vFunClass->name);
                }
                *nindent = 0;
        } else {
                sprintf(ppcTmpBuff,"%s", c->a[ii].s);
                *nindent = 0;
        }
}
void olCompletionListInit(S_position *originalPos) {
        olcxSetCurrentUser(s_opt.user);
        olcxFreeOldCompletionItems(&s_olcxCurrentUser->completionsStack);
        olcxPushEmptyStackItem(&s_olcxCurrentUser->completionsStack);
        s_olcxCurrentUser->completionsStack.top->cpos = *originalPos;
}
static int completionsWillPrintEllipsis(S_olCompletion *olc) {
        int max, ellipsis;
        { register S_olCompletion *tmp; register int co=0; tmp = olc; while (tmp!=NULL) {++co; tmp = tmp->next; } max = co; };
        ellipsis = 0;
        if (max >= MAX_COMPLETIONS - 2 || max == s_opt.maxCompletions) {
                ellipsis = 1;
        }
        return(ellipsis);
}
void printCompletionsBeginning(S_olCompletion *olc, int noFocus) {
        int max;
        S_olCompletion *cc;
        int tlen;
        { register S_olCompletion *tmp; register int co=0; tmp = olc; while (tmp!=NULL) {++co; tmp = tmp->next; } max = co; };
        if (s_opt.xref2) {
                if (s_opt.editor == ED_JEDIT && ! s_opt.jeditOldCompletions) {
                        ppcGenTwoNumericAndRecordBegin(PPC_FULL_MULTIPLE_COMPLETIONS,
                                                                                   PPCA_NUMBER, max,
                                                                                   PPCA_NO_FOCUS, noFocus);
                } else {
                        tlen = 0;
                        for(cc=olc; cc!=NULL; cc=cc->next) {
                                tlen += strlen(cc->fullName);
                                if (cc->next!=NULL) tlen++;
                        }
                        if (completionsWillPrintEllipsis(olc)) tlen += 4;
                        ppcGenAllCompletionsRecordBegin(noFocus, tlen);
                }
        } else {
                fprintf(ccOut,";");
        }
}
void printOneCompletion(S_olCompletion *olc) {
        if (s_opt.editor == ED_JEDIT && ! s_opt.jeditOldCompletions) {
                fprintf(ccOut,"<%s %s=\"%s\" %s=%d %s=%d>", PPC_MULTIPLE_COMPLETION_LINE,
                                PPCA_VCLASS, olc->vclass,
                                PPCA_VALUE, olc->jindent,
                                PPCA_LEN, strlen(olc->fullName));
                fprintf(ccOut, "%s", olc->fullName);
                fprintf(ccOut, "</%s>\n", PPC_MULTIPLE_COMPLETION_LINE);
        } else {
                fprintf(ccOut, "%s", olc->fullName);
        }
}
void printCompletionsEnding(S_olCompletion *olc) {
        if (completionsWillPrintEllipsis(olc)) {
                if (s_opt.editor == ED_JEDIT && ! s_opt.jeditOldCompletions) {
                } else {
                        fprintf(ccOut,"\n...");
                }
        }
        if (s_opt.xref2) {
                if (s_opt.editor == ED_JEDIT && ! s_opt.jeditOldCompletions) {
                        ppcGenRecordEnd(PPC_FULL_MULTIPLE_COMPLETIONS);
                } else {
                        ppcGenRecordEnd(PPC_ALL_COMPLETIONS);
                }
        }
}
void printCompletionsList(int noFocus) {
        S_olCompletion *cc, *olc;
        olc = s_olcxCurrentUser->completionsStack.top->cpls;
        printCompletionsBeginning(olc, noFocus);
        for(cc=olc; cc!=NULL; cc=cc->next) {
                printOneCompletion(cc);
                if (cc->next!=NULL) fprintf(ccOut,"\n");
        }
        printCompletionsEnding(olc);
}
void printCompletions(S_completions* c) {
        int i, ii, indent, jindent, max, vFunCl, tlen, ellipsis;
        S_olCompletion *olc;
        char *vclass;
        jindent = 0; vclass = NULL;
        olCompletionListInit(&c->idToProcessPos);
        if (c->ai == 0) {
                if (s_opt.xref2) {
                        ppcGenRecordWithNumeric(PPC_BOTTOM_INFORMATION, PPCA_BEEP, 0, "** No completion possible **","\n");
                } else {
                        fprintf(ccOut,"-");
                }
                goto finiWithoutMenu;
        }
        if ((! c->fullMatchFlag) && c->ai==1) {
                if (s_opt.xref2) {
                        ppcGenGotoPositionRecord(&s_olcxCurrentUser->completionsStack.top->cpos);
                        ppcGenRecord(PPC_SINGLE_COMPLETION, c->a[0].s,"\n");
                } else {
                        fprintf(ccOut,".%s", c->comPrefix+c->idToProcessLen);
                }
                goto finiWithoutMenu;
        }
        if ((! c->fullMatchFlag) && strlen(c->comPrefix) > c->idToProcessLen) {
                if (s_opt.xref2) {
                        ppcGenGotoPositionRecord(&s_olcxCurrentUser->completionsStack.top->cpos);
                        ppcGenRecord(PPC_SINGLE_COMPLETION, c->comPrefix,"\n");
                        ppcGenRecordWithNumeric(PPC_BOTTOM_INFORMATION, PPCA_BEEP, 1, "Multiple completions","\n");
                } else {
                        fprintf(ccOut,",%s", c->comPrefix+c->idToProcessLen);
                }
                goto finiWithoutMenu;
        }
        indent = c->maxLen;
        if (s_opt.olineLen - indent < MIN_COMPLETION_INDENT_REST) {
                indent = s_opt.olineLen - MIN_COMPLETION_INDENT_REST;
                if (indent < MIN_COMPLETION_INDENT) indent = MIN_COMPLETION_INDENT;
        }
        if (indent > MAX_COMPLETION_INDENT) indent = MAX_COMPLETION_INDENT;
        if (c->ai > s_opt.maxCompletions) max = s_opt.maxCompletions;
        else max = c->ai;
        for(ii=0; ii<max; ii++) {
                if (s_opt.editor == ED_JEDIT && ! s_opt.jeditOldCompletions) {
                        sprintFullJeditCompletionInfo(c, ii, &jindent, &vclass);
                } else {
                        sprintFullCompletionInfo(c, ii, indent);
                }
                vFunCl = s_noneFileIndex;
                if (((s_language & (4)) != 0) && c->a[ii].vFunClass!=NULL) {
                        vFunCl = c->a[ii].vFunClass->u.s->classFile;
                        if (vFunCl == -1) vFunCl = s_noneFileIndex;
                }
                olc = olCompletionListPrepend(c->a[ii].s, ppcTmpBuff, vclass, jindent, c->a[ii].t,NULL, &s_noRef, c->a[ii].symType, vFunCl, s_olcxCurrentUser->completionsStack.top);
        }
        olCompletionListReverse();
        printCompletionsList(c->noFocusOnCompletions);
        fflush(ccOut);
        return;
 finiWithoutMenu:
        s_olcxCurrentUser->completionsStack.top = s_olcxCurrentUser->completionsStack.top->previous;
        fflush(ccOut);
}
static int isTheSameSymbol(S_cline *c1, S_cline *c2) {
        int r;
        if (strcmp(c1->s, c2->s) != 0) return(0);
        if (c1->symType != c2->symType) return(0);
        if (s_language != 4) return(1);
        if (c1->symType == TypeStruct) {
                if (c1->t!=NULL && c2->t!=NULL) {
                        return(strcmp(c1->t->linkName, c2->t->linkName)==0);
                }
        }
        if (c1->symType != TypeDefault) return(1);
        { if (!(c1->t && c1->t->u.type)) internalCheckFail("c1->t && c1->t->u.type", "complet.c", 522);};
        { if (!(c2->t && c2->t->u.type)) internalCheckFail("c2->t && c2->t->u.type", "complet.c", 523);};
        if (c1->t->u.type->m != c2->t->u.type->m) return(0);
        if (c1->vFunClass != c2->vFunClass) return(0);
        if (c2->t->u.type->m != TypeFunction) return(1);
        { if (!(c1->t->u.type->u.m.sig && c2->t->u.type->u.m.sig)) internalCheckFail("c1->t->u.type->u.m.sig && c2->t->u.type->u.m.sig", "complet.c", 529);};
        if (strcmp(c1->t->u.type->u.m.sig,c2->t->u.type->u.m.sig)) return(0);
        return(1);
}
static int symbolIsInTab(S_cline *a, int ai, int *ii, char *s, S_cline *t) {
        int i,j;
        for(i= *ii-1; i>=0 && strcmp(a[i].s,s)==0; i--) ;
        for(j= *ii+1; j<ai && strcmp(a[j].s,s)==0; j++) ;
        for (i++; i<j; i++) if (isTheSameSymbol(&a[i],t)) return(1);
        return(0);
}
static int compareCompletionClassName(S_cline *c1, S_cline *c2) {
        char n1[TMP_STRING_SIZE];
        int c;
        char *n2;
        strcpy(n1, getCompletionClassFieldString(c1));
        n2 = getCompletionClassFieldString(c2);
        c = strcmp(n1, n2);
        if (c<0) return(-1);
        if (c>0) return(1);
        return(0);
}
static int completionOrderCmp(S_cline *c1, S_cline *c2) {
        int c, l1, l2;
        char *s1, *s2;
        if (! ((s_language & (4)) != 0)) {
                s1 = strchr(c1->s, '(');
                if (s1 == NULL) l1 = strlen(c1->s);
                else l1 = s1 - c1->s;
                s2 = strchr(c2->s, '(');
                if (s2 == NULL) l2 = strlen(c2->s);
                else l2 = s2 - c2->s;
                if (l1 == s_completions.idToProcessLen && l2 != s_completions.idToProcessLen) return(-1);
                if (l1 != s_completions.idToProcessLen && l2 == s_completions.idToProcessLen) return(1);
                return(strcmp(c1->s, c2->s));
        } else {
                if (c1->symType==TypeKeyword && c2->symType!=TypeKeyword) return(1);
                if (c1->symType!=TypeKeyword && c2->symType==TypeKeyword) return(-1);
                if (c1->symType==TypeNonImportedClass && c2->symType!=TypeNonImportedClass) return(1);
                if (c1->symType!=TypeNonImportedClass && c2->symType==TypeNonImportedClass) return(-1);
                if (c1->symType!=TypeInheritedFullMethod && c2->symType==TypeInheritedFullMethod) return(1);
                if (c1->symType==TypeInheritedFullMethod && c2->symType!=TypeInheritedFullMethod) return(-1);
                if (c1->symType==TypeInheritedFullMethod && c2->symType==TypeInheritedFullMethod) {
                        if (c1->t == NULL) return(1);
                        if (c2->t == NULL) return(-1);
                        c = compareCompletionClassName(c1, c2);
                        if (c!=0) return(c);
                }
                if (c1->symType!=TypeDefault && c2->symType==TypeDefault) return(1);
                if (c1->symType==TypeDefault && c2->symType!=TypeDefault) return(-1);
                l1 = strlen(c1->s);
                l2 = strlen(c2->s);
                if (l1 == s_completions.idToProcessLen && l2 != s_completions.idToProcessLen) return(-1);
                if (l1 != s_completions.idToProcessLen && l2 == s_completions.idToProcessLen) return(1);
                if (c1->symType==TypeDefault && c2->symType==TypeDefault) {
                        c = c1->virtLevel - c2->virtLevel;
                        if (c<0) return(-1);
                        if (c>0) return(1);
                        c = compareCompletionClassName(c1, c2);
                        if (c!=0) return(c);
                        if (c1->t!=NULL && c2->t!=NULL) {
                                if (c1->t->b.storage==StorageField && c2->t->b.storage==StorageMethod) return(-1);
                                if (c1->t->b.storage==StorageMethod && c2->t->b.storage==StorageField) return(1);
                        }
                }
                if (c1->symType==TypeNonImportedClass && c2->symType==TypeNonImportedClass) {
                        s1 = lastOccurenceInString(c1->s, '.');
                        if (s1 == NULL) s1 = c1->s;
                        s2 = lastOccurenceInString(c2->s, '.');
                        if (s2 == NULL) s2 = c2->s;
                        return(strcmp(s1, s2));
                }
                return(strcmp(c1->s, c2->s));
        }
}
static int realyInsert( S_cline *a,
                                                int *aip,
                                                char *s,
                                                S_cline *t,
                                                int orderFlag
        ) {
        int ai;
        int l,r,x,c,i,tmp;
        ai = *aip;
        l = 0; r = ai-1;
        { if (!(t->s == s)) internalCheckFail("t->s == s", "complet.c", 627);};
        if (orderFlag) {
                while (l<=r) {
                        x = (l+r)/2;
                        c = completionOrderCmp(t, &a[x]);
                        if (c==0) {
                                if (s_language != 4) return(0);
                                if (symbolIsInTab(a, ai, &x, s, t)) return(0);
                                r = x; l = x + 1;
                                break;
                        }
                        if (c<0) r=x-1; else l=x+1;
                }
                { if (!(l==r+1)) internalCheckFail("l==r+1", "complet.c", 642);};
        } else {
                for(l=0; l<ai; l++) {
                        if (isTheSameSymbol(t, &a[l])) return(0);
                }
        }
        if (orderFlag) {
                memmove(a+l+1, a+l, sizeof(S_cline)*(ai-l));
        } else {
                l = ai;
        }
        a[l] = *t;
        a[l].s = s;
        if (ai < MAX_COMPLETIONS-2) ai++;
        *aip = ai;
        return(1);
}
static void computeComPrefix(char *d, char *s) {
        while (*d == *s ) {
                if (*d == 0) return;
                d++; s++;
        }
        *d = 0;
}
static int completionTestPrefix(S_completions *ci, char *s) {
        char *d;
        d = ci->idToProcess;
        while (*d == *s || (s_opt.completionCaseSensitive==0 && tolower(*d)==tolower(*s))) {
                if (*d == 0) {
                        ci->isCompleteFlag = 1;
                        return(0);
                }
                d++; s++;
        }
        if (*d == 0) return(0);
        return(1);
}
int stringContainsCaseInsensitive(char *s1, char *s2) {
        register char *p,*a,*b;
        for (p=s1; *p; p++) {
                for(a=p,b=s2; tolower(*a)==tolower(*b); a++,b++) ;
                if (*b==0) return(1);
        }
        return(0);
}
static void completionInsertName(char *name, S_cline *compLine, int orderFlag,
                                                                 S_completions *ci) {
        int len,l;
        name = compLine->s;
        len = ci->idToProcessLen;
        if (ci->ai == 0) {
                strcpy(ci->comPrefix, name);
                ci->a[ci->ai] = *compLine;
                ci->a[ci->ai].s = name ;
                ci->ai++;
                ci->maxLen = strlen(name );
                ci->fullMatchFlag = ((len==ci->maxLen)
                                                         || (len==ci->maxLen-1 && name[len]=='(')
                                                         || (len==ci->maxLen-2 && name[len]=='('));
        } else {
                if (realyInsert(ci->a, &ci->ai, name , compLine, orderFlag)) {
                        ci->fullMatchFlag = 0;
                        l = strlen(name );
                        if (l > ci->maxLen) ci->maxLen = l;
                        computeComPrefix( ci->comPrefix, name);
                }
        }
}
void completeName(char *name, S_cline *compLine, int orderFlag,
                                S_completions *ci) {
        int len,l;
        if (name == NULL) return;
        if (completionTestPrefix(ci, name)) return;
        completionInsertName(name, compLine, orderFlag, ci);
}
void searchName(char *name, S_cline *compLine, int orderFlag,
                                S_completions *ci) {
        int len,l;
        if (name == NULL) return;
        if (s_opt.olcxSearchString==NULL || *s_opt.olcxSearchString==0) {
                if (stringContainsCaseInsensitive(name, ci->idToProcess) == 0) return;
        } else {
                if (searchStringFitness(name, strlen(name)) == 0) return;
        }
        name = compLine->s;
        if (ci->ai == 0) {
                ci->fullMatchFlag = 0;
                ci->comPrefix[0]=0;
                ci->a[ci->ai] = *compLine;
                ci->a[ci->ai].s = name;
                ci->ai++;
                ci->maxLen = strlen(name);
        } else {
                if (realyInsert(ci->a, &ci->ai, name, compLine, 1)) {
                        ci->fullMatchFlag = 0;
                        l = strlen(name);
                        if (l > ci->maxLen) ci->maxLen = l;
                }
        }
}
void processName(char *name, S_cline *compLine, int orderFlag, void *c) {
        S_completions *ci;
        ci = (S_completions *) c;
        if (s_opt.cxrefs == OLO_SEARCH) {
                searchName(name, compLine, orderFlag, ci);
        } else {
                completeName(name, compLine, orderFlag, ci);
        }
}
static void completeFun(S_symbol *s, void *c) {
        S_completionSymInfo *cc;
        S_cline compLine;
        cc = (S_completionSymInfo *) c;
        { if (!(s && cc)) internalCheckFail("s && cc", "complet.c", 776);};
        if (s->b.symType != cc->symType) return;
        if (s->b.symType != TypeMacro) {
                { (&compLine)->s = s->name; (&compLine)->t = s; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        } else {
                if (s->u.mbody==NULL) {
                        { (&compLine)->s = s->name; (&compLine)->t = s; (&compLine)->symType = TypeUndefMacro; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                } else {
                        { (&compLine)->s = s->name; (&compLine)->t = s; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = s->u.mbody->argn; (&compLine)->margs = s->u.mbody->args; (&compLine)->vFunClass = NULL;};
                }
        }
        processName(s->name, &compLine, 1, cc->res);
}
static void completeFunctionOrMethodName(S_completions *c, int orderFlag, int vlevel, S_symbol *r, S_symbol *vFunCl) {
        S_cline compLine;
        int cnamelen;
        char *cn, *cname, *psuff, *msig;
        cname = r->name;
        cnamelen = strlen(cname);
        if (s_opt.completeParenthesis == 0) {
                cn = cname;
        } else {
                { if (!(r->u.type!=NULL)) internalCheckFail("r->u.type!=NULL", "complet.c", 810);};
                if (((s_language & (4)) != 0)) {
                        msig = r->u.type->u.m.sig;
                        { if (!(msig!=NULL)) internalCheckFail("msig!=NULL", "complet.c", 813);};
                        if (msig[0]=='(' && msig[1]==')') {
                                psuff = "()";
                        } else {
                                psuff = "(";
                        }
                } else {
                        if (r->u.type!=NULL && r->u.type->u.f.args == NULL) {
                                psuff = "()";
                        } else {
                                psuff = "(";
                        }
                }
                {cn = (char*) stackMemoryAlloc((cnamelen+strlen(psuff)+1)*sizeof(char)); };
                strcpy(cn, cname);
                strcpy(cn+cnamelen, psuff);
        }
        { (&compLine)->s = cn; (&compLine)->t = r; (&compLine)->symType = TypeDefault; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
        processName(cn, &compLine, orderFlag, (void*) c);
}
static void completeSymFun(S_symbol *s, void *c) {
        S_completionSymFunInfo *cc;
        S_cline compLine;
        char *completionName;
        cc = (S_completionSymFunInfo *) c;
        { if (!(s)) internalCheckFail("s", "complet.c", 840);};
        if (s->b.symType != TypeDefault) return;
        { if (!(s)) internalCheckFail("s", "complet.c", 842);};
        if (cc->storage==StorageTypedef && s->b.storage!=StorageTypedef) return;
        completionName = s->name;
        { if (cc->storage!=StorageConstructor && s->b.storage==StorageConstructor) { completionName = NULL; } if (cc->storage==StorageConstructor && s->b.storage!=StorageConstructor) { completionName = NULL; }};
        if (completionName!=NULL) {
                if (s->b.symType == TypeDefault && s->u.type!=NULL && s->u.type->m == TypeFunction) {
                        completeFunctionOrMethodName(cc->res, 1, 0, s, NULL);
                } else {
                        { (&compLine)->s = completionName; (&compLine)->t = s; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                        processName(completionName, &compLine, 1, cc->res);
                }
        }
}
void completeStructs(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
        { (&ii)->res = c; (&ii)->symType = TypeUnion;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
static int javaLinkable(unsigned storage, unsigned accessFlags) {
        if (s_language != 4) return(1);
        if (storage == 0x800) return(1);
        if ((s_opt.ooChecksBits & 00001) == 0) return(1);
        if (storage & 0x008) return((accessFlags & 0x008) != 0);
        return(1);
}
static void processSpecialInheritedFullCompletion( S_completions *c, int orderFlag, int vlevel, S_symbol *r, S_symbol *vFunCl, char *cname) {
        int size, ll;
        char *fcc;
        char tt[MAX_CX_SYMBOL_SIZE];
        S_cline compLine;
        tt[0]=0; ll=0; size=MAX_CX_SYMBOL_SIZE;
        if (((s_language & (4)) != 0)) {
                ll+=printJavaModifiers(tt+ll, &size, r->b.accessFlags);
        }
        typeSPrint(tt+ll, &size, r->u.type, cname, ' ', 0, 1,SHORT_NAME, NULL);
        {fcc = (char*) stackMemoryAlloc((strlen(tt)+1)*sizeof(char)); };
        strcpy(fcc,tt);
        { (&compLine)->s = fcc; (&compLine)->t = r; (&compLine)->symType = TypeInheritedFullMethod; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
        processName(fcc, &compLine, orderFlag, (void*) c);
}
static int getAccCheckOption() {
        int accCheck;
        if (s_opt.ooChecksBits & 00002) {
                accCheck = ACC_CHECK_YES;
        } else {
                accCheck = ACC_CHECK_NO;
        }
        return(accCheck);
}
static void completeRecordsNames(
                                                        S_completions *c,
                                                        S_symbol *s,
                                                        unsigned accessMod,
                                                        int classification,
                                                        int constructorOpt,
                                                        int completionType,
                                                        int vlevelOffset
                                                        ) {
        S_cline compLine;
        int orderFlag,rr,vlevel, accCheck, visibCheck, cnamelen;
        S_symbol *r, *vFunCl;
        S_recFindStr rfs;
        char *cname, *cn, *fcc, *psuff, *msig;
        if (s==NULL) return;
        if ((* c->idToProcess == 0 && s_language!=4)) {
                orderFlag = 0;
        } else {
                orderFlag = 1;
        }
        { if (!(s->u.s)) internalCheckFail("s->u.s", "complet.c", 923);};
        iniFind(s, &rfs);
        for(;;) {
                visibCheck = VISIB_CHECK_NO;
                accCheck = getAccCheckOption();
                rr = findStrRecordSym(&rfs, NULL, &r, classification, accCheck, visibCheck);
                if (rr != 0) break;
                if (constructorOpt==StorageConstructor && rfs.currClass!=s) break;
                { if (!(r)) internalCheckFail("r", "complet.c", 940);};
                cname = r->name;
                { if (constructorOpt!=StorageConstructor && r->b.storage==StorageConstructor) { cname = NULL; } if (constructorOpt==StorageConstructor && r->b.storage!=StorageConstructor) { cname = NULL; }};
                if ( cname!=NULL
                                && *cname != 0
                                && r->b.symType != TypeError
                                && (! symbolNameShouldBeHiddenFromReports(r->linkName))
                                && javaLinkable(accessMod,r->b.accessFlags)) {
                        { if (!(rfs.currClass && rfs.currClass->u.s)) internalCheckFail("rfs.currClass && rfs.currClass->u.s", "complet.c", 953);};
                        { if (!(r->b.symType == TypeDefault)) internalCheckFail("r->b.symType == TypeDefault", "complet.c", 954);};
                        vFunCl = rfs.currClass;
                        if (vFunCl->u.s->classFile == -1) {
                                vFunCl = NULL;
                        }
                        vlevel = rfs.sti + vlevelOffset;
                        if (completionType == TypeInheritedFullMethod) {
                                if (vlevel > 1
                                        && vlevel <= s_opt.completionOverloadWizardDeep+1
                                        && (r->b.accessFlags & 0x002)==0
                                        && (r->b.accessFlags & 0x008)==0) {
                                        processSpecialInheritedFullCompletion(c,orderFlag,vlevel,
                                                                                                                  r, vFunCl, cname);
                                }
                                c->comPrefix[0]=0;
                        } else if (completionType == TypeSpecialConstructorCompletion) {
                                { (&compLine)->s = c->idToProcess; (&compLine)->t = r; (&compLine)->symType = TypeDefault; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
                                completionInsertName(c->idToProcess, &compLine, orderFlag, (void*) c);
                        } else if (s_opt.completeParenthesis
                                           && (r->b.storage==StorageMethod || r->b.storage==StorageConstructor)) {
                                completeFunctionOrMethodName(c, orderFlag, vlevel, r, vFunCl);
                        } else {
                                { (&compLine)->s = cname; (&compLine)->t = r; (&compLine)->symType = TypeDefault; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
                                processName(cname, &compLine, orderFlag, (void*) c);
                        }
                }
        }
        if ((* c->idToProcess == 0 && s_language!=4)) c->comPrefix[0] = 0;
}
void completeRecNames(S_completions *c) {
    S_typeModifiers *str;
        S_symbol *s;
        { if (!(s_structRecordCompletionType)) internalCheckFail("s_structRecordCompletionType", "complet.c", 991);};
        str = s_structRecordCompletionType;
        if (str->m == TypeStruct || str->m == TypeUnion) {
                s = str->u.t;
                { if (!(s)) internalCheckFail("s", "complet.c", 995);};
                completeRecordsNames(c, s, 0x000,CLASS_TO_ANY,
                                                         StorageDefault,TypeDefault,0);
        }
        s_structRecordCompletionType = &s_errorModifier;
}
static void completeFromSymTab( S_completions*c,
                                                                unsigned storage
                                                          ){
        S_completionSymFunInfo ii;
        S_javaStat *cs;
        int vlevelOffset;
        { (&ii)->res = c; (&ii)->storage = storage;};
        if (s_language == 4) {
                vlevelOffset = 0;
                for(cs=s_javaStat; cs!=NULL && cs->thisClass!=NULL ;cs=cs->next) {
                        symTabMap2(cs->locals, completeSymFun, (void*) &ii);
                        completeRecordsNames(c, cs->thisClass, s_javaStat->cpMethodMods,
                                                                 CLASS_TO_ANY,
                                                                storage,TypeDefault,vlevelOffset);
                        vlevelOffset += 1000;
                }
        } else {
                symTabMap2(s_symTab, completeSymFun, (void*) &ii);
        }
}
void completeEnums(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeEnum;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void completeLabels(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeLabel;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void completeMacros(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeMacro;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void completeTypes(S_completions* c) {
        completeFromSymTab(c, StorageTypedef);
}
void completeOthers(S_completions *c) {
        completeFromSymTab(c, StorageDefault);
        completeMacros(c);
}
static S_symbol * getSymFromRef(S_reference *rr) {
        int i;
        S_symbolRefItem *ss;
        S_reference *r;
        S_symbol *sym;
        r = NULL; ss = NULL;
        for(i=0; i<s_cxrefTab.size; i++) {
                ss = s_cxrefTab.tab[i];
                if (ss!=NULL) {
                        for(r=ss->refs; r!=NULL; r=r->next) {
                                if (rr == r) goto cont;
                        }
                }
        }
 cont:
        if (i>=s_cxrefTab.size) return(NULL);
        { if (!(r==rr)) internalCheckFail("r==rr", "complet.c", 1068);};
        for(i=0; i<s_symTab->size; i++) {
                for(sym=s_symTab->tab[i]; sym!=NULL; sym=sym->next) {
                        if (strcmp(sym->linkName,ss->name)==0) return(sym);
                }
        }
        return(NULL);
}
static int isEqualType(S_typeModifiers *t1, S_typeModifiers *t2) {
        S_typeModifiers *s1,*s2;
        S_symbol *ss1,*ss2;
        { if (!(t1 && t2)) internalCheckFail("t1 && t2", "complet.c", 1081);};
        for(s1=t1,s2=t2; s1->next!=NULL&&s2->next!=NULL; s1=s1->next,s2=s2->next) {
                if (s1->m!=s2->m) return(0);
        }
        if (s1->next!=NULL || s2->next!=NULL) return(0);
        if (s1->m != s2->m) return(0);
        if (s1->m==TypeStruct || s1->m==TypeUnion || s1->m==TypeEnum) {
                if (s1->u.t != s2->u.t) return(0);
        } else if (s1->m==TypeFunction) {
                if (((s_language & (4)) != 0)) {
                        if (strcmp(s1->u.m.sig,s2->u.m.sig)!=0) return(0);
                } else {
                        for(ss1=s1->u.f.args, ss2=s2->u.f.args;
                                ss1!=NULL&&ss2!=NULL;
                                ss1=ss1->next, ss2=ss2->next) {
                                if (! isEqualType(ss1->u.type, ss2->u.type)) return(0);
                        }
                        if (ss1!=NULL||ss2!=NULL) return(0);
                }
        }
        return(1);
}
static char *spComplFindNextRecord(S_exprTokenType *tok) {
        S_recFindStr rfs;
        int rr;
        S_symbol *r,*s;
        char *cname,*res;
        static char *cnext="next";
        static char *cprevious="previous";
        s = tok->t->next->u.t;
        res = NULL;
        { if (!(s->u.s)) internalCheckFail("s->u.s", "complet.c", 1113);};
        iniFind(s, &rfs);
        for(;;) {
                rr = findStrRecordSym(&rfs, NULL, &r, CLASS_TO_ANY, ACC_CHECK_YES, VISIB_CHECK_YES);
                if (rr != 0) break;
                { if (!(r)) internalCheckFail("r", "complet.c", 1118);};
                cname = r->name;
                { if (StorageDefault!=StorageConstructor && r->b.storage==StorageConstructor) { cname = NULL; } if (StorageDefault==StorageConstructor && r->b.storage!=StorageConstructor) { cname = NULL; }};
                if ( cname!=NULL &&
                                javaLinkable(0x800,r->b.accessFlags)) {
                        { if (!(rfs.currClass && rfs.currClass->u.s)) internalCheckFail("rfs.currClass && rfs.currClass->u.s", "complet.c", 1123);};
                        { if (!(r->b.symType == TypeDefault)) internalCheckFail("r->b.symType == TypeDefault", "complet.c", 1124);};
                        if (isEqualType(r->u.type, tok->t)) {
                                if (res == NULL) res = cname;
                                else if (strcmp(cname,cnext)==0) res = cnext;
                                else if (res!=cnext&&strcmp(cname,"previous")==0)res=cprevious;
                        }
                }
        }
        return(res);
}
static int isForCompletionSymbol(S_completions *c,
                                                                 S_exprTokenType *tok,
                                                                 S_symbol **sym,
                                                                 char **nextRecord
        ) {
        S_symbol *ss,*sy;
        char *rec;
        if (s_opt.cxrefs != OLO_COMPLETION) return(0);
        if (tok->t==NULL) return(0);
        if (c->idToProcessLen != 0) return(0);
        if (tok->t->m == TypePointer) {
                { if (!(tok->t->next)) internalCheckFail("tok->t->next", "complet.c", 1147);};
                if (tok->t->next->m == TypeStruct) {
                        *sym = sy = getSymFromRef(tok->r);
                        if (sy==NULL) return(0);
                        *nextRecord = spComplFindNextRecord(tok);
                        return(1);
                }
        }
        return(0);
}
void completeForSpecial1(S_completions* c) {
        static char ss[TMP_STRING_SIZE];
        char *rec;
        S_cline compLine;
        S_symbol *sym;
        if (isForCompletionSymbol(c,&s_forCompletionType,&sym,&rec)) {
                sprintf(ss,"%s!=NULL; ", sym->name);
                { (&compLine)->s = ss; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                completeName(ss, &compLine, 0, c);
        }
}
void completeForSpecial2(S_completions* c) {
        static char ss[TMP_STRING_SIZE];
        char *rec;
        S_cline compLine;
        S_symbol *sym;
        if (isForCompletionSymbol(c, &s_forCompletionType,&sym,&rec)) {
                if (rec!=NULL) {
                        sprintf(ss,"%s=%s->%s) {", sym->name, sym->name, rec);
                        { (&compLine)->s = ss; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                        completeName(ss, &compLine, 0, c);
                }
        }
}
void completeUpFunProfile(S_completions* c) {
        S_symbol *dd;
        if (s_upLevelFunctionCompletionType!=NULL
                && c->idToProcess[0] == 0
                && c->ai==0
                ) {
                {dd = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
                { (&dd->b)->record = 0; (&dd->b)->isSingleImported = 0; (&dd->b)->accessFlags = 0; (&dd->b)->javaSourceLoaded = 0; (&dd->b)->javaFileLoaded = 0; (&dd->b)->symType = TypeDefault; (&dd->b)->storage = StorageDefault; (&dd->b)->npointers = 0;};
                { (dd)->name = "    "; (dd)->linkName = "    "; (dd)->pos = s_noPos; (dd)->b = dd->b; (dd)->u.type = s_upLevelFunctionCompletionType; (dd)->next = NULL;};
                { (&c->a[0])->s = "    "; (&c->a[0])->t = dd; (&c->a[0])->symType = TypeDefault; (&c->a[0])->virtLevel = 0; (&c->a[0])->margn = 0; (&c->a[0])->margs = NULL; (&c->a[0])->vFunClass = NULL;};
                c->fullMatchFlag = 1;
                c->comPrefix[0]=0;
                c->ai++;
        }
}
static S_symbol * javaGetFileNameClass(char *fname) {
        char *pp;
        S_symbol *res;
        pp = javaCutClassPathFromFileName(fname);
        res = javaGetFieldClass(pp,NULL);
        return(res);
}
static void completeConstructorsFromFile(S_completions *c, char *fname) {
        S_symbol *memb;
        memb = javaGetFileNameClass(fname);
        if (strcmp(memb->name, c->idToProcess)==0) {
                javaLoadClassSymbolsFromFile(memb);
                completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,TypeDefault,0);
        }
}
static void completeJavaConstructors(S_symbol *s, void *c) {
        if (s->b.symType != TypeStruct) return;
        completeConstructorsFromFile((S_completions *)c, s->linkName);
}
static void javaPackageNameCompletion(
                                                                        char *fname,
                                                                        char *path,
                                                                        char *pack,
                                                                        S_completions *c,
                                                                        void *idp,
                                                                        int *pstorage
                                                                ) {
        S_cline compLine;
        char *cname;
        struct stat stt;
        S_idIdentList *id;
        id = (S_idIdentList *) idp;
        if (strchr(fname,'.')!=NULL) return;
        {cname = (char*) stackMemoryAlloc((strlen(fname)+1)*sizeof(char)); };
        strcpy(cname, fname);
        { (&compLine)->s = cname; (&compLine)->t = NULL; (&compLine)->symType = TypePackage; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(cname, &compLine, 1, (void*) c);
}
static void javaTypeNameCompletion(
                                                                        char *fname,
                                                                        char *path,
                                                                        char *pack,
                                                                        S_completions *c,
                                                                        void *idp,
                                                                        int *pstorage
                                                                ) {
        char cfname[MAX_FILE_NAME_SIZE];
        S_cline compLine;
        char *cname,*suff;
        struct stat stt;
        S_idIdentList ttl,*id;
        int len,storage,complType;
        S_symbol *memb;
        memb = NULL;
        id = (S_idIdentList *) idp;
        if (pstorage == NULL) storage = StorageDefault;
        else storage = *pstorage;
        len = strlen(fname);
        complType = TypePackage;
        if (strchr(fname,'.') != NULL) {
                if (strchr(fname,'$') != NULL) return;
                suff = strchr(fname,'.');
                if (suff == NULL) return;
                if (strcmp(suff,".java")==0) len -= 5;
                else if (strcmp(suff,".class")==0) len -= 6;
                else return;
                complType = TypeStruct;
                sprintf(cfname,"%s/%s", pack, fname);
                { if (!(strlen(cfname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(cfname)+1 < MAX_FILE_NAME_SIZE", "complet.c", 1291);};
                memb = javaGetFieldClass(cfname,NULL);
                if (storage == StorageConstructor) {
                        sprintf(cfname,"%s/%s/%s", path, pack, fname);
                        { if (!(strlen(cfname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(cfname)+1 < MAX_FILE_NAME_SIZE", "complet.c", 1295);};
                        memb = javaGetFileNameClass(cfname);
                        completeConstructorsFromFile(c, cfname);
                }
        }
        {cname = (char*) stackMemoryAlloc((len+1)*sizeof(char)); };
        strncpy(cname, fname, len);
        cname[len]=0;
        { (&compLine)->s = cname; (&compLine)->t = memb; (&compLine)->symType = complType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(cname, &compLine, 1, (void*) c);
}
static void javaCompleteNestedClasses( S_completions *c,
                                                                                S_symbol *cclas,
                                                                                int storage
                                                                                ) {
        S_cline compLine;
        int i;
        S_symbol *memb;
        S_symbol *str;
        str = cclas;
        for(str=cclas;
                str!=NULL && str->u.s->super!=NULL;
                str=str->u.s->super->d) {
                { if (!(str && str->u.s)) internalCheckFail("str && str->u.s", "complet.c", 1320);};
                for(i=0; i<str->u.s->nnested; i++) {
                        if (str->u.s->nest[i].membFlag) {
                                memb = str->u.s->nest[i].cl;
                                { if (!(memb)) internalCheckFail("memb", "complet.c", 1324);};
                                memb->b.accessFlags |= str->u.s->nest[i].accFlags;
                                { (&compLine)->s = memb->name; (&compLine)->t = memb; (&compLine)->symType = TypeStruct; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                                processName(memb->name, &compLine, 1, (void*) c);
                                if (storage == StorageConstructor) {
                                        javaLoadClassSymbolsFromFile(memb);
                                        completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,TypeDefault,0);
                                }
                        }
                }
        }
}
static void javaCompleteNestedClSingleName(S_completions *cc) {
        S_cline compLine;
        S_javaStat *cs;
        S_symbol *nest,*mc;
        int i;
        for(cs=s_javaStat; cs!=NULL && cs->thisClass!=NULL; cs=cs->next) {
                javaCompleteNestedClasses(cc, cs->thisClass, StorageDefault);
        }
}
static void javaCompleteComposedName(
                                                                S_completions*c,
                                                                int classif,
                                                                int storage,
                                                                int innerConstruct
                                                                ) {
        S_symbol *str;
        S_typeModifiers *expr;
        int i,nameType;
        char *p,*lp,*fullName;
        char packName[MAX_FILE_NAME_SIZE];
        unsigned accs;
        S_reference *orr;
        nameType = javaClassifyAmbiguousName(s_javaStat->lastParsedName,NULL,&str,
                                                                                 &expr,&orr,NULL, USELESS_FQT_REFS_ALLOWED,classif,UsageUsed);
        if (innerConstruct && nameType != TypeExpression) return;
        if (nameType == TypeExpression) {
                if (expr->m == TypeArray) expr = &s_javaArrayObjectSymbol.u.s->stype;
                if (expr->m != TypeStruct) return;
                str = expr->u.t;
                accs = 0x000;
        } else {
                accs = 0x008;
        }
        if (nameType==TypePackage){
                javaCreateComposedName(NULL,s_javaStat->lastParsedName,'/',NULL,packName,MAX_FILE_NAME_SIZE);
                javaMapDirectoryFiles1(packName, javaTypeNameCompletion,
                                                        c,s_javaStat->lastParsedName, &storage);
        }
        if (nameType==TypeStruct || innerConstruct){
                javaLoadClassSymbolsFromFile(str);
                javaCompleteNestedClasses(c, str, storage);
        }
        if (classif==CLASS_TO_EXPR && str!=NULL && storage!=StorageConstructor
                        && (nameType==TypeStruct || nameType==TypeExpression)) {
                javaLoadClassSymbolsFromFile(str);
                completeRecordsNames(c, str, accs,CLASS_TO_ANY, storage,TypeDefault,0);
        }
}
void javaHintCompleteMethodParameters(S_completions *c) {
        S_cline compLine;
        S_symbol *r, *vFunCl;
        S_recFindStr *rfs;
        S_typeModifiersList *aaa;
        int visibCheck, accCheck, vlevel, rr, actArgi;
        char *mname, *mess;
        char actArg[MAX_PROFILE_SIZE];
        if (c->idToProcessLen != 0) return;
        if (s_cp.erfsForParamsComplet==NULL) return;
        r = s_cp.erfsForParamsComplet->memb;
        rfs = &s_cp.erfsForParamsComplet->s;
        mname = r->name;
        visibCheck = VISIB_CHECK_NO;
        accCheck = getAccCheckOption();
        *actArg = 0; actArgi = 0;
        for(aaa=s_cp.erfsForParamsComplet->params; aaa!=NULL; aaa=aaa->next) {
                actArgi += javaTypeToString(aaa->d,actArg+actArgi,MAX_PROFILE_SIZE-actArgi);
        }
        do {
                { if (!(r != NULL)) internalCheckFail("r != NULL", "complet.c", 1417);};
                if (*actArg==0 || javaMethodApplicability(r,actArg)==PROFILE_PARTIALLY_APPLICABLE){
                        vFunCl = rfs->currClass;
                        if (vFunCl->u.s->classFile == -1) {
                                vFunCl = NULL;
                        }
                        vlevel = rfs->sti;
                        { (&compLine)->s = r->name; (&compLine)->t = r; (&compLine)->symType = TypeDefault; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
                        processName(r->name, &compLine, 0, (void*) c);
                }
                rr = findStrRecordSym(rfs, mname, &r, CLASS_TO_METHOD, accCheck, visibCheck);
        } while (rr == 0);
        if (c->ai != 0) {
                c->comPrefix[0]=0;
                c->fullMatchFlag = 1;
                c->noFocusOnCompletions = 1;
        }
        if (s_opt.cxrefs != OLO_SEARCH) s_completions.abortFurtherCompletions = 1;
}
void javaCompletePackageSingleName(S_completions*c) {
        javaMapDirectoryFiles2(NULL, javaPackageNameCompletion, c, NULL, NULL);
}
void javaCompleteThisPackageName(S_completions *c) {
        S_cline compLine;
        static char cname[TMP_STRING_SIZE];
        char *cc, *ss, *dd;
        if (c->idToProcessLen != 0) return;
        ss = javaCutSourcePathFromFileName(getRealFileNameStatic(s_fileTab.tab[s_olOriginalFileNumber]->name));
        strcpy(cname, ss);
        dd = lastOccurenceInString(cname, '.');
        if (dd!=NULL) *dd=0;
        javaDotifyFileName(cname);
        cc = lastOccurenceInString(cname, '.');
        if (cc==NULL) return;
        *cc++ = ';'; *cc = 0;
        { (&compLine)->s = cname; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        completeName(cname, &compLine, 0, c);
}
static void javaCompleteThisClassDefinitionName(S_completions*c) {
        S_cline compLine;
        static char cname[TMP_STRING_SIZE];
        char *cc;
        javaGetClassNameFromFileNum(s_olOriginalFileNumber, cname, DOTIFY_NAME);
        cc = strchr(cname,0);
        { if (!(cc!=NULL)) internalCheckFail("cc!=NULL", "complet.c", 1466);};
        *cc++ = ' '; *cc=0;
        cc = lastOccurenceInString(cname, '.');
        if (cc==NULL) return;
        cc++;
        { (&compLine)->s = cc; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        completeName(cc, &compLine, 0, c);
}
void javaCompleteClassDefinitionNameSpecial(S_completions*c) {
        if (c->idToProcessLen != 0) return;
        javaCompleteThisClassDefinitionName(c);
}
void javaCompleteClassDefinitionName(S_completions*c) {
        S_completionSymInfo ii;
        javaCompleteThisClassDefinitionName(c);
        javaCompleteNestedClSingleName(c);
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void javaCompletePackageCompName(S_completions*c) {
        javaClassifyToPackageNameAndAddRefs(s_javaStat->lastParsedName, UsageUsed);
        javaMapDirectoryFiles2(s_javaStat->lastParsedName,
                        javaPackageNameCompletion, c, s_javaStat->lastParsedName, NULL);
}
void javaCompleteTypeSingleName(S_completions*c) {
        S_completionSymInfo ii;
        javaCompleteNestedClSingleName(c);
        javaMapDirectoryFiles2(NULL, javaTypeNameCompletion, c, NULL, NULL);
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
static void completeFqtFromFileName(char *file, void *cfmpi) {
        char ttt[MAX_FILE_NAME_SIZE];
        char sss[MAX_FILE_NAME_SIZE];
        char *tt,*suff, *sname, *ss;
        S_cline compLine;
        S_completionFqtMapInfo *fmi;
        S_completions *c;
        S_symbol *memb;
        int i;
        fmi = (S_completionFqtMapInfo *) cfmpi;
        c = fmi->res;
        suff = getFileSuffix(file);
        if (fnCmp(suff, ".class")==0 || fnCmp(suff, ".java")==0) {
                sprintf(ttt, "%s", file);
                { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "complet.c", 1518);};
                suff = lastOccurenceInString(ttt, '.');
                { if (!(suff)) internalCheckFail("suff", "complet.c", 1520);};
                *suff = 0;
                sname = lastOccurenceOfSlashOrAntiSlash(ttt);
                if (sname == NULL) sname = ttt;
                else sname ++;
                if (pathncmp(c->idToProcess, sname, c->idToProcessLen, s_opt.completionCaseSensitive)==0
                        || (fmi->completionType == FQT_COMPLETE_ALSO_ON_PACKAGE
                                && pathncmp(c->idToProcess, ttt, c->idToProcessLen, s_opt.completionCaseSensitive)==0)) {
                        memb = javaGetFieldClass(ttt, &sname);
                        linkNamePrettyPrint(sss, ttt, TMP_STRING_SIZE, LONG_NAME);
                        {ss = (char*) stackMemoryAlloc((strlen(sss)+1)*sizeof(char)); };
                        strcpy(ss, sss);
                        sname = lastOccurenceInString(ss,'.');
                        if (sname!=NULL) {
                                sname++;
                                { (&compLine)->s = ss; (&compLine)->t = memb; (&compLine)->symType = TypeNonImportedClass; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                                if (fmi->completionType == FQT_COMPLETE_ALSO_ON_PACKAGE) {
                                        processName(ss, &compLine, 1, c);
                                } else {
                                        processName(sname, &compLine, 1, c);
                                }
                                c->comPrefix[0] = 0;
                                c->fullMatchFlag = 1;
                        }
                }
        }
}
static void completeFqtClassFileFromZipArchiv(char *zip, char *file, void *cfmpi) {
        completeFqtFromFileName(file, cfmpi);
}
static int isItCurrentPackageName(char *fn) {
        int plen;
        if (s_javaThisPackageName!=NULL && s_javaThisPackageName[0]!=0) {
                plen = strlen(s_javaThisPackageName);
                if (fnnCmp(fn, s_javaThisPackageName, plen)==0) return(1);
        }
        return(0);
}
static void completeFqtClassFileFromFileTab(S_fileItem *fi, void *cfmpi) {
        char *fn;
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "complet.c", 1565);};
        if (fi->name[0] == ';') {
                fn = fi->name+1;
                if (! isItCurrentPackageName(fn)) {
                        completeFqtFromFileName(fn, cfmpi);
                }
        }
}
static void comleteRecursivelyFqtNamesFromDirectory(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5) {
        char *fname, *dir, *path;
        char fn[MAX_FILE_NAME_SIZE];
        struct stat st;
        int stt, plen;
        fname = file;
        dir = a1;
        path = a2;
        if (strcmp(fname,".")==0) return;
        if (strcmp(fname,"..")==0) return;
        if (strlen(dir)+strlen(fname) >= MAX_FILE_NAME_SIZE-50) return;
        sprintf(fn,"%s%c%s",dir,SLASH,fname);
        stt = statb(fn, &st);
        if (stt==0 && (st.st_mode & S_IFMT)==S_IFDIR) {
                mapDirectoryFiles(fn, comleteRecursivelyFqtNamesFromDirectory, DO_NOT_ALLOW_EDITOR_FILES,
                                                  fn, path, NULL, a4, NULL);
        } else if (stt==0) {
                { if (!(path!=NULL)) internalCheckFail("path!=NULL", "complet.c", 1594);};
                plen = strlen(path);
                { if (!(fnnCmp(fn, path, plen)==0)) internalCheckFail("fnnCmp(fn, path, plen)==0", "complet.c", 1596);};
                if (fn[plen]!=0 && ! isItCurrentPackageName(fn)) {
                        completeFqtFromFileName(fn+plen+1, a4);
                }
        }
}
static void javaFqtCompletions(S_completions *c, int completionType) {
        S_completionFqtMapInfo cfmi;
        int i;
        S_stringList *pp;
        { (&cfmi)->res = c; (&cfmi)->completionType = completionType;};
        if (s_opt.fqtNameToCompletions == 0) return;
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                fsRecMapOnFiles(s_zipArchivTab[i].dir, s_zipArchivTab[i].fn,
                                                "", completeFqtClassFileFromZipArchiv, &cfmi);
        }
        if (s_opt.fqtNameToCompletions <= 1) return;
        for(i=0; i<s_fileTab.size; i++) {
                if (s_fileTab.tab[i]!=NULL) completeFqtClassFileFromFileTab(s_fileTab.tab[i], &cfmi);
        }
        if (s_opt.fqtNameToCompletions <= 2) return;
        for(pp=s_javaClassPaths; pp!=NULL; pp=pp->next) {
                mapDirectoryFiles(pp->d, comleteRecursivelyFqtNamesFromDirectory,DO_NOT_ALLOW_EDITOR_FILES,
                                                  pp->d,pp->d,NULL,&cfmi,NULL);
        }
        if (s_opt.fqtNameToCompletions <= 3) return;
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "complet.c", 1628);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { mapDirectoryFiles(currentPath, comleteRecursivelyFqtNamesFromDirectory,DO_NOT_ALLOW_EDITOR_FILES, currentPath,currentPath,NULL,&cfmi,NULL); }; currentPath += jmop_ind; currentPath++; }};
}
void javaHintCompleteNonImportedTypes(S_completions*c) {
        javaFqtCompletions(c, DEFAULT_VALUE);
}
void javaHintImportFqt(S_completions*c) {
        javaFqtCompletions(c, FQT_COMPLETE_ALSO_ON_PACKAGE);
}
void javaHintVariableName(S_completions*c) {
        S_cline compLine;
        char ss[TMP_STRING_SIZE];
        char *name, *affect1, *affect2;
        if (! ((s_language & (4)) != 0)) return;
        if (c->idToProcessLen != 0) return;
        if (s_lastReturnedLexem != 440) return;
        sprintf(ss, "%s", uniyylval->bbidIdent.d->name);
        if (ss[0]!=0) ss[0] = tolower(ss[0]);
        {name = (char*) stackMemoryAlloc((strlen(ss)+1)*sizeof(char)); };
        strcpy(name, ss);
        sprintf(ss, "%s = new %s", name, uniyylval->bbidIdent.d->name);
        {affect1 = (char*) stackMemoryAlloc((strlen(ss)+1)*sizeof(char)); };
        strcpy(affect1, ss);
        sprintf(ss, "%s = null;", name);
        {affect2 = (char*) stackMemoryAlloc((strlen(ss)+1)*sizeof(char)); };
        strcpy(affect2, ss);
        { (&compLine)->s = affect1; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(affect1, &compLine, 0, c);
        { (&compLine)->s = affect2; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(affect2, &compLine, 0, c);
        { (&compLine)->s = name; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(name, &compLine, 0, c);
        c->comPrefix[0] = 0;
}
void javaCompleteTypeCompName(S_completions *c) {
        javaCompleteComposedName(c, CLASS_TO_TYPE, StorageDefault,0);
}
void javaCompleteConstructSingleName(S_completions *c) {
        S_completionSymFunInfo ii;
        symTabMap2(s_symTab, completeJavaConstructors, c);
}
void javaCompleteHintForConstructSingleName(S_completions *c) {
        S_cline compLine;
        char *name;
        if (c->idToProcessLen == 0 && s_opt.cxrefs == OLO_COMPLETION) {
                if (s_cps.lastAssignementStruct!=NULL) {
                        name = s_cps.lastAssignementStruct->name;
                        { (&compLine)->s = name; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                        processName(name, &compLine, 0, c); }
        }
}
void javaCompleteConstructCompName(S_completions*c) {
        javaCompleteComposedName(c, CLASS_TO_TYPE, StorageConstructor,0);
}
void javaCompleteConstructNestNameName(S_completions*c) {
        javaCompleteComposedName(c, CLASS_TO_EXPR, StorageConstructor,1);
}
void javaCompleteConstructNestPrimName(S_completions*c) {
        S_symbol *memb;
        if (s_javaCompletionLastPrimary == NULL) return;
        if (s_javaCompletionLastPrimary->m == TypeStruct) {
                memb = s_javaCompletionLastPrimary->u.t;
        } else return;
        { if (!(memb)) internalCheckFail("memb", "complet.c", 1711);};
        javaCompleteNestedClasses(c, memb, StorageConstructor);
}
void javaCompleteExprSingleName(S_completions*c) {
        S_completionSymInfo ii;
        javaMapDirectoryFiles1(NULL, javaTypeNameCompletion, c, NULL, NULL);
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
        completeFromSymTab(c, StorageDefault);
}
void javaCompleteThisConstructor (S_completions *c) {
        S_symbol *memb;
        if (strcmp(c->idToProcess,"this")!=0) return;
        if (s_opt.cxrefs == OLO_SEARCH) return;
        memb = s_javaStat->thisClass;
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,
                                                 TypeSpecialConstructorCompletion,0);
}
void javaCompleteSuperConstructor (S_completions *c) {
        S_symbol *memb;
        if (strcmp(c->idToProcess,"super")!=0) return;
        if (s_opt.cxrefs == OLO_SEARCH) return;
        memb = javaCurrentSuperClass();
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,
                                                 TypeSpecialConstructorCompletion,0);
}
void javaCompleteSuperNestedConstructor (S_completions *c) {
        if (strcmp(c->idToProcess,"super")!=0) return;
}
void javaCompleteExprCompName(S_completions*c) {
        javaCompleteComposedName(c, CLASS_TO_EXPR, StorageDefault,0);
}
void javaCompleteStrRecordPrimary(S_completions*c) {
        S_symbol *memb;
        if (s_javaCompletionLastPrimary == NULL) return;
        if (s_javaCompletionLastPrimary->m == TypeStruct) {
                memb = s_javaCompletionLastPrimary->u.t;
        } else if (s_javaCompletionLastPrimary->m == TypeArray) {
                memb = &s_javaArrayObjectSymbol;
        } else return;
        { if (!(memb)) internalCheckFail("memb", "complet.c", 1760);};
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, 0x000,CLASS_TO_ANY, StorageDefault,TypeDefault,0);
}
void javaCompleteStrRecordSuper(S_completions*c) {
        S_symbol *memb;
        memb = javaCurrentSuperClass();
        if (memb == &s_errorSymbol || memb->b.symType==TypeError) return;
        { if (!(memb)) internalCheckFail("memb", "complet.c", 1770);};
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, s_javaStat->cpMethodMods,CLASS_TO_ANY, StorageDefault,TypeDefault,0);
}
void javaCompleteStrRecordQualifiedSuper(S_completions*c) {
        S_symbol *str;
        S_typeModifiers *expr;
        S_idIdentList *ii;
        S_reference *rr, *lastUselessRef;
        int ttype;
        lastUselessRef = NULL;
        ttype = javaClassifyAmbiguousName(s_javaStat->lastParsedName, NULL,&str,&expr,&rr,
                                                                          &lastUselessRef, USELESS_FQT_REFS_ALLOWED,CLASS_TO_TYPE,UsageUsed);
        if (ttype != TypeStruct) return;
        javaLoadClassSymbolsFromFile(str);
        str = javaGetSuperClass(str);
        if (str == &s_errorSymbol || str->b.symType==TypeError) return;
        { if (!(str)) internalCheckFail("str", "complet.c", 1788);};
        completeRecordsNames(c, str, s_javaStat->cpMethodMods,CLASS_TO_ANY, StorageDefault,TypeDefault,0);
}
void javaCompleteUpMethodSingleName(S_completions*c) {
        S_completionSymFunInfo ii;
        if (s_javaStat!=NULL) {
                completeRecordsNames(c, s_javaStat->thisClass, 0x800,CLASS_TO_ANY,
                                                         StorageDefault,TypeDefault,0);
        }
}
void javaCompleteFullInheritedMethodHeader(S_completions*c) {
        S_completionSymFunInfo ii;
        S_cline compLine;
        char *maindecl;
        if (c->idToProcessLen != 0) return;
        if (s_javaStat!=NULL) {
                completeRecordsNames(c,s_javaStat->thisClass,0x800,CLASS_TO_METHOD,
                                                         StorageDefault,TypeInheritedFullMethod,0);
        }
}
void javaCompleteMethodCompName(S_completions*c) {
        javaCompleteExprCompName(c);
}
static void completeFromXrefFun(S_symbolRefItem *s, void *c) {
        S_completionSymInfo *cc;
        S_cline compLine;
        cc = (S_completionSymInfo *) c;
        { if (!(s && cc)) internalCheckFail("s && cc", "complet.c", 1831);};
        if (s->b.symType != cc->symType) return;
        { (&compLine)->s = s->name; (&compLine)->t = NULL; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(s->name, &compLine, 1, cc->res);
}
void completeYaccLexem(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeYaccSymbol;};
        refTabMap2(&s_cxrefTab, completeFromXrefFun, (void*) &ii);
}
