
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
S_editorMemoryBlock *s_editorMemory[32];
S_editorBufferList *s_staticEditorBufferTabTab[100];
S_editorBufferTab s_editorBufferTab;
void editorBufferTabNAInit(struct editorBufferTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_editorBufferList *)*t->size);
}
void editorBufferTabInit(struct editorBufferTab *t, int size) {
        register int i;
        {t->tab = (S_editorBufferList **) stackMemoryAlloc((size)*sizeof(S_editorBufferList *)); };
        editorBufferTabNAInit(t, size);
}
int editorBufferTabIsMember(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int *position,
                                        S_editorBufferList **original
                        ) {
        unsigned posid;
        S_editorBufferList *pp;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if ((strcmp(pp->f->name,elem->f->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int editorBufferTabNextMember(
                                        S_editorBufferList *elem,
                                        S_editorBufferList **original
                        ) {
        S_editorBufferList *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if ((strcmp(pp->f->name,elem->f->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int editorBufferTabMembEqual(
                                        S_editorBufferList *e1,
                                        S_editorBufferList *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return((strcmp(e1->f->name,e2->f->name)==0));
}
int editorBufferTabDelete(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem
                        ) {
        unsigned posid;
        S_editorBufferList **pp;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((strcmp((*pp)->f->name,elem->f->name)==0)) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int editorBufferTabDeleteExact(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem
                        ) {
        unsigned posid;
        S_editorBufferList **pp;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int editorBufferTabDeleteLast(
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem
                        ) {
        unsigned posid;
        S_editorBufferList **pp, **dd;
        posid = hashFun(elem->f->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((strcmp((*pp)->f->name,elem->f->name)==0)) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void editorBufferTabSet (
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void editorBufferTabSetLast (
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int position
                                ) {
        S_editorBufferList **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void editorBufferTabAdd (
                                        struct editorBufferTab *t,
                                        S_editorBufferList *elem,
                                        int *position
                                ) {
  S_editorBufferList *origin;
  if (! editorBufferTabIsMember(t,elem,position,&origin)) {
        editorBufferTabSet (t,elem,*position);
  }
}
void editorBufferTabFree(struct editorBufferTab *t) {
        { };
}
void editorBufferTabMap(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *)
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void editorBufferTabMap2(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *, void *),
                                        void *a
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void editorBufferTabMap3(
                                        struct editorBufferTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void editorBufferTabMap31(
                                        struct editorBufferTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void editorBufferTabMap32(
                                        struct editorBufferTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void editorBufferTabMap4(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *, int),
                                        int a
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void editorBufferTabMap5(
                                        struct editorBufferTab *t,
                                        void (*fun)(S_editorBufferList *, void *),
                                        void *arg
                                ) {
        int i;
        S_editorBufferList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void editorBufferTabStatistics(
                                        struct editorBufferTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_editorBufferList *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
static void editorApplyCrLfCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*s == '\r') { if (s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = '\n'; } } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyCrLfConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*s == '\r' && s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*s == '\r') { *d++ = '\n'; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyUtf8CrLfCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z <= 223) {s+=1; *d++ = ' ';} else if (z <= 239) {s+=2; *d++ = ' ';} else if (z <= 247) {s+=3; *d++ = ' ';} else if (z <= 251) {s+=4; *d++ = ' ';} else {s+=5; *d++ = ' ';} } else if (*s == '\r') { if (s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = '\n'; } } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyUtf8CrLfConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z <= 223) {s+=1; *d++ = ' ';} else if (z <= 239) {s+=2; *d++ = ' ';} else if (z <= 247) {s+=3; *d++ = ' ';} else if (z <= 251) {s+=4; *d++ = ' ';} else {s+=5; *d++ = ' ';} } else if (*s == '\r' && s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyUtf8CrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z <= 223) {s+=1; *d++ = ' ';} else if (z <= 239) {s+=2; *d++ = ' ';} else if (z <= 247) {s+=3; *d++ = ' ';} else if (z <= 251) {s+=4; *d++ = ' ';} else {s+=5; *d++ = ' ';} } else if (*s == '\r') { *d++ = '\n'; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyUtf8Conversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z <= 223) {s+=1; *d++ = ' ';} else if (z <= 239) {s+=2; *d++ = ' ';} else if (z <= 247) {s+=3; *d++ = ' ';} else if (z <= 251) {s+=4; *d++ = ' ';} else {s+=5; *d++ = ' ';} } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyEucCrLfCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z == 0x8e) {s+=2; *d++ = ' ';} else if (z == 0x8f) {s+=3; *d++ = ' ';} else {s+=1; *d++ = ' ';} } else if (*s == '\r') { if (s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = '\n'; } } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyEucCrLfConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z == 0x8e) {s+=2; *d++ = ' ';} else if (z == 0x8f) {s+=3; *d++ = ' ';} else {s+=1; *d++ = ' ';} } else if (*s == '\r' && s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyEucCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z == 0x8e) {s+=2; *d++ = ' ';} else if (z == 0x8f) {s+=3; *d++ = ' ';} else {s+=1; *d++ = ' ';} } else if (*s == '\r') { *d++ = '\n'; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyEucConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z == 0x8e) {s+=2; *d++ = ' ';} else if (z == 0x8f) {s+=3; *d++ = ' ';} else {s+=1; *d++ = ' ';} } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplySjisCrLfCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z >= 0xa1 && z <= 0xdf) {*d++ = ' ';} else {s+=1; *d++ = ' ';} } else if (*s == '\r') { if (s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = '\n'; } } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplySjisCrLfConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z >= 0xa1 && z <= 0xdf) {*d++ = ' ';} else {s+=1; *d++ = ' ';} } else if (*s == '\r' && s+1<maxs && *(s+1)=='\n') { s++; *d++ = *s; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplySjisCrConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z >= 0xa1 && z <= 0xdf) {*d++ = ' ';} else {s+=1; *d++ = ' ';} } else if (*s == '\r') { *d++ = '\n'; } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplySjisConversion(S_editorBuffer *buff) {
        { register unsigned char *s, *d, *maxs; unsigned char *space; space = (unsigned char *)buff->a.text; maxs = space + buff->a.bufferSize; for(s=d=space; s<maxs; s++) { { if (*(s) & 0x80) { unsigned z; z = *s; if (z >= 0xa1 && z <= 0xdf) {*d++ = ' ';} else {s+=1; *d++ = ' ';} } else { *d++ = *s; } } } buff->a.bufferSize = d - space;};
}
static void editorApplyUtf16Conversion(S_editorBuffer *buff) {
        register unsigned char *s, *d, *maxs;
        register unsigned cb, cb2;
        int little_endian;
        unsigned char *space;
        space = (unsigned char *)buff->a.text;
        maxs = space + buff->a.bufferSize;
        s = space;
        cb = (*s << 8) + *(s+1);
        if (cb == 0xfeff) {
                little_endian = 0;
                s += 2;
        } else if (cb == 0xfffe) {
                little_endian = 1;
                s += 2;
        } else if (s_opt.fileEncoding == MULE_UTF_16LE) {
                little_endian = 1;
        } else if (s_opt.fileEncoding == MULE_UTF_16BE) {
                little_endian = 0;
        } else {
                little_endian = 1;
        }
        for(s++,d=space; s<maxs; s+=2) {
                if (little_endian) cb = (*(s) << 8) + *(s-1);
                else cb = (*(s-1) << 8) + *(s);
                if (cb != 0xfeff) {
                        if (cb >= 0xd800 && cb <= 0xdfff) {
                                s += 2;
                                if (little_endian) cb2 = (*(s) << 8) + *(s-1);
                                else cb2 = (*(s-1) << 8) + *(s);
                                cb = 0x10000 + ((cb & 0x3ff) << 10) + (cb2 & 0x3ff);
                        }
                        if (cb < 0x80) {
                                *d++ = (char)(cb & 0xff);
                        } else {
                                *d++ = ' ';
                        }
                }
        }
        buff->a.bufferSize = d - space;
}
static int editorBufferStartsWithUtf16Bom(S_editorBuffer *buff) {
        register unsigned char *s;
        register unsigned cb;
        s = buff->a.text;
        if (buff->a.bufferSize >= 2) {
                cb = (*s << 8) + *(s+1);
                if (cb == 0xfeff || cb == 0xfffe) return(1);
        }
        return(0);
}
static void editorPerformSimpleLineFeedConversion(S_editorBuffer *buff) {
        if ((s_opt.eolConversion&1)
                && (s_opt.eolConversion & 2)) {
                editorApplyCrLfCrConversion(buff);
        } else if (s_opt.eolConversion & 1) {
                editorApplyCrLfConversion(buff);
        } else if (s_opt.eolConversion & 2) {
                editorApplyCrConversion(buff);
        }
}
static void editorPerformEncodingAdjustemets(S_editorBuffer *buff) {
        if (s_opt.fileEncoding == MULE_EUROPEAN) {
                editorPerformSimpleLineFeedConversion(buff);
        } else if (s_opt.fileEncoding == MULE_EUC) {
                if ((s_opt.eolConversion&1)
                        && (s_opt.eolConversion & 2)) {
                        editorApplyEucCrLfCrConversion(buff);
                } else if (s_opt.eolConversion & 1) {
                        editorApplyEucCrLfConversion(buff);
                } else if (s_opt.eolConversion & 2) {
                        editorApplyEucCrConversion(buff);
                } else {
                        editorApplyEucConversion(buff);
                }
        } else if (s_opt.fileEncoding == MULE_SJIS) {
                if ((s_opt.eolConversion&1)
                        && (s_opt.eolConversion & 2)) {
                        editorApplySjisCrLfCrConversion(buff);
                } else if (s_opt.eolConversion & 1) {
                        editorApplySjisCrLfConversion(buff);
                } else if (s_opt.eolConversion & 2) {
                        editorApplySjisCrConversion(buff);
                } else {
                        editorApplySjisConversion(buff);
                }
        } else {
                if ((s_opt.fileEncoding != MULE_UTF_8 && editorBufferStartsWithUtf16Bom(buff))
                        || s_opt.fileEncoding == MULE_UTF_16
                        || s_opt.fileEncoding == MULE_UTF_16LE
                        || s_opt.fileEncoding == MULE_UTF_16BE
                        ) {
                        editorApplyUtf16Conversion(buff);
                        editorPerformSimpleLineFeedConversion(buff);
                } else {
                        if ((s_opt.eolConversion&1)
                                && (s_opt.eolConversion & 2)) {
                                editorApplyUtf8CrLfCrConversion(buff);
                        } else if (s_opt.eolConversion & 1) {
                                editorApplyUtf8CrLfConversion(buff);
                        } else if (s_opt.eolConversion & 2) {
                                editorApplyUtf8CrConversion(buff);
                        } else {
                                editorApplyUtf8Conversion(buff);
                        }
                }
        }
}
void editorInit() {
        s_editorBufferTab.tab = s_staticEditorBufferTabTab;
        editorBufferTabNAInit(&s_editorBufferTab, 100);
}
int statb(char *path, struct stat *statbuf) {
        int res;
        S_editorBuffer *buff;
        buff = editorGetOpenedBuffer(path);
        if (buff!=NULL) {
                if (statbuf!=NULL) {
                        *statbuf = buff->stat;
                }
                return(0);
        }
        res = stat(path, statbuf);
        return(res);
}
static void editorError(int errCode, char *message) {
        error(errCode, message);
}
int editorMarkerLess(S_editorMarker *m1, S_editorMarker *m2) {
        int c;
        if (m1->buffer < m2->buffer) return(1);
        if (m1->buffer > m2->buffer) return(0);
        if (m1->offset < m2->offset) return(1);
        if (m1->offset > m2->offset) return(0);
        return(0);
}
int editorMarkerLessOrEq(S_editorMarker *m1, S_editorMarker *m2) {
        return(! editorMarkerLess(m2, m1));
}
int editorMarkerGreater(S_editorMarker *m1, S_editorMarker *m2) {
        return(editorMarkerLess(m2, m1));
}
int editorMarkerGreaterOrEq(S_editorMarker *m1, S_editorMarker *m2) {
        return(editorMarkerLessOrEq(m2, m1));
}
int editorMarkerListLess(S_editorMarkerList *l1, S_editorMarkerList *l2) {
        return(editorMarkerLess(l1->d, l2->d));
}
int editorRegionListLess(S_editorRegionList *l1, S_editorRegionList *l2) {
        if (editorMarkerLess(l1->r.b, l2->r.b)) return(1);
        if (editorMarkerLess(l2->r.b, l1->r.b)) return(0);
        if (editorMarkerLess(l1->r.e, l2->r.e)) return(1);
        if (editorMarkerLess(l2->r.e, l1->r.e)) return(0);
        return(0);
}
static void editorAffectMarkerToBuffer(S_editorBuffer *buff, S_editorMarker *marker) {
        marker->buffer = buff;
        marker->next = buff->markers;
        buff->markers = marker;
        marker->previous = NULL;
        if (marker->next!=NULL) marker->next->previous = marker;
}
S_editorMarker *editorCrNewMarker(S_editorBuffer *buff, int offset) {
        S_editorMarker *m;
        { { int n = (1) * sizeof(S_editorMarker); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { m = NULL; } else { m = (S_editorMarker*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (m==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarker); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { m = NULL; } else { m = (S_editorMarker*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (m)->buffer = NULL; (m)->offset = offset; (m)->previous = NULL; (m)->next = NULL;};
        editorAffectMarkerToBuffer(buff, m);
        return(m);
}
S_editorMarker *editorCrNewMarkerForPosition(S_position *pos) {
        S_editorBuffer *buf;
        S_editorMarker *mm;
        if (pos->file==s_noneFileIndex || pos->file<0) {
                error(ERR_INTERNAL, "[editor] creating marker for nonexistant position");
        }
        buf = editorFindFile(s_fileTab.tab[pos->file]->name);
        mm = editorCrNewMarker(buf, 0);
        editorMoveMarkerToLineCol(mm, pos->line, pos->coll);
        return(mm);
}
S_editorMarker *editorDuplicateMarker(S_editorMarker *mm) {
        return(editorCrNewMarker(mm->buffer, mm->offset));
}
static void editorRemoveMarkerFromBufferNoFreeing(S_editorMarker *marker) {
        S_editorMarker **m, *next;
        S_editorBuffer *buff;
        if (marker == NULL) return;
        if (marker->next!=NULL) marker->next->previous = marker->previous;
        if (marker->previous==NULL) {
                marker->buffer->markers = marker->next;
        } else {
                marker->previous->next = marker->next;
        }
}
void editorFreeMarker(S_editorMarker *marker) {
        if (marker == NULL) return;
        editorRemoveMarkerFromBufferNoFreeing(marker);
        { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorMarker); free(marker);};
}
static void editorFreeTextSpace(char *space, int index) {
        S_editorMemoryBlock *sp;
        sp = (S_editorMemoryBlock *) space;
        sp->next = s_editorMemory[index];
        s_editorMemory[index] = sp;
}
static void editorFreeBuffer(S_editorBufferList *ll) {
        S_editorMarker *m, *mm;
        if (ll->f->fileName != ll->f->name) {
                { {}; olcxMemoryAllocatedBytes -= strlen(ll->f->fileName)+1; free(ll->f->fileName);};
        }
        { {}; olcxMemoryAllocatedBytes -= strlen(ll->f->name)+1; free(ll->f->name);};
        for(m=ll->f->markers; m!=NULL;) {
                mm = m->next;
                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorMarker); free(m);};
                m = mm;
        }
        if (ll->f->b.textLoaded) {
                { if (!(ll->f->a.allocatedBlock[ll->f->a.allocatedSize] == 0x3b)) internalCheckFail("ll->f->a.allocatedBlock[ll->f->a.allocatedSize] == 0x3b", "editor.c", 460);};
                editorFreeTextSpace(ll->f->a.allocatedBlock,ll->f->a.allocatedIndex);
        }
        { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorBuffer); free(ll->f);};
        { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorBufferList); free(ll);};
}
static void editorLoadFileIntoBufferText(S_editorBuffer *buff, struct stat *st) {
        register char *s, *d, *maxs;
        char *space, *fname;
        FILE *ff;
        char *bb;
        int n, ss, size;
        fname = buff->fileName;
        space = buff->a.text;
        size = buff->a.bufferSize;
#if defined (__WIN32__) || defined (__OS2__)
        ff = fopen(fname, "r");
#else
        ff = fopen(fname, "r");
#endif
        if (ff == NULL) {
                fatalError(ERR_CANT_OPEN, fname, 65);
        }
        bb = space; ss = size;
        { if (!(bb != NULL)) internalCheckFail("bb != NULL", "editor.c", 486);};
        do {
                n = fread(bb, 1, ss, ff);
                bb = bb + n;
                ss = ss - n;
        } while (n>0);
        fclose(ff);
        if (ss!=0) {
                buff->a.bufferSize -= ss;
                if (ss < 0) {
                        sprintf(tmpBuff,"File %s: readed %d chars of %d", fname, size-ss, size);
                        editorError(ERR_INTERNAL, tmpBuff);
                }
        }
        editorPerformEncodingAdjustemets(buff);
        buff->stat = *st;
        buff->b.textLoaded = 1;
}
static void allocNewEditorBufferTextSpace(S_editorBuffer *ff, int size) {
        int minSize, allocIndex, allocSize;
        char *space;
        minSize = size + 1024 + 16;
        allocIndex = 11; allocSize = 2048;
        for(; allocSize<minSize; ) {
                allocIndex ++;
                allocSize = allocSize << 1;
        }
        space = (char *)s_editorMemory[allocIndex];
        if (space == NULL) {
                space = malloc(allocSize+1);
                if (space == NULL) fatalError(ERR_NO_MEMORY, "global malloc", 65);
                space[allocSize] = 0x3b;
        } else {
                s_editorMemory[allocIndex] = s_editorMemory[allocIndex]->next;
        }
        { (&ff->a)->bufferSize = size; (&ff->a)->text = space+16; (&ff->a)->allocatedFreePrefixSize = 16; (&ff->a)->allocatedBlock = space; (&ff->a)->allocatedIndex = allocIndex; (&ff->a)->allocatedSize = allocSize;};
}
static void fillEmptyEditorBuffer(S_editorBuffer *ff, char *aname, int ftnum,
                                                                  char*afname) {
        { (&ff->b)->textLoaded = 0; (&ff->b)->modified = 0; (&ff->b)->modifiedSinceLastQuasySave = 0;};
        { (&ff->a)->bufferSize = 0; (&ff->a)->text = NULL; (&ff->a)->allocatedFreePrefixSize = 0; (&ff->a)->allocatedBlock = NULL; (&ff->a)->allocatedIndex = 0; (&ff->a)->allocatedSize = 0;};
        { (ff)->name = aname; (ff)->ftnum = ftnum; (ff)->fileName = afname; (ff)->stat = s_noStat; (ff)->markers = NULL; (ff)->a = ff->a; (ff)->b = ff->b;};
}
static S_editorBuffer *editorCrNewBuffer(char *name, char *fileName, struct stat *st) {
        int minSize, allocIndex, allocSize, ii;
        char *space;
        char *aname, *nname, *afname, *nfileName;
        S_editorBuffer *ff;
        S_editorBufferList *ffl;
        int ftnum;
        nname = normalizeFileName(name, s_cwd);
        { { int n = (strlen(nname)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { aname = NULL; } else { aname = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (aname==NULL) { freeOldestOlcx(); { int n = (strlen(nname)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { aname = NULL; } else { aname = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        strcpy(aname, nname);
        nfileName = normalizeFileName(fileName, s_cwd);
        if (strcmp(nfileName, aname)==0) {
                afname = aname;
        } else {
                { { int n = (strlen(nfileName)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { afname = NULL; } else { afname = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (afname==NULL) { freeOldestOlcx(); { int n = (strlen(nfileName)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { afname = NULL; } else { afname = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                strcpy(afname, nfileName);
        }
        { { int n = (1) * sizeof(S_editorBuffer); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ff = NULL; } else { ff = (S_editorBuffer*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ff==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorBuffer); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ff = NULL; } else { ff = (S_editorBuffer*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        fillEmptyEditorBuffer(ff, aname, 0, afname);
        ff->stat = *st;
        { { int n = (1) * sizeof(S_editorBufferList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ffl = NULL; } else { ffl = (S_editorBufferList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ffl==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorBufferList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ffl = NULL; } else { ffl = (S_editorBufferList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (ffl)->f = ff; (ffl)->next = NULL;};
        editorBufferTabAdd(&s_editorBufferTab, ffl, &ii);
        addFileTabItem(aname, &ftnum);
        ff->ftnum = ftnum;
        return(ff);
}
static void editorSetBufferModifiedFlag(S_editorBuffer *buff) {
        buff->b.modified = 1;
        buff->b.modifiedSinceLastQuasySave = 1;
}
S_editorBuffer *editorGetOpenedBuffer(char *name) {
        S_editorBufferBits ddb;
        S_editorBuffer dd;
        S_editorBufferList ddl, *memb;
        int ii;
        fillEmptyEditorBuffer(&dd, name, 0, name);
        { (&ddl)->f = &dd; (&ddl)->next = NULL;};
        if (editorBufferTabIsMember(&s_editorBufferTab, &ddl, &ii, &memb)) {
                return(memb->f);
        }
        return(NULL);
}
S_editorBuffer *editorGetOpenedAndLoadedBuffer(char *name) {
        S_editorBuffer *res;
        res = editorGetOpenedBuffer(name);
        if (res!=NULL && res->b.textLoaded) return(res);
        return(NULL);
}
void editorRenameBuffer(S_editorBuffer *buff, char *nName, S_editorUndo **undo) {
        char newName[MAX_FILE_NAME_SIZE];
        int fti, ii, mem, deleted;
        S_editorBufferBits ddb;
        S_editorBuffer dd, *removed;
        S_editorBufferList ddl, *memb, *memb2;
        S_editorUndo *uu;
        char *oldName;
        strcpy(newName, normalizeFileName(nName, s_cwd));
        fillEmptyEditorBuffer(&dd, buff->name, 0, buff->name);
        { (&ddl)->f = &dd; (&ddl)->next = NULL;};
        mem = editorBufferTabIsMember(&s_editorBufferTab, &ddl, &ii, &memb);
        if (! mem) {
                sprintf(tmpBuff, "Trying to rename non existing buffer %s", buff->name);
                error(ERR_INTERNAL, tmpBuff);
                return;
        }
        { if (!(memb->f == buff)) internalCheckFail("memb->f == buff", "editor.c", 614);};
        deleted = editorBufferTabDeleteExact(&s_editorBufferTab, memb);
        { if (!(deleted)) internalCheckFail("deleted", "editor.c", 616);};
        oldName = buff->name;
        { { int n = (strlen(newName)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { buff->name = NULL; } else { buff->name = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (buff->name==NULL) { freeOldestOlcx(); { int n = (strlen(newName)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { buff->name = NULL; } else { buff->name = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        strcpy(buff->name, newName);
        addFileTabItem(newName, &fti);
        s_fileTab.tab[fti]->b.commandLineEntered = s_fileTab.tab[buff->ftnum]->b.commandLineEntered;
        buff->ftnum = fti;
        { (memb)->f = buff; (memb)->next = NULL;};
        if (editorBufferTabIsMember(&s_editorBufferTab, memb, &ii, &memb2)) {
                editorBufferTabDeleteExact(&s_editorBufferTab, memb2);
                editorFreeBuffer(memb2);
        }
        editorBufferTabAdd(&s_editorBufferTab, memb, &ii);
        if (undo!=NULL) {
                { { int n = (1) * sizeof(S_editorUndo); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu = NULL; } else { uu = (S_editorUndo*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (uu==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorUndo); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu = NULL; } else { uu = (S_editorUndo*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                { (uu)->buffer = buff; (uu)->operation = UNDO_RENAME_BUFFER; { (&((&(uu)->u)->rename))->name = oldName;}; (uu)->next = *undo;};
                *undo = uu;
        }
        editorSetBufferModifiedFlag(buff);
        removed = editorCrNewBuffer(oldName, oldName, &buff->stat);
        allocNewEditorBufferTextSpace(removed, 0);
        removed->b.textLoaded = 1;
        editorSetBufferModifiedFlag(removed);
}
S_editorBuffer *editorOpenBufferNoFileLoad(char *name, char *fileName) {
        S_editorBuffer *res;
        struct stat st;
        res = editorGetOpenedBuffer(name);
        if (res != NULL) {
                return(res);
        }
        stat(fileName, &st);
        res = editorCrNewBuffer(name, fileName, &st);
        return(res);
}
S_editorBuffer *editorFindFile(char *name) {
        int size;
        struct stat st;
        S_editorBuffer *res;
        res = editorGetOpenedAndLoadedBuffer(name);
        if (res==NULL) {
                res = editorGetOpenedBuffer(name);
                if (res == NULL) {
                        if (stat(name, &st)==0 && (st.st_mode & S_IFMT)!=S_IFDIR) {
                                res = editorCrNewBuffer(name, name, &st);
                        }
                }
                if (res != NULL && stat(res->fileName, &st)==0 && (st.st_mode & S_IFMT)!=S_IFDIR) {
                        size = st.st_size;
                        allocNewEditorBufferTextSpace(res, size);
                        editorLoadFileIntoBufferText(res, &st);
                } else {
                        return(NULL);
                }
        }
        return(res);
}
S_editorBuffer *editorFindFileCreate(char *name) {
        S_editorBuffer *res;
        struct stat st;
        res = editorFindFile(name);
        if (res == NULL) {
                st.st_size = 0;
                st.st_mtime = st.st_atime = st.st_ctime = time(NULL);
                st.st_mode = S_IFCHR;
                res = editorCrNewBuffer(name, name, &st);
                { if (!(res!=NULL)) internalCheckFail("res!=NULL", "editor.c", 698);};
                allocNewEditorBufferTextSpace(res, 0);
                res->b.textLoaded = 1;
        }
        return(res);
}
void editorReplaceString(S_editorBuffer *buff, int position, int delsize,
                                                 char *str, int strlength, S_editorUndo **undo) {
        int nsize, oldsize, index, undosize, pattractor;
        char *text, *space, *undotext;
        S_editorBuffer *nb;
        S_editorMarker *m;
        S_editorUndo *uu;
        { if (!(position >=0 && position <= buff->a.bufferSize)) internalCheckFail("position >=0 && position <= buff->a.bufferSize", "editor.c", 712);};
        { if (!(delsize >= 0)) internalCheckFail("delsize >= 0", "editor.c", 713);};
        { if (!(strlength >= 0)) internalCheckFail("strlength >= 0", "editor.c", 714);};
        oldsize = buff->a.bufferSize;
        if (delsize+position > oldsize) {
                delsize = oldsize - position;
                if (s_opt.debug) { if (!(0)) internalCheckFail("0", "editor.c", 720);};
        }
        nsize = oldsize + strlength - delsize;
        if (nsize >= buff->a.allocatedSize - buff->a.allocatedFreePrefixSize) {
                text = buff->a.text;
                space = buff->a.allocatedBlock; index = buff->a.allocatedIndex;
                allocNewEditorBufferTextSpace(buff, nsize);
                memcpy(buff->a.text, text, oldsize);
                buff->a.bufferSize = oldsize;
                editorFreeTextSpace(space, index);
        }
        { if (!(nsize < buff->a.allocatedSize - buff->a.allocatedFreePrefixSize)) internalCheckFail("nsize < buff->a.allocatedSize - buff->a.allocatedFreePrefixSize", "editor.c", 735);};
        if (undo!=NULL) {
                undosize = strlength;
                { if (!(delsize >= 0)) internalCheckFail("delsize >= 0", "editor.c", 739);};
                { { int n = (delsize+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { undotext = NULL; } else { undotext = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (undotext==NULL) { freeOldestOlcx(); { int n = (delsize+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { undotext = NULL; } else { undotext = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                memcpy(undotext, buff->a.text+position, delsize);
                undotext[delsize]=0;
                { { int n = (1) * sizeof(S_editorUndo); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu = NULL; } else { uu = (S_editorUndo*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (uu==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorUndo); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu = NULL; } else { uu = (S_editorUndo*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                { (uu)->buffer = buff; (uu)->operation = UNDO_REPLACE_STRING; { (&((&(uu)->u)->replace))->offset = position; (&((&(uu)->u)->replace))->size = undosize; (&((&(uu)->u)->replace))->strlen = delsize; (&((&(uu)->u)->replace))->str = undotext;}; (uu)->next = *undo;};
                *undo = uu;
        }
        memmove(buff->a.text+position+strlength, buff->a.text+position+delsize,
                        buff->a.bufferSize - position - delsize);
        memcpy(buff->a.text+position, str, strlength);
        buff->a.bufferSize = buff->a.bufferSize - delsize + strlength;
        if (delsize > strlength) {
                if (strlength > 0) pattractor = position + strlength - 1;
                else pattractor = position + strlength;
                for(m=buff->markers; m!=NULL; m=m->next) {
                        if (m->offset >= position + strlength) {
                                if (m->offset < position+delsize) {
                                        m->offset = pattractor;
                                } else {
                                        m->offset = m->offset - delsize + strlength;
                                }
                        }
                }
        } else {
                for(m=buff->markers; m!=NULL; m=m->next) {
                        if (m->offset >= position + delsize) {
                                m->offset = m->offset - delsize + strlength;
                        }
                }
        }
        editorSetBufferModifiedFlag(buff);
}
void editorMoveBlock(S_editorMarker *dest, S_editorMarker *src, int size,
                                         S_editorUndo **undo) {
        S_editorMarker *mmoved, *tmp, **mmm, *mm;
        S_editorBuffer *sb, *db;
        S_editorUndo *uu;
        int off1, off2, offd, undodoffset;
        mmoved = NULL;
        { if (!(size>=0)) internalCheckFail("size>=0", "editor.c", 786);};
        if (dest->buffer == src->buffer
                && dest->offset > src->offset
                && dest->offset < src->offset+size) {
                error(ERR_INTERNAL, "[editor] moving block to its original place");
                return;
        }
        sb = src->buffer;
        db = dest->buffer;
        offd = dest->offset;
        off1 = src->offset;
        off2 = off1+size;
        { if (!(off1 <= off2)) internalCheckFail("off1 <= off2", "editor.c", 799);};
        editorReplaceString(db, offd, 0, sb->a.text+off1, off2-off1, NULL);
        off1 = src->offset;
        off2 = off1+size;
        editorReplaceString(db, offd, off2-off1, sb->a.text+off1, off2-off1, NULL);
        undodoffset = src->offset;
        { if (!(off1 == src->offset)) internalCheckFail("off1 == src->offset", "editor.c", 810);};
        { if (!(off2 == off1+size)) internalCheckFail("off2 == off1+size", "editor.c", 811);};
        mm = sb->markers;
        while (mm!=NULL) {
                tmp = mm->next;
                if (mm->offset>=off1 && mm->offset<off2) {
                        editorRemoveMarkerFromBufferNoFreeing(mm);
                        mm->offset = offd + (mm->offset-off1);
                        editorAffectMarkerToBuffer(db, mm);
                }
                mm = tmp;
        }
        editorReplaceString(sb, off1, off2-off1, sb->a.text+off1, 0, NULL);
        editorSetBufferModifiedFlag(sb);
        editorSetBufferModifiedFlag(db);
        if (undo!=NULL) {
                { { int n = (1) * sizeof(S_editorUndo); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu = NULL; } else { uu = (S_editorUndo*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (uu==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorUndo); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu = NULL; } else { uu = (S_editorUndo*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                { (uu)->buffer = db; (uu)->operation = UNDO_MOVE_BLOCK; { (&((&(uu)->u)->moveBlock))->offset = src->offset; (&((&(uu)->u)->moveBlock))->size = off2-off1; (&((&(uu)->u)->moveBlock))->dbuffer = sb; (&((&(uu)->u)->moveBlock))->doffset = undodoffset;}; (uu)->next = *undo;};
                *undo = uu;
        }
}
void editorDumpBuffer(S_editorBuffer *buff) {
        int i;
        for(i=0; i<buff->a.bufferSize; i++) {
                putc(buff->a.text[i], dumpOut);
        }
}
void editorDumpBuffers() {
        int i;
        S_editorBufferList *ll;
        fprintf(dumpOut,"[editorDumpBuffers] start\n");
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        fprintf(dumpOut,"%d : %s==%s, %d\n", i, ll->f->name, ll->f->fileName,
                                        ll->f->b.textLoaded);
                }
        }
        fprintf(dumpOut,"[editorDumpBuffers] end\n");
}
static void editorQuasySaveBuffer(S_editorBuffer *buff) {
        buff->b.modifiedSinceLastQuasySave = 0;
        buff->stat.st_mtime = time(NULL);
        { if (!(s_fileTab.tab[buff->ftnum])) internalCheckFail("s_fileTab.tab[buff->ftnum]", "editor.c", 860);};
        s_fileTab.tab[buff->ftnum]->lastModif = buff->stat.st_mtime;
}
void editorQuasySaveModifiedBuffers() {
        int i, saving;
        static time_t lastQuazySaveTime = 0;
        time_t timeNull;
        S_editorBufferList *ll;
        saving = 0;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (ll->f->b.modifiedSinceLastQuasySave) {
                                saving = 1;
                                goto cont;
                        }
                }
        }
 cont:
        if (saving) {
                timeNull = time(NULL);
                if (lastQuazySaveTime > timeNull+5) {
                        fatalError(ERR_INTERNAL, "last save in the future, travelling in time?", 65);
                } else if (lastQuazySaveTime >= timeNull) {
                        sleep(1+lastQuazySaveTime-timeNull);
                }
        }
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (ll->f->b.modifiedSinceLastQuasySave) {
                                editorQuasySaveBuffer(ll->f);
                        }
                }
        }
        lastQuazySaveTime = time(NULL);
}
void editorLoadAllOpenedBufferFiles() {
        int i, size;
        S_editorBufferList *ll,*nn;
        struct stat st;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (!ll->f->b.textLoaded) {
                                if (stat(ll->f->fileName, &st)==0) {
                                        size = st.st_size;
                                        allocNewEditorBufferTextSpace(ll->f, size);
                                        editorLoadFileIntoBufferText(ll->f, &st);
                                }
                        }
                }
        }
}
int editorRunWithMarkerUntil(S_editorMarker *m, int (*until)(int), int step) {
        int offset, max;
        char *text;
        { if (!(step==-1 || step==1)) internalCheckFail("step==-1 || step==1", "editor.c", 921);};
        offset = m->offset;
        max = m->buffer->a.bufferSize;
        text = m->buffer->a.text;
        while (offset>=0 && offset<max && (*until)(text[offset])==0) offset += step;
        m->offset = offset;
        if (offset<0) {
                m->offset = 0;
                return(0);
        }
        if (offset>=max) {
                m->offset = max-1;
                return(0);
        }
        return(1);
}
int editorCountLinesBetweenMarkers(S_editorMarker *m1, S_editorMarker *m2) {
        int i, max, count;
        char *text;
        if (m1 == NULL || m2==NULL) return(0);
        { if (!(m1->buffer == m2->buffer)) internalCheckFail("m1->buffer == m2->buffer", "editor.c", 943);};
        { if (!(m1->offset <= m2->offset)) internalCheckFail("m1->offset <= m2->offset", "editor.c", 944);};
        text = m1->buffer->a.text;
        max = m2->offset;
        count = 0;
        for(i=m1->offset; i<max; i++) {
                if (text[i]=='\n') count ++;
        }
        return(count);
}
static int isNewLine(int c) {return(c=='\n');}
int editorMoveMarkerToNewline(S_editorMarker *m, int direction) {
        return(editorRunWithMarkerUntil(m, isNewLine, direction));
}
static int isNonBlank(int c) {return(! isspace(c));}
int editorMoveMarkerToNonBlank(S_editorMarker *m, int direction) {
        return(editorRunWithMarkerUntil(m, isNonBlank, direction));
}
static int isNonBlankOrNewline(int c) {return(c=='\n' || ! isspace(c));}
int editorMoveMarkerToNonBlankOrNewline(S_editorMarker *m, int direction) {
        return(editorRunWithMarkerUntil(m, isNonBlankOrNewline, direction));
}
static int isNotIdentPart(int c) {return((! isalnum(c)) && c!='_' && c!='$');}
int editorMoveMarkerBeyondIdentifier(S_editorMarker *m, int direction) {
        return(editorRunWithMarkerUntil(m, isNotIdentPart, direction));
}
void editorRemoveBlanks(S_editorMarker *mm, int direction, S_editorUndo **undo) {
        int moffset, len;
        moffset = mm->offset;
        if (direction < 0) {
                mm->offset --;
                editorMoveMarkerToNonBlank(mm, -1);
                mm->offset ++;
                editorReplaceString(mm->buffer, mm->offset, moffset - mm->offset, "", 0, undo);
        } else if (direction > 0) {
                editorMoveMarkerToNonBlank(mm, 1);
                editorReplaceString(mm->buffer, moffset, mm->offset - moffset, "", 0, undo);
        } else {
                mm->offset --;
                editorMoveMarkerToNonBlank(mm, -1);
                mm->offset ++;
                moffset = mm->offset;
                editorMoveMarkerToNonBlank(mm, 1);
                editorReplaceString(mm->buffer, moffset, mm->offset - moffset, "", 0, undo);
        }
}
void editorMoveMarkerToLineCol(S_editorMarker *m, int line, int col) {
        register char *s, *smax;
        register int ln;
        S_editorBuffer *buff;
        int c;
        { if (!(m)) internalCheckFail("m", "editor.c", 1001);};
        buff = m->buffer;
        s = buff->a.text;
        smax = s + buff->a.bufferSize;
        ln = 1;
        if (line > 1) {
                for(; s<smax; s++) {
                        if (*s == '\n') {
                                ln ++;
                                if (ln == line) break;
                        }
                }
                if (s < smax) s++;
        }
        c = 0;
        for(; s<smax && c<col; s++,c++) {
                if (*s == '\n') break;
        }
        m->offset = s - buff->a.text;
        { if (!(m->offset>=0 && m->offset<=buff->a.bufferSize)) internalCheckFail("m->offset>=0 && m->offset<=buff->a.bufferSize", "editor.c", 1020);};
}
S_editorMarkerList *editorReferencesToMarkers(S_reference *refs,
                                                                                          int (*filter)(S_reference *, void *),
                                                                                          void *filterParam) {
        S_reference *r;
        S_editorMarker *m;
        S_editorMarkerList *res, *rrr;
        int line, col, file, maxoffset;
        register char *s, *smax;
        register int ln, c;
        S_editorBuffer *buff;
        res = NULL;
        r = refs;
        while (r!=NULL) {
                while (r!=NULL && ! filter(r,filterParam)) r = r->next;
                if (r != NULL) {
                        file = r->p.file;
                        line = r->p.line;
                        col = r->p.coll;
                        buff = editorFindFile(s_fileTab.tab[file]->name);
                        if (buff==NULL) {
                                error(ERR_CANT_OPEN, s_fileTab.tab[file]->name);
                                while (r!=NULL && file == r->p.file) r = r->next;
                        } else {
                                s = buff->a.text;
                                smax = s + buff->a.bufferSize;
                                maxoffset = buff->a.bufferSize - 1;
                                if (maxoffset < 0) maxoffset = 0;
                                ln = 1; c = 0;
                                for(; s<smax; s++, c++) {
                                        if (ln==line && c==col) {
                                                m = editorCrNewMarker(buff, s - buff->a.text);
                                                { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rrr = NULL; } else { rrr = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rrr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rrr = NULL; } else { rrr = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                                                { (rrr)->d = m; (rrr)->usg = r->usg; (rrr)->next = res;};
                                                res = rrr;
                                                r = r->next;
                                                while (r!=NULL && ! filter(r,filterParam)) r = r->next;
                                                if (r==NULL || file != r->p.file) break;
                                                line = r->p.line;
                                                col = r->p.coll;
                                        }
                                        if (*s=='\n') {ln++; c = -1;}
                                }
                                while (r!=NULL && file == r->p.file) {
                                        m = editorCrNewMarker(buff, maxoffset);
                                        { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rrr = NULL; } else { rrr = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rrr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rrr = NULL; } else { rrr = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                                        { (rrr)->d = m; (rrr)->usg = r->usg; (rrr)->next = res;};
                                        res = rrr;
                                        r = r->next;
                                        while (r!=NULL && ! filter(r,filterParam)) r = r->next;
                                }
                        }
                }
        }
        { register S_editorMarkerList *list,*tmp,*revlist; list = res; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } res = revlist;};
        return(res);
}
S_reference *editorMarkersToReferences(S_editorMarkerList **mms) {
        S_editorMarkerList *mm;
        S_editorBuffer *buf;
        char *s, *smax, *off;
        int ln, c;
        S_reference *res, *rr;
        { S_editorMarkerList *_macrores; _macrores = (*mms); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*mms) = _macrores;};
        res = NULL;
        mm = *mms;
        while (mm!=NULL) {
                buf = mm->d->buffer;
                s = buf->a.text;
                smax = s + buf->a.bufferSize;
                off = buf->a.text + mm->d->offset;
                ln = 1; c = 0;
                for( ; s<smax; s++, c++) {
                        if (s == off) {
                                { { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                                { (&rr->p)->file = buf->ftnum; (&rr->p)->line = ln; (&rr->p)->coll = c;};
                                { (rr)->usg = mm->usg; (rr)->p = rr->p; (rr)->next = res;};
                                res = rr;
                                mm = mm->next;
                                if (mm==NULL || mm->d->buffer != buf) break;
                                off = buf->a.text + mm->d->offset;
                        }
                        if (*s=='\n') {ln++; c = -1;}
                }
                while (mm!=NULL && mm->d->buffer==buf) {
                        { { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                        { (&rr->p)->file = buf->ftnum; (&rr->p)->line = ln; (&rr->p)->coll = 0;};
                        { (rr)->usg = mm->usg; (rr)->p = rr->p; (rr)->next = res;};
                        res = rr;
                        mm = mm->next;
                }
        }
        { S_reference *_macrores; _macrores = (res); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (res) = _macrores;};
        return(res);
}
void editorFreeRegionListNotMarkers(S_editorRegionList *occs) {
        S_editorRegionList *o, *next;
        for(o=occs; o!=NULL; ) {
                next = o->next;
                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorRegionList); free(o);};
                o = next;
        }
}
void editorFreeMarkersAndRegionList(S_editorRegionList *occs) {
        S_editorRegionList *o, *next;
        for(o=occs; o!=NULL; ) {
                next = o->next;
                editorFreeMarker(o->r.b);
                editorFreeMarker(o->r.e);
                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorRegionList); free(o);};
                o = next;
        }
}
void editorFreeMarkerListNotMarkers(S_editorMarkerList *occs) {
        S_editorMarkerList *o, *next;
        for(o=occs; o!=NULL; ) {
                next = o->next;
                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorMarkerList); free(o);};
                o = next;
        }
}
void editorFreeMarkersAndMarkerList(S_editorMarkerList *occs) {
        S_editorMarkerList *o, *next;
        for(o=occs; o!=NULL; ) {
                next = o->next;
                editorFreeMarker(o->d);
                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorMarkerList); free(o);};
                o = next;
        }
}
void editorDumpMarker(S_editorMarker *mm) {
        sprintf(tmpBuff, "[%s:%d] --> %c", simpleFileName(mm->buffer->name), mm->offset, (*(mm->buffer->a.text+mm->offset))); ppcGenTmpBuff();
}
void editorDumpMarkerList(S_editorMarkerList *mml) {
        S_editorMarkerList *mm;
        sprintf(tmpBuff, "------------------[[dumping editor markers]]");ppcGenTmpBuff();
        for(mm=mml; mm!=NULL; mm=mm->next) {
                if (mm->d == NULL) {
                        sprintf(tmpBuff, "[null]");ppcGenTmpBuff();
                } else {
                        sprintf(tmpBuff, "[%s:%d] --> %c", simpleFileName(mm->d->buffer->name), mm->d->offset, (*(mm->d->buffer->a.text+mm->d->offset))); ppcGenTmpBuff();
                }
        }
        sprintf(tmpBuff, "------------------[[dumpend]]\n");ppcGenTmpBuff();
}
void editorDumpRegionList(S_editorRegionList *mml) {
        S_editorRegionList *mm;
        sprintf(tmpBuff,"-------------------[[dumping editor regions]]\n");
        fprintf(dumpOut,"%s\n",tmpBuff);
        for(mm=mml; mm!=NULL; mm=mm->next) {
                if (mm->r.b == NULL || mm->r.e == NULL) {
                        sprintf(tmpBuff,"%d: [null]", mm);
                        fprintf(dumpOut,"%s\n",tmpBuff);
                } else {
                        sprintf(tmpBuff,"%d: [%s: %d - %d] --> %c - %c", mm, simpleFileName(mm->r.b->buffer->name), mm->r.b->offset, mm->r.e->offset, (*(mm->r.b->buffer->a.text+mm->r.b->offset)), (*(mm->r.e->buffer->a.text+mm->r.e->offset)));
                        fprintf(dumpOut,"%s\n",tmpBuff);
                }
        }
        sprintf(tmpBuff, "------------------[[dumpend]]\n");
        fprintf(dumpOut,"%s\n",tmpBuff);
}
void editorDumpUndoList(S_editorUndo *uu) {
        fprintf(dumpOut,"\n\n[undodump] begin\n");
        while (uu!=NULL) {
                switch (uu->operation) {
                case UNDO_REPLACE_STRING:
                        sprintf(tmpBuff,"replace string [%s:%d] %d (%d)%s %d", uu->buffer->name, uu->u.replace.offset, uu->u.replace.size, uu->u.replace.str, uu->u.replace.str, uu->u.replace.strlen);
                        if (strlen(uu->u.replace.str)!=uu->u.replace.strlen) fprintf(dumpOut,"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
                        fprintf(dumpOut,"%s\n",tmpBuff);
                        break;
                case UNDO_RENAME_BUFFER:
                        sprintf(tmpBuff,"rename buffer %s %s", uu->buffer->name, uu->u.rename.name);
                        fprintf(dumpOut,"%s\n",tmpBuff);
                        break;
                case UNDO_MOVE_BLOCK:
                        sprintf(tmpBuff,"move block [%s:%d] [%s:%d] size==%d", uu->buffer->name, uu->u.moveBlock.offset, uu->u.moveBlock.dbuffer->name, uu->u.moveBlock.doffset, uu->u.moveBlock.size);
                        fprintf(dumpOut,"%s\n",tmpBuff);
                        break;
                default:
                        error(ERR_INTERNAL,"Unknown operation to undo");
                }
                uu = uu->next;
        }
        fprintf(dumpOut,"[undodump] end\n");
        fflush(dumpOut);
}
void editorMarkersDifferences(S_editorMarkerList **list1, S_editorMarkerList **list2,
                                                          S_editorMarkerList **diff1, S_editorMarkerList **diff2) {
        S_editorMarkerList *l1, *l2, *ll;
        S_editorMarker *m;
        { S_editorMarkerList *_macrores; _macrores = (*list1); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*list1) = _macrores;};
        { S_editorMarkerList *_macrores; _macrores = (*list2); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*list2) = _macrores;};
        *diff1 = *diff2 = NULL;
        for(l1 = *list1, l2 = *list2; l1!=NULL && l2!=NULL; ) {
                if (editorMarkerListLess(l1, l2)) {
                        m = editorCrNewMarker(l1->d->buffer, l1->d->offset);
                        { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                        { (ll)->d = m; (ll)->usg = l1->usg; (ll)->next = *diff1;};
                        *diff1 = ll;
                        l1 = l1->next;
                } else if (editorMarkerListLess(l2, l1)) {
                        m = editorCrNewMarker(l2->d->buffer, l2->d->offset);
                        { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                        { (ll)->d = m; (ll)->usg = l2->usg; (ll)->next = *diff2;};
                        *diff2 = ll;
                        l2 = l2->next;
                } else {
                        l1 = l1->next; l2 = l2->next;
                }
        }
        while (l1 != NULL) {
                m = editorCrNewMarker(l1->d->buffer, l1->d->offset);
                { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                { (ll)->d = m; (ll)->usg = l1->usg; (ll)->next = *diff1;};
                *diff1 = ll;
                l1 = l1->next;
        }
        while (l2 != NULL) {
                m = editorCrNewMarker(l2->d->buffer, l2->d->offset);
                { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ll = NULL; } else { ll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                { (ll)->d = m; (ll)->usg = l2->usg; (ll)->next = *diff2;};
                *diff2 = ll;
                l2 = l2->next;
        }
}
void editorSortRegionsAndRemoveOverlaps(S_editorRegionList **regions) {
        S_editorRegionList *rr, *rrr;
        S_editorMarker *newend;
        { S_editorRegionList *_macrores; _macrores = (*regions); { S_editorRegionList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorRegionListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*regions) = _macrores;};
        for(rr= *regions; rr!=NULL; rr=rr->next) {
        contin:
                rrr = rr->next;
                if (rrr!=NULL && rr->r.b->buffer==rrr->r.b->buffer) {
                        { if (!(rr->r.b->buffer == rr->r.e->buffer)) internalCheckFail("rr->r.b->buffer == rr->r.e->buffer", "editor.c", 1274);};
                        { if (!(rrr->r.b->buffer == rrr->r.e->buffer)) internalCheckFail("rrr->r.b->buffer == rrr->r.e->buffer", "editor.c", 1275);};
                        { if (!(rr->r.b->offset <= rrr->r.b->offset)) internalCheckFail("rr->r.b->offset <= rrr->r.b->offset", "editor.c", 1276);};
                        newend = NULL;
                        if (rrr->r.e->offset <= rr->r.e->offset) {
                                newend = rr->r.e;
                                editorFreeMarker(rrr->r.b);
                                editorFreeMarker(rrr->r.e);
                        } else if (rrr->r.b->offset <= rr->r.e->offset) {
                                newend = rrr->r.e;
                                editorFreeMarker(rrr->r.b);
                                editorFreeMarker(rr->r.e);
                        }
                        if (newend!=NULL) {
                                rr->r.e = newend;
                                rr->next = rrr->next;
                                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorRegionList); free(rrr);};
                                rrr = NULL;
                                goto contin;
                        }
                }
        }
}
void editorSplitMarkersWithRespectToRegions(
        S_editorMarkerList **inMarkers,
        S_editorRegionList **inRegions,
        S_editorMarkerList **outInsiders,
        S_editorMarkerList **outOutsiders
        ) {
        S_editorMarkerList *mm, *nn, *nextmm;
        S_editorRegionList *rr;
        *outInsiders = NULL;
        *outOutsiders = NULL;
        { S_editorMarkerList *_macrores; _macrores = (*inMarkers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*inMarkers) = _macrores;};
        editorSortRegionsAndRemoveOverlaps(inRegions);
        { register S_editorRegionList *list,*tmp,*revlist; list = *inRegions; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } *inRegions = revlist;};
        { register S_editorMarkerList *list,*tmp,*revlist; list = *inMarkers; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } *inMarkers = revlist;};
        rr = *inRegions;
        mm= *inMarkers;
        while (mm!=NULL) {
                nn = mm->next;
                while (rr!=NULL && editorMarkerGreater(rr->r.b, mm->d)) rr = rr->next;
                if (rr!=NULL && editorMarkerGreater(rr->r.e, mm->d)) {
                        mm->next = *outInsiders;
                        *outInsiders = mm;
                } else {
                        mm->next = *outOutsiders;
                        *outOutsiders = mm;
                }
                mm = nn;
        }
        *inMarkers = NULL;
        { register S_editorRegionList *list,*tmp,*revlist; list = *inRegions; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } *inRegions = revlist;};
        { register S_editorMarkerList *list,*tmp,*revlist; list = *outInsiders; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } *outInsiders = revlist;};
        { register S_editorMarkerList *list,*tmp,*revlist; list = *outOutsiders; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } *outOutsiders = revlist;};
}
void editorRestrictMarkersToRegions(S_editorMarkerList **mm, S_editorRegionList **regions) {
        S_editorMarkerList *ins, *outs;
        editorSplitMarkersWithRespectToRegions(mm, regions, &ins, &outs);
        *mm = ins;
        editorFreeMarkersAndMarkerList(outs);
}
S_editorMarker *editorCrMarkerForBufferBegin(S_editorBuffer *buffer) {
        return(editorCrNewMarker(buffer,0));
}
S_editorMarker *editorCrMarkerForBufferEnd(S_editorBuffer *buffer) {
        return(editorCrNewMarker(buffer,buffer->a.bufferSize));
}
S_editorRegionList *editorWholeBufferRegion(S_editorBuffer *buffer) {
        S_editorMarker *bufferBegin, *bufferEnd;
        S_editorRegionList *theBufferRegion;
        bufferBegin = editorCrMarkerForBufferBegin(buffer);
        bufferEnd = editorCrMarkerForBufferEnd(buffer);
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { theBufferRegion = NULL; } else { theBufferRegion = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (theBufferRegion==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { theBufferRegion = NULL; } else { theBufferRegion = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (theBufferRegion)->r.b = bufferBegin; (theBufferRegion)->r.e = bufferEnd; (theBufferRegion)->next = NULL;};
        return(theBufferRegion);
}
void editorScheduleModifiedBuffersToUpdate() {
        int i;
        S_editorBufferList *ll;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        if (ll->f->b.modified) {
                                s_fileTab.tab[ll->f->ftnum]->b.scheduledToUpdate = 1;
                        }
                }
        }
}
static S_editorBufferList *editorComputeAllBuffersList() {
        int i;
        S_editorBufferList *ll, *rr, *res;
        res = NULL;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL; ll=ll->next) {
                        { { int n = (1) * sizeof(S_editorBufferList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_editorBufferList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorBufferList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_editorBufferList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                        { (rr)->f = ll->f; (rr)->next = res;};
                        res = rr;
                }
        }
        return(res);
}
static void editorFreeBufferListButNotBuffers(S_editorBufferList *list) {
        S_editorBufferList *ll, *nn;
        ll=list;
        while (ll!=NULL) {
                nn = ll->next;
                { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorBufferList); free(ll);};
                ll = nn;
        }
}
static int editorBufferNameLess(S_editorBufferList*l1,S_editorBufferList*l2) {
        return(strcmp(l1->f->name, l2->f->name));
}
int editorMapOnNonexistantFiles(
                char *dirname,
                void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                int deep,
                char *a1,
                char *a2,
                S_completions *a3,
                void *a4,
                int *a5
        ) {
        int i, dlen, fnlen, res, lastMappedLen;
        S_editorBufferList *ll, *bl;
        char *ss, *lastMapped;
        char fname[MAX_FILE_NAME_SIZE];
        struct stat st;
        res = 0;
        dlen = strlen(dirname);
        bl = editorComputeAllBuffersList();
        { S_editorBufferList *_macrores; _macrores = (bl); { S_editorBufferList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorBufferNameLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (bl) = _macrores;};
        ll = bl;
        while(ll!=NULL) {
                if (fnnCmp(ll->f->name, dirname, dlen)==0
                        && (ll->f->name[dlen]=='/' || ll->f->name[dlen]=='\\')) {
                        if (deep == DEEP_ONE) {
                                ss = strchr(ll->f->name+dlen+1, '/');
                                if (ss==NULL) ss = strchr(ll->f->name+dlen+1, '\\');
                                if (ss==NULL) {
                                        strcpy(fname, ll->f->name+dlen+1);
                                        fnlen = strlen(fname);
                                } else {
                                        fnlen = ss-(ll->f->name+dlen+1);
                                        strncpy(fname, ll->f->name+dlen+1, fnlen);
                                        fname[fnlen]=0;
                                }
                        } else {
                                strcpy(fname, ll->f->name+dlen+1);
                                fnlen = strlen(fname);
                        }
                        if (stat(ll->f->name, &st)!=0) {
                                (*fun)(fname, a1, a2, a3, a4, a5);
                                res = 1;
                                lastMapped = ll->f->name;
                                lastMappedLen = dlen+1+fnlen;
                                ll = ll->next;
                                while (ll!=NULL
                                           && fnnCmp(ll->f->name, lastMapped, lastMappedLen)==0
                                           && (ll->f->name[lastMappedLen]=='/' || ll->f->name[lastMappedLen]=='\\')) {
                                        ll = ll->next;
                                }
                        } else {
                                ll = ll->next;
                        }
                } else {
                        ll = ll->next;
                }
        }
        editorFreeBufferListButNotBuffers(bl);
        return(res);
}
static void editorCloseBuffer(S_editorBufferList *memb, int ii) {
        S_editorBufferList **ll;
        for(ll= &s_editorBufferTab.tab[ii]; (*ll)!=NULL; ll = &(*ll)->next) {
                if (*ll == memb) break;
        }
        if (*ll == memb) {
                *ll = (*ll)->next;
                editorFreeBuffer(memb);
        }
}
void editorCloseBufferIfClosable(char *name) {
        S_editorBuffer dd;
        S_editorBufferList ddl, *memb, **ll;
        int ii;
        fillEmptyEditorBuffer(&dd, name, 0, name);
        { (&ddl)->f = &dd; (&ddl)->next = NULL;};
        if (editorBufferTabIsMember(&s_editorBufferTab, &ddl, &ii, &memb)) {
                if (( memb->f->b.textLoaded && memb->f->markers==NULL && memb->f->name==memb->f->fileName && ! memb->f->b.modified)) {
                        editorCloseBuffer(memb, ii);
                }
        }
}
void editorCloseAllBuffersIfClosable() {
        int i;
        S_editorBufferList *ll,*nn;
        S_editorMarker *m, *mm;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL;) {
                        nn = ll->next;
                        if (( ll->f->b.textLoaded && ll->f->markers==NULL && ll->f->name==ll->f->fileName && ! ll->f->b.modified)) editorCloseBuffer(ll, i);
                        ll = nn;
                }
        }
}
void editorCloseAllBuffers() {
        int i;
        S_editorBufferList *ll,*nn;
        S_editorMarker *m, *mm;
        for(i=0; i<s_editorBufferTab.size; i++) {
                for(ll=s_editorBufferTab.tab[i]; ll!=NULL;) {
                        nn = ll->next;
                        editorFreeBuffer(ll);
                        ll = nn;
                }
                s_editorBufferTab.tab[i] = NULL;
        }
}
void editorTest() {
        S_editorBuffer *buff;
}
