
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
        S_extRecFindStr *erfs;
        S_bb_int bbinteger;
        S_bb_unsigned bbunsign;
        S_bb_symbol bbsymbol;
        S_bb_symbolList bbsymbolList;
        S_bb_typeModifiers bbtypeModif;
        S_bb_typeModifiersList bbtypeModifList;
        S_bb_freeTrail bbtrail;
        S_bb_idIdent bbidIdent;
        S_bb_idIdentList bbidlist;
        S_bb_exprTokenType bbexprType;
        S_bb_intPair bbintpair;
        S_bb_whileExtractData bbwhiledata;
        S_bb_position bbposition;
        S_bb_unsPositionPair bbunsPositionPair;
        S_bb_symbolPositionPair bbsymbolPositionPair;
        S_bb_symbolPositionLstPair bbsymbolPositionLstPair;
        S_bb_positionLst bbpositionLst;
        S_bb_typeModifiersListPositionLstPair bbtypeModifiersListPositionLstPair;
        S_bb_nestedConstrTokenType bbnestedConstrTokenType;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
char *s_debugSurveyPointer;
int s_fileAbortionEnabled;
int s_wildCharSearch;
int s_lastReturnedLexem;
S_position s_spp[SPP_MAX];
S_usageBits s_noUsage = {UsageNone, 0, };
S_reference s_noRef = {{UsageNone, 0, }, {-1, 0, 0}, NULL};
int s_progressOffset=0;
int s_progressFactor=1;
S_availableRefactoring s_availableRefactorings[500];
S_editorUndo *s_editorUndo = NULL;
z_stream s_defaultZStream = {NULL,};
S_counters s_count;
unsigned s_recFindCl = 1;
S_currentlyParsedCl s_cp;
S_currentlyParsedCl s_cpInit = {0,};
S_currentlyParsedStatics s_cps;
S_currentlyParsedStatics s_cpsInit = {0,};
int s_javaPreScanOnly=0;
S_caching s_cache;
S_topBlock *s_topBlock;
int ppmMemoryi=0;
int mbMemoryi=0;
time_t s_expTime;
char s_olSymbolType[COMPLETION_STRING_SIZE];
char s_olSymbolClassType[COMPLETION_STRING_SIZE];
S_position s_paramPosition;
S_position s_paramBeginPosition;
S_position s_paramEndPosition;
S_position s_primaryStartPosition;
S_position s_staticPrefixStartPosition;
S_idIdent s_yyIdentBuf[YYBUFFERED_ID_INDEX];
int s_yyIdentBufi = 0;
S_typeModifiers *s_structRecordCompletionType;
S_typeModifiers *s_upLevelFunctionCompletionType;
S_exprTokenType s_forCompletionType;
S_typeModifiers *s_javaCompletionLastPrimary;
YYSTYPE *uniyylval = &cyylval;
struct yyGlobalState *s_yygstate;
struct yyGlobalState *s_initYygstate;
char *s_input_file_name="";
S_completions s_completions;
S_fileDesc cFile = {0};
S_symTab *s_symTab;
S_javaFqtTab s_javaFqtTab;
S_idTab s_fileTab;
S_refTab s_cxrefTab;
S_fileDesc inStack[INSTACK_SIZE];
int inStacki=0;
S_lexInput macStack[MACSTACK_SIZE];
int macStacki=0;
S_lexInput cInput;
char tmpMemory[SIZE_TMP_MEM];
char memory[SIZE_workMemory];
char ppmMemory[SIZE_ppmMemory];
char mbMemory[SIZE_mbMemory];
char ftMemory[SIZE_ftMemory];
int ftMemoryi = 0;
int next;
char nextus[32];
char tmpWorkMemory[SIZE_tmpWorkMemory];
int tmpWorkMemoryi = 0;
int olcxMemoryAllocatedBytes;
S_memory *cxMemory=NULL;
int s_ifEvaluation = 0;
S_position s_olcxByPassPos;
S_position s_cxRefPos;
int s_cxRefFlag=0;
time_t s_fileProcessStartTime;
int s_language;
int s_currCppPass;
int s_maximalCppPass;
S_userOlcx *s_olcxCurrentUser;
unsigned s_menuFilterOoBits[MAX_MENU_FILTER_LEVEL] = {
        (00000 | 00000),
        (00000 | 02000),
        (00100 | 02000),
};
int s_refListFilters[MAX_REF_LIST_FILTER_LEVEL] = {
        UsageMaxOLUsages,
        UsageUsed,
        UsageAddrUsed,
        UsageLvalUsed,
};
char *s_cppVarArgsName = "__VA_ARGS__";
char s_defaultClassPath[] = ".";
S_stringList *s_javaClassPaths;
char *s_javaSourcePaths;
S_idIdent s_javaAnonymousClassName = {"{Anonymous}", NULL, -1,0,0};
S_idIdent s_javaConstructorName = {"<init>", NULL, -1,0,0};
static S_idIdentList s_javaDefaultPackageNameBody[] = {
        {"", NULL, -1,0,0, "", TypePackage, NULL},
};
S_idIdentList *s_javaDefaultPackageName = s_javaDefaultPackageNameBody;
static S_idIdentList s_javaLangNameBody[] = {
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangNameBody[1]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangName = s_javaLangNameBody;
static S_idIdentList s_javaLangStringNameBody[] = {
        {"String", NULL, -1,0,0, "String", TypeStruct, &s_javaLangStringNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangStringNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangStringName = s_javaLangStringNameBody;
static S_idIdentList s_javaLangCloneableNameBody[] = {
        {"Cloneable", NULL, -1,0,0, "Cloneable", TypeStruct, &s_javaLangCloneableNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangCloneableNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangCloneableName = s_javaLangCloneableNameBody;
static S_idIdentList s_javaIoSerializableNameBody[] = {
        {"Serializable", NULL, -1,0,0, "Serializable", TypeStruct, &s_javaIoSerializableNameBody[1]},
        {"io", NULL, -1,0,0, "io", TypePackage, &s_javaIoSerializableNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaIoSerializableName = s_javaIoSerializableNameBody;
static S_idIdentList s_javaLangClassNameBody[] = {
        {"Class", NULL, -1,0,0, "Class", TypeStruct, &s_javaLangClassNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangClassNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangClassName = s_javaLangClassNameBody;
static S_idIdentList s_javaLangObjectNameBody[] = {
        {"Object", NULL, -1,0,0, "Object", TypeStruct, &s_javaLangObjectNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangObjectNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangObjectName = s_javaLangObjectNameBody;
char *s_javaLangObjectLinkName="java/lang/Object";
char s_olstring[MAX_FUN_NAME_SIZE];
int s_olstringFound = 0;
int s_olstringServed = 0;
int s_olstringUsage = 0;
char *s_olstringInMbody = NULL;
int s_olMacro2PassFile;
char *yytext;
S_options s_opt;
S_options s_ropt;
S_javaStat *s_javaStat;
S_javaStat s_initJavaStat;
char *s_javaThisPackageName = "";
FILE *cxOut;
FILE *fIn;
FILE *ccOut=NULL;
int s_cxResizingBlocked = 0;
int s_input_file_number = -1;
int s_olStringSecondProcessing=0;
int s_olOriginalFileNumber = -1;
int s_olOriginalComFileNumber = -1;
int s_noneFileIndex = -1;
time_t s_expiration;
S_typeModifiers s_defaultIntModifier;
S_symbol s_defaultIntDefinition;
S_typeModifiers s_defaultPackedTypeModifier;
S_typeModifiers s_defaultVoidModifier;
S_symbol s_defaultVoidDefinition;
S_typeModifiers s_errorModifier;
S_symbol s_errorSymbol;
struct stat s_noStat;
S_position s_noPos = {-1, 0, 0};
S_symbol s_javaArrayObjectSymbol;
S_symbol *s_javaStringSymbol;
S_symbol *s_javaCloneableSymbol;
S_symbol *s_javaIoSerializableSymbol;
S_symbol *s_javaObjectSymbol;
S_typeModifiers s_javaStringModifier;
S_typeModifiers s_javaClassModifier;
S_typeModifiers s_javaObjectModifier;
S_zipFileTabItem s_zipArchivTab[MAX_JAVA_ZIP_ARCHIVES];
char s_cwd[MAX_FILE_NAME_SIZE];
char s_base[MAX_FILE_NAME_SIZE];
char ppcTmpBuff[MAX_PPC_RECORD_SIZE];
jmp_buf cxmemOverflow;
jmp_buf s_memoryResize;
S_options s_cachedOptions;
int s_javaRequiredeAccessibilitiesTable[3 +1] = {
        0x001,
        0x004,
        0x000,
        0x002,
};
S_options s_initOpt = {
        MULE_DEFAULT,
        0,
        NID_IMPORT_ON_DEMAND,
        0,
        0,
        1,
        0,
        0,
        NULL,
        NULL,
        RC_ZERO,
        0,
        NULL,
        0,
        NULL,
        CUT_OUTERS,
        NULL,
        0,
        "",
        "",
        0,
        0,
        0,
        0,
        NULL,
        RegimeUndefined,
        0,
        NULL,
#if defined (__WIN32__) || defined (__OS2__)
        "c;C",
        "java;JAV",
        "C;cpp;CC;cc",
#else
        "c:C",
        "java",
        "C:cpp:CC:cc",
#endif
        1,
        ":",
        0,
        TSS_FULL_SEARCH,
        "1.3",
        "",
        0,
        0,
        0,
        0,
        "nouser",
        0,
        0,
        NULL,
        TPC_NONE,
        1,
        1,
        0,
        0,
        NULL,
        NULL,
        NULL,
        DEFAULT_CXREF_FILE,
        NULL,
        NULL,
        0,
        ((int) (((unsigned) -2)>>1)),
        0,
        "",
        0,
        1,
        0,
        NULL,
        80,
        "java.applet:java.awt:java.beans:java.io:java.lang:java.math:java.net:java.rmi:java.security:java.sql:java.text:java.util:javax.accessibility:javax.swing:org.omg.CORBA:org.omg.CosNaming",
        0,
        NULL,
        "",
        0,
        NULL,
        0,
        "/tmp",
        0,
        0,
        0,
        1,
        0,
        "",
        DEFAULT_VALUE,
        NULL,
        1,
        0,
        0,
        "navy",
        "",
        0,
        (00100 | 02000),
        0,
        0,
        1,
        1,
        0,
        NULL,
        0,
        "0:3",
        NULL,
        "",
        79,
        "1/1/2000/1365:x:dadde11113b13b11",
        "",
        "*_",
        EXTR_FUNCTION,
        0,
        MAX_COMPLETIONS,
        0,
        0,
        "",
        1,
        "",
        8,
        "",
        0,
        0,
        0,
        0,
        -1,
        -1,
        RegimeXref,
        "nouser",
        0,
        1,
        0,
        0,
        0,
        "",
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        NULL,
        0,
        {0, },
        {0, },
        NULL,
        {0, },
        {0, },
};
char *s_editCommunicationString = "C@$./@mVeDitznAC";
uchar typeShortChange[MAX_TYPE];
uchar typeLongChange[MAX_TYPE];
uchar typeSignedChange[MAX_TYPE];
uchar typeUnsignedChange[MAX_TYPE];
char s_javaBaseTypeCharCodes[MAX_TYPE];
int s_javaCharCodeBaseTypes[127];
char s_javaTypePCTIConvert[MAX_TYPE];
char s_javaPrimitiveWideningConversions[MAX_PCTIndex-1][MAX_PCTIndex-1] = {
    1, 1, 0, 1, 1, 1, 1,
    0, 1, 0, 1, 1, 1, 1,
    0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1,
    0, 0, 0, 0, 1, 1, 1,
    0, 0, 0, 0, 0, 1, 1,
    0, 0, 0, 0, 0, 0, 1,
};
char *s_tokenName[451];
int s_tokenLength[451];
S_typeModifiers * s_preCrTypesTab[MAX_TYPE];
S_typeModifiers * s_preCrPtr1TypesTab[MAX_TYPE];
S_typeModifiers * s_preCrPtr2TypesTab[MAX_TYPE];
S_typeModificationsInit s_typeModificationsInit[] = {
  {TypeDefault, TypeShortInt, TypeLongInt, TypeSignedInt, TypeUnsignedInt},
  {TypeChar, -1, -1, TypeSignedChar, TypeUnsignedChar},
  {TypeInt, TypeShortInt, TypeLongInt, TypeSignedInt, TypeUnsignedInt},
  {TypeUnsignedInt, TypeShortUnsignedInt, TypeLongUnsignedInt, -1, -1},
  {TypeSignedInt, TypeShortSignedInt, TypeLongSignedInt, -1, -1},
  {TypeShortInt, -1, -1, TypeShortSignedInt, TypeShortUnsignedInt},
  {TypeLongInt, -1, -1, TypeLongSignedInt, TypeLongUnsignedInt},
  {TmodLong, -1, -1, TmodLongSigned, TmodLongUnsigned},
  {TmodShort, -1, -1, TmodShortSigned, TmodShortUnsigned},
  {TmodSigned, TmodShortSigned, TmodLongSigned, -1, -1},
  {TmodUnsigned, TmodShortUnsigned, TmodLongUnsigned, -1, -1},
  {-1,-1,-1,-1,-1}
};
S_tokenNameIni s_tokenNameIniTab[] = {
        {"asm", 364 ,16},
        {"auto", 315 ,2 | 8 | 16},
        {"enum", 321 ,2 | 8 | 16},
        {"extern", 314 ,2 | 8 | 16},
        {"register", 316 ,2 | 8 | 16},
        {"signed", 317 ,2 | 8 | 16},
        {"sizeof", 322 ,2 | 8 | 16},
        {"struct", 319 ,2 | 8 | 16},
        {"typedef", 313 ,2 | 8 | 16},
        {"union", 320 ,2 | 8 | 16},
        {"unsigned", 318 ,2 | 8 | 16},
        {"abstract", 324 ,4},
        {"boolean", 325 ,4},
        {"byte", 326 ,4},
        {"catch", 327 ,4 | 16},
        {"class", 328 ,4 | 16},
        {"extends", 329 ,4},
        {"final", 330 ,4},
        {"finally", 331 ,4},
        {"implements", 332 ,4},
        {"import", 333 ,4},
        {"instanceof", 334 ,4},
        {"interface", 335 ,4},
        {"native", 336 ,4},
        {"new", 337 ,4 | 16},
        {"package", 338 ,4},
        {"private", 339 ,4 | 16},
        {"protected", 340 ,4 | 16},
        {"public", 341 ,4 | 16},
        {"super", 342 ,4},
        {"synchronized",343 ,4},
        {"strictfp", 352 ,4},
        {"this", 344 ,4 | 16},
        {"throw", 345 ,4 | 16},
        {"throws", 346 ,4},
        {"transient", 347 ,4},
        {"try", 348 ,4 | 16},
        {"true", 349 ,4 | 16},
        {"false", 350 ,4 | 16},
        {"null", 351 ,4},
        {"bool", 362 ,16},
        {"const_cast", 372 ,16},
        {"delete", 358 ,16},
        {"dynamic_cast", 369 ,16},
        {"explicit", 360 ,16},
        {"friend", 354 ,16},
        {"inline", 367 ,16},
        {"mutable", 359 ,16},
        {"namespace", 356 ,16},
        {"operator", 355 ,16},
        {"reinterpret_cast", 371,16},
        {"static_cast", 370 ,16},
        {"template", 357 ,16},
        {"typeid", 373 ,16},
        {"typename", 368 ,16},
        {"using", 363 ,16},
        {"virtual", 366 ,16},
        {"wchar_t", 361 ,16},
        {"break", 292 ,2 | 8 | 16 | 4},
        {"case", 293 ,2 | 8 | 16 | 4},
        {"char", 294 ,2 | 8 | 16 | 4},
        {"const", 295 ,2 | 8 | 16 | 4},
        {"continue", 296 ,2 | 8 | 16 | 4},
        {"default", 297 ,2 | 8 | 16 | 4},
        {"do", 298 ,2 | 8 | 16 | 4},
        {"double", 299 ,2 | 8 | 16 | 4},
        {"else", 300 ,2 | 8 | 16 | 4},
        {"float", 301 ,2 | 8 | 16 | 4},
        {"for", 302 ,2 | 8 | 16 | 4},
        {"goto", 303 ,2 | 8 | 16 | 4},
        {"if", 304 ,2 | 8 | 16 | 4},
        {"int", 305 ,2 | 8 | 16 | 4},
        {"long", 306 ,2 | 8 | 16 | 4},
        {"return", 307 ,2 | 8 | 16 | 4},
        {"short", 308 ,2 | 8 | 16 | 4},
        {"static", 291 ,2 | 8 | 16 | 4},
        {"switch", 309 ,2 | 8 | 16 | 4},
        {"void", 310 ,2 | 8 | 16 | 4},
        {"volatile", 311 ,2 | 8 | 16 | 4},
        {"while", 312 ,2 | 8 | 16 | 4},
        {">>>=", 285 ,4},
        {">>>", 284 ,4},
        {"...", 283 ,2},
        {">>=", 278 ,2},
        {"<<=", 277 ,2},
        {"+=", 275 ,2},
        {"-=", 276 ,2},
        {"*=", 272 ,2},
        {"/=", 273 ,2},
        {"%=", 274 ,2},
        {"&=", 279 ,2},
        {"^=", 280 ,2},
        {"|=", 281 ,2},
        {">>", 265 ,2},
        {"<<", 264 ,2},
        {"++", 262 ,2},
        {"--", 263 ,2},
        {"->", 282 ,2},
        {"->*", 290 ,16},
        {".*", 289 ,16},
        {"::", 288 ,16},
        {"&&", 270 ,2},
        {"||", 271 ,2},
        {"<=", 266 ,2},
        {">=", 267 ,2},
        {"==", 268 ,2},
        {"!=", 269 ,2},
        {";", ';' ,2},
        {"{", '{' ,2},
        {"}", '}' ,2},
        {",", ',' ,2},
        {":", ':' ,2},
        {"=", '=' ,2},
        {"(", '(' ,2},
        {")", ')' ,2},
        {"[", '[' ,2},
        {"]", ']' ,2},
        {".", '.' ,2},
        {"&", '&' ,2},
        {"!", '!' ,2},
        {"~", '~' ,2},
        {"-", '-' ,2},
        {"+", '+' ,2},
        {"*", '*' ,2},
        {"/", '/' ,2},
        {"%", '%' ,2},
        {"<", '<' ,2},
        {">", '>' ,2},
        {"^", '^' ,2},
        {"|", '|' ,2},
        {"?", '?' ,2},
        {"()", 437 ,16},
        {"[]", 438 ,16},
        {"'CONSTANT'", 441 ,2},
        {"'CONSTANT'", 442 ,2},
        {"'CONSTANT'", 443 ,2},
        {"'CONSTANT'", 444 ,2},
        {"'STRING_LITERAL'", 445 ,2},
        {"'IDENTIFIER'", 440 ,2},
        {"'LINE_TOK'", 446 ,2},
        {"'BLOCK_MARKER'", 432 ,2},
        {"#INCLUDE", 415 ,2},
        {"#DEFINE0", 426 ,2},
        {"#DEFINE", 416 ,2},
        {"#IFDEF", 417 ,2},
        {"#IFNDEF", 418 ,2},
        {"#IF", 419 ,2},
        {"#ELSE", 420 ,2},
        {"#ENDIF", 421 ,2},
        {"#PRAGMA", 424 ,2},
        {"#LINE", 425 ,2},
        {"##", 428 ,2},
        {NULL, 0 ,2}
};
S_tokenNameIni s_tokenNameIniTab2[] = {
        {"__const", 295 ,2 | 8 | 16},
        {"__const__", 295 ,2 | 8 | 16},
        {"__signed", 317 ,2 | 8 | 16},
        {"__signed__", 317 ,2 | 8 | 16},
        {"__inline", 323 ,2 | 8 | 16},
        {"__inline__", 323 ,2 | 8 | 16},
        {"__volatile", 311 ,2 | 8 | 16},
        {"__volatile__", 311 ,2 | 8 | 16},
        {"__asm", 364 ,2 | 16},
        {"__asm__", 364 ,2 | 16},
        {"__label__", 376 ,2 | 16},
        {"__near", 323 ,2 | 8 | 16},
        {"__far", 323 ,2 | 8 | 16},
        {"__pascal", 323 ,2 | 8 | 16},
        {"_near", 323 ,2 | 8 | 16},
        {"_far", 323 ,2 | 8 | 16},
        {"_pascal", 323 ,2 | 8 | 16},
        {"_const", 323 ,2 | 8 | 16},
        {"__near", 323 ,2 | 8 | 16},
        {"__far", 323 ,2 | 8 | 16},
        {"__pascal", 323 ,2 | 8 | 16},
        {"__cdecl", 323 ,2 | 8 | 16},
        {"__fastcall", 323 ,2 | 8 | 16},
        {"__stdcall", 323 ,2 | 8 | 16},
        {"__int8", 305 ,2 | 8 | 16},
        {"__int16", 305 ,2 | 8 | 16},
        {"__int32", 305 ,2 | 8 | 16},
        {"__int64", 305 ,2 | 8 | 16},
        {NULL, 0 ,2}
};
S_tokenNameIni s_tokenNameIniTab3[] = {
        {"assert", 353 ,4},
        {NULL, 0 ,2}
};
S_typeCharCodeIni s_baseTypeCharCodesIniTab[] = {
        {TypeByte, 'B'},
        {TypeChar, 'C'},
        {TypeDouble, 'D'},
        {TypeFloat, 'F'},
        {TypeInt, 'I'},
        {TypeLong, 'J'},
        {TypeShort, 'S'},
        {TypeBoolean, 'Z'},
        {TypeVoid, 'V'},
        {TypeError, 'E'},
        {TypeNull, 'N'},
        {-1, ' '},
};
S_javaTypePCTIConvertIni s_javaTypePCTIConvertIniTab[] = {
        {TypeByte, PCTIndexByte},
        {TypeShort, PCTIndexShort},
        {TypeChar, PCTIndexChar},
        {TypeInt, PCTIndexInt},
        {TypeLong, PCTIndexLong},
        {TypeFloat, PCTIndexFloat},
        {TypeDouble, PCTIndexDouble},
        {-1,-1},
};
char *s_extractStorageName[MAX_STORAGE];
S_intStringTab s_extractStoragesNamesInitTab[] = {
        {StorageExtern, "extern "},
        {StorageStatic, "static "},
        {StorageRegister, "register "},
        {StorageTypedef, "typedef "},
        {-1, NULL}
};
S_intStringTab s_typesNamesInitTab[] = {
        {TypeDefault , "Default"},
        {TypeChar , "char"},
        {TypeUnsignedChar , "unsigned char"},
        {TypeSignedChar , "signed char"},
        {TypeInt , "int"},
        {TypeUnsignedInt , "unsigned int"},
        {TypeSignedInt , "signed int"},
        {TypeShortInt , "short int"},
        {TypeShortUnsignedInt , "short unsigned int"},
        {TypeShortSignedInt , "short signed int"},
        {TypeLongInt , "long int"},
        {TypeLongUnsignedInt , "long unsigned int"},
        {TypeLongSignedInt , "long signed int"},
        {TypeFloat , "float"},
        {TypeDouble , "double"},
        {TypeStruct, "struct"},
        {TypeUnion, "union"},
        {TypeEnum , "enum"},
        {TypeVoid , "void"},
        {TypePointer, "Pointer"},
        {TypeArray, "Array"},
        {TypeFunction, "Function"},
        {TypeAnonymeField, "AnonymeField"},
        {TypeError, "Error"},
        {TypeCppIfElse, "#if-else-fi"},
        {TypeCppInclude, "#include"},
        {TypeCppCollate, "##"},
        {TmodLong, "long"},
        {TmodShort, "short"},
        {TmodSigned, "signed"},
        {TmodUnsigned, "unsigned"},
        {TmodShortSigned, "short signed"},
        {TmodShortUnsigned, "short unsigned"},
        {TmodLongSigned, "long signed"},
        {TmodLongUnsigned, "long unsigned"},
        {TypeElipsis, "elipsis"},
        {TypeByte, "byte"},
        {TypeShort, "short"},
        {TypeLong, "long"},
        {TypeBoolean, "boolean"},
        {TypeNull, "null"},
        {TypeOverloadedFunction, "OverloadedFunction"},
        {TypeWchar_t, "wchar_t"},
        {TypeLabel, "label"},
        {TypeKeyword, "keyword"},
        {TypeToken, "token"},
        {TypeMacro, "macro"},
        {TypeMacroArg, "macro argument"},
        {TypeUndefMacro, "Undefined Macro"},
        {TypePackage, "package"},
        {TypeYaccSymbol, "yacc symbol"},
        {TypeCppCollate, "Cpp##sym"},
        {TypeSpecialComplet, "(Completion Wizard)"},
        {TypeInheritedFullMethod, "(Override Wizard)"},
        {TypeNonImportedClass, "fully qualified name"},
        {-1,NULL}
};
int s_preCrTypesIniTab[] = {
        TypeDefault,
        TypeChar ,
        TypeUnsignedChar ,
        TypeSignedChar ,
        TypeInt ,
        TypeUnsignedInt ,
        TypeSignedInt ,
        TypeShortInt ,
        TypeShortUnsignedInt ,
        TypeShortSignedInt ,
        TypeLongInt ,
        TypeLongUnsignedInt ,
        TypeLongSignedInt ,
        TypeFloat ,
        TypeDouble ,
        TypeVoid ,
        TypeError ,
        TypeAnonymeField ,
        TmodLong,
        TmodShort,
        TmodSigned,
        TmodUnsigned,
        TmodShortSigned,
        TmodShortUnsigned,
        TmodLongSigned,
        TmodLongUnsigned,
        TypeByte,
        TypeShort,
        TypeLong,
        TypeBoolean,
        TypeNull,
        TypeWchar_t,
        -1,
};
