
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
typedef unsigned char bitArray;
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
static int s_ppcIndentOffset = 0;
void ppcGenSynchroRecord() {
        fprintf(stdout, "<%s>\n", PPC_SYNCHRO_RECORD);
        fflush(stdout);
}
void ppcIndentOffset() {
        int i;
        for(i=0; i<s_ppcIndentOffset; i++) fputc(' ', ccOut);
}
void ppcGenPosition(S_position *p) {
        char *fn;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "misc.c", 37);};
        fn = s_fileTab.tab[p->file]->name;
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d %s=%d>%s</%s>\n",
                        PPC_LC_POSITION,
                        PPCA_LINE, p->line, PPCA_COL, p->coll,
                        PPCA_LEN, strlen(fn), fn,
                        PPC_LC_POSITION);
}
void ppcGenGotoPositionRecord(S_position *p) {
        ppcGenRecordBegin(PPC_GOTO);
        ppcGenPosition(p);
        ppcGenRecordEnd(PPC_GOTO);
}
void ppcGenGotoMarkerRecord(S_editorMarker *pos) {
        ppcGenRecordBegin(PPC_GOTO);
        ppcGenMarker(pos);
        ppcGenRecordEnd(PPC_GOTO);
}
void ppcGenOffsetPosition(char *fn, int offset) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d>%s</%s>\n",
                        PPC_OFFSET_POSITION,
                        PPCA_OFFSET, offset,
                        PPCA_LEN, strlen(fn), fn,
                        PPC_OFFSET_POSITION);
}
void ppcGenMarker(S_editorMarker *m) {
        ppcGenOffsetPosition(m->buffer->name, m->offset);
}
void ppcGenGotoOffsetPosition(char *fname, int offset) {
        ppcGenRecordBegin(PPC_GOTO);
        ppcGenOffsetPosition(fname, offset);
        ppcGenRecordEnd(PPC_GOTO);
}
void ppcGenRecordBegin(char *kind) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s>\n", kind);
        s_ppcIndentOffset ++;
}
void ppcGenRecordWithAttributeBegin(char *kind, char *attr, char *val) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%s>", kind, attr, val);
        s_ppcIndentOffset ++;
}
void ppcGenRecordWithNumAttributeBegin(char *kind, char *attr, int val) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d>", kind, attr, val);
        s_ppcIndentOffset ++;
}
void ppcGenRecordEnd(char *kind) {
        s_ppcIndentOffset --;
        ppcIndentOffset();
        fprintf(ccOut, "</%s>\n", kind);
}
void ppcGenNumericRecordBegin(char *kind, int val) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d>\n", kind, PPCA_VALUE, val);
}
void ppcGenWithNumericAndRecordBegin(char *kind, int val, char *attr, char *attrVal) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%s>\n", kind, PPCA_VALUE, val, attr, attrVal);
}
void ppcGenTwoNumericAndRecordBegin(char *kind, char *attr1, int val1, char *attr2, int val2) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d>\n", kind, attr1, val1, attr2, val2);
}
void ppcGenAllCompletionsRecordBegin(int nofocus, int len) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d>", PPC_ALL_COMPLETIONS, PPCA_NO_FOCUS, nofocus, PPCA_LEN, len);
}
void ppcGenRecordWithNumeric(char *kind, char *attr, int val, char *message,char *suff) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d>%s</%s>%s", kind,
                        attr, val, PPCA_LEN, strlen(message),
                        message, kind, suff);
}
void ppcGenTwoNumericsAndrecord(char *kind, char *attr1, int val1, char *attr2, int val2, char *message,char *suff) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d %s=%d>%s</%s>%s", kind,
                        attr1, val1,
                        attr2, val2,
                        PPCA_LEN, strlen(message),
                        message, kind, suff);
}
void ppcGenNumericRecord(char *kind, int val,char *message,char *suff) {
        ppcIndentOffset();
        ppcGenRecordWithNumeric(kind, PPCA_VALUE, val, message, suff);
}
void ppcGenRecord(char *kind, char *message, char *suffix) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d>%s</%s>%s", kind, PPCA_LEN, strlen(message), message,
                        kind, suffix);
}
void ppcGenTmpBuff() {
        ppcGenRecord(PPC_BOTTOM_INFORMATION,tmpBuff,"\n");
        fflush(ccOut);
}
void ppcGenDisplaySelectionRecord(char *message, int messageType, int continuation) {
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d %s=%d %s=%d>%s</%s>\n", PPC_DISPLAY_RESOLUTION,
                        PPCA_LEN, strlen(message),
                        PPCA_MTYPE, messageType,
                        PPCA_CONTINUE, (continuation==CONTINUATION_ENABLED) ? 1 : 0,
                        message, PPC_DISPLAY_RESOLUTION);
}
void ppcGenReplaceRecord(char *file, int offset, char *oldName, int oldLen, char *newName) {
        int i;
        ppcGenGotoOffsetPosition(file, offset);
        ppcGenRecordBegin(PPC_REFACTORING_REPLACEMENT);
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d>", PPC_STRING_VALUE, PPCA_LEN, oldLen);
        for(i=0; i<oldLen; i++) putc(oldName[i], ccOut);
        fprintf(ccOut, "</%s> ", PPC_STRING_VALUE);
        ppcGenRecord(PPC_STRING_VALUE, newName,"\n");
        ppcGenRecordEnd(PPC_REFACTORING_REPLACEMENT);
}
void ppcGenPreCheckRecord(S_editorMarker *pos, int oldLen) {
        int i;
        char *bufferedText;
        bufferedText = pos->buffer->a.text + pos->offset;
        ppcGenGotoMarkerRecord(pos);
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d>", PPC_REFACTORING_PRECHECK, PPCA_LEN, oldLen);
        for(i=0; i<oldLen; i++) putc(bufferedText[i], ccOut);
        fprintf(ccOut, "</%s>\n", PPC_REFACTORING_PRECHECK);
}
void ppcGenReferencePreCheckRecord(S_reference *r, char *text) {
        int i,len;
        len = strlen(text);
        ppcGenGotoPositionRecord(&r->p);
        ppcIndentOffset();
        fprintf(ccOut, "<%s %s=%d>", PPC_REFACTORING_PRECHECK, PPCA_LEN, len);
        fprintf(ccOut, "%s", text);
        fprintf(ccOut, "</%s>\n", PPC_REFACTORING_PRECHECK);
}
void ppcGenDefinitionNotFoundWarning() {
        ppcGenRecord(PPC_WARNING, "Definition not found", "\n");
}
void ppcGenDefinitionNotFoundWarningAtBottom() {
        ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Definition not found", "\n");
}
void noSuchRecordError(char *rec) {
        if (s_opt.debug || s_opt.err) {
                sprintf(tmpBuff," member %s not found\n", rec);
                error(ERR_ST, tmpBuff);
        }
}
void methodAppliedOnNonClass(char *rec) {
        if (s_opt.debug || s_opt.err) {
                sprintf(tmpBuff," %s not applied on a class\n", rec);
                error(ERR_ST, tmpBuff);
        }
}
void methodNameNotRecognized(char *rec) {
        if (s_opt.debug || s_opt.err) {
                sprintf(tmpBuff," %s not recognized as method name\n", rec);
                error(ERR_ST, tmpBuff);
        }
}
void dumpOptions(int nargc, char **nargv) {
        int i;
        tmpBuff[0]=0;
        for(i=0; i<nargc; i++) {
                sprintf(tmpBuff+strlen(tmpBuff), "%s\n", nargv[i]);
        }
        { if (!(strlen(tmpBuff)<TMP_BUFF_SIZE-1)) internalCheckFail("strlen(tmpBuff)<TMP_BUFF_SIZE-1", "misc.c", 242);};
        ppcGenRecord(PPC_INFORMATION,tmpBuff,"\n");
}
unsigned hashFun(char *ss) {
        register unsigned h = 0;
        register char *s = ss;
        register char c;
        for(c= *s; c ; c= *++s) { h+=c; h+=(h<<10); h^=(h>>6);};
        { h+=(h<<3); h^=(h>>11); h+=(h<<15);};
        return(h);
}
unsigned fileTabHashFun(char *ss) {
        register unsigned h = 0;
        register char *s = ss;
        register char c;
        for(c= *s; c ; c= *++s) { h+=c; h+=(h<<10); h^=(h>>6);};
        { h+=(h<<3); h^=(h>>11); h+=(h<<15);};
        return(h);
}
void symTabNAInit(struct symTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_symbol *)*t->size);
}
void symTabInit(struct symTab *t, int size) {
        register int i;
        {t->tab = (S_symbol **) stackMemoryAlloc((size)*sizeof(S_symbol *)); };
        symTabNAInit(t, size);
}
int symTabIsMember(
                                        struct symTab *t,
                                        S_symbol *elem,
                                        int *position,
                                        S_symbol **original
                        ) {
        unsigned posid;
        S_symbol *pp;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if ((pp->b.symType==elem->b.symType && strcmp(pp->name,elem->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int symTabNextMember(
                                        S_symbol *elem,
                                        S_symbol **original
                        ) {
        S_symbol *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if ((pp->b.symType==elem->b.symType && strcmp(pp->name,elem->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int symTabMembEqual(
                                        S_symbol *e1,
                                        S_symbol *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return((e1->b.symType==e2->b.symType && strcmp(e1->name,e2->name)==0));
}
int symTabDelete(
                                        struct symTab *t,
                                        S_symbol *elem
                        ) {
        unsigned posid;
        S_symbol **pp;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (((*pp)->b.symType==elem->b.symType && strcmp((*pp)->name,elem->name)==0)) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int symTabDeleteExact(
                                        struct symTab *t,
                                        S_symbol *elem
                        ) {
        unsigned posid;
        S_symbol **pp;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int symTabDeleteLast(
                                        struct symTab *t,
                                        S_symbol *elem
                        ) {
        unsigned posid;
        S_symbol **pp, **dd;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (((*pp)->b.symType==elem->b.symType && strcmp((*pp)->name,elem->name)==0)) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void symTabSet (
                                        struct symTab *t,
                                        S_symbol *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void symTabSetLast (
                                        struct symTab *t,
                                        S_symbol *elem,
                                        int position
                                ) {
        S_symbol **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void symTabAdd (
                                        struct symTab *t,
                                        S_symbol *elem,
                                        int *position
                                ) {
  S_symbol *origin;
  if (! symTabIsMember(t,elem,position,&origin)) {
        symTabSet (t,elem,*position);
  }
}
void symTabFree(struct symTab *t) {
        { };
}
void symTabMap(
                                        struct symTab *t,
                                        void (*fun)(S_symbol *)
                                ) {
        int i;
        S_symbol *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void symTabMap2(
                                        struct symTab *t,
                                        void (*fun)(S_symbol *, void *),
                                        void *a
                                ) {
        int i;
        S_symbol *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void symTabMap3(
                                        struct symTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void symTabMap31(
                                        struct symTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void symTabMap32(
                                        struct symTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void symTabMap4(
                                        struct symTab *t,
                                        void (*fun)(S_symbol *, int),
                                        int a
                                ) {
        int i;
        S_symbol *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void symTabMap5(
                                        struct symTab *t,
                                        void (*fun)(S_symbol *, void *),
                                        void *arg
                                ) {
        int i;
        S_symbol *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void symTabStatistics(
                                        struct symTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_symbol *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
void javaFqtTabNAInit(struct javaFqtTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_symbolList *)*t->size);
}
void javaFqtTabInit(struct javaFqtTab *t, int size) {
        register int i;
        {t->tab = (S_symbolList **) stackMemoryAlloc((size)*sizeof(S_symbolList *)); };
        javaFqtTabNAInit(t, size);
}
int javaFqtTabIsMember(
                                        struct javaFqtTab *t,
                                        S_symbolList *elem,
                                        int *position,
                                        S_symbolList **original
                        ) {
        unsigned posid;
        S_symbolList *pp;
        posid = hashFun(elem->d->linkName);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if (( pp->d->b.symType==elem->d->b.symType && strcmp(pp->d->linkName,elem->d->linkName)==0 )) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int javaFqtTabNextMember(
                                        S_symbolList *elem,
                                        S_symbolList **original
                        ) {
        S_symbolList *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if (( pp->d->b.symType==elem->d->b.symType && strcmp(pp->d->linkName,elem->d->linkName)==0 )) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int javaFqtTabMembEqual(
                                        S_symbolList *e1,
                                        S_symbolList *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return(( e1->d->b.symType==e2->d->b.symType && strcmp(e1->d->linkName,e2->d->linkName)==0 ));
}
int javaFqtTabDelete(
                                        struct javaFqtTab *t,
                                        S_symbolList *elem
                        ) {
        unsigned posid;
        S_symbolList **pp;
        posid = hashFun(elem->d->linkName);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (( (*pp)->d->b.symType==elem->d->b.symType && strcmp((*pp)->d->linkName,elem->d->linkName)==0 )) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int javaFqtTabDeleteExact(
                                        struct javaFqtTab *t,
                                        S_symbolList *elem
                        ) {
        unsigned posid;
        S_symbolList **pp;
        posid = hashFun(elem->d->linkName);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int javaFqtTabDeleteLast(
                                        struct javaFqtTab *t,
                                        S_symbolList *elem
                        ) {
        unsigned posid;
        S_symbolList **pp, **dd;
        posid = hashFun(elem->d->linkName);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (( (*pp)->d->b.symType==elem->d->b.symType && strcmp((*pp)->d->linkName,elem->d->linkName)==0 )) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void javaFqtTabSet (
                                        struct javaFqtTab *t,
                                        S_symbolList *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void javaFqtTabSetLast (
                                        struct javaFqtTab *t,
                                        S_symbolList *elem,
                                        int position
                                ) {
        S_symbolList **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void javaFqtTabAdd (
                                        struct javaFqtTab *t,
                                        S_symbolList *elem,
                                        int *position
                                ) {
  S_symbolList *origin;
  if (! javaFqtTabIsMember(t,elem,position,&origin)) {
        javaFqtTabSet (t,elem,*position);
  }
}
void javaFqtTabFree(struct javaFqtTab *t) {
        { };
}
void javaFqtTabMap(
                                        struct javaFqtTab *t,
                                        void (*fun)(S_symbolList *)
                                ) {
        int i;
        S_symbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void javaFqtTabMap2(
                                        struct javaFqtTab *t,
                                        void (*fun)(S_symbolList *, void *),
                                        void *a
                                ) {
        int i;
        S_symbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void javaFqtTabMap3(
                                        struct javaFqtTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void javaFqtTabMap31(
                                        struct javaFqtTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void javaFqtTabMap32(
                                        struct javaFqtTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void javaFqtTabMap4(
                                        struct javaFqtTab *t,
                                        void (*fun)(S_symbolList *, int),
                                        int a
                                ) {
        int i;
        S_symbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void javaFqtTabMap5(
                                        struct javaFqtTab *t,
                                        void (*fun)(S_symbolList *, void *),
                                        void *arg
                                ) {
        int i;
        S_symbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void javaFqtTabStatistics(
                                        struct javaFqtTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_symbolList *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
void jslTypeTabNAInit(struct jslTypeTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_jslSymbolList *)*t->size);
}
void jslTypeTabInit(struct jslTypeTab *t, int size) {
        register int i;
        {t->tab = (S_jslSymbolList **) stackMemoryAlloc((size)*sizeof(S_jslSymbolList *)); };
        jslTypeTabNAInit(t, size);
}
int jslTypeTabIsMember(
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem,
                                        int *position,
                                        S_jslSymbolList **original
                        ) {
        unsigned posid;
        S_jslSymbolList *pp;
        posid = hashFun(elem->d->name);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if (( pp->d->b.symType==elem->d->b.symType && strcmp(pp->d->name,elem->d->name)==0 )) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int jslTypeTabNextMember(
                                        S_jslSymbolList *elem,
                                        S_jslSymbolList **original
                        ) {
        S_jslSymbolList *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if (( pp->d->b.symType==elem->d->b.symType && strcmp(pp->d->name,elem->d->name)==0 )) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int jslTypeTabMembEqual(
                                        S_jslSymbolList *e1,
                                        S_jslSymbolList *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return(( e1->d->b.symType==e2->d->b.symType && strcmp(e1->d->name,e2->d->name)==0 ));
}
int jslTypeTabDelete(
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem
                        ) {
        unsigned posid;
        S_jslSymbolList **pp;
        posid = hashFun(elem->d->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (( (*pp)->d->b.symType==elem->d->b.symType && strcmp((*pp)->d->name,elem->d->name)==0 )) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int jslTypeTabDeleteExact(
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem
                        ) {
        unsigned posid;
        S_jslSymbolList **pp;
        posid = hashFun(elem->d->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int jslTypeTabDeleteLast(
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem
                        ) {
        unsigned posid;
        S_jslSymbolList **pp, **dd;
        posid = hashFun(elem->d->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (( (*pp)->d->b.symType==elem->d->b.symType && strcmp((*pp)->d->name,elem->d->name)==0 )) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void jslTypeTabSet (
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void jslTypeTabSetLast (
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem,
                                        int position
                                ) {
        S_jslSymbolList **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void jslTypeTabAdd (
                                        struct jslTypeTab *t,
                                        S_jslSymbolList *elem,
                                        int *position
                                ) {
  S_jslSymbolList *origin;
  if (! jslTypeTabIsMember(t,elem,position,&origin)) {
        jslTypeTabSet (t,elem,*position);
  }
}
void jslTypeTabFree(struct jslTypeTab *t) {
        { };
}
void jslTypeTabMap(
                                        struct jslTypeTab *t,
                                        void (*fun)(S_jslSymbolList *)
                                ) {
        int i;
        S_jslSymbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void jslTypeTabMap2(
                                        struct jslTypeTab *t,
                                        void (*fun)(S_jslSymbolList *, void *),
                                        void *a
                                ) {
        int i;
        S_jslSymbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void jslTypeTabMap3(
                                        struct jslTypeTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void jslTypeTabMap31(
                                        struct jslTypeTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void jslTypeTabMap32(
                                        struct jslTypeTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void jslTypeTabMap4(
                                        struct jslTypeTab *t,
                                        void (*fun)(S_jslSymbolList *, int),
                                        int a
                                ) {
        int i;
        S_jslSymbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void jslTypeTabMap5(
                                        struct jslTypeTab *t,
                                        void (*fun)(S_jslSymbolList *, void *),
                                        void *arg
                                ) {
        int i;
        S_jslSymbolList *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void jslTypeTabStatistics(
                                        struct jslTypeTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_jslSymbolList *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
void refTabNAInit(struct refTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_symbolRefItem *)*t->size);
}
void refTabInit(struct refTab *t, int size) {
        register int i;
        {t->tab = (S_symbolRefItem **) stackMemoryAlloc((size)*sizeof(S_symbolRefItem *)); };
        refTabNAInit(t, size);
}
int refTabIsMember(
                                        struct refTab *t,
                                        S_symbolRefItem *elem,
                                        int *position,
                                        S_symbolRefItem **original
                        ) {
        unsigned posid;
        S_symbolRefItem *pp;
        posid = (hashFun(elem->name) + (unsigned)elem->vFunClass);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if (( pp->b.symType==elem->b.symType && pp->b.storage==elem->b.storage && pp->b.category==elem->b.category && pp->vApplClass==elem->vApplClass && strcmp(pp->name,elem->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int refTabNextMember(
                                        S_symbolRefItem *elem,
                                        S_symbolRefItem **original
                        ) {
        S_symbolRefItem *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if (( pp->b.symType==elem->b.symType && pp->b.storage==elem->b.storage && pp->b.category==elem->b.category && pp->vApplClass==elem->vApplClass && strcmp(pp->name,elem->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int refTabMembEqual(
                                        S_symbolRefItem *e1,
                                        S_symbolRefItem *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return(( e1->b.symType==e2->b.symType && e1->b.storage==e2->b.storage && e1->b.category==e2->b.category && e1->vApplClass==e2->vApplClass && strcmp(e1->name,e2->name)==0));
}
int refTabDelete(
                                        struct refTab *t,
                                        S_symbolRefItem *elem
                        ) {
        unsigned posid;
        S_symbolRefItem **pp;
        posid = (hashFun(elem->name) + (unsigned)elem->vFunClass);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (( (*pp)->b.symType==elem->b.symType && (*pp)->b.storage==elem->b.storage && (*pp)->b.category==elem->b.category && (*pp)->vApplClass==elem->vApplClass && strcmp((*pp)->name,elem->name)==0)) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int refTabDeleteExact(
                                        struct refTab *t,
                                        S_symbolRefItem *elem
                        ) {
        unsigned posid;
        S_symbolRefItem **pp;
        posid = (hashFun(elem->name) + (unsigned)elem->vFunClass);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int refTabDeleteLast(
                                        struct refTab *t,
                                        S_symbolRefItem *elem
                        ) {
        unsigned posid;
        S_symbolRefItem **pp, **dd;
        posid = (hashFun(elem->name) + (unsigned)elem->vFunClass);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if (( (*pp)->b.symType==elem->b.symType && (*pp)->b.storage==elem->b.storage && (*pp)->b.category==elem->b.category && (*pp)->vApplClass==elem->vApplClass && strcmp((*pp)->name,elem->name)==0)) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void refTabSet (
                                        struct refTab *t,
                                        S_symbolRefItem *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void refTabSetLast (
                                        struct refTab *t,
                                        S_symbolRefItem *elem,
                                        int position
                                ) {
        S_symbolRefItem **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void refTabAdd (
                                        struct refTab *t,
                                        S_symbolRefItem *elem,
                                        int *position
                                ) {
  S_symbolRefItem *origin;
  if (! refTabIsMember(t,elem,position,&origin)) {
        refTabSet (t,elem,*position);
  }
}
void refTabFree(struct refTab *t) {
        { };
}
void refTabMap(
                                        struct refTab *t,
                                        void (*fun)(S_symbolRefItem *)
                                ) {
        int i;
        S_symbolRefItem *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void refTabMap2(
                                        struct refTab *t,
                                        void (*fun)(S_symbolRefItem *, void *),
                                        void *a
                                ) {
        int i;
        S_symbolRefItem *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void refTabMap3(
                                        struct refTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void refTabMap31(
                                        struct refTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void refTabMap32(
                                        struct refTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void refTabMap4(
                                        struct refTab *t,
                                        void (*fun)(S_symbolRefItem *, int),
                                        int a
                                ) {
        int i;
        S_symbolRefItem *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void refTabMap5(
                                        struct refTab *t,
                                        void (*fun)(S_symbolRefItem *, void *),
                                        void *arg
                                ) {
        int i;
        S_symbolRefItem *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void refTabStatistics(
                                        struct refTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_symbolRefItem *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
void idTabNAInit(struct idTab *t, int size) {
        int i;
        t->numberOfElements = 0;
        t->size = size;
        memset(t->tab, 0, sizeof(S_fileItem*)*t->size);
}
void idTabInit(struct idTab *t, int size) {
        int i;
        {t->tab = (S_fileItem **) stackMemoryAlloc((size)*sizeof(S_fileItem *)); };
        idTabNAInit(t, size);
}
int idTabIsMember(
                                        struct idTab *t,
                                        S_fileItem *elem,
                                        int *position
                        ) {
        unsigned posid;
        posid = fileTabHashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashtab.tc", 57);};
        while (t->tab[posid] != NULL) {
                if ((strcmp(t->tab[posid]->name,elem->name)==0)) {
                        *position = posid;
                        return(1);
                }
                posid=(posid+211) % t->size;
        }
        *position = posid;
        return(0);
}
void idTabSet (
                                        struct idTab *t,
                                        S_fileItem *elem,
                                        int position
                                ) {
    if (t->tab[position]==NULL) {
                t->numberOfElements ++;
            if ((t->numberOfElements * 9) / 8 >= t->size) {
          fatalError(ERR_ST, "[hashAdd] file table overflowed", 65);
            }
        }
    t->tab[position] = elem;
}
void idTabAdd (
                                        struct idTab *t,
                                        S_fileItem *elem,
                                        int *position
                                ) {
  if (! idTabIsMember(t,elem,position)) {
        idTabSet (t,elem,*position);
  }
}
void idTabFree(struct idTab *t) {
        { };
}
void idTabMap(
                                        struct idTab *t,
                                        void (*fun)(S_fileItem *)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i]);
        }
}
void idTabMap2(
                                        struct idTab *t,
                                        void (*fun)(S_fileItem *, void *),
                                        void *a
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i], a);
        }
}
void idTabMap4(
                                        struct idTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *a,
                                        void *b
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(i, a, b);
        }
}
void idTabMap3(
                                        struct idTab *t,
                                        void (*fun)(S_fileItem *, int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i], i);
        }
}
void stackMemoryInit() {
        s_topBlock = (S_topBlock *) memory;
        { (s_topBlock)->firstFreeIndex = sizeof(S_topBlock); (s_topBlock)->tmpMemoryBasei = 0; (s_topBlock)->trail = NULL; (s_topBlock)->previousTopBlock = NULL;};
}
void *stackMemoryAlloc(int size) {
        register int i;
        i = s_topBlock->firstFreeIndex;
        i = ((char *)(((char*)(memory+i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(memory+i))-1) & (STANDARD_ALLIGNEMENT-1)))))-memory;
        if (i+size < SIZE_workMemory) {
                s_topBlock->firstFreeIndex = i+size;
                return( & memory[i] );
        } else {
        fatalError(ERR_ST,"i+size > SIZE_workMemory,\n\tworking memory overflowed,\n\tread TROUBLES section of README file\n", 65);
                { if (!(0)) internalCheckFail("0", "misc.c", 415);};
                return(NULL);
        }
}
void *stackMemoryRealloc(void *p, int n, int oldn) {
        { if (!(((char *)p) - memory + oldn == s_topBlock->firstFreeIndex)) internalCheckFail("((char *)p) - memory + oldn == s_topBlock->firstFreeIndex", "misc.c", 421);};
        if (s_topBlock->firstFreeIndex + n - oldn >= SIZE_workMemory) {
        fatalError(ERR_ST,"i+size > SIZE_workMemory,\n\tworking memory overflowed,\n\tread TROUBLES section of README file\n", 65);
                { if (!(0)) internalCheckFail("0", "misc.c", 424);};
        }
        s_topBlock->firstFreeIndex += n - oldn;
        return(p);
}
void *stackMemoryPush(void *p, int size) {
        void *m;
        m = stackMemoryAlloc(size);
        memcpy(m,p,size);
        return(m);
}
void stackMemoryPop(void *p, int size) {
        int i;
        i = s_topBlock->firstFreeIndex;
        if (i-size < 0) {
                fprintf(stderr,"i-size < 0\n"); { if (!(0)) internalCheckFail("0", "misc.c", 441);};
        }
        memcpy(p, & memory[i-size], size);
        s_topBlock->firstFreeIndex = i-size;
}
int *stackMemoryPushInt(int x) {
        return((int*)stackMemoryPush(&x, sizeof(int)));
}
char *stackMemoryPushString(char *s) {
        return((char*)stackMemoryPush(s, strlen(s)+1));
}
void stackMemoryBlockStart() {
        S_topBlock *p,top;
        top = *s_topBlock;
        p = ((S_topBlock*) stackMemoryPush(&top,sizeof(S_topBlock)));
        { (s_topBlock)->firstFreeIndex = s_topBlock->firstFreeIndex; (s_topBlock)->tmpMemoryBasei = tmpWorkMemoryi; (s_topBlock)->trail = s_topBlock->trail; (s_topBlock)->previousTopBlock = p;};
}
void stackMemoryBlockFree() {
        int memi;
        { if (!(s_topBlock && s_topBlock->previousTopBlock)) internalCheckFail("s_topBlock && s_topBlock->previousTopBlock", "misc.c", 472);};
        removeFromTrailUntil(s_topBlock->previousTopBlock->trail);
        { if (!(tmpWorkMemoryi >= s_topBlock->tmpMemoryBasei)) internalCheckFail("tmpWorkMemoryi >= s_topBlock->tmpMemoryBasei", "misc.c", 475);};
        tmpWorkMemoryi = s_topBlock->tmpMemoryBasei;
        memi = s_topBlock->firstFreeIndex;
        * s_topBlock = * s_topBlock->previousTopBlock;
        { if (!(s_topBlock != NULL)) internalCheckFail("s_topBlock != NULL", "misc.c", 482);};
}
void stackMemoryDump() {
        int i;
        fprintf(dumpOut,"start stackMemoryDump\n");
        fprintf(dumpOut,"sorry, not yet implemented ");
        for(i=0; i<s_topBlock->firstFreeIndex; i++) {
                if (i%10 == 0) fprintf(dumpOut," ");
                fprintf(dumpOut,".");
        }
        fprintf(dumpOut,"end stackMemoryDump\n");
}
static void trailDump() {
        S_freeTrail *t;
        fprintf(dumpOut,"\nstart trailDump\n");
        for(t=s_topBlock->trail; t!=NULL; t=t->next) fprintf(dumpOut,"%p ",t);
        fprintf(dumpOut,"\nstop trailDump\n");
}
void addToTrail (void (*a)(void*), void *p) {
        S_freeTrail *t;
        if ((s_topBlock->previousTopBlock == NULL) && (((s_language & (2)) != 0)||((s_language & (8)) != 0))) return;
        t = ((S_freeTrail*) stackMemoryAlloc(sizeof(S_freeTrail)));
        t->action = a;
        t->p = (void **) p;
        t->next = s_topBlock->trail;
        s_topBlock->trail = t;
}
void removeFromTrailUntil(S_freeTrail *untilP) {
        S_freeTrail *p;
        for(p=s_topBlock->trail; untilP<p; p=p->next) {
                { if (!(p!=NULL)) internalCheckFail("p!=NULL", "misc.c", 521);};
                (*(p->action))(p->p);
        }
        if (p!=untilP) {
                error(ERR_INTERNAL,"a block structure mismatch?");
        }
        s_topBlock->trail = p;
}
void symDump(S_symbol *s) {
        fprintf(dumpOut,"[symbol] %s\n",s->name);
}
void typeDump(S_typeModifiers *t) {
        fprintf(dumpOut,"dumpStart\n");
        for(; t!=NULL; t=t->next) {
                fprintf(dumpOut," %x\n",t->m);
        }
        fprintf(dumpOut,"dumpStop\n");
}
void symbolRefItemDump(S_symbolRefItem *ss) {
        fprintf(dumpOut,"%s\t%s %s %d %d %d %d %d\n",
                        ss->name,
                        s_fileTab.tab[ss->vApplClass]->name,
                        s_fileTab.tab[ss->vFunClass]->name,
                        ss->b.symType, ss->b.storage, ss->b.scope,
                        ss->b.accessFlags, ss->b.category);
}
int javaTypeStringSPrint(char *buff, char *str, int nameStyle, int *oNamePos) {
        int i, bj;
        char *pp;
        i = 0;
        if (oNamePos!=NULL) *oNamePos = i;
        for(pp=str; *pp; pp++) {
                if ( s_language == 4 &&
                                *pp == '.' &&
                                *(pp+1) == '<') {
                        while (*pp && *pp!='>') pp++;
                } else if (*pp == '/' || *pp == '$') {
                        if (nameStyle == SHORT_NAME) i=0;
                        else buff[i++] = '.';
                        if (oNamePos!=NULL) *oNamePos = i;
                } else {
                        buff[i++] = *pp;
                }
        }
        buff[i] = 0;
        return(i);
}
void typeSPrint(char *buff, int *size, S_typeModifiers *t,
                                char *name, int dclSepChar, int maxDeep, int typedefexp,
                                int longOrShortName, int *oNamePos) {
        unsigned u;
        S_symbol *dd; S_symbol *ddd;
        char pref[COMPLETION_STRING_SIZE];
        char post[COMPLETION_STRING_SIZE];
        char type[COMPLETION_STRING_SIZE];
        char tmp[COMPLETION_STRING_SIZE];
        char *ttm, *pp;
        int i,j,par,realsize,r,rr,jj,minInfi,typedefexpFlag;
        typedefexpFlag = typedefexp;
        type[0] = 0;
        i = COMPLETION_STRING_SIZE-1;
        pref[i]=0;
        j=0;
        for(;t!=NULL;t=t->next) {
                par = 0;
                for (;t!=NULL && t->m==TypePointer;t=t->next) {
                        { if (t->typedefin != NULL && typedefexpFlag) { { if (!(t->typedefin->name)) internalCheckFail("t->typedefin->name", "misc.c", 610);}; strcpy(type, t->typedefin->name); goto typebreak; } typedefexpFlag = 1;};
                        pref[--i]='*'; par=1;
                }
                { if (!(i>2)) internalCheckFail("i>2", "misc.c", 613);};
                if (t==NULL) goto typebreak;
                { if (t->typedefin != NULL && typedefexpFlag) { { if (!(t->typedefin->name)) internalCheckFail("t->typedefin->name", "misc.c", 615);}; strcpy(type, t->typedefin->name); goto typebreak; } typedefexpFlag = 1;};
                switch (t->m) {
                case TypeArray:
                        if (par) {pref[--i]='('; post[j++]=')'; }
                        if (((s_language & (4)) != 0)) {
                                pref[--i]=' '; pref[--i]=']'; pref[--i]='[';
                        } else {
                                post[j++]='['; post[j++]=']';
                        }
                        break;
                case TypeFunction:
                        if (par) {pref[--i]='('; post[j++]=')'; }
                        sprintf(post+j,"(");
                        j += strlen(post+j);
                        if (s_language == 4) {
                                jj = COMPLETION_STRING_SIZE - j - 100;
                                javaSignatureSPrint(post+j, &jj, t->u.m.sig,longOrShortName);
                                j += jj;
                        } else {
                                for(dd=t->u.f.args; dd!=NULL; dd=dd->next) {
                                        if (dd->b.symType == TypeElipsis) ttm = "...";
                                        else if (dd->name == NULL) ttm = "";
                                        else ttm = dd->name;
                                        if (dd->b.symType == TypeDefault && dd->u.type!=NULL) {
                                                jj = COMPLETION_STRING_SIZE - j - 100;
                                                typeSPrint(post+j,&jj,dd->u.type,ttm,' ',maxDeep-1,1,longOrShortName, NULL);
                                                j += jj;
                                        } else {
                                                sprintf(post+j,"%s",ttm);
                                                j += strlen(post+j);
                                        }
                                        if (dd->next!=NULL && j<COMPLETION_STRING_SIZE)
                                                sprintf(post+j,", ");
                                                j += strlen(post+j);
                                }
                        }
                        post[j++]=')';
                        break;
                case TypeStruct: case TypeUnion:
                        if (s_language != 4) {
                                if (t->m == TypeStruct) sprintf(type,"struct ");
                                else sprintf(type,"union ");
                                r = strlen(type);
                        } else r=0;
                        if (t->u.t->name!=NULL) {
                                if (s_language == 4) {
                                        r += javaTypeStringSPrint(type+r, t->u.t->linkName,longOrShortName, NULL);
                                } else {
                                        sprintf(type+r,"%s ",t->u.t->name);
                                        r += strlen(type+r);
                                }
                        }
                        if (maxDeep>0) {
                                minInfi = r;
                                sprintf(type+r,"{ ");
                                r += strlen(type+r);
                                { if (!(t->u.t->u.s)) internalCheckFail("t->u.t->u.s", "misc.c", 672);};
                                for(ddd=t->u.t->u.s->records; ddd!=NULL; ddd=ddd->next) {
                                        if (ddd->name == NULL) ttm = "";
                                        else ttm = ddd->name;
                                        rr = COMPLETION_STRING_SIZE - r - 100;
                                        { if (!(ddd->u.type)) internalCheckFail("ddd->u.type", "misc.c", 677);};
                                        typeSPrint(type+r, &rr, ddd->u.type, ttm,' ', maxDeep-1,1,longOrShortName, NULL);
                                        r += rr;
                                        if (ddd->next!=NULL && r<COMPLETION_STRING_SIZE) {
                                                sprintf(type+r,"; ");
                                                r += strlen(type+r);
                                        }
                                }
                                sprintf(type+r,"}");
                                r += strlen(type+r);
                                if (r > *size - 100) {
                                        r = minInfi;
                                        type[r] = 0;
                                }
                        }
                        break;
                case TypeEnum:
                        if (t->u.t->name==NULL) sprintf(type,"enum ");
                        else sprintf(type,"enum %s",t->u.t->linkName);
                        r = strlen(type);
                        break;
                default:
                        { if (!(t->m >= 0 && t->m < MAX_TYPE)) internalCheckFail("t->m >= 0 && t->m < MAX_TYPE", "misc.c", 711);};
                        { if (!(strlen(typesName[t->m]) < COMPLETION_STRING_SIZE)) internalCheckFail("strlen(typesName[t->m]) < COMPLETION_STRING_SIZE", "misc.c", 712);};
                        strcpy(type, typesName[t->m]);
                        r = strlen(type);
                        break;
                }
                { if (!(i>2 && j<COMPLETION_STRING_SIZE-3)) internalCheckFail("i>2 && j<COMPLETION_STRING_SIZE-3", "misc.c", 717);};
        }
typebreak:
        post[j]=0;
        realsize = strlen(type) + strlen(pref+i) +
                                strlen(name) + strlen(post) +2;
        if (realsize < *size) {
                if (dclSepChar==' ') {
                        sprintf(buff,"%s %s", type, pref+i);
                } else {
                        sprintf(buff,"%s%c %s", type, dclSepChar, pref+i);
                }
                *size = strlen(buff);
                if (oNamePos!=NULL) *oNamePos = *size;
                        sprintf(buff+ *size,"%s", name);
                        *size += strlen(buff+ *size);
                sprintf(buff+ *size,"%s", post);
                *size += strlen(buff+ *size);
        } else {
                *size = 0;
                if (oNamePos!=NULL) *oNamePos = *size;
                buff[0]=0;
        }
}
void throwsSprintf(char *out, int outsize, S_symbolList *exceptions) {
        int outi,firstflag;
        S_symbolList *ee;
        outi = 0;
        if (exceptions != NULL ) {
                sprintf(out+outi, " throws");
                outi += strlen(out+outi);
                firstflag = 1;
                for(ee=exceptions; ee!=NULL; ee=ee->next) {
                        if (outi-10 > outsize) break;
                        sprintf(out+outi, "%c%s", firstflag?' ':',', ee->d->name);
                        outi += strlen(out+outi);
                }
                if (ee!=NULL) sprintf(out+outi, "...");
        }
}
void macDefSPrintf(char *tt, int *size, char *name1, char *name2,
                                                                int argn, char **args, int *oNamePos) {
        int ii,ll,i,brief=0;
        ii = 0;
        sprintf(tt,"#define ");
        ll = strlen(tt);
        if (oNamePos!=NULL) *oNamePos = ll;
        sprintf(tt+ll,"%s%s",name1,name2);
        ii = strlen(tt);
        { if (!(ii< *size)) internalCheckFail("ii< *size", "misc.c", 786);};
        if (argn != -1) {
                sprintf(tt+ii,"(");
                ii += strlen(tt+ii);
                for(i=0;i<argn;i++) {
                        if (args[i]!=NULL && !brief) {
                                if (strcmp(args[i], s_cppVarArgsName)==0) sprintf(tt+ii,"...");
                                else sprintf(tt+ii,"%s",args[i]);
                                ii += strlen(tt+ii);
                        }
                        if (i+1<argn) {
                                sprintf(tt+ii,", ");
                                ii += strlen(tt+ii);
                        }
                        if (ii+100>= *size) {
                                sprintf(tt+ii,"...");
                                ii += strlen(tt+ii);
                                goto pbreak;
                        }
                }
        pbreak:
                sprintf(tt+ii,")");
                ii += strlen(tt+ii);
        }
        *size = ii;
}
char * string3ConcatInStackMem(char *str1, char *str2, char *str3) {
        int l1,l2,l3;
        char *p,*s;
        l1 = strlen(str1);
        l2 = strlen(str2);
        l3 = strlen(str3);
        {s = (char*) stackMemoryAlloc((l1+l2+l3+1)*sizeof(char)); };
        strcpy(s,str1);
        strcpy(s+l1,str2);
        strcpy(s+l1+l2,str3);
        return(s);
}
char *javaCutClassPathFromFileName(char *fname) {
        S_stringList *cp;
        int len;
        char *res,*ss;
        res = fname;
        ss = strchr(fname, ';');
        if (ss!=NULL) {
                res = ss+1;
                goto fini;
        }
        for(cp=s_javaClassPaths; cp!=NULL; cp=cp->next) {
                len = strlen(cp->d);
                if (fnnCmp(cp->d, fname, len) == 0) {
                        res = fname+len;
                        goto fini;
                }
        }
 fini:
        if (*res=='/' || *res=='\\') res++;
        return(res);
}
char *javaCutSourcePathFromFileName(char *fname) {
        S_stringList *cp;
        int len;
        char *res,*ss;
        res = fname;
        ss = strchr(fname, ';');
        if (ss!=NULL) return(ss+1);
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "misc.c", 857);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { len = strlen(currentPath); if (fnnCmp(currentPath, fname, len) == 0) { res = fname+len; goto fini; } }; currentPath += jmop_ind; currentPath++; }};
        if (s_javaStat!=NULL && s_javaStat->namedPackageDir != NULL) {
                len = strlen(s_javaStat->namedPackageDir);
                if (fnnCmp(s_javaStat->namedPackageDir, fname, len) == 0) {
                        res = fname+len;
                        goto fini;
                }
        }
 fini:
        if (*res=='/' || *res=='\\') res++;
        return(res);
}
void javaDotifyFileName(char *ss) {
        char *s, *o, *lp;
        lp = NULL;
        for (s=ss; *s; s++) {
                if (*s == '/' || *s == '\\') *s = '.';
        }
}
void javaDotifyClassName(char *ss) {
        char *s, *o;
        for (s=ss; *s; s++) {
                if (*s == '/' || *s == '\\' || *s=='$') *s = '.';
        }
}
void javaSlashifyDotName(char *ss) {
        char *s;
        for (s=ss; *s; s++) {
                if (*s == '.') *s = SLASH;
        }
}
static void getClassFqtNameFromFileNum(int fnum, char *ttt) {
        char *dd, *ss;
        ss = javaCutClassPathFromFileName(getRealFileNameStatic(s_fileTab.tab[fnum]->name));
        strcpy(ttt, ss);
        dd = lastOccurenceInString(ttt, '.');
        if (dd!=NULL) *dd=0;
}
void javaGetClassNameFromFileNum(int nn, char *tmpOut, int dotify) {
        char *ss,*s,*o,*lp;
        S_stringList *cp;
        int len;
        getClassFqtNameFromFileNum(nn, tmpOut);
        if (dotify==DOTIFY_NAME) javaDotifyFileName(tmpOut);
}
char *javaGetShortClassName(char *inn) {
        int i;
        char *cut,*res;
        cut = strchr(inn, '!');
        if (cut==NULL) cut = inn;
        else cut ++;
        res = cut;
        for(i=0; cut[i]; i++) {
                if (cut[i]=='.' || cut[i]=='/' || cut[i]=='\\' || cut[i]=='$') {
                        res = cut+i+1;
                }
        }
        return(res);
}
char *javaGetShortClassNameFromFileNum_st(int fnum) {
        static char res[TMP_STRING_SIZE];
        javaGetClassNameFromFileNum(fnum, res, DOTIFY_NAME);
        return(javaGetShortClassName(res));
}
char *javaGetNudePreTypeName_st( char *inn, int cutMode) {
        int i,len;
        char *cut,*res,*res2;
        static char ttt[TMP_STRING_SIZE];
        cut = strchr(inn, '!');
        if (cut==NULL) cut = inn;
        else cut ++;
        res = res2 = cut;
        for(i=0; cut[i] ; i++) {
                if (cut[i]=='.' || cut[i]=='/' || cut[i]=='\\'
                        || cut[i] == ';'
                        || (cut[i]=='$' && cutMode==CUT_OUTERS)) {
                        res = res2;
                        res2 = cut+i+1;
                }
        }
        len = res2-res-1;
        if (len<0) len=0;
        strncpy(ttt, res, len);
        ttt[len]=0;
        return(ttt);
}
void javaSignatureSPrint(char *buff, int *size, char *sig, int classstyle) {
        char post[COMPLETION_STRING_SIZE];
        int posti;
        char *ssig;
        int j,bj,typ;
        if (sig == NULL) return;
        j = 0;
        { if (!(*sig == '(')) internalCheckFail("*sig == '('", "misc.c", 973);};
        ssig = sig; posti=0; post[0]=0;
        for(ssig++; *ssig && *ssig!=')'; ssig++) {
                { if (!(j+1 < *size)) internalCheckFail("j+1 < *size", "misc.c", 976);};
                if (j+100 > *size) goto fini;
        switchLabel:
                switch (*ssig) {
                case '[':
                  sprintf(post+posti,"[]");
                  posti += strlen(post+posti);
                  for(ssig++; *ssig && isdigit(*ssig); ssig++) ;
                  goto switchLabel;
                case 'L':
                  bj = j;
                  for(ssig++; *ssig && *ssig!=';'; ssig++) {
                        if (*ssig != '/' && *ssig != '$') buff[j++] = *ssig;
                        else if (classstyle==LONG_NAME) buff[j++] = '.';
                        else j=bj;
                  }
                  break;
                default:
                  typ = s_javaCharCodeBaseTypes[*ssig];
                  { if (!(typ > 0 && typ < MAX_TYPE)) internalCheckFail("typ > 0 && typ < MAX_TYPE", "misc.c", 995);};
                  sprintf(buff+j, "%s", typesName[typ]);
                  j += strlen(buff+j);
                }
                sprintf(buff+j, "%s",post);
                j += strlen(buff+j);
                posti = 0; post[0] = 0;
                if (*(ssig+1)!=')') {
                  sprintf(buff+j, ", ");
                  j += strlen(buff+j);
                }
        }
 fini:
        { if (!(j+1 < *size)) internalCheckFail("j+1 < *size", "misc.c", 1008);};
        if (j+100 > *size) {
          j = *size - 100 - 3;
          sprintf(buff+j, "...");
          j += strlen(buff+j);
        }
        buff[j] = 0;
        *size = j;
}
void linkNamePrettyPrint(char *ff, char *javaLinkName, int maxlen,
                                                         int argsStyle) {
  int tlen;
  char *tt;
  tt = strchr(javaLinkName, '!');
  if (tt==NULL) tt = javaLinkName;
  else tt ++;
  for(; *tt && *tt!='('; tt++) {
        if (*tt == '/' || *tt=='\\' || *tt=='$') *ff++ = '.';
        else *ff++ = *tt;
        maxlen--;
        if (maxlen <=0) goto fini;
  }
  if (*tt == '(') {
        tlen = maxlen + 100;
        if (tlen <= 100) goto fini;
        *ff ++ = '('; tlen--;
        javaSignatureSPrint(ff, &tlen, tt, argsStyle);
        ff += tlen;
        *ff ++ = ')';
  }
 fini:
  *ff = 0;
}
char *simpleFileNameFromFileNum(int fnum) {
        return(
                simpleFileName(getRealFileNameStatic(s_fileTab.tab[fnum]->name))
                );
}
char *getShortClassNameFromClassNum_st(int fnum) {
        return(javaGetNudePreTypeName_st(getRealFileNameStatic(s_fileTab.tab[fnum]->name),s_opt.nestedClassDisplaying));
}
void printSymbolLinkNameString( FILE *ff, char *linkName) {
        char ttt[MAX_CX_SYMBOL_SIZE];
        linkNamePrettyPrint(ttt, linkName, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
        fprintf(ff,"%s", ttt);
}
void printClassFqtNameFromClassNum(FILE *ff, int fnum) {
        char ttt[MAX_CX_SYMBOL_SIZE];
        getClassFqtNameFromFileNum(fnum, ttt);
        printSymbolLinkNameString(ff, ttt);
}
void sprintfSymbolLinkName(char *ttt, S_olSymbolsMenu *ss) {
        if (ss->s.b.symType == TypeCppInclude) {
                sprintf(ttt, "%s", simpleFileName(getRealFileNameStatic(
                        s_fileTab.tab[ss->s.vApplClass]->name)));
        } else {
                linkNamePrettyPrint(ttt, ss->s.name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
        }
}
void printSymbolLinkName(FILE *ff, S_olSymbolsMenu *ss) {
        char ttt[MAX_CX_SYMBOL_SIZE];
        sprintfSymbolLinkName(ttt, ss);
        fprintf(ff, "%s", ttt);
}
void fillTrivialSpecialRefItem( S_symbolRefItem *ddd , char *name) {
        { (&ddd->b)->symType = TypeUnknown; (&ddd->b)->storage = StorageAuto; (&ddd->b)->scope = ScopeAuto; (&ddd->b)->accessFlags = 0x000; (&ddd->b)->category = CatLocal; (&ddd->b)->htmlWasLn = 0;};
        { (ddd)->name = name; (ddd)->fileHash = cxFileHashNumber(name); (ddd)->vApplClass = s_noneFileIndex; (ddd)->vFunClass = s_noneFileIndex; (ddd)->b = ddd->b; (ddd)->refs = NULL; (ddd)->next = NULL;};
}
void fPutDecimal(FILE *ff, int num) {
        static char ttt[TMP_STRING_SIZE]= {0,};
        char *d;
        int n;
        n = num;
        { if (!(n>0)) internalCheckFail("n>0", "misc.c", 1098);};
        d = ttt+TMP_STRING_SIZE-1;
        while (n>=10) {
                *(--d) = n%10 + '0';
                n = n/10;
        }
        *(--d) = n + '0';
        { if (!(d>=ttt)) internalCheckFail("d>=ttt", "misc.c", 1105);};
        fputs(d, ff);
}
char *strmcpy(char *dest, char *src) {
        register char *p1,*p2;
        for(p1=dest,p2=src; *p2; p1++, p2++) *p1 = *p2;
        *p1 = 0;
        return(p1);
}
char *lastOccurenceInString(char *ss, int ch) {
        register char *s,*res;
        res = NULL;
        for(s=ss; *s; s++) {
                if (*s == ch) res=s;
        }
        return(res);
}
char *lastOccurenceOfSlashOrAntiSlash(char *ss) {
        register char *s,*res;
        res = NULL;
        for(s=ss; *s; s++) {
                if (*s == '/' || *s == '\\') res=s;
        }
        return(res);
}
char * getFileSuffix(char *fn) {
        char *cc;
        if (fn == NULL) return("");
        cc = fn + strlen(fn);
        while (*cc != '.' && *cc != SLASH && cc > fn) cc--;
        return(cc);
}
char *simpleFileName(char *fullFileName) {
        char *pp,*fn;
        for(fn=pp=fullFileName; *pp!=0; pp++) {
                if (*pp == '/' || *pp == SLASH) fn = pp+1;
        }
        return(fn);
}
char *simpleFileNameWithoutSuffix_st(char *fullFileName) {
        static char res[MAX_FILE_NAME_SIZE];
        char *pp,*fn;
        int i;
        for(fn=pp=fullFileName; *pp!=0; pp++) {
                if (*pp == '/' || *pp == SLASH) fn = pp+1;
        }
        for (i=0; *fn!='.' && *fn; i++,fn++) {
                res[i] = *fn;
        }
        res[i] = 0;
        return(res);
}
char *directoryName_st(char *fullFileName) {
        static char res[MAX_FILE_NAME_SIZE];
        int ii;
        copyDir(res, fullFileName, &ii);
        { if (!(ii < MAX_FILE_NAME_SIZE-1)) internalCheckFail("ii < MAX_FILE_NAME_SIZE-1", "misc.c", 1168);};
        if (ii>2 && res[ii-1]==SLASH) res[ii-1] = 0;
        return(res);
}
int pathncmp(char *ss1, char *ss2, int n, int caseSensitive) {
        register char *s1,*s2;
        register int i;
        int res;
        res = 0;
#if (!defined (__WIN32__)) && (! defined (__OS2__))
        if (caseSensitive) return(strncmp(ss1,ss2,n));
#endif
        if (n<=0) return(0);
#if defined (__WIN32__) || defined (__OS2__)
        if (ss1[0]!=0 && tolower(ss1[0])==tolower(ss2[0]) && ss1[1]==':' && ss2[1]==':') {
                ss1+=2;
                ss2+=2;
                n -= 2;
        }
#endif
        if (n<=0) return(0);
        for(s1=ss1,s2=ss2,i=1; *s1 && *s2 && i<n; s1++,s2++,i++) {
#if defined (__WIN32__) || defined (__OS2__)
                if ( (*s1 == '/' || *s1 == '\\')
                        && (*s2 == '/' || *s2 == '\\')) continue;
#endif
                if (caseSensitive) {
                        if (*s1 != *s2) break;
                } else {
                        if (tolower(*s1) != tolower(*s2)) break;
                }
        }
#if defined (__WIN32__) || defined (__OS2__)
        if ( (*s1 == '/' || *s1 == '\\')
                && (*s2 == '/' || *s2 == '\\')) {
                res = 0;
        } else
#endif
                if (caseSensitive) {
                res = *s1 - *s2;
        } else {
                res = tolower(*s1) - tolower(*s2);
        }
        return(res);
}
int fnnCmp(char *ss1, char *ss2, int n) {
        return(pathncmp(ss1, ss2, n, s_opt.fileNamesCaseSensitive));
}
int fnCmp(char *ss1, char *ss2) {
        register char *s1,*s2;
        int n;
#if (!defined (__WIN32__)) && (! defined (__OS2__))
        if (s_opt.fileNamesCaseSensitive) return(strcmp(ss1,ss2));
#endif
        n = strlen(ss1);
        return(fnnCmp(ss1,ss2,n+1));
}
static S_intlist *shellMatchNewState(int s, S_intlist *next) {
  S_intlist *res;
  { { int n = (1) * sizeof(S_intlist); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { res = NULL; } else { res = (S_intlist*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (res==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_intlist); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { res = NULL; } else { res = (S_intlist*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
  res->i = s;
  res->next = next;
  return(res);
}
static void shellMatchDeleteState(S_intlist **s) {
  S_intlist *p;
  p = *s;
  *s = (*s)->next;
  { {}; olcxMemoryAllocatedBytes -= sizeof(S_intlist); free(p);};
}
static int shellMatchParseBracketPattern(char *pattern, int pi, int caseSensitive, char *asciiMap) {
        register int i,j,m;
        int setval = 1;
        i = pi;
        { if (!(pattern[i] == '[')) internalCheckFail("pattern[i] == '['", "misc.c", 1251);};
        i++;
        if (pattern[i] == '^') {
                setval = ! setval;
                i++;
        }
        memset(asciiMap, ! setval, 256);
        if (pattern[i]==']') {
                asciiMap[pattern[i]] = setval;
                i++;
        }
        while (pattern[i] && pattern[i]!=']') {
                if (pattern[i+1]=='-') {
                        m = pattern[i+2];
                        for(j=pattern[i]; j<=m; j++) asciiMap[j] = setval;
                        if ((! caseSensitive) && isalpha(pattern[i]) && isalpha(pattern[i+2])) {
                                m = tolower(pattern[i+2]);
                                for(j=tolower(pattern[i]); j<=m; j++) asciiMap[j] = setval;
                                m = toupper(pattern[i+2]);
                                for(j=toupper(pattern[i]); j<=m; j++) asciiMap[j] = setval;
                        }
                        i += 3;
                } else {
                        asciiMap[pattern[i]] = setval;
                        if ((! caseSensitive) && isalpha(pattern[i])) {
                                asciiMap[tolower(pattern[i])] = setval;
                                asciiMap[toupper(pattern[i])] = setval;
                        }
                        i ++;
                }
        }
        if (pattern[i] != ']') {
                error(ERR_ST,"wrong [] pattern in regexp");
        }
        return(i);
}
int shellMatch(char *string, int stringLen, char *pattern, int caseSensitive) {
        int si, pi, slen, plen, res;
        S_intlist *states, **p, *f;
        char asciiMap[256];
        si = 0;
        slen = stringLen;
        plen = strlen(pattern);
        states = shellMatchNewState(0, NULL);
        while (si<slen) {
                if (states == NULL) goto fini;
                p= &states;
                while(*p!=NULL) {
                        pi = (*p)->i;
                        if (pattern[pi] == 0) {shellMatchDeleteState(p); continue;}
                        if (pattern[pi] == '*') {
                                (*p)->next = shellMatchNewState(pi+1, (*p)->next);
                        } else if (pattern[pi] == '?') {
                                (*p)->i = pi + 1;
                        } else if (pattern[pi] == '[') {
                                pi = shellMatchParseBracketPattern(pattern, pi, 1, asciiMap);
                                if (! asciiMap[string[si]]) {shellMatchDeleteState(p); continue;}
                                if (pattern[pi]==']') (*p)->i = pi+1;
                        } else if (isalpha(pattern[pi]) && ! caseSensitive) {
                                if (tolower(pattern[pi]) != tolower(string[si])) {
                                        shellMatchDeleteState(p); continue;
                                }
                                (*p)->i = pi + 1;
                        } else {
                                if (pattern[pi] != string[si]) {
                                        shellMatchDeleteState(p); continue;
                                }
                                (*p)->i = pi + 1;
                        }
                        p= &(*p)->next;
                }
                si ++;
        }
 fini:
        res = 0;
        for(f=states; f!=NULL; f=f->next) {
                if (f->i == plen || (f->i < plen
                                                         && strncmp(pattern+f->i,"**************",plen-f->i)==0)
                        ) {
                        res = 1;
                        break;
                }
        }
        while (states!=NULL) shellMatchDeleteState(&states);
        return(res);
}
int containsWildCharacter(char *ss) {
        register int c;
        for(; *ss; ss++) {
                c = *ss;
                if (c=='*' || c=='?' || c=='[') return(1);
        }
        return(0);
}
static void expandWildCharsMapFun(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5) {
        char ttt[MAX_FILE_NAME_SIZE];
        char *dir1, *pattern, *dir2, **outpath;
        int *freeolen;
        struct stat st;
        dir1 = (char*) a1;
        pattern = (char*) a2;
        dir2 = (char*) a3;
        outpath = (char **) a4;
        freeolen = a5;
        if (dir2[0] == SLASH) {
                sprintf(ttt, "%s%s", dir1, file);
                if (statb(ttt, &st)!=0 || (st.st_mode & S_IFMT) != S_IFDIR) return;
        }
        if (shellMatch(file, strlen(file), pattern, s_opt.fileNamesCaseSensitive)) {
                sprintf(ttt, "%s%s%s", dir1, file, dir2);
                expandWildCharactersInOnePathRec(ttt, outpath, freeolen);
        }
}
void expandWildCharactersInOnePathRec(char *fn, char **outpaths, int *freeolen) {
        char ttt[MAX_FILE_NAME_SIZE];
        int i, si,di,bdi, ldi, len;
        struct stat st;
        if (containsWildCharacter(fn)) {
                si = 0; di = 0;
                while (fn[si]) {
                        ldi = di;
                        while (fn[si] && fn[si]!=SLASH) {
                                ttt[di] = fn[si];
                                si++; di++;
                        }
                        ttt[di] = 0;
                        if (containsWildCharacter(ttt+ldi)) {
                                for(i=di; i>=ldi; i--) ttt[i+1] = ttt[i];
                                ttt[ldi]=0;
                                mapDirectoryFiles(ttt, expandWildCharsMapFun, 0, ttt, ttt+ldi+1,
                                                                  (S_completions*)(fn+si), outpaths, freeolen);
                        } else {
                                ttt[di] = fn[si];
                                if (fn[si]) { di++; si++; }
                        }
                }
        } else if (statb(fn, &st) == 0) {
                len = strlen(fn);
                strcpy(*outpaths, fn);
                *outpaths += len;
                *freeolen -= len;
                *((*outpaths)++) = CLASS_PATH_SEPARATOR;
                *(*outpaths) = 0;
                *freeolen -= 1;
                if (*freeolen <= 0) {
                        sprintf(tmpBuff, "expanded option %s overflows over MAX_OPTION_LEN",
                                        *outpaths-(MAX_OPTION_LEN-*freeolen));
                        fatalError(ERR_ST, tmpBuff, 65);
                }
        }
}
void expandWildCharactersInOnePath(char *fn, char *outpaths, int freeolen) {
        char *oop, *opaths;
        int olen;
        { if (!(freeolen == MAX_OPTION_LEN)) internalCheckFail("freeolen == MAX_OPTION_LEN", "misc.c", 1426);};
        oop = opaths = outpaths; olen = freeolen;
        expandWildCharactersInOnePathRec(fn, &opaths, &olen);
        *opaths = 0;
        if (opaths != oop) *(opaths-1) = 0;
}
void expandWildCharactersInPaths(char *paths, char *outpaths, int freeolen) {
        char *oop, *opaths;
        int olen;
        { if (!(freeolen == MAX_OPTION_LEN)) internalCheckFail("freeolen == MAX_OPTION_LEN", "misc.c", 1436);};
        oop = opaths = outpaths; olen = freeolen;
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(paths!=NULL)) internalCheckFail("paths!=NULL", "misc.c", 1438);}; jmop_pp = paths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { expandWildCharactersInOnePathRec(currentPath, &opaths, &olen); }; currentPath += jmop_ind; currentPath++; }};
        *opaths = 0;
        if (opaths != oop) *(opaths-1) = 0;
}
char * getRealFileNameStatic(char *fn) {
        static char ttt[MAX_FILE_NAME_SIZE];
#if defined (__WIN32__)
        WIN32_FIND_DATA fdata;
        HANDLE han;
        int si,di,bdi;
        for(si=0,di=0; fn[si]&&fn[si]!=SLASH; si++,di++) ttt[di]=fn[si];
        if (fn[si]) ttt[di++]=fn[si++];
        while (fn[si] && fn[si]!=';') {
                bdi = di;
                while (fn[si] && fn[si]!=SLASH && fn[si]!=';') {
                        ttt[di] = fn[si];
                        si++; di++;
                }
                ttt[di] = 0;
                han = FindFirstFile(ttt, &fdata);
                if (han == INVALID_HANDLE_VALUE) goto bbreak;
                strcpy(ttt+bdi, fdata.cFileName);
                di = bdi + strlen(ttt+bdi);
                FindClose(han);
                { if (!(di < MAX_FILE_NAME_SIZE-1)) internalCheckFail("di < MAX_FILE_NAME_SIZE-1", "misc.c", 1469);};
                ttt[di] = fn[si];
                if (fn[si]) { di++; si++; }
        }
 bbreak:
        strcpy(ttt+di, fn+si);
        return(ttt);
#else
#if defined (__OS2__)
        FILEFINDBUF3 fdata = {0};
        HDIR han = HDIR_CREATE;
        ULONG nEntries = 1;
        int si,di,bdi;
        for(si=0,di=0; fn[si]&&fn[si]!=SLASH; si++,di++) ttt[di]=fn[si];
        if (fn[si]) ttt[di++]=fn[si++];
        while (fn[si] && fn[si]!=';') {
                bdi = di;
                while (fn[si] && fn[si]!=SLASH && fn[si]!=';') {
                        ttt[di] = fn[si];
                        si++; di++;
                }
                ttt[di] = 0;
                if (DosFindFirst (ttt, &han, FILE_NORMAL | FILE_DIRECTORY, &fdata, sizeof (FILEFINDBUF3), &nEntries, FIL_STANDARD)) goto bbreak;
                strcpy(ttt+bdi, fdata.achName);
                di = bdi + strlen(ttt+bdi);
                DosFindClose(han);
                { if (!(di < MAX_FILE_NAME_SIZE-1)) internalCheckFail("di < MAX_FILE_NAME_SIZE-1", "misc.c", 1496);};
                ttt[di] = fn[si];
                if (fn[si]) { di++; si++; }
        }
 bbreak:
        strcpy(ttt+di, fn+si);
        return(ttt);
#else
        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE-1", "misc.c", 1504);};
        strcpy(ttt,fn);
        return(fn);
#endif
#endif
}
#if defined (__WIN32__) || defined (__OS2__)
int mapPatternFiles(
                                        char *pattern ,
                                        void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                                        char *a1, char *a2,
                                        S_completions *a3,
                                        void *a4, int *a5) {
#if defined (__WIN32__)
        WIN32_FIND_DATA fdata;
        HANDLE han;
        int res;
        res = 0;
        han = FindFirstFile(pattern, &fdata);
        if (han != INVALID_HANDLE_VALUE) {
                do {
                        if ( strcmp(fdata.cFileName,".")!=0
                                        && strcmp(fdata.cFileName,"..")!=0) {
                                (*fun)(fdata.cFileName, a1, a2, a3, a4, a5);
                                res = 1;
                        }
                } while (FindNextFile(han,&fdata));
                FindClose(han);
        }
        return(res);
#else
        FILEFINDBUF3 fdata = {0};
        HDIR han = HDIR_CREATE;
        ULONG nEntries = 1;
        int res;
        res = 0;
        if (!DosFindFirst (pattern, &han, FILE_NORMAL | FILE_DIRECTORY, &fdata, sizeof (FILEFINDBUF3), &nEntries, FIL_STANDARD)) {
        do {
                        if ( strcmp(fdata.achName,".")!=0
                                 && strcmp(fdata.achName,"..")!=0) {
                (*fun)(fdata.achName, a1, a2, a3, a4, a5);
                res = 1;
                        }
        } while (!DosFindNext (han, &fdata, sizeof (FILEFINDBUF3), &nEntries));
        DosFindClose(han);
        }
        return(res);
#endif
}
#endif
int mapDirectoryFiles(
                char *dirname,
                void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                int allowEditorFilesFlag,
                char *a1,
                char *a2,
                S_completions *a3,
                void *a4,
                int *a5
        ){
        int res=0;
#ifdef __WIN32__
        WIN32_FIND_DATA fdata;
        HANDLE han;
        char *s,*d;
        char ttt[MAX_FILE_NAME_SIZE];
        for (s=dirname,d=ttt; *s; s++,d++) {
                if (*s=='/') *d=SLASH;
                else *d = *s;
        }
        { if (!(d-ttt < MAX_FILE_NAME_SIZE-3)) internalCheckFail("d-ttt < MAX_FILE_NAME_SIZE-3", "misc.c", 1580);};
        sprintf(d,"%c*",SLASH);
        res = mapPatternFiles( ttt, fun, a1, a2, a3, a4, a5);
#else
#ifdef __OS2__
        char *s,*d;
        char ttt[MAX_FILE_NAME_SIZE];
        for (s=dirname,d=ttt; *s; s++,d++) {
                if (*s=='/') *d=SLASH;
                else *d = *s;
        }
        { if (!(d-ttt < MAX_FILE_NAME_SIZE-3)) internalCheckFail("d-ttt < MAX_FILE_NAME_SIZE-3", "misc.c", 1591);};
        sprintf(d,"%c*",SLASH);
        res = mapPatternFiles( ttt, fun, a1, a2, a3, a4, a5);
#else
        struct stat stt;
        DIR *fd;
        struct dirent *dirbuf;
        if ( statb(dirname,&stt) == 0
                        && (stt.st_mode & S_IFMT) == S_IFDIR
                        && (fd = opendir(dirname)) != NULL) {
                while ((dirbuf=readdir(fd)) != NULL) {
                        if (
#ifndef __QNX__
                                dirbuf->d_ino != 0 &&
#endif
                                strcmp(dirbuf->d_name, ".") != 0
                                && strcmp(dirbuf->d_name, "..") != 0) {
                                (*fun)(dirbuf->d_name, a1, a2, a3, a4, a5);
                                res = 1;
                        }
                }
                closedir(fd);
        }
#endif
#endif
        if (s_ropt.refactoringRegime == RegimeRefactory
                && allowEditorFilesFlag==ALLOW_EDITOR_FILES) {
                res |= editorMapOnNonexistantFiles(dirname, fun, DEEP_ONE, a1, a2, a3, a4, a5);
        }
        return(res);
}
static char *concatFNameInTmpMemory( char *dirname , char *packfile) {
        register char *s, *tt, *fname;
        fname = tmpMemory;
        tt = strmcpy(fname, dirname);
        if (*packfile) {
                *tt = SLASH;
                strcpy(tt+1,packfile);
#if defined (__WIN32__) || defined (__OS2__)
                for(s=tt+1; *s; s++) if (*s=='/') *s=SLASH;
#endif
        }
        return(fname);
}
static int pathsStringContainsPath(char *paths, char *path) {
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(paths!=NULL)) internalCheckFail("paths!=NULL", "misc.c", 1642);}; jmop_pp = paths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { if (fnCmp(currentPath, path)==0) { return(1); } }; currentPath += jmop_ind; currentPath++; }};
        return(0);
}
static int classPathContainsPath(char *path) {
        S_stringList *cp;
        for (cp=s_javaClassPaths; cp!=NULL; cp=cp->next) {
                if (fnCmp(cp->d, path)==0) {
                        return(1);
                }
        }
        return(0);
}
int fileNameHasOneOfSuffixes(char *fname, char *suffs) {
        char *suff;
        suff = getFileSuffix(fname);
        if (suff==NULL) return(0);
        if (*suff == '.') suff++;
        return(pathsStringContainsPath(suffs, suff));
}
int stringEndsBySuffix(char *s, char *suffix) {
        int sl, sfl;
        sl = strlen(s);
        sfl = strlen(suffix);
        if (sl >= sfl && strcmp(s+sl-sfl, suffix)==0) return(1);
        return(0);
}
int stringContainsSubstring(char *s, char *subs) {
        register int i, im;
        int sl, sbl;
        sl = strlen(s);
        sbl = strlen(subs);
        im = sl-sbl;
        for(i=0; i<=im; i++) {
                if (strncmp(s+i, subs, sbl)==0) return(1);
        }
        return(0);
}
int substringIndexWithLimit(char *s, int limit, char *subs) {
        register int i, im;
        int sl, sbl;
        sl = limit;
        sbl = strlen(subs);
        im = sl-sbl;
        for(i=0; i<=im; i++) {
                if (strncmp(s+i, subs, sbl)==0) return(i);
        }
        return(-1);
}
int substringIndex(char *s, char *subs) {
        register int i, im;
        int sl, sbl;
        sl = strlen(s);
        sbl = strlen(subs);
        im = sl-sbl;
        for(i=0; i<=im; i++) {
                if (strncmp(s+i, subs, sbl)==0) return(i);
        }
        return(-1);
}
void javaGetPackageNameFromSourceFileName(char *src, char *opack) {
        char *sss, *ss, *dd;
        sss = javaCutSourcePathFromFileName(src);
        strcpy(opack, sss);
        { if (!(strlen(opack)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(opack)+1 < MAX_FILE_NAME_SIZE", "misc.c", 1720);};
        dd = lastOccurenceInString(opack, '.');
        if (dd!=NULL) *dd=0;
        javaDotifyFileName(opack);
        dd = lastOccurenceInString(opack, '.');
        if (dd!=NULL) *dd=0;
}
static int fileIsFromDirectory(char *file, char *dir) {
        int fl, dl, cmp;
        char ttt[MAX_FILE_NAME_SIZE];
        fl = strlen(file);
        dl = strlen(dir);
        if (dl>fl) return(0);
        if (file[dl]!='/' && file[dl]!='\\') return(0);
        strncpy(ttt, file, dl);
        ttt[dl]=0;
        cmp = fnCmp(ttt, dir);
        if (cmp!=0) return(0);
        if (strchr(file+dl+1, '/')!=NULL) return(0);
        if (strchr(file+dl+1, '\\')!=NULL) return(0);
        return(1);
}
void javaMapDirectoryFiles1(
                char *packfile,
                void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                S_completions *a1,
                void *a2,
                int *a3
        ){
        S_stringList *cp;
        struct stat stt;
        struct dirent *dirbuf;
        char *tt,*fname,*ttt, *filename;
        int i;
        if (packfile == NULL) packfile = "";
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "misc.c", 1788);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { fname = concatFNameInTmpMemory( currentPath, packfile); mapDirectoryFiles(fname,fun,ALLOW_EDITOR_FILES,currentPath,packfile,a1,a2,a3); }; currentPath += jmop_ind; currentPath++; }};
        for (cp=s_javaClassPaths; cp!=NULL; cp=cp->next) {
                if ((! pathsStringContainsPath(s_javaSourcePaths, cp->d))) {
                        { if (!(strlen(cp->d)+strlen(packfile)+2 < SIZE_TMP_MEM)) internalCheckFail("strlen(cp->d)+strlen(packfile)+2 < SIZE_TMP_MEM", "misc.c", 1796);};
                        fname = concatFNameInTmpMemory( cp->d, packfile);
                        mapDirectoryFiles(fname,fun,ALLOW_EDITOR_FILES,cp->d,packfile,a1,a2,a3);
                }
        }
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                javaMapZipDirFile(&s_zipArchivTab[i],packfile,a1,a2,a3,fun,
                                                  s_zipArchivTab[i].fn,packfile);
        }
        if (s_javaStat->namedPackageDir != NULL) {
                if ((! pathsStringContainsPath(s_javaSourcePaths, s_javaStat->namedPackageDir))
                        && (! classPathContainsPath(s_javaStat->namedPackageDir))) {
                        fname = concatFNameInTmpMemory(s_javaStat->namedPackageDir, packfile);
                        mapDirectoryFiles(fname,fun,ALLOW_EDITOR_FILES,s_javaStat->namedPackageDir,packfile,a1,a2,a3);
                }
        }
}
void javaMapDirectoryFiles2(
                S_idIdentList *packid,
                void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                S_completions *a1,
                void *a2,
                int *a3
        ){
        char *packfile;
        char dname[MAX_FILE_NAME_SIZE];
        packfile=javaCreateComposedName(NULL,packid,'/',NULL,dname,MAX_FILE_NAME_SIZE);
        javaMapDirectoryFiles1(packfile,fun,a1,a2,a3);
}
static void scanClassFile(char *zip, char *file, void *arg) {
        char ttt[MAX_FILE_NAME_SIZE];
        char *tt, *suff;
        S_symbol *memb;
        S_position pos;
        int cpi, fileInd;
        suff = getFileSuffix(file);
        if (fnCmp(suff, ".class")==0) {
                cpi = s_cache.cpi;
                s_cache.activeCache = 1;
                poseCachePoint(0);
                s_cache.activeCache = 0;
                memb = javaGetFieldClass(file, &tt);
                fileInd = javaCreateClassFileItem( memb);
                if (! s_fileTab.tab[fileInd]->b.cxSaved) {
                        sprintf(ttt, "%s%s", zip, file);
                        { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "misc.c", 1851);};
                        { if (!(memb->u.s)) internalCheckFail("memb->u.s", "misc.c", 1853);};
                        javaReadClassFile(ttt, memb, DO_NOT_LOAD_SUPER);
                }
                recoverCachePoint(cpi-1,s_cache.cp[cpi-1].lbcc,0);
        }
}
void jarFileParse() {
        int archi,ii,rr;
        archi = zipIndexArchive(s_input_file_name);
        rr = addFileTabItem(s_input_file_name, &ii);
        { if (!(rr==0)) internalCheckFail("rr==0", "misc.c", 1869);};
        testFileModifTime(ii);
        s_fileTab.tab[ii]->b.cxLoading = 1;
        if (archi>=0 && archi<MAX_JAVA_ZIP_ARCHIVES) {
                fsRecMapOnFiles(s_zipArchivTab[archi].dir, s_zipArchivTab[archi].fn,
                                                "", scanClassFile, NULL);
        }
        s_fileTab.tab[ii]->b.cxLoaded = 1;
}
void scanJarFilesForTagSearch() {
        int i;
        for (i=0; i<MAX_JAVA_ZIP_ARCHIVES; i++) {
                fsRecMapOnFiles(s_zipArchivTab[i].dir, s_zipArchivTab[i].fn,
                                                "", scanClassFile, NULL);
        }
}
void classFileParse() {
        char ttt[MAX_FILE_NAME_SIZE];
        char *t,*tt;
        { if (!(strlen(s_input_file_name) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(s_input_file_name) < MAX_FILE_NAME_SIZE-1", "misc.c", 1892);};
        strcpy(ttt, s_input_file_name);
        tt = strchr(ttt, ';');
        if (tt==NULL) {
                ttt[0]=0;
                t = s_input_file_name;
        } else {
                *(tt+1) = 0;
                t = strchr(s_input_file_name, ';');
                { if (!(t!=NULL)) internalCheckFail("t!=NULL", "misc.c", 1901);};
                t ++;
        }
        scanClassFile(ttt, t, NULL);
}
int optionsOverflowHandler(int n) {
        fatalError(ERR_NO_MEMORY, "opiMemory", 65);
        return(1);
}
int cxMemoryOverflowHandler(int n) {
        int delta,ofaktor,faktor,oldsize, newsize;
        S_memory *oldcxMemory;
        { if (s_opt.debug) {fprintf(dumpOut,"Reallocating cxMemory.\n");fflush(dumpOut);}};
        if (cxMemory!=NULL) {
                oldsize = cxMemory->size;
        } else {
                oldsize = 0;
        }
        ofaktor = oldsize / CX_MEMORY_CHUNK_SIZE;
        faktor = ((n>1)?(n-1):0)/CX_MEMORY_CHUNK_SIZE + 1;
        faktor += ofaktor;
        if (ofaktor*2 > faktor) faktor = ofaktor*2;
        newsize = faktor * CX_MEMORY_CHUNK_SIZE;
        oldcxMemory = cxMemory;
        if (oldcxMemory!=NULL) free(oldcxMemory);
        cxMemory = malloc(newsize + sizeof(S_memory));
        if (cxMemory!=NULL) {
                { (cxMemory)->overflowHandler = cxMemoryOverflowHandler; (cxMemory)->i = 0; (cxMemory)->size = newsize; (cxMemory)->b = 0;};
        }
        return(cxMemory!=NULL);
}
