
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
typedef struct olcxTab S_olcxTab;
struct olcxTab {
        int size;
        S_userOlcx **tab;
};
extern void olcxTabInit ();
extern void olcxTabNAInit ();
extern int olcxTabIsMember ();
int olcxTabMembEqual ();
int olcxTabNextMember ();
void olcxTabSet ();
void olcxTabSetLast ();
extern void olcxTabAdd ();
int olcxTabDelete ();
int olcxTabDeleteExact ();
int olcxTabDeleteLast ();
extern void olcxTabFree ();
extern void olcxTabMap ();
extern void olcxTabMap2 ();
extern void olcxTabMap3 ();
extern void olcxTabMap31 ();
extern void olcxTabMap32 ();
extern void olcxTabMap4 ();
extern void olcxTabMap5 ();
void olcxTabStatistics ();
void olcxTabNAInit(struct olcxTab *t, int size) {
        register int i;
        t->size = size;
        memset(t->tab, 0, sizeof(S_userOlcx *)*t->size);
}
void olcxTabInit(struct olcxTab *t, int size) {
        register int i;
        {t->tab = (S_userOlcx **) stackMemoryAlloc((size)*sizeof(S_userOlcx *)); };
        olcxTabNAInit(t, size);
}
int olcxTabIsMember(
                                        struct olcxTab *t,
                                        S_userOlcx *elem,
                                        int *position,
                                        S_userOlcx **original
                        ) {
        unsigned posid;
        S_userOlcx *pp;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        *position = posid;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 55);};
        for (pp=t->tab[posid]; pp!=NULL; pp=pp->next) {
                if ((strcmp(pp->name,elem->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int olcxTabNextMember(
                                        S_userOlcx *elem,
                                        S_userOlcx **original
                        ) {
        S_userOlcx *pp;
        { if (!(*original)) internalCheckFail("*original", "hashlist.tc", 77);};
        for (pp= (*original)->next; pp!=NULL; pp=pp->next) {
                if ((strcmp(pp->name,elem->name)==0)) {
                        *original = pp;
                        return(1);
                }
        }
        *original = NULL;
        return(0);
}
int olcxTabMembEqual(
                                        S_userOlcx *e1,
                                        S_userOlcx *e2
                        ) {
        { if (!(e1 && e2)) internalCheckFail("e1 && e2", "hashlist.tc", 93);};
        return((strcmp(e1->name,e2->name)==0));
}
int olcxTabDelete(
                                        struct olcxTab *t,
                                        S_userOlcx *elem
                        ) {
        unsigned posid;
        S_userOlcx **pp;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 106);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((strcmp((*pp)->name,elem->name)==0)) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int olcxTabDeleteExact(
                                        struct olcxTab *t,
                                        S_userOlcx *elem
                        ) {
        unsigned posid;
        S_userOlcx **pp;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 125);};
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((*pp) == elem) {
                        *pp = (*pp)->next;
                        return(1);
                }
        }
        return(0);
}
int olcxTabDeleteLast(
                                        struct olcxTab *t,
                                        S_userOlcx *elem
                        ) {
        unsigned posid;
        S_userOlcx **pp, **dd;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashlist.tc", 144);};
        dd = NULL;
        for (pp= &(t->tab[posid]); *pp!=NULL; pp= &((*pp)->next)) {
                if ((strcmp((*pp)->name,elem->name)==0)) {
                        dd = pp;
                }
        }
        if (dd!=NULL) {
                *dd = (*dd)->next;
                return(1);
        }
        return(0);
}
void olcxTabSet (
                                        struct olcxTab *t,
                                        S_userOlcx *elem,
                                        int position
                                ) {
        elem->next = t->tab[position];
    t->tab[position] = elem;
}
void olcxTabSetLast (
                                        struct olcxTab *t,
                                        S_userOlcx *elem,
                                        int position
                                ) {
        S_userOlcx **pp;
        for (pp= &(t->tab[position]); *pp!=NULL; pp= &((*pp)->next)) ;
    *pp = elem;
        elem->next = NULL;
}
void olcxTabAdd (
                                        struct olcxTab *t,
                                        S_userOlcx *elem,
                                        int *position
                                ) {
  S_userOlcx *origin;
  if (! olcxTabIsMember(t,elem,position,&origin)) {
        olcxTabSet (t,elem,*position);
  }
}
void olcxTabFree(struct olcxTab *t) {
        { };
}
void olcxTabMap(
                                        struct olcxTab *t,
                                        void (*fun)(S_userOlcx *)
                                ) {
        int i;
        S_userOlcx *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp);
        }
}
void olcxTabMap2(
                                        struct olcxTab *t,
                                        void (*fun)(S_userOlcx *, void *),
                                        void *a
                                ) {
        int i;
        S_userOlcx *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void olcxTabMap3(
                                        struct olcxTab *t,
                                        void (*fun)(int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i);
        }
}
void olcxTabMap31(
                                        struct olcxTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *arg1, void *arg2
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2);
        }
}
void olcxTabMap32(
                                        struct olcxTab *t,
                                        void (*fun)(int, void *, void *, void *),
                                        void *arg1, void *arg2, void *arg3
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i] != NULL) (*fun)(i,arg1,arg2,arg3);
        }
}
void olcxTabMap4(
                                        struct olcxTab *t,
                                        void (*fun)(S_userOlcx *, int),
                                        int a
                                ) {
        int i;
        S_userOlcx *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, a);
        }
}
void olcxTabMap5(
                                        struct olcxTab *t,
                                        void (*fun)(S_userOlcx *, void *),
                                        void *arg
                                ) {
        int i;
        S_userOlcx *pp;
        for(i=0; i<t->size; i++) {
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) (*fun)(pp, arg);
        }
}
void olcxTabStatistics(
                                        struct olcxTab *t,
                                        int *usedIndexes,
                                        int *elements,
                                        int *maxdeep
                                ) {
        int i,ui,el,dp,mdp,mdpi;
        S_userOlcx *pp;
        ui= el = dp = mdp = 0;
        mdpi = -1;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) ui ++;
                dp = el;
                for(pp=t->tab[i]; pp!=NULL; pp=pp->next) {
                        el++;
                }
                if (mdp < el-dp) {mdp = el-dp; mdpi = i;}
        }
        *usedIndexes = ui;
        *elements = el;
        *maxdeep = mdp;
}
static S_olcxTab s_olcxTab;
static void oloPushByNameIfNothingPushed();
int olcxReferenceInternalLessFunction(S_reference *r1, S_reference *r2) {
        return((( (((r1)->p).file < (((*r2)).p).file) || (((r1)->p).file==(((*r2)).p).file && ((r1)->p).line < (((*r2)).p).line) || (((r1)->p).file==(((*r2)).p).file && ((r1)->p).line==(((*r2)).p).line && ((r1)->p).coll < (((*r2)).p).coll) )));
}
int olSymbolRefItemLess(S_symbolRefItem *s1, S_symbolRefItem *s2) {
        int cmp;
        cmp = strcmp(s1->name, s2->name);
        if (cmp < 0) return(1);
        else if (cmp > 0) return(0);
        if (s1->vFunClass < s2->vFunClass) return(1);
        else if (s1->vFunClass > s2->vFunClass) return(0);
        if (s1->vApplClass < s2->vApplClass) return(1);
        else if (s1->vApplClass > s2->vApplClass) return(0);
        if (s1->b.symType < s2->b.symType) return(1);
        else if (s1->b.symType > s2->b.symType) return(0);
        if (s1->b.storage < s2->b.storage) return(1);
        else if (s1->b.storage > s2->b.storage) return(0);
        if (s1->b.category < s2->b.category) return(1);
        else if (s1->b.category > s2->b.category) return(0);
        return(0);
}
static int olSymbolMenuLess(S_olSymbolsMenu *s1, S_olSymbolsMenu *s2) {
        int cmp;
        return(olSymbolRefItemLess(&s1->s, &s2->s));
}
S_olSymbolsMenu *olCreateNewMenuItem(
                S_symbolRefItem *sym, int vApplClass, int vFunCl, S_position *defpos, int defusage,
                int selected, int visible,
                unsigned ooBits, int olusage, int vlevel
        ) {
        S_olSymbolsMenu *rr;
        int nlen;
        char *nn;
        nlen = strlen(sym->name);
        { { int n = (nlen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (nn==NULL) { freeOldestOlcx(); { int n = (nlen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        strcpy(nn, sym->name);
        { { int n = (1) * sizeof(S_olSymbolsMenu); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_olSymbolsMenu*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_olSymbolsMenu); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_olSymbolsMenu*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (rr)->s.name = nn; (rr)->s.fileHash = cxFileHashNumber(nn); (rr)->s.vApplClass = vApplClass; (rr)->s.vFunClass = vFunCl; (rr)->s.b.symType = sym->b.symType; (rr)->s.b.storage = sym->b.storage; (rr)->s.b.scope = sym->b.scope; (rr)->s.b.accessFlags = sym->b.accessFlags; (rr)->s.b.category = sym->b.category; (rr)->s.b.htmlWasLn = sym->b.htmlWasLn; (rr)->s.refs = NULL; (rr)->s.next = NULL; (rr)->selected = selected; (rr)->visible = visible; (rr)->ooBits = ooBits; (rr)->olUsage = olusage; (rr)->vlevel = vlevel; (rr)->refn = 0; (rr)->defRefn = 0; (rr)->defUsage = defusage; (rr)->defpos.file = defpos->file; (rr)->defpos.line = defpos->line; (rr)->defpos.coll = defpos->coll; (rr)->outOnLine = 0; (rr)->markers = NULL; (rr)->next = NULL;};
        return(rr);
}
S_olSymbolsMenu *olAddBrowsedSymbol(
                                                S_symbolRefItem *sym, S_olSymbolsMenu **list,
                                                int selected, int visible, unsigned ooBits,
                                                int olusage, int vlevel,
                                                S_position *defpos, int defusage) {
        S_olSymbolsMenu *rr, *ll, **place, ddd;
        int nlen;
        char *nn;
        { (&ddd)->s = *sym; (&ddd)->selected = 0; (&ddd)->visible = 0; (&ddd)->ooBits = 0; (&ddd)->olUsage = olusage; (&ddd)->vlevel = vlevel; (&ddd)->refn = 0; (&ddd)->defRefn = 0; (&ddd)->defUsage = UsageNone; (&ddd)->defpos = s_noPos; (&ddd)->outOnLine = 0; (&ddd)->markers = NULL; (&ddd)->next = NULL;};
        { register S_olSymbolsMenu *tmp,**lStMp; tmp = *(list); lStMp = list; while (tmp!=NULL && olSymbolMenuLess(tmp, ((&ddd)))) { lStMp = &(tmp->next); tmp = *lStMp; } place = lStMp; };
        rr = *place;
        if (*place==NULL || olSymbolMenuLess(&ddd, *place)) {
                { if (!(sym)) internalCheckFail("sym", "cxref.c", 150);};
                rr = olCreateNewMenuItem( sym, sym->vApplClass, sym->vFunClass, defpos, defusage,
                                                                  selected, visible, ooBits,
                                                                  olusage, vlevel);
                {(rr)->next = ((*place)); (*place) = rr;};
        }
        return(rr);
}
void renameCollationSymbols(S_olSymbolsMenu *sss) {
        S_olSymbolsMenu *ss;
        int filei,len,len1;
        char *nn, *cs;
        { if (!(sss)) internalCheckFail("sss", "cxref.c", 164);};
        for(ss=sss; ss!=NULL; ss=ss->next) {
                cs = strchr(ss->s.name, '#');
                if (cs!=NULL && ss->s.b.symType==TypeCppCollate) {
                        len = strlen(ss->s.name);
                        { if (!(len>=2)) internalCheckFail("len>=2", "cxref.c", 169);};
                        { { int n = (len-1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (nn==NULL) { freeOldestOlcx(); { int n = (len-1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                        len1 = cs-ss->s.name;
                        strncpy(nn, ss->s.name, len1);
                        strcpy(nn+len1, cs+2);
                        { {}; olcxMemoryAllocatedBytes -= len+1; free(ss->s.name);};
                        ss->s.name = nn;
                }
        }
}
void setIntToZero(void *p) {
        int *pp;
        pp = (int *) p;
        *pp = 0;
}
S_reference **addToRefList( S_reference **list,
                                                        S_usageBits *pusage,
                                                        S_position *pos,
                                                        int category
                                                ) {
        S_reference *rr, **place;
        S_reference ppp;
        { (&ppp)->usg = *pusage; (&ppp)->p = *pos; (&ppp)->next = NULL;};
        { register S_reference *tmp,**lStMp; tmp = *(list); lStMp = list; while (tmp!=NULL && (( (((tmp)->p).file < (((ppp)).p).file) || (((tmp)->p).file==(((ppp)).p).file && ((tmp)->p).line < (((ppp)).p).line) || (((tmp)->p).file==(((ppp)).p).file && ((tmp)->p).line==(((ppp)).p).line && ((tmp)->p).coll < (((ppp)).p).coll) ))) { lStMp = &(tmp->next); tmp = *lStMp; } place = lStMp; };
        if (*place==NULL || ( ( ((((*place))->p).file != ((ppp).p).file) || ((((*place))->p).line != ((ppp).p).line) || ((((*place))->p).coll != ((ppp).p).coll) ))
                        || s_opt.cxrefs==OLO_EXTRACT) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxref.c", 218);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_reference) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } rr = (S_reference*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_reference);};};};
                { (rr)->usg = *pusage; (rr)->p = *pos; (rr)->next = NULL;};
                {(rr)->next = ((*place)); (*place) = rr;};
        } else {
                { if (!(*place)) internalCheckFail("*place", "cxref.c", 222);};
                (*place)->usg = *pusage;
        }
        return(place);
}
int isInRefList(S_reference *list,
                                S_usageBits *pusage,
                                S_position *pos,
                                int category
                                ) {
        S_reference *rr;
        S_reference ppp;
        { (&ppp)->usg = *pusage; (&ppp)->p = *pos; (&ppp)->next = NULL;};
        { register S_reference *tmp; tmp = list; while (tmp!=NULL && (( (((tmp)->p).file < (((ppp)).p).file) || (((tmp)->p).file==(((ppp)).p).file && ((tmp)->p).line < (((ppp)).p).line) || (((tmp)->p).file==(((ppp)).p).file && ((tmp)->p).line==(((ppp)).p).line && ((tmp)->p).coll < (((ppp)).p).coll) ))) tmp=tmp->next; rr=tmp; };
        if (rr==NULL || ( ( (((rr)->p).file != ((ppp).p).file) || (((rr)->p).line != ((ppp).p).line) || (((rr)->p).coll != ((ppp).p).coll) ))) return(0);
        return(1);
}
S_reference *duplicateReference(S_reference *r) {
        S_reference *rr;
        r->usg = s_noUsage;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxref.c", 248);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_reference) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } rr = (S_reference*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_reference);};};};
        *rr = *r;
        r->next = rr;
        return(rr);
}
static int newRefTabItem(S_refTab *reftab,
                                                S_symbolRefItem **memb,
                                                int usage,
                                                int storage,
                                                 int scope,
                                                int category,
                                                S_symbol *p,
                                                int vApplClass,
                                                int vFunClass,
                                                int *ii
                                                ) {
        int rr;
        S_symbolRefItem ppp;
        { (&ppp.b)->symType = p->b.symType; (&ppp.b)->storage = storage; (&ppp.b)->scope = scope; (&ppp.b)->accessFlags = p->b.accessFlags; (&ppp.b)->category = category; (&ppp.b)->htmlWasLn = 0;};
        { (&ppp)->name = p->linkName; (&ppp)->fileHash = 0; (&ppp)->vApplClass = vApplClass; (&ppp)->vFunClass = vFunClass; (&ppp)->b = ppp.b; (&ppp)->refs = NULL; (&ppp)->next = NULL;};
        rr = refTabIsMember(reftab, &ppp, ii, memb);
        if (rr == 0) return(1);
        return(0);
}
static int htmlReferencableSymbol(int scope, int category, S_symbol *p) {
        if (scope==ScopeFile) return(1);
        if (category==CatGlobal) return(1);
        if (p->b.symType==TypeDefault && p->b.storage==StorageStatic) return(1);
        return(0);
}
static void getSymbolCxrefCategories(
                                                                        S_symbol *p,
                                                                        int *p_category,
                                                                        int *p_scope,
                                                                        int *p_storage
        ) {
        int category, scope, storage;
        category = CatLocal; scope = ScopeAuto; storage=StorageAuto;
        if (p->b.symType==TypeDefault) {
                storage = p->b.storage;
                if ( p->b.storage==StorageExtern
                        || p->b.storage==StorageDefault
                        || p->b.storage==StorageTypedef
                        || p->b.storage==StorageField
                        || p->b.storage==StorageMethod
                        || p->b.storage==StorageConstructor
                        || p->b.storage==StorageStatic
                        ) {
                                if (p->linkName[0]==' ' && p->linkName[1]==' ') {
                                        category = CatLocal;
                                } else {
                                        category = CatGlobal;
                                }
                                scope = ScopeGlobal;
                }
        }
        if (p->b.symType==TypeDefault && p->b.storage==StorageConstant) {
                category = CatGlobal; scope = ScopeGlobal; storage=StorageExtern;
        }
        if ((p->b.symType==TypeStruct||p->b.symType==TypeUnion||p->b.symType==TypeEnum)){
                category = CatGlobal; scope = ScopeGlobal; storage=StorageExtern;
        }
        if (p->b.symType == TypeMacro) {
                category = CatGlobal; scope = ScopeGlobal; storage=StorageExtern;
        }
        if (p->b.symType == TypeLabel) {
                category = CatLocal; scope = ScopeFile; storage=StorageStatic;
        }
        if (p->b.symType == TypeCppIfElse) {
                category = CatLocal; scope = ScopeFile; storage=StorageStatic;
        }
        if (p->b.symType == TypeCppInclude) {
                category = CatGlobal; scope = ScopeGlobal; storage=StorageExtern;
        }
        if (p->b.symType == TypeCppCollate) {
                category = CatGlobal; scope = ScopeGlobal; storage=StorageExtern;
        }
        if (p->b.symType == TypeYaccSymbol) {
                category = CatLocal; scope = ScopeFile; storage=StorageStatic;
        }
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                if (p->b.symType == TypeKeyword) {
                        category = CatGlobal; scope = ScopeFile; storage=StorageStatic;
                }
                if (p->b.symType == TypeComment) {
                        category = CatGlobal; scope = ScopeFile; storage=StorageStatic;
                }
                if (p->b.symType == TypeCppAny) {
                        category = CatGlobal; scope = ScopeFile; storage=StorageStatic;
                }
                if (p->b.symType == TypeCppIfElse) {
                        category = CatLocal; scope = ScopeFile; storage=StorageStatic;
                }
        }
        if (p->b.symType == TypePackage) {
                category = CatGlobal; scope = ScopeGlobal; storage=StorageExtern;
        }
        *p_category = category;
        *p_scope = scope;
        *p_storage = storage;
}
static void setClassTreeBaseType(S_classTreeData *ct, S_symbol *p) {
        S_symbol *rtcls;
        S_typeModifiers *tt;
        { if (!(s_javaObjectSymbol && s_javaObjectSymbol->u.s)) internalCheckFail("s_javaObjectSymbol && s_javaObjectSymbol->u.s", "cxref.c", 380);};
        { if (!(ct)) internalCheckFail("ct", "cxref.c", 381);};
        ct->baseClassIndex = s_javaObjectSymbol->u.s->classFile;
        if (p->b.symType == TypeStruct) {
                { if (!(p->u.s)) internalCheckFail("p->u.s", "cxref.c", 385);};
                ct->baseClassIndex = p->u.s->classFile;
        } else if (p->b.symType == TypeDefault && p->b.storage!=StorageConstructor) {
                tt = p->u.type;
                { if (!(tt)) internalCheckFail("tt", "cxref.c", 389);};
                if (tt->m == TypeFunction) tt = tt->next;
                { if (!(tt)) internalCheckFail("tt", "cxref.c", 391);};
                if (tt->m == TypeStruct) {
                        rtcls = tt->u.t;
                        { if (!(rtcls!=NULL && rtcls->b.symType==TypeStruct && rtcls->u.s!=NULL)) internalCheckFail("rtcls!=NULL && rtcls->b.symType==TypeStruct && rtcls->u.s!=NULL", "cxref.c", 394);};
                        ct->baseClassIndex = rtcls->u.s->classFile;
                }
        }
}
S_reference *addSpecialFieldReference(char *name,int storage, int fnum,
                                                                          S_position *p, int usage){
        S_symbol ss;
        S_symbolBits bb;
        S_reference *res;
        { (&bb)->record = 0; (&bb)->isSingleImported = 0; (&bb)->accessFlags = 0x000; (&bb)->javaSourceLoaded = 0; (&bb)->javaFileLoaded = 0; (&bb)->symType = TypeDefault; (&bb)->storage = storage; (&bb)->npointers = 0;};
        { (&ss)->name = name; (&ss)->linkName = name; (&ss)->pos = *p; (&ss)->b = bb; (&ss)->u.type = NULL; (&ss)->next = NULL;};
        res = addCxReference(&ss, p, usage, fnum, fnum);
        return(res);
}
static int isEnclosingClass(int enclosedClass, int enclosingClass) {
        int i;
        int cc,slow;
        for(i = slow = enclosedClass, cc=0;
                i!=s_noneFileIndex && i!=-1;
                i=s_fileTab.tab[i]->directEnclosingInstance) {
                { if (!(s_fileTab.tab[i])) internalCheckFail("s_fileTab.tab[i]", "cxref.c", 419);};
                if (i == enclosingClass) return(1);
                if (cc==0) {
                        cc = !cc;
                } else {
                        { if (!(slow != i)) internalCheckFail("slow != i", "cxref.c", 425);};
                        slow = s_fileTab.tab[slow]->directEnclosingInstance;
                }
        }
        return(0);
}
int isStrictlyEnclosingClass(int enclosedClass, int enclosingClass) {
        if (enclosedClass == enclosingClass) return(0);
        return(isEnclosingClass(enclosedClass, enclosingClass));
}
void changeFieldRefUsages(S_symbolRefItem *ri, void *rrcd) {
        S_referencesChangeData *rcd;
        S_symbolRefItem ddd;
        S_reference *rr;
        rcd = (S_referencesChangeData*) rrcd;
        { (&ddd.b)->symType = TypeDefault; (&ddd.b)->storage = StorageField; (&ddd.b)->scope = ScopeFile; (&ddd.b)->accessFlags = 0x000; (&ddd.b)->category = rcd->category; (&ddd.b)->htmlWasLn = 0;};
        { (&ddd)->name = rcd->linkName; (&ddd)->fileHash = cxFileHashNumber(rcd->linkName); (&ddd)->vApplClass = s_noneFileIndex; (&ddd)->vFunClass = s_noneFileIndex; (&ddd)->b = ddd.b; (&ddd)->refs = NULL; (&ddd)->next = NULL;};
        if (itIsSameCxSymbol(ri, &ddd)) {
                for(rr = ri->refs; rr!=NULL; rr=rr->next) {
                        if (rr->p.file == rcd->fnum &&
                                ( ((char*)rr) >= ((char*)&cxMemory->b) + (rcd->cxMemBegin) && ((char*)rr) < ((char*)&cxMemory->b) + (rcd->cxMemEnd) )) {
                                switch(rr->usg.base) {
                                case UsageMaybeThis:
                                        { if (!(rcd->cclass->u.s)) internalCheckFail("rcd->cclass->u.s", "cxref.c", 457);};
                                        if (isEnclosingClass(rcd->cclass->u.s->classFile, ri->vFunClass)) {
                                                rr->usg.base = UsageMaybeThisInClassOrMethod;
                                        }
                                        break;
                                case UsageMaybeQualifiedThis:
                                        { if (!(rcd->cclass->u.s)) internalCheckFail("rcd->cclass->u.s", "cxref.c", 463);};
                                        if (isEnclosingClass(rcd->cclass->u.s->classFile, ri->vFunClass)) {
                                                rr->usg.base = UsageMaybeQualifThisInClassOrMethod;
                                        }
                                        break;
                                case UsageNotFQType: rr->usg.base = UsageNotFQTypeInClassOrMethod;
                                        break;
                                case UsageNotFQField: rr->usg.base = UsageNotFQFieldInClassOrMethod;
                                        break;
                                case UsageNonExpandableNotFQTName: rr->usg.base = UsageNonExpandableNotFQTNameInClassOrMethod;
                                        break;
                                case UsageLastUseless: rr->usg.base = UsageLastUselessInClassOrMethod;
                                        break;
                                case UsageOtherUseless:
                                        break;
                                case UsageLastUselessInClassOrMethod:
                                case UsageNotFQFieldInClassOrMethod:
                                case UsageNotFQTypeInClassOrMethod:
                                case UsageMaybeQualifThisInClassOrMethod:
                                case UsageMaybeThisInClassOrMethod:
                                        break;
                                default:
                                        break;
                                }
                        }
                }
        }
}
void changeMethodReferencesUsages(char *linkName, int category, int fnum,
                                                                  S_symbol *cclass){
        S_referencesChangeData rr;
        { (&rr)->linkName = linkName; (&rr)->fnum = fnum; (&rr)->cclass = cclass; (&rr)->category = category; (&rr)->cxMemBegin = s_cps.cxMemiAtMethodBeginning; (&rr)->cxMemEnd = s_cps.cxMemiAtMethodEnd;};
        refTabMap2(&s_cxrefTab, changeFieldRefUsages, &rr);
}
void changeClassReferencesUsages(char *linkName, int category, int fnum,
                                                                 S_symbol *cclass){
        S_referencesChangeData rr;
        { (&rr)->linkName = linkName; (&rr)->fnum = fnum; (&rr)->cclass = cclass; (&rr)->category = category; (&rr)->cxMemBegin = s_cps.cxMemiAtClassBeginning; (&rr)->cxMemEnd = s_cps.cxMemiAtClassEnd;};
        refTabMap2(&s_cxrefTab, changeFieldRefUsages, &rr);
}
S_reference * getDefinitionRef(S_reference *rr) {
        S_reference *r;
        S_reference *res;
        res = NULL;
        for(r=rr; r!=NULL; r=r->next) {
                if (r->usg.base==UsageDefined || r->usg.base==UsageOLBestFitDefined) {
                        res = r;
                }
                if (r->usg.base==UsageDeclared && res==NULL) res = r;
        }
        return(res);
}
static void setOlSymbolTypeForPrint(S_symbol *p) {
        int size, len;
        S_typeModifiers *tt;
        size = COMPLETION_STRING_SIZE;
        s_olSymbolType[0]=0;
        s_olSymbolClassType[0]=0;
        if (p->b.symType == TypeDefault) {
                tt = p->u.type;
                if (tt!=NULL && tt->m==TypeFunction) tt = tt->next;
                typeSPrint(s_olSymbolType, &size, tt, "", ' ', 0, 1, LONG_NAME, NULL);
                if (tt->m == TypeStruct && tt->u.t!=NULL) {
                        strcpy(s_olSymbolClassType, tt->u.t->linkName);
                        { if (!(strlen(s_olSymbolClassType)+1 < COMPLETION_STRING_SIZE)) internalCheckFail("strlen(s_olSymbolClassType)+1 < COMPLETION_STRING_SIZE", "cxref.c", 545);};
                }
                len = strlen(s_olSymbolType);
                while (len > 0 && s_olSymbolType[len-1] == ' ') len--;
                s_olSymbolType[len]=0;
        }
}
static void setOlAvailableRefactorings(S_symbol *p, S_olSymbolsMenu *mmi, int usage) {
        char *opt;
        if (strcmp(p->linkName, "  unimported type")==0) {
                s_availableRefactorings[PPC_AVR_ADD_TO_IMPORT].available = 1;
                return;
        }
        switch (p->b.symType) {
        case TypePackage:
                s_availableRefactorings[PPC_AVR_RENAME_PACKAGE].available = 1;
                {{ { if (!((strlen(mmi->s.name)+1) >= 0)) internalCheckFail("(strlen(mmi->s.name)+1) >= 0", "cxref.c", 563);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(strlen(mmi->s.name)+1)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(strlen(mmi->s.name)+1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } opt = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (strlen(mmi->s.name)+1)*sizeof(char);};};
                strcpy(opt, mmi->s.name);
                javaDotifyFileName(opt);
                s_availableRefactorings[PPC_AVR_RENAME_PACKAGE].option = opt;
                break;
        case TypeStruct:
                if (((s_language & (4)) != 0)) {
                        if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                                s_availableRefactorings[PPC_AVR_RENAME_CLASS].available = 1;
                                s_availableRefactorings[PPC_AVR_MOVE_CLASS].available = 1;
                                s_availableRefactorings[PPC_AVR_MOVE_CLASS_TO_NEW_FILE].available = 1;
                                s_availableRefactorings[PPC_AVR_EXPAND_NAMES].available = 1;
                                s_availableRefactorings[PPC_AVR_REDUCE_NAMES].available = 1;
                        }
                } else {
                        s_availableRefactorings[PPC_AVR_RENAME_SYMBOL].available = 1;
                }
                break;
        case TypeMacroArg:
                s_availableRefactorings[PPC_AVR_RENAME_SYMBOL].available = 1;
                break;
        case TypeLabel:
                s_availableRefactorings[PPC_AVR_RENAME_SYMBOL].available = 1;
                break;
        case TypeMacro:
                s_availableRefactorings[PPC_AVR_RENAME_SYMBOL].available = 1;
                s_availableRefactorings[PPC_AVR_ADD_PARAMETER].available = 1;
                s_availableRefactorings[PPC_AVR_ADD_PARAMETER].option = "macro";
                s_availableRefactorings[PPC_AVR_DEL_PARAMETER].available = 1;
                s_availableRefactorings[PPC_AVR_DEL_PARAMETER].option = "macro";
                s_availableRefactorings[PPC_AVR_MOVE_PARAMETER].available = 1;
                s_availableRefactorings[PPC_AVR_MOVE_PARAMETER].option = "macro";
                break;
        default:
                if (p->b.storage != StorageConstructor) {
                        s_availableRefactorings[PPC_AVR_RENAME_SYMBOL].available = 1;
                }
                if (p->u.type->m == TypeFunction || p->u.type->m == TypeMacro) {
                        s_availableRefactorings[PPC_AVR_ADD_PARAMETER].available = 1;
                        s_availableRefactorings[PPC_AVR_DEL_PARAMETER].available = 1;
                        s_availableRefactorings[PPC_AVR_MOVE_PARAMETER].available = 1;
                }
                if (p->b.storage == StorageField) {
                        if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                                if (p->b.accessFlags & 0x008) {
                                        s_availableRefactorings[PPC_AVR_MOVE_STATIC_FIELD].available = 1;
                                } else {
                                        s_availableRefactorings[PPC_AVR_PULL_UP_FIELD].available = 1;
                                        s_availableRefactorings[PPC_AVR_PUSH_DOWN_FIELD].available = 1;
                                }
                                s_availableRefactorings[PPC_AVR_MOVE_FIELD].available = 1;
                                s_availableRefactorings[PPC_AVR_ENCAPSULATE_FIELD].available = 1;
                                s_availableRefactorings[PPC_AVR_SELF_ENCAPSULATE_FIELD].available = 1;
                        }
                }
                if (p->b.storage == StorageMethod || p->b.storage == StorageConstructor) {
                        if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                                if (p->b.accessFlags & 0x008) {
                                        s_availableRefactorings[PPC_AVR_MOVE_STATIC_METHOD].available = 1;
                                        if (p->b.storage == StorageMethod) {
                                                s_availableRefactorings[PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC].available = 1;
                                        }
                                } else {
                                        if (p->b.storage == StorageMethod) {
                                                s_availableRefactorings[PPC_AVR_PULL_UP_METHOD].available = 1;
                                                s_availableRefactorings[PPC_AVR_PUSH_DOWN_METHOD].available = 1;
                                                s_availableRefactorings[PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC].available = 1;
                                        }
                                }
                        }
                }
                break;
        }
}
static void olGetAvailableRefactorings() {
        int i, count;
        char *additional;
        count = 0;
        for(i=0; i<500; i++) {
                count += (s_availableRefactorings[i].available!=0);
        }
        if (count==0) s_availableRefactorings[PPC_AVR_SET_MOVE_TARGET].available = 1;
        if (s_opt.editor == ED_EMACS) {
                s_availableRefactorings[PPC_AVR_UNDO].available = 1;
        }
        if (s_opt.olCursorPos != s_opt.olMarkPos) {
                if (((s_language & (4)) != 0)) {
                        s_availableRefactorings[PPC_AVR_EXTRACT_METHOD].available = 1;
                } else {
                        s_availableRefactorings[PPC_AVR_EXTRACT_FUNCTION].available = 1;
                }
                if (! ((s_language & (4)) != 0)) {
                        s_availableRefactorings[PPC_AVR_EXTRACT_MACRO].available = 1;
                }
        }
        if (! s_opt.xref2) {
                fprintf(ccOut,"* refactoring list not available in Xrefactory-I");
                return;
        }
        ppcGenRecordBegin(PPC_AVAILABLE_REFACTORINGS);
        for(i=0; i<500; i++) {
                if (s_availableRefactorings[i].available) {
                        ppcGenNumericRecord(PPC_INT_VALUE, i, s_availableRefactorings[i].option, "\n");
                }
        }
        ppcGenRecordEnd(PPC_AVAILABLE_REFACTORINGS);
}
static int olcxOnlyParseNoPushing(opt) {
        return(
                opt==OLO_GLOBAL_UNUSED
                || opt==OLO_LOCAL_UNUSED
                );
}
S_reference * addCxReferenceNew(S_symbol *p, S_position *pos, S_usageBits *usageb,
                                                         int vFunCl, int vApplCl) {
        int ii,mm,category,scope,storage,defusage;
        char *ss;
        S_reference rr, **place;
        S_position *defpos;
        S_symbolRefItem *pp,*memb, ppp;
        S_olSymbolsMenu *mmi;
        S_refTab *reftab;
        int usage;
        usage = usageb->base;
        if (s_javaPreScanOnly) return(NULL);
        if (p->linkName == NULL) return(NULL);
        if (* p->linkName == 0) return(NULL);
        if (p == &s_errorSymbol || p->b.symType==TypeError) return(NULL);
        if (pos->file == s_noneFileIndex) return(NULL);
        { if (!(pos->file<MAX_FILES)) internalCheckFail("pos->file<MAX_FILES", "cxref.c", 714);};
        { if (!(s_fileTab.tab[pos->file])) internalCheckFail("s_fileTab.tab[pos->file]", "cxref.c", 715);};
        if (p->b.symType==TypeDefault && p->b.storage==StorageConstant) {
                if (s_opt.no_ref_enumerator) return(NULL);
        }
        if (p->b.symType==TypeDefault && p->b.storage==StorageTypedef) {
                if (s_opt.no_ref_typedef) return(NULL);
        }
        if ((p->b.symType==TypeStruct||p->b.symType==TypeUnion||p->b.symType==TypeEnum)){
                if (s_opt.no_ref_typedef) return(NULL);
        }
        if (p->b.symType == TypeMacro) {
                if (s_opt.no_ref_macro) return(NULL);
        }
        if (p->b.symType==TypeDefault) {
                if (p->b.record && s_opt.no_ref_records) return(NULL);
        }
        getSymbolCxrefCategories( p, &category, &scope, &storage);
        if (scope == ScopeAuto && s_opt.no_ref_locals) return(NULL);
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxref.c", 739);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (s_opt.cxrefs == OLO_EXTRACT) {
                        if (s_input_file_number != cFile.lb.cb.fileNumber) return(NULL);
                } else {
                        if (category==CatGlobal && p->b.symType!=TypeCppInclude && s_opt.cxrefs!=OLO_TAG_SEARCH) {
                                if (s_olOriginalFileNumber!=pos->file
                                        && s_opt.noIncludeRefs) return(NULL);
                        }
                }
        }
        if (s_opt.taskRegime == RegimeGenerate) return(NULL);
        if (s_opt.taskRegime == RegimeXref) {
                if (category == CatLocal) return(NULL);
                if (s_fileTab.tab[pos->file]->b.cxLoading==0) return(NULL);
        }
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                if (s_fileTab.tab[pos->file]->b.cxLoading==0&&category==CatGlobal) return(NULL);
                if (s_fileTab.tab[pos->file]->b.cxLoaded
                        &&p->b.symType==TypeCppIfElse) return(NULL);
        }
        reftab = &s_cxrefTab;
        { (&ppp.b)->symType = p->b.symType; (&ppp.b)->storage = storage; (&ppp.b)->scope = scope; (&ppp.b)->accessFlags = p->b.accessFlags; (&ppp.b)->category = category; (&ppp.b)->htmlWasLn = 0;};
        { (&ppp)->name = p->linkName; (&ppp)->fileHash = 0; (&ppp)->vApplClass = vApplCl; (&ppp)->vFunClass = vFunCl; (&ppp)->b = ppp.b; (&ppp)->refs = NULL; (&ppp)->next = NULL;};
        if (s_opt.taskRegime==RegimeEditServer && s_opt.cxrefs==OLO_TAG_SEARCH && s_opt.tagSearchSpecif==TSS_FULL_SEARCH) {
                { (&rr.usg)->base = usage; (&rr.usg)->requiredAccess = 0; (&rr.usg)->dummy = 0;};
                { (&rr)->usg = rr.usg; (&rr)->p = *pos; (&rr)->next = NULL;};
                searchSymbolCheckReference(&ppp, &rr);
                return(NULL);
        }
        mm = refTabIsMember(reftab, &ppp, &ii, &memb);
        if (mm==0) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxref.c", 783);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_symbolRefItem) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } pp = (S_symbolRefItem*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_symbolRefItem);};};};
                {{ { if (!((strlen(p->linkName)+1) >= 0)) internalCheckFail("(strlen(p->linkName)+1) >= 0", "cxref.c", 784);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(strlen(p->linkName)+1)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(strlen(p->linkName)+1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } ss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (strlen(p->linkName)+1)*sizeof(char);};};
                strcpy(ss, p->linkName);
                { (&pp->b)->symType = p->b.symType; (&pp->b)->storage = storage; (&pp->b)->scope = scope; (&pp->b)->accessFlags = p->b.accessFlags; (&pp->b)->category = category; (&pp->b)->htmlWasLn = 0;};
                { (pp)->name = ss; (pp)->fileHash = cxFileHashNumber(ss); (pp)->vApplClass = vApplCl; (pp)->vFunClass = vFunCl; (pp)->b = pp->b; (pp)->refs = NULL; (pp)->next = NULL;};
                refTabSet(reftab, pp, ii);
                memb = pp;
        } else {
                memb->b.accessFlags |= p->b.accessFlags;
        }
        place = addToRefList(&memb->refs,usageb,pos,category);
        if (s_opt.taskRegime == RegimeEditServer
                && (! ( ((s_cxRefPos).file != (*pos).file) || ((s_cxRefPos).line != (*pos).line) || ((s_cxRefPos).coll != (*pos).coll) ))
                && usage<UsageMaxOLUsages) {
                if (p->linkName[0] == ' ') {
                        if (strcmp(p->linkName, "  unimported type")==0) {
                                if (s_opt.cxrefs == OLO_GET_AVAILABLE_REFACTORINGS) {
                                        setOlAvailableRefactorings(p, NULL, usage);
                                }
                        }
                } else {
                        s_olstringServed = 1;
                        s_olstringUsage = usage;
                        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 816);};
                        olSetCallerPosition(pos);
                        defpos = &s_noPos;
                        defusage = s_noUsage.base;
                        if (p->b.symType==TypeMacro && ! s_opt.exactPositionResolve) {
                                defpos = &p->pos;
                                defusage = UsageDefined;
                        }
                        if (! olcxOnlyParseNoPushing(s_opt.cxrefs)) {
                                mmi = olAddBrowsedSymbol(memb,&s_olcxCurrentUser->browserStack.top->hkSelectedSym,
                                                                                 1,1,0,usage,0, defpos, defusage);
                                if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                                        mmi->defpos = *pos;
                                        mmi->defUsage = usage;
                                }
                                if (s_opt.cxrefs == OLO_CLASS_TREE
                                        && (((s_language & (4)) != 0) || ((s_language & (16)) != 0))) {
                                        setClassTreeBaseType(&s_olcxCurrentUser->ct, p);
                                }
                                if (s_opt.cxrefs == OLO_GET_SYMBOL_TYPE) {
                                        setOlSymbolTypeForPrint(p);
                                }
                                if (s_opt.cxrefs == OLO_GET_AVAILABLE_REFACTORINGS) {
                                        setOlAvailableRefactorings(p, mmi, usage);
                                }
                        }
                }
        }
        { { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxref.c", 849);}; if (s_opt.taskRegime==RegimeXref||s_opt.taskRegime==RegimeHtmlGenerate) { if (!((cxMemory->i+(CX_SPACE_RESERVE) < cxMemory->size))) { longjmp(cxmemOverflow,MESS_REFERENCE_OVERFLOW); } }};
        { if (!(place)) internalCheckFail("place", "cxref.c", 850);};
        return(*place);
}
S_reference * addCxReference(S_symbol *p, S_position *pos, int usage, int vFunCl, int vApplCl) {
        S_usageBits ub;
        { (&ub)->base = usage; (&ub)->requiredAccess = 0; (&ub)->dummy = 0;};
        return(addCxReferenceNew(p, pos, &ub, vFunCl, vApplCl));
}
void addTrivialCxReference(char *name,int symType,int storage,S_position *pos,int usage) {
        S_symbol ss;
        S_symbolBits bb;
        { (&bb)->record = 0; (&bb)->isSingleImported = 0; (&bb)->accessFlags = 0; (&bb)->javaSourceLoaded = 0; (&bb)->javaFileLoaded = 0; (&bb)->symType = symType; (&bb)->storage = storage; (&bb)->npointers = 0;};
        { (&ss)->name = name; (&ss)->linkName = name; (&ss)->pos = *pos; (&ss)->b = bb; (&ss)->u.type = NULL; (&ss)->next = NULL;};
        addCxReference(&ss, pos, usage,s_noneFileIndex, s_noneFileIndex);
}
void addClassTreeHierarchyReference(int fnum, S_position *p, int usage) {
        addSpecialFieldReference(" [classTree]",StorageMethod,
                                                         fnum, p, usage);
}
void addCfClassTreeHierarchyRef(int fnum, int usage) {
        S_position p;
        { (&p)->file = fnum; (&p)->line = 0; (&p)->coll = 0;};
        addClassTreeHierarchyReference(fnum, &p, usage);
}
int isSmallerOrEqClassR(int inf, int sup, int level) {
        S_chReference *p;
        int smallerLevel;
        { if (!(level>0)) internalCheckFail("level>0", "cxref.c", 921);};
        if (inf == sup) return(level);
        { if (!(s_fileTab.tab[inf])) internalCheckFail("s_fileTab.tab[inf]", "cxref.c", 924);};
        for(p=s_fileTab.tab[inf]->sups; p!=NULL; p=p->next) {
                if (p->clas == sup) {
                        return(level+1);
                }
        }
        for(p=s_fileTab.tab[inf]->sups; p!=NULL; p=p->next) {
                smallerLevel = isSmallerOrEqClassR(p->clas, sup, level+1);
                if (smallerLevel) {
                        return(smallerLevel);
                }
        }
        return(0);
}
int isSmallerOrEqClass(int inf, int sup) {
        return(isSmallerOrEqClassR(inf, sup, 1)!=0);
}
void olcxFreeReferences(S_reference *r) {
        S_reference *tmp;
        while (r!=NULL) {
                tmp = r->next;
                { { {}; olcxMemoryAllocatedBytes -= sizeof(S_reference); free((r));};};
                r = tmp;
        }
}
static void olcxFreeCompletion(S_olCompletion *r) {
        int nlen;
        { {}; olcxMemoryAllocatedBytes -= strlen(r->name)+1; free(r->name);};
        if (r->fullName!=NULL) { {}; olcxMemoryAllocatedBytes -= strlen(r->fullName)+1; free(r->fullName);};
        if (r->vclass!=NULL) { {}; olcxMemoryAllocatedBytes -= strlen(r->vclass)+1; free(r->vclass);};
        if (r->cat == CatGlobal) {
                { if (!(r->sym.name)) internalCheckFail("r->sym.name", "cxref.c", 966);};
                nlen = strlen(r->sym.name);
                { {}; olcxMemoryAllocatedBytes -= nlen+1; free(r->sym.name);};
        }
        { {}; olcxMemoryAllocatedBytes -= sizeof(S_olCompletion); free(r);};
}
static void olcxFreeCompletions( S_olCompletion *r ) {
        S_olCompletion *tmp;
        int nlen;
        while (r!=NULL) {
                tmp = r->next;
                olcxFreeCompletion(r);
                r = tmp;
        }
}
S_olSymbolsMenu *olcxFreeSymbolMenuItem(S_olSymbolsMenu *ll) {
        int nlen;
        S_olSymbolsMenu *tt;
        nlen = strlen(ll->s.name);
        { {}; olcxMemoryAllocatedBytes -= nlen+1; free(ll->s.name);};
        olcxFreeReferences(ll->s.refs);
        tt = ll->next;
        { {}; olcxMemoryAllocatedBytes -= sizeof(*ll); free(ll);};
        ll = tt;
        return(ll);
}
void olcxFreeResolutionMenu( S_olSymbolsMenu *sym ) {
        int nlen;
        S_olSymbolsMenu *ll,*tt;
        S_reference *r,*rr;
        ll = sym;
        while (ll!=NULL) {
                ll = olcxFreeSymbolMenuItem(ll);
        }
}
static void deleteOlcxRefs(S_olcxReferences **rrefs, S_olcxReferencesStack *stack) {
        S_olcxReferences *refs;
        refs = *rrefs;
        olcxFreeReferences(refs->r);
        olcxFreeCompletions(refs->cpls);
        olcxFreeResolutionMenu(refs->hkSelectedSym);
        olcxFreeResolutionMenu(refs->menuSym);
        if (refs==stack->top) {
                stack->top = refs->previous;
        }
        if (refs==stack->root) {
                stack->root = refs->previous;
        }
        *rrefs = refs->previous;
        { {}; olcxMemoryAllocatedBytes -= sizeof(S_olcxReferences); free(refs);};
}
void freeOldestOlcx() {
        int i;
        S_userOlcx *user;
        S_olcxReferences **refs,**oldest;
        time_t oldestt;
        S_olcxReferencesStack *oldestStack;
        oldestt = s_fileProcessStartTime; oldest=NULL; oldestStack=NULL;
        if (s_ropt.refactoringRegime != RegimeRefactory) {
                for(i=0; i<OLCX_TAB_SIZE; i++) {
                        user = s_olcxTab.tab[i];
                        if (user!=NULL) {
                                { if ((&user->browserStack)->root!=NULL) { for(refs= &((&user->browserStack)->root->previous); *refs!=NULL; refs= &(*refs)->previous) { if (oldestt > (*refs)->atime) { oldestt = (*refs)->atime; oldest = refs; oldestStack = (&user->browserStack); } } }};
                                { if ((&user->completionsStack)->root!=NULL) { for(refs= &((&user->completionsStack)->root->previous); *refs!=NULL; refs= &(*refs)->previous) { if (oldestt > (*refs)->atime) { oldestt = (*refs)->atime; oldest = refs; oldestStack = (&user->completionsStack); } } }};
                                { if ((&user->retrieverStack)->root!=NULL) { for(refs= &((&user->retrieverStack)->root->previous); *refs!=NULL; refs= &(*refs)->previous) { if (oldestt > (*refs)->atime) { oldestt = (*refs)->atime; oldest = refs; oldestStack = (&user->retrieverStack); } } }};
                        }
                }
        }
        if (oldestt == s_fileProcessStartTime || oldest == NULL) {
                fatalError(ERR_ST, "olcxMemory memory overflow, please try again.", 65);
        } else {
                { if (!(oldest!=NULL && oldestStack!=NULL)) internalCheckFail("oldest!=NULL && oldestStack!=NULL", "cxref.c", 1062);};
                deleteOlcxRefs(oldest, oldestStack);
        }
}
int olcxFreeOldCompletionItems(S_olcxReferencesStack *stack) {
        S_olcxReferences **ss;
        int i;
        ss = &stack->top;
        if (*ss == NULL) return(0);
        for(i=1; i<MAX_COMPLETIONS_HISTORY_DEEP; i++) {
                ss = &(*ss)->previous;
                if (*ss == NULL) return(0);
        }
        deleteOlcxRefs(ss, stack);
        return(1);
}
void olcxInit() {
        int i;
        void * uu[30];
        {olcxMemoryAllocatedBytes = 0; {};};
        { int n = (OLCX_TAB_SIZE) * sizeof(S_userOlcx *); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { s_olcxTab.tab = NULL; } else { s_olcxTab.tab = (S_userOlcx **) malloc(n); olcxMemoryAllocatedBytes += n; {}; }};
        olcxTabNAInit(&s_olcxTab, OLCX_TAB_SIZE);
        for(i=0; i<30; i++) { { int n = (1) * sizeof(S_userOlcx); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu[i] = NULL; } else { uu[i] = (S_userOlcx*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (uu[i]==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_userOlcx); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { uu[i] = NULL; } else { uu[i] = (S_userOlcx*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        for(i=0; i<30; i++) { {}; olcxMemoryAllocatedBytes -= sizeof(S_userOlcx); free(uu[i]);};
}
S_userOlcx *olcxSetCurrentUser(char *user) {
        S_userOlcx dd,*memb;
        int ii,sz;
        char *nn;
        { (&dd)->name = user; (&dd)->browserStack.top = NULL; (&dd)->browserStack.root = NULL; (&dd)->completionsStack.top = NULL; (&dd)->completionsStack.root = NULL; (&dd)->retrieverStack.top = NULL; (&dd)->retrieverStack.root = NULL; (&dd)->ct.baseClassIndex = s_noneFileIndex; (&dd)->ct.tree = NULL; (&dd)->next = NULL;};
        if (! olcxTabIsMember(&s_olcxTab, &dd, &ii, &memb)) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxref.c", 1099);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(1)*sizeof(S_userOlcx) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } memb = (S_userOlcx*) (ftMemory + ftMemoryi); ftMemoryi += (1)*sizeof(S_userOlcx);};};};
                sz = strlen(user)+1;
                if (sz < sizeof(void*)) sz = sizeof(void*);
                {{ { if (!((sz) >= 0)) internalCheckFail("(sz) >= 0", "cxref.c", 1102);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(sz)*sizeof(char) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } nn = (char*) (ftMemory + ftMemoryi); ftMemoryi += (sz)*sizeof(char);};};
                strcpy(nn, user);
                { (memb)->name = nn; (memb)->browserStack.top = NULL; (memb)->browserStack.root = NULL; (memb)->completionsStack.top = NULL; (memb)->completionsStack.root = NULL; (memb)->retrieverStack.top = NULL; (memb)->retrieverStack.root = NULL; (memb)->ct.baseClassIndex = s_noneFileIndex; (memb)->ct.tree = NULL; (memb)->next = NULL;};
                olcxTabAdd(&s_olcxTab, memb, &ii);
        }
        s_olcxCurrentUser = memb;
        return(memb);
}
static void setRefSuffix(S_olcxReferences *refs) {
        strncpy(refs->refsuffix, s_opt.olcxRefSuffix, MAX_OLCX_SUFF_SIZE-1);
        refs->refsuffix[MAX_OLCX_SUFF_SIZE-1]=0;
        refs->act = refs->r;
}
static void olcxFreePopedStackItems(S_olcxReferencesStack *stack) {
        { if (!(stack)) internalCheckFail("stack", "cxref.c", 1118);};
        while (stack->root != stack->top) {
                deleteOlcxRefs(&stack->root, stack);
        }
}
void olcxPushEmptyStackItem(S_olcxReferencesStack *stack) {
        S_olcxReferences *res, *rr;
        olcxFreePopedStackItems(stack);
        { { int n = (1) * sizeof(S_olcxReferences); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { res = NULL; } else { res = (S_olcxReferences*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (res==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_olcxReferences); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { res = NULL; } else { res = (S_olcxReferences*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (res)->r = NULL; (res)->act = NULL; (res)->command = s_opt.cxrefs; (res)->language = s_language; (res)->atime = s_fileProcessStartTime; (res)->cpos = s_noPos; (res)->cpls = NULL; (res)->hkSelectedSym = NULL; (res)->menuSym = NULL; (res)->menuFilterLevel = DEFAULT_MENU_FILTER_LEVEL; (res)->refsFilterLevel = DEFAULT_REFS_FILTER_LEVEL; (res)->previous = stack->top;};
        setRefSuffix(res);
        stack->top = stack->root = res;
}
static int olcxVirtualyUsageAdequate(int vApplCl, int vFunCl,
                                                                int olUsage, int olApplCl, int olFunCl) {
        int res;
        res = 0;
        if (( ( (olUsage)==UsageDefined || (olUsage)==UsageOLBestFitDefined) || (olUsage)==UsageDeclared )) {
                if (vFunCl == olFunCl) res = 1;
                if (isSmallerOrEqClass(olFunCl, vApplCl)) res = 1;
        } else {
                        if (vApplCl == olFunCl) res = 1;
                        if (isSmallerOrEqClass(vApplCl, olApplCl)) res = 1;
        }
        return(res);
}
S_reference *olcxAddReferenceNoUsageCheck(S_reference **rlist, S_reference *ref, int bestMatchFlag) {
        S_reference **place, *rr;
        rr = NULL;
        { register S_reference *tmp,**lStMp; tmp = *(rlist); lStMp = rlist; while (tmp!=NULL && (( (((tmp)->p).file < (((*ref)).p).file) || (((tmp)->p).file==(((*ref)).p).file && ((tmp)->p).line < (((*ref)).p).line) || (((tmp)->p).file==(((*ref)).p).file && ((tmp)->p).line==(((*ref)).p).line && ((tmp)->p).coll < (((*ref)).p).coll) ))) { lStMp = &(tmp->next); tmp = *lStMp; } place = lStMp; };
        if (*place==NULL || ( ( (((*place)->p).file != ((*ref).p).file) || (((*place)->p).line != ((*ref).p).line) || (((*place)->p).coll != ((*ref).p).coll) ))) {
                { { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                *rr = *ref;
                if (((s_language & (4)) != 0)) {
                        if (ref->usg.base==UsageDefined && bestMatchFlag) {
                                rr->usg.base = UsageOLBestFitDefined;
                        }
                }
                {(rr)->next = ((*place)); (*place) = rr;};
        }
        return(rr);
}
S_reference *olcxAddReference(S_reference **rlist,S_reference *ref,int bestMatchFlag) {
        S_reference **place,*rr;
        if (! ((ref)->usg.base < UsageMaxOLUsages)) return(NULL);
        rr = olcxAddReferenceNoUsageCheck(rlist, ref, bestMatchFlag);
        return(rr);
}
static S_reference *olcxCopyReference(S_reference *ref) {
        S_reference *rr;
        { { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        *rr = *ref;
        rr->next = NULL;
        return(rr);
}
void olcxAppendReference(S_reference *ref, S_olcxReferences *refs) {
        S_reference *rr;
        rr = olcxCopyReference(ref);
        { if ((refs->r)==NULL) refs->r = rr; else { register S_reference *tempnsl; tempnsl = refs->r; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = rr; } };
}
void olcxAddReferences(S_reference *list, S_reference **dlist,
                                           int fnum, int bestMatchFlag) {
        S_reference *revlist,*tmp;
        revlist = NULL;
        while (list!=NULL) {
                tmp = list->next; list->next = revlist;
                revlist = list; list = tmp;
        }
        list = revlist;
        revlist = NULL;
        while (list!=NULL) {
                if (fnum==(-1) || fnum==list->p.file) {
                        olcxAddReference(dlist, list, bestMatchFlag);
                }
                tmp = list->next; list->next = revlist;
                revlist = list; list = tmp;
        }
        list = revlist;
}
void olcxAddReferenceToOlSymbolsMenu(S_olSymbolsMenu *cms, S_reference *rr,
                                                  int bestFitTlag) {
        int bestfit;
        S_reference *added;
        added = olcxAddReference(&cms->s.refs, rr, bestFitTlag);
        if (rr->usg.base == UsageClassTreeDefinition) cms->defpos = rr->p;
        if (added!=NULL) {
                if (( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared )) {
                        if (rr->usg.base==UsageDefined && (! ( ((rr->p).file != (cms->defpos).file) || ((rr->p).line != (cms->defpos).line) || ((rr->p).coll != (cms->defpos).coll) ))) {
                                added->usg.base = UsageOLBestFitDefined;
                        }
                        if (rr->usg.base < cms->defUsage) {
                                cms->defUsage = rr->usg.base;
                                cms->defpos = rr->p;
                        }
                        cms->defRefn ++;
                } else {
                        cms->refn ++;
                }
        }
}
static void olcxAddReferencesToOlSymbolsMenu(S_olSymbolsMenu *cms,
                                                                                         S_reference *rlist,
                                                                                         int bestFitFlag
        ) {
        S_reference *rr;
        for(rr=rlist; rr!=NULL; rr=rr->next) {
                olcxAddReferenceToOlSymbolsMenu(cms, rr, bestFitFlag);
        }
}
void generateOnlineCxref( S_position *p,
                                                        char *commandString,
                                                        int usage,
                                                        char *suffix,
                                                        char *suffix2
        ) {
        if (s_opt.xref2) {
                ppcGenGotoPositionRecord(p);
        } else {
                fprintf(ccOut,"%s%s#*+*#%d %d :%c%s%s ;;\n", commandString,
                                getRealFileNameStatic(s_fileTab.tab[p->file]->name),
                                p->line, p->coll, refCharCode(usage),
                                suffix, suffix2);
        }
}
static void olcxRenameInit() {
        S_olcxReferences *refs;
        S_reference *rr,*rrd;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 1304);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        refs->act = refs->r;
        generateOnlineCxref(&refs->act->p, "#",
                                                refs->act->usg.base, refs->refsuffix, "");
}
int olcxListLessFunction(S_reference *r1, S_reference *r2) {
        int fc;
        char *s1,*s2;
        s1 = simpleFileName(s_fileTab.tab[r1->p.file]->name);
        s2 = simpleFileName(s_fileTab.tab[r2->p.file]->name);
        fc=strcmp(s1, s2);
        if (fc<0) return(1);
        if (fc>0) return(0);
        if (r1->p.file < r2->p.file) return(1);
        if (r1->p.file > r2->p.file) return(0);
        if (r1->p.line < r2->p.line) return(1);
        if (r1->p.line > r2->p.line) return(0);
        if (r1->p.coll < r2->p.coll) return(1);
        if (r1->p.coll > r2->p.coll) return(0);
        return(0);
}
int olcxPushLessFunction(S_reference *r1, S_reference *r2) {
        int fc;
        char *s1,*s2;
        if (( r1->usg.base==UsageDefined || r1->usg.base==UsageDeclared || r1->usg.base==UsageOLBestFitDefined || r2->usg.base==UsageDefined || r2->usg.base==UsageDeclared || r2->usg.base==UsageOLBestFitDefined)) {
                if (r1->usg.base < r2->usg.base) return(1);
                if (r1->usg.base > r2->usg.base) return(0);
        }
        return(olcxListLessFunction(r1, r2));
}
static void olcxNaturalReorder(S_olcxReferences *refs) {
        { S_reference *_macrores; _macrores = (refs->r); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxPushLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (refs->r) = _macrores;};
}
static void olcxGenNoReferenceSignal() {
        if (s_opt.xref2) {
                ppcGenRecord(PPC_BOTTOM_INFORMATION, "No reference", "\n");
        } else {
                fprintf(ccOut, "_");
        }
}
static void olcxOrderRefsAndGotoFirst() {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 1380);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        { S_reference *_macrores; _macrores = (refs->r); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxListLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (refs->r) = _macrores;};
        refs->act = refs->r;
        if (refs->r != NULL) {
                generateOnlineCxref(&refs->act->p, "#",
                                                        refs->act->usg.base, refs->refsuffix, "");
        } else {
                olcxGenNoReferenceSignal();
        }
}
static int olcxSetCurrentRefsOnCaller( S_olcxReferences *refs ) {
        S_reference *rr;
        for(rr=refs->r; rr!=NULL; rr=rr->next){
                if (! ( ((rr->p).file < (refs->cpos).file) || ((rr->p).file==(refs->cpos).file && (rr->p).line < (refs->cpos).line) || ((rr->p).file==(refs->cpos).file && (rr->p).line==(refs->cpos).line && (rr->p).coll < (refs->cpos).coll) )) break;
        }
        if (rr == NULL) {
                refs->act = refs->r;
                return(0);
        } else {
                refs->act = rr;
                return(1);
        }
}
char *getJavaDocUrl_st(S_symbolRefItem *rr) {
        static char res[MAX_HTML_REF_LEN];
        char *tt;
        int len = MAX_HTML_REF_LEN;
        res[0] = 0;
        if (rr->b.symType == TypeDefault) {
                if (rr->vFunClass==s_noneFileIndex) {
                        tt = strchr(rr->name, '.');
                        if (tt==NULL) {
                                sprintf(res,"packages.html#xrefproblem");
                        } else {
                                len = tt - rr->name;
                                strncpy(res, rr->name, len);
                                sprintf(res+len, ".html#");
                                len = strlen(res);
                                linkNamePrettyPrint(res+len, tt+1,
                                                                                MAX_HTML_REF_LEN-len, LONG_NAME);
                        }
                } else {
                        javaGetClassNameFromFileNum(rr->vFunClass, res, KEEP_SLASHES);
                        for(tt=res; *tt; tt++) if (*tt=='$') *tt = '.';
                        len = strlen(res);
                        sprintf(res+len, ".html");
                        len += strlen(res+len);
                        if (strcmp(rr->name, " [classTree]")!=0) {
                                sprintf(res+len, "#");
                                len += strlen(res+len);
                                linkNamePrettyPrint(res+len, rr->name,
                                                                        MAX_HTML_REF_LEN-len, LONG_NAME);
                        }
                }
        } else if (rr->b.symType == TypeStruct) {
                sprintf(res,"%s.html",rr->name);
        } else if (rr->b.symType == TypePackage) {
                sprintf(res,"%s/package-tree.html",rr->name);
        }
        { if (!(strlen(res)<MAX_HTML_REF_LEN-1)) internalCheckFail("strlen(res)<MAX_HTML_REF_LEN-1", "cxref.c", 1445);};
        return(res);
}
int htmlJdkDocAvailableForUrl(char *ss){
        char ttt[MAX_FILE_NAME_SIZE];
        char *cp;
        int ind, nlen;
        cp = s_opt.htmlJdkDocAvailable;
        while (*cp!=0) {
                for(ind=0;
                        cp[ind]!=0 && cp[ind]!=CLASS_PATH_SEPARATOR && cp[ind]!=':' ;
                        ind++) {
                                ttt[ind]=cp[ind];
                                if (cp[ind]=='.') ttt[ind] = '/';
                }
                ttt[ind]=0;
                if (strncmp(ttt, ss, ind)==0) return(1);
                cp += ind;
                if (*cp == CLASS_PATH_SEPARATOR || *cp == ':') cp++;
        }
        return(0);
}
static int olcxGenHtmlFileWithIndirectLink(char *ofname, char *url) {
        FILE *of;
        of = fopen(ofname, "w");
        if (of == NULL) {
                fprintf(ccOut,"* ** Can't open temporary file %s\n", ofname);
                return(0);
        }
        fprintf(of, "<html><head>");
        if (s_opt.urlAutoRedirect || strchr(url,' ')==NULL) {
                fprintf(of, "<META http-equiv=\"refresh\" ");
                fprintf(of, "content=\"0;URL=%s\">\n", url);
        }
        fprintf(of, "</head><body>\n");
        if (! (s_opt.urlAutoRedirect || strchr(url,' ')==NULL)) {
                fprintf(of, "Please follow the link: ");
        }
        fprintf(of, "<A HREF=\"%s\">", url);
        fprintf(of, "%s", url);
        fprintf(of, "</A>\n");
        fprintf(of, "</body></html>");
        fclose(of);
        return(1);
}
static char *getExpandedLocalJavaDocFile_st(char *expandedPath, char *prefix, char *tmpfname) {
        static char fullurl[MAX_FILE_NAME_SIZE];
        char fullfname[MAX_FILE_NAME_SIZE];
        char *s;
        struct stat st;
        int cplen;
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(expandedPath!=NULL)) internalCheckFail("expandedPath!=NULL", "cxref.c", 1500);}; jmop_pp = expandedPath; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { cplen = strlen(currentPath); if (cplen>0 && currentPath[cplen-1]==SLASH) { if (prefix == NULL) { sprintf(fullurl, "%s%s", currentPath, tmpfname); } else { sprintf(fullurl, "%sapi%c%s", currentPath, SLASH, tmpfname); } } else { if (prefix == NULL) { sprintf(fullurl, "%s%c%s", currentPath, SLASH, tmpfname); } else { sprintf(fullurl, "%s%capi%c%s", currentPath, SLASH, SLASH, tmpfname); } } strcpy(fullfname, fullurl); if ((s=strchr(fullfname, '#'))!=NULL) *s = 0; if (stat(fullfname, &st)==0) return(fullurl); }; currentPath += jmop_ind; currentPath++; }};
        return(NULL);
}
char *getLocalJavaDocFile_st(char *fileUrl) {
        char tmpfname[MAX_FILE_NAME_SIZE];
        static char wcJavaDocPath[MAX_OPTION_LEN];
        char *ss, *res;
        if (s_opt.javaDocPath==NULL) return(NULL);
        strcpy(tmpfname, fileUrl);
        for(ss=tmpfname; *ss; ss++) if (*ss == '/') *ss = SLASH;
        expandWildCharactersInPaths(s_opt.javaDocPath, wcJavaDocPath, MAX_OPTION_LEN);
        res = getExpandedLocalJavaDocFile_st(wcJavaDocPath, NULL, tmpfname);
        if (res == NULL) {
                res = getExpandedLocalJavaDocFile_st(wcJavaDocPath, "api", tmpfname);
        }
        return(res);
}
static void unBackslashifyUrl(char *url) {
        char *ss;
#if defined (__WIN32__) || defined (__OS2__)
        for(ss=url; *ss; ss++) {
                if (*ss=='\\') *ss='/';
        }
#endif
}
char *getFullUrlOfJavaDoc_st(char *fileUrl) {
        static char fullUrl[MAX_CX_SYMBOL_SIZE];
        char *ss;
        ss = getLocalJavaDocFile_st(fileUrl);
        if (ss!=NULL) {
                sprintf(fullUrl,"file:///%s", ss);
        } else {
                sprintf(fullUrl, "%s/%s", s_opt.htmlJdkDocUrl, fileUrl);
        }
        unBackslashifyUrl(fullUrl);
        return(fullUrl);
}
static int olcxBrowseSymbolInJavaDoc( S_symbolRefItem *rr ) {
        char *url, *tt, *tmd, *lfn, *furl;
        char tmpfname[MAX_FILE_NAME_SIZE];
        char theUrl[MAX_FILE_NAME_SIZE];
        int rrr;
        url = getJavaDocUrl_st(rr);
        lfn = getLocalJavaDocFile_st(url);
        if (lfn==NULL && (s_opt.htmlJdkDocUrl==NULL || ! htmlJdkDocAvailableForUrl(url))) return(0);
        if (! s_opt.urlGenTemporaryFile) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_BROWSE_URL, getFullUrlOfJavaDoc_st(url), "\n");
                } else {
                        fprintf(ccOut,"~%s\n", getFullUrlOfJavaDoc_st(url));
                }
        } else {
#ifdef __WIN32__
                tmd = getenv("TEMP");
                { if (!(tmd)) internalCheckFail("tmd", "cxref.c", 1579);};
                sprintf(tmpfname, "%s/xrefjdoc.html", tmd);
                unBackslashifyUrl(tmpfname);
#else
                tmd = getenv("LOGNAME");
                { if (!(tmd)) internalCheckFail("tmd", "cxref.c", 1584);};
                sprintf(tmpfname, "/tmp/%sxref.html", tmd);
#endif
                rrr = olcxGenHtmlFileWithIndirectLink(tmpfname, getFullUrlOfJavaDoc_st(url));
                if (rrr) {
                        sprintf(theUrl, "file:///%s", tmpfname);
                        { if (!(strlen(theUrl)<MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(theUrl)<MAX_FILE_NAME_SIZE-1", "cxref.c", 1590);};
                        if (s_opt.xref2) {
                                ppcGenRecord(PPC_BROWSE_URL, theUrl, "\n");
                        } else {
                                fprintf(ccOut,"~%s\n", theUrl);
                        }
                }
        }
        return(1);
}
static int checkTheJavaDocBrowsing( S_olcxReferences *refs ) {
        S_olSymbolsMenu *mm;
        int res;
        res = 0;
        if (((s_language & (4)) != 0)) {
                for(mm=refs->menuSym; mm!=NULL; mm=mm->next) {
                        if (mm->visible && mm->selected) {
                                res = olcxBrowseSymbolInJavaDoc(&mm->s);
                                if (res) goto fini;
                        }
                }
    }
 fini:
        return(res);
}
static void orderRefsAndGotoDefinition(S_olcxReferences *refs, int afterMenuFlag) {
        S_olSymbolsMenu *mm;
        int res;
        olcxNaturalReorder(refs);
        if (refs->r == NULL) {
                refs->act = refs->r;
                if (afterMenuFlag==PUSH_AFTER_MENU) res=0;
                else res = checkTheJavaDocBrowsing(refs);
                if (res==0) {
                        olcxGenNoReferenceSignal();
                }
        } else if (refs->r->usg.base<=UsageDeclared) {
                refs->act = refs->r;
                generateOnlineCxref(&refs->act->p, "#",
                                                        refs->act->usg.base, refs->refsuffix, "");
        } else {
                if (afterMenuFlag==PUSH_AFTER_MENU) res=0;
                else res = checkTheJavaDocBrowsing(refs);
                if (res==0) {
                        if (s_opt.xref2) {
                                ppcGenDefinitionNotFoundWarning();
                        } else {
                                fprintf(ccOut,"*** Definition reference not found **");
                        }
                }
        }
}
static void olcxOrderRefsAndGotoDefinition(int afterMenuFlag) {
        S_olcxReferences *refs;
        S_olSymbolsMenu *mm;
        int res;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 1653);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        orderRefsAndGotoDefinition(refs, afterMenuFlag);
}
static void skipNLines(FILE **cofile, int n) {
        int c;
        for(; n>0; n--) {
                while ((c=fgetc(*cofile)) != '\n' && c!=EOF) ;
                if (c==EOF) {
                        *cofile = NULL;
                        return;
                }
        }
}
int refCharCode(int usage) {
        switch (usage) {
        case UsageOLBestFitDefined: return('!');
        case UsageDefined: return('*');
        case UsageDeclared: return('+');
        case UsageLvalUsed: return(',');
        case UsageAddrUsed: return('.');
        case UsageNotFQFieldInClassOrMethod: return('.');
        case UsageConstructorDefinition: return('-');
        default: return(' ');
        }
        { if (!(0)) internalCheckFail("0", "cxref.c", 1703);};
}
static char s_crefListLine[MAX_REF_LIST_LINE_LEN+5];
static int s_crefListLinei = 0;
static void passSourcePutChar(int c, FILE *ff) {
        if (s_opt.xref2) {
                if (s_crefListLinei < MAX_REF_LIST_LINE_LEN) {
                        s_crefListLine[s_crefListLinei++] = c;
                        s_crefListLine[s_crefListLinei] = 0;
                } else {
                        strcpy(s_crefListLine + s_crefListLinei, "...");
                }
        } else {
                if (s_opt.taskRegime == RegimeHtmlGenerate) htmlPutChar(ff,c);
                else fputc(c,ff);
        }
}
static void printKawaRefRecord(FILE *off, int type, char *rec) {
        int len;
        len = strlen(rec);
        fprintf(off, " %d%c%s", len, type, rec);
}
static void linePosProcess( FILE *off,
                                                        char *ofname,
                                                        int usages,
                                                        int usageFilter,
                                                        char *fname,
                                                        S_reference **rrr,
                                                        S_position *callerp,
                                                        S_position *cp,
                                                        int *cch,
                                                        S_charBuf *cxfBuf
                                                ) {
        int ch, pendingRefFlag, line, linerefn;
        S_reference *rr,*r;
        char *fn;
        rr = *rrr;
        ch = *cch;
        fn = simpleFileName(getRealFileNameStatic(fname));
        r = NULL; pendingRefFlag = 0;
        line = 0; linerefn = 0;
        s_crefListLinei = 0;
        s_crefListLine[s_crefListLinei] = 0;
        do {
                if (( usages==USAGE_ANY || usages==rr->usg.base || (usages==USAGE_FILTER && rr->usg.base<usageFilter) )) {
                        if (r==NULL || r->usg.base > rr->usg.base) r = rr;
                        if (s_opt.taskRegime!=RegimeHtmlGenerate) {
                                if (pendingRefFlag) {
                                        if (! s_opt.xref2) fprintf(off,"\n");
                                }
                                if (s_opt.xref2) {
                                        if (! pendingRefFlag) {
                                                sprintf(s_crefListLine+s_crefListLinei, "%s:%d:", fn, rr->p.line);
                                                s_crefListLinei += strlen(s_crefListLine+s_crefListLinei);
                                        }
                                } else {
                                        if (( ((*callerp).file != (rr->p).file) || ((*callerp).line != (rr->p).line) || ((*callerp).coll != (rr->p).coll) )) fprintf(off, " ");
                                        else fprintf(off, ">");
                                        fprintf(off,"%c%s:%d:",refCharCode(rr->usg.base),fn,
                                                        rr->p.line);
                                }
                                line = rr->p.line;
                                linerefn ++;
                                pendingRefFlag = 1;
                        }
                }
                rr=rr->next;
        } while (rr!=NULL && ((rr->p.file == cp->file && rr->p.line == cp->line)
                || (rr->usg.base>UsageMaxOLUsages)));
        if (r!=NULL) {
                if (! cxfBuf->isAtEOF) {
                        while (ch!='\n' && (! cxfBuf->isAtEOF)) {
                                passSourcePutChar(ch,off);
                                { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; { if ((cxfBuf)->cc >= (cxfBuf)->fin) { if ((cxfBuf)->isAtEOF || getCharBuf(cxfBuf) == 0) { ch = EOF; (cxfBuf)->isAtEOF = 1; } else { ch = * ((unsigned char*)(cxfBuf)->cc); (cxfBuf)->cc ++; } } else { ch = * ((unsigned char*)(cxfBuf)->cc); (cxfBuf)->cc++; } };};
                        }
                }
                if (! s_opt.xref2) passSourcePutChar('\n',off);
        }
        if (s_opt.xref2 && s_crefListLinei!=0) {
                ppcIndentOffset();
                fprintf(off, "<%s %s=%d %s=%d>%s</%s>\n",
                                PPC_SRC_LINE, PPCA_REFN, linerefn,
                                PPCA_LEN, strlen(s_crefListLine),
                                s_crefListLine, PPC_SRC_LINE);
        }
        *rrr = rr;
        *cch = ch;
}
static S_reference *passNonPrintableRefsForFile(S_reference *r,
                                                                                                int fnum,
                                                                                                int usages, int usageFilter
        ) {
        S_reference *rr;
        for(rr=r; rr!=NULL && rr->p.file == fnum; rr=rr->next) {
                if (( usages==USAGE_ANY || usages==rr->usg.base || (usages==USAGE_FILTER && rr->usg.base<usageFilter) )) return(rr);
        }
        return(rr);
}
static void passRefsThroughSourceFile(S_reference **rrr, S_position *callerp,
                                                                        FILE *off,
                                                                          char *ofname, int usages, int usageFilter) {
        S_reference *rr,*oldrr;
        int n,ch,fnum;
        FILE *cofile;
        S_editorBuffer *ebuf;
        char *cofileName;
        S_position cp;
        S_charBuf cxfBuf;
        rr = *rrr;
        if (rr==NULL) goto fin;
        fnum = rr->p.file;
        { if (!(s_fileTab.tab[fnum])) internalCheckFail("s_fileTab.tab[fnum]", "cxref.c", 1826);};
        cofileName = s_fileTab.tab[fnum]->name;
        rr = passNonPrintableRefsForFile(rr, fnum, usages, usageFilter);
        if (rr==NULL || rr->p.file != fnum) goto fin;
        if (s_opt.referenceListWithoutSource) {
                ebuf = NULL;
        } else {
                ebuf = editorFindFile(cofileName);
                if (ebuf==NULL) {
                        if (s_opt.xref2) {
                                sprintf(tmpBuff, "file %s not accessible", cofileName);
                                error(ERR_ST, tmpBuff);
                        } else {
                                fprintf(off,"  !!! file %s is not accessible: ", cofileName);
                        }
                }
        }
        ch = ' ';
        if (ebuf==NULL) {
                cxfBuf.isAtEOF = 1;
        } else {
                { (&cxfBuf)->cc = ebuf->a.text; (&cxfBuf)->fin = ebuf->a.text+ebuf->a.bufferSize; (&cxfBuf)->ff = NULL; (&cxfBuf)->filePos = ebuf->a.bufferSize; (&cxfBuf)->fileNumber = s_noneFileIndex; (&cxfBuf)->lineNum = 0; (&cxfBuf)->lineBegin = ebuf->a.text; (&cxfBuf)->collumnOffset = 0; (&cxfBuf)->isAtEOF = 0; (&cxfBuf)->inputMethod = INPUT_DIRECT; (&cxfBuf)->zipStream = s_defaultZStream;};
                { if (ch=='\n') {(&cp)->line++; (&cp)->coll=0;} else (&cp)->coll++; { if ((&cxfBuf)->cc >= (&cxfBuf)->fin) { if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = EOF; (&cxfBuf)->isAtEOF = 1; } else { ch = * ((unsigned char*)(&cxfBuf)->cc); (&cxfBuf)->cc ++; } } else { ch = * ((unsigned char*)(&cxfBuf)->cc); (&cxfBuf)->cc++; } };};
        }
        { (&cp)->file = rr->p.file; (&cp)->line = 1; (&cp)->coll = 0;};
        oldrr=NULL;
        while (rr!=NULL && rr->p.file==cp.file && rr->p.line>=cp.line) {
                { if (!(oldrr!=rr)) internalCheckFail("oldrr!=rr", "cxref.c", 1856);}; oldrr=rr;
                while ((! cxfBuf.isAtEOF) && cp.line<rr->p.line) {
                        while (ch!='\n' && ch!=EOF) { if ((&cxfBuf)->cc >= (&cxfBuf)->fin) { if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = EOF; (&cxfBuf)->isAtEOF = 1; } else { ch = * ((unsigned char*)(&cxfBuf)->cc); (&cxfBuf)->cc ++; } } else { ch = * ((unsigned char*)(&cxfBuf)->cc); (&cxfBuf)->cc++; } };
                        { if (ch=='\n') {(&cp)->line++; (&cp)->coll=0;} else (&cp)->coll++; { if ((&cxfBuf)->cc >= (&cxfBuf)->fin) { if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = EOF; (&cxfBuf)->isAtEOF = 1; } else { ch = * ((unsigned char*)(&cxfBuf)->cc); (&cxfBuf)->cc ++; } } else { ch = * ((unsigned char*)(&cxfBuf)->cc); (&cxfBuf)->cc++; } };};
                }
                linePosProcess(off, ofname, usages, usageFilter, cofileName,
                                           &rr, callerp, &cp, &ch, &cxfBuf);
        }
 fin:
        *rrr = rr;
}
void olcxDumpSelectionMenu(S_olSymbolsMenu *menu) {
        S_olSymbolsMenu *ss;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                fprintf(dumpOut,">> %d/%d %s %s %s %d\n", ss->defRefn, ss->refn, ss->s.name, simpleFileName(s_fileTab.tab[ss->s.vFunClass]->name), simpleFileName(s_fileTab.tab[ss->s.vApplClass]->name), ss->outOnLine);
        }
        fprintf(dumpOut,"\n\n");
}
int ooBitsGreaterOrEqual(unsigned oo1, unsigned oo2) {
        if ((oo1&07000) < (oo2&07000)) {
                return(0);
        }
        if ((oo1&00700) < (oo2&00700)) {
                return(0);
        }
        return(1);
}
void olcxPrintClassTree(S_olSymbolsMenu *sss) {
        if (s_opt.xref2) {
                ppcGenRecordBegin(PPC_DISPLAY_CLASS_TREE);
        } else {
                fprintf(ccOut, "<");
        }
        readOneAppropReferenceFile(NULL, s_cxScanFunTabForClassHierarchy);
        htmlGenGlobRefLists(sss, ccOut, "__NO_HTML_FILE_NAME!__");
        if (s_opt.xref2) ppcGenRecordEnd(PPC_DISPLAY_CLASS_TREE);
}
void olcxPrintSelectionMenu(S_olSymbolsMenu *sss) {
        if (s_opt.xref2) {
                ppcGenRecordBegin(PPC_SYMBOL_RESOLUTION);
        } else {
                fprintf(ccOut, ">");
        }
        if (sss!=NULL) {
                readOneAppropReferenceFile(NULL, s_cxScanFunTabForClassHierarchy);
                htmlGenGlobRefLists(sss, ccOut, "__NO_HTML_FILE_NAME!__");
        }
        if (s_opt.xref2) {
                ppcGenRecordEnd(PPC_SYMBOL_RESOLUTION);
        } else {
                if (s_opt.cxrefs==OLO_RENAME || s_opt.cxrefs==OLO_ARG_MANIP || s_opt.cxrefs==OLO_ENCAPSULATE) {
                        if (((s_language & (4)) != 0)) {
                                fprintf(ccOut, "-![Warning] It is highly recommended to process the whole hierarchy of related classes at once. Unselection of any class of applications above (and its exclusion from refactoring process) may cause changes in your program behavior. Press <return> to continue.\n");
                        } else {
                                fprintf(ccOut, "-![Warning] It is highly recommended to process all symbols at once. Unselection of any symbols and its exclusion from refactoring process may cause changes in your program behavior. Press <return> to continue.\n");
                        }
                }
                if (s_opt.cxrefs==OLO_VIRTUAL2STATIC_PUSH) {
                        fprintf(ccOut, "-![Warning] If you see this message it is highly probable that turning this virtual method into static will not be behaviour preserving! This refactoring is behaviour preserving only if the method does not use mechanism of virtual invocations. On this screen you should select the application classes which are refering to the method which will become static. If you can't unambiguously determine those references do not continue in this refactoring!\n");
                }
                if (s_opt.cxrefs==OLO_SAFETY_CHECK2) {
                        if (((s_language & (4)) != 0)) {
                                fprintf(ccOut, "-![Warning] There are differences between original class hierarchy and the new one, those name clashes may cause that the refactoring will not be behavior preserving!\n");
                        } else {
                                fprintf(ccOut, "-![Error] There is differences between original and new symbols referenced at this position. The difference is due to name clashes and may cause changes in the behaviour of the program. Please, undo last refactoring!");
                        }
                }
                if (s_opt.cxrefs==OLO_PUSH_ENCAPSULATE_SAFETY_CHECK) {
                        fprintf(ccOut, "-![Warning] A method (getter or setter) created during the encapsulation has the same name as an existing method, so it will be inserted into this (existing) inheritance hierarchy. This may cause that the refactoring will not be behaviour preserving. Please, select applications unambiguously reporting to the newly created method. If you can't do this, you should undo the refactoring and rename the field first!\n");
                }
        }
}
static int getCurrentRefPosition(S_olcxReferences *refs) {
        S_reference *rr;
        int actn;
        int rlevel;
        actn = 0;
        rr = NULL;
        if (refs!=NULL) {
                rlevel = s_refListFilters[refs->refsFilterLevel];
                for(rr=refs->r; rr!=NULL && rr!=refs->act; rr=rr->next) {
                        if (rr->usg.base < rlevel) actn ++ ;
                }
        }
        if (rr==NULL) actn = 0;
        return(actn);
}
static void symbolHighlighNameSprint(char *output, S_olSymbolsMenu *ss) {
        char *bb, *cc;
        int len, llen;
        sprintfSymbolLinkName(output, ss);
        cc = strchr(output, '(');
        if (cc != NULL) *cc = 0;
        len = strlen(output);
        output[len]=0;
        bb = lastOccurenceInString(output,'.');
        if (bb!=NULL) {
                bb++;
                llen = strlen(bb);
                memmove(output, bb, llen+1);
                output[llen]=0;
        }
}
static void olcxPrintRefList( char *commandString, S_olcxReferences *refs ) {
        S_reference *rr;
        int actn, nn, len;
        char ttt[MAX_CX_SYMBOL_SIZE];
        char *cc;
        if (s_opt.xref2) {
                actn = getCurrentRefPosition(refs);
                if (refs!=NULL && refs->menuSym != NULL) {
                        ttt[0]='\"';
                        symbolHighlighNameSprint(ttt+1, refs->menuSym);
                        len = strlen(ttt);
                        ttt[len]='\"';
                        ttt[len+1]=0;
                        ppcGenWithNumericAndRecordBegin(PPC_REFERENCE_LIST, actn,
                                                                                        PPCA_SYMBOL, ttt);
                } else {
                        ppcGenNumericRecordBegin(PPC_REFERENCE_LIST, actn);
                }
        } else {
                fprintf(ccOut,"%s",commandString);
        }
        if (refs!=NULL) {
                rr=refs->r;
                while (rr != NULL) {
                        passRefsThroughSourceFile(&rr, &refs->act->p,
                                                                          ccOut, "*xref-list*", USAGE_FILTER,
                                                                          s_refListFilters[refs->refsFilterLevel]);
                }
        }
        if (s_opt.xref2) {
                ppcGenRecordEnd(PPC_REFERENCE_LIST);
        }
        fflush(ccOut);
}
static void olcxReferenceList(char *commandString) {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2007);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxPrintRefList( commandString, refs);
}
static void olcxListTopReferences(char *commandString) {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2015);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (DEFAULT_VALUE==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxPrintRefList( commandString, refs);
}
static void olcxGenGotoActReference(S_olcxReferences *refs) {
        if (refs->act != NULL) {
                generateOnlineCxref(&refs->act->p, "#",
                                                        refs->act->usg.base, refs->refsuffix, "");
        } else {
                olcxGenNoReferenceSignal();
        }
}
static void olcxPushOnly() {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2030);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxGenGotoActReference(refs);
}
static void olcxPushAndCallMacro() {
        S_olcxReferences *refs;
        S_reference *rr;
        char symbol[MAX_CX_SYMBOL_SIZE];
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2039);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        { S_reference *_macrores; _macrores = (refs->r); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxListLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (refs->r) = _macrores;};
        { register S_reference *list,*tmp,*revlist; list = refs->r; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } refs->r = revlist;};
        { if (!(s_opt.xref2)) internalCheckFail("s_opt.xref2", "cxref.c", 2042);};
        symbolHighlighNameSprint(symbol, refs->hkSelectedSym);
        for(rr=refs->r; rr!=NULL; rr=rr->next) {
                ppcGenReferencePreCheckRecord(rr, symbol);
        }
        for(rr=refs->r; rr!=NULL; rr=rr->next) {
                ppcGenReferencePreCheckRecord(rr, symbol);
                ppcGenRecord(PPC_CALL_MACRO, "", "\n");
        }
        { register S_reference *list,*tmp,*revlist; list = refs->r; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } refs->r = revlist;};
}
static void olcxReferenceGotoRef(int refn) {
        S_olcxReferences *refs;
        S_reference *rr;
        int i,rfilter;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2059);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        rfilter = s_refListFilters[refs->refsFilterLevel];
        for(rr=refs->r,i=1; rr!=NULL && (i<refn||rr->usg.base>=rfilter); rr=rr->next){
                if (rr->usg.base < rfilter) i++;
        }
        refs->act = rr;
        olcxGenGotoActReference(refs);
}
S_olCompletion *olCompletionNthLineRef(S_olCompletion *cpls, int refn) {
        S_olCompletion *rr, *rrr;
        int i;
        for(rr=rrr=cpls, i=1; i<=refn && rrr!=NULL; rrr=rrr->next) {
                i += rrr->lineCount;
                rr = rrr;
        }
        return(rr);
}
static void olcxPopUser() {
        s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
}
static void olcxPopUserAndFreePoped() {
        olcxPopUser();
        olcxFreePopedStackItems(&s_olcxCurrentUser->browserStack);
}
static S_olcxReferences *olcxPushUserOnPhysicalTopOfStack() {
        S_olcxReferences *oldtop;
        oldtop = s_olcxCurrentUser->browserStack.top;
        s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.root;
        olcxPushEmptyStackItem(&s_olcxCurrentUser->browserStack);
        return(oldtop);
}
static void olcxPopAndFreeAndPopsUntil(S_olcxReferences *oldtop) {
        olcxPopUserAndFreePoped();
        while (s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top!=oldtop) {
                olcxPopUser();
        }
}
static void olcxFindDefinitionAndGenGoto(S_symbolRefItem *sym) {
        S_olcxReferences *refs, *oldtop;
        S_olSymbolsMenu mmm;
        oldtop = olcxPushUserOnPhysicalTopOfStack();
        refs = s_olcxCurrentUser->browserStack.top;
        { (&mmm)->s = *sym; (&mmm)->selected = 1; (&mmm)->visible = 1; (&mmm)->ooBits = 0; (&mmm)->olUsage = UsageUsed; (&mmm)->vlevel = 0; (&mmm)->refn = 0; (&mmm)->defRefn = 0; (&mmm)->defUsage = UsageNone; (&mmm)->defpos = s_noPos; (&mmm)->outOnLine = 0; (&mmm)->markers = NULL; (&mmm)->next = NULL;};
        refs->menuSym = &mmm;
        readOneAppropReferenceFile(sym->name, s_cxFullScanFunTab);
        orderRefsAndGotoDefinition(refs, DEFAULT_VALUE);
        refs->menuSym = NULL;
        olcxPopAndFreeAndPopsUntil(oldtop);
}
static void olcxReferenceGotoCompletion(int refn) {
        S_olcxReferences *refs;
        S_olCompletion *rr,*rrr;
        S_symbolRefItemBits sb;
        int i,jdoc;
        { if (!(refn > 0)) internalCheckFail("refn > 0", "cxref.c", 2126);};
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2127);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        rr = olCompletionNthLineRef(refs->cpls, refn);
        if (rr != NULL) {
                if (rr->cat == CatLocal ) {
                        if (rr->ref.usg.base != UsageClassFileDefinition
                                && rr->ref.usg.base != UsageClassTreeDefinition
                                && ( ((rr->ref.p).file != (s_noPos).file) || ((rr->ref.p).line != (s_noPos).line) || ((rr->ref.p).coll != (s_noPos).coll) )) {
                                        generateOnlineCxref(&rr->ref.p, "#",
                                                                                UsageDefined, refs->refsuffix, "");
                        } else {
                                jdoc = olcxBrowseSymbolInJavaDoc(&rr->sym);
                                if (jdoc==0) olcxGenNoReferenceSignal();
                        }
                } else {
                        olcxFindDefinitionAndGenGoto(&rr->sym);
                }
        } else {
                olcxGenNoReferenceSignal();
        }
}
static void olcxReferenceGotoTagSearchItem(int refn) {
        S_olCompletion *rr,*rrr;
        S_symbolRefItemBits sb;
        int i,jdoc;
        { if (!(refn > 0)) internalCheckFail("refn > 0", "cxref.c", 2152);};
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2153);};
        { if (!(s_olcxCurrentUser->retrieverStack.top)) internalCheckFail("s_olcxCurrentUser->retrieverStack.top", "cxref.c", 2154);};
        rr = olCompletionNthLineRef(s_olcxCurrentUser->retrieverStack.top->cpls, refn);
        if (rr != NULL) {
                if (rr->ref.usg.base != UsageClassFileDefinition
                        && rr->ref.usg.base != UsageClassTreeDefinition
                        && ( ((rr->ref.p).file != (s_noPos).file) || ((rr->ref.p).line != (s_noPos).line) || ((rr->ref.p).coll != (s_noPos).coll) )) {
                        generateOnlineCxref(&rr->ref.p, "#",
                                                                UsageDefined, "0:#", "");
                } else {
                        jdoc = olcxBrowseSymbolInJavaDoc(&rr->sym);
                        if (jdoc==0) olcxGenNoReferenceSignal();
                }
        } else {
                olcxGenNoReferenceSignal();
        }
}
static void olcxReferenceBrowseCompletion(int refn) {
        S_olcxReferences *refs;
        S_olCompletion *rr;
        char *url,*tt;
        int aa;
        { if (!(refn > 0)) internalCheckFail("refn > 0", "cxref.c", 2176);};
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2177);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        rr = olCompletionNthLineRef(refs->cpls, refn);
        if (rr != NULL) {
                if (rr->cat == CatLocal) {
                        fprintf(ccOut,"* ** no JavaDoc is available for local symbols **");
                } else {
                        aa = olcxBrowseSymbolInJavaDoc(&rr->sym);
                        if (aa==0) {
                                fprintf(ccOut, "*** JavaDoc for ");
                                url = getJavaDocUrl_st(&rr->sym);
                                for(tt=url ; *tt && *tt!='#'; tt++) fputc(*tt, ccOut);
                                fprintf(ccOut, " not available, (check -javadocpath) **");
                        }
                }
        } else {
                fprintf(ccOut, "* ** out of range **");
        }
}
static void olcxSetActReferenceToFirstVisible(S_olcxReferences *refs, S_reference *r) {
        int rlevel;
        rlevel = s_refListFilters[refs->refsFilterLevel];
        while (r!=NULL && r->usg.base>=rlevel) r = r->next;
        if (r != NULL) {
                refs->act = r;
        } else {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_BOTTOM_INFORMATION, "Moving to the first reference", "\n");
                }
                r = refs->r;
                while (r!=NULL && r->usg.base>=rlevel) r = r->next;
                refs->act = r;
        }
}
static void olcxReferencePlus() {
        S_olcxReferences *refs;
        S_reference *r;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2215);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (refs->act == NULL) refs->act = refs->r;
        else {
                r = refs->act->next;
                olcxSetActReferenceToFirstVisible(refs, r);
        }
        olcxGenGotoActReference(refs);
}
static void olcxReferenceMinus() {
        S_olcxReferences *refs;
        S_reference *r,*l,*act;
        int rlevel;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2228);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        rlevel = s_refListFilters[refs->refsFilterLevel];
        if (refs->act == NULL) refs->act = refs->r;
        else {
                act = refs->act;
                l = NULL;
                for(r=refs->r; r!=act && r!=NULL; r=r->next) {
                        if (r->usg.base < rlevel) l = r;
                }
                if (l==NULL) {
                        if (s_opt.xref2) {
                                ppcGenRecord(PPC_BOTTOM_INFORMATION, "Moving to the last reference", "\n");
                        }
                        for( ; r!=NULL; r=r->next) {
                                if (r->usg.base < rlevel) l = r;
                        }
                }
                refs->act = l;
        }
        olcxGenGotoActReference(refs);
}
static void olcxReferenceGotoDef() {
        S_olcxReferences *refs;
        S_reference *dr;
        int rlevel;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2254);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        dr = getDefinitionRef(refs->r);
        if (dr != NULL) refs->act = dr;
        else refs->act = refs->r;
        olcxGenGotoActReference(refs);
}
static void olcxReferenceGotoCurrent() {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2264);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxGenGotoActReference(refs);
}
static void olcxReferenceGetCurrentRefn() {
        S_olcxReferences *refs;
        int n;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2271);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        n = getCurrentRefPosition(refs);
        { if (!(s_opt.xref2)) internalCheckFail("s_opt.xref2", "cxref.c", 2273);};
        ppcGenNumericRecord(PPC_UPDATE_CURRENT_REFERENCE, n, "", "\n");
}
static void olcxReferenceGotoCaller() {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2279);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (refs->cpos.file != s_noneFileIndex) {
                generateOnlineCxref(&refs->cpos, "#",
                                                        UsageUsed, refs->refsuffix, "");
        } else {
                olcxGenNoReferenceSignal();
        }
}
static void olcxPrintSymbolName( S_olcxReferences *refs ) {
        char ttt[MAX_CX_SYMBOL_SIZE+50];
        S_olSymbolsMenu *ss;
        if (refs==NULL) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_BOTTOM_INFORMATION, "stack is now empty", "\n");
                } else {
                        fprintf(ccOut, "*stack is now empty");
                }
        } else if (refs->hkSelectedSym==NULL) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_BOTTOM_INFORMATION, "Current top symbol: <empty>", "\n");
                } else {
                        fprintf(ccOut, "*Current top symbol: <empty>");
                }
        } else {
                ss = refs->hkSelectedSym;
                if (s_opt.xref2) {
                        sprintf(ttt, "Current top symbol: ");
                        { if (!(strlen(ttt) < 50)) internalCheckFail("strlen(ttt) < 50", "cxref.c", 2311);};
                        sprintfSymbolLinkName(ttt+strlen(ttt), ss);
                        ppcGenRecord(PPC_BOTTOM_INFORMATION, ttt, "\n");
                } else {
                        fprintf(ccOut, "*Current top symbol: ");
                        printSymbolLinkName(ccOut, ss);
                }
        }
}
static void olcxShowTopSymbol() {
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2325);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (DEFAULT_VALUE==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxPrintSymbolName( refs);
}
static int referenceLess(S_reference *r1, S_reference *r2) {
        return(( ((r1->p).file < (r2->p).file) || ((r1->p).file==(r2->p).file && (r1->p).line < (r2->p).line) || ((r1->p).file==(r2->p).file && (r1->p).line==(r2->p).line && (r1->p).coll < (r2->p).coll) ));
}
static S_olSymbolsMenu *findSymbolCorrespondingToReference(
        S_olSymbolsMenu *menu,
        S_reference *ref
        ) {
        S_olSymbolsMenu *ss;
        S_reference *rr;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                { register S_reference *tmp; tmp = ss->s.refs; while (tmp!=NULL && referenceLess(tmp,(ref))) tmp=tmp->next; rr=tmp; };
                if (rr!=NULL && (! ( ((rr->p).file != (ref->p).file) || ((rr->p).line != (ref->p).line) || ((rr->p).coll != (ref->p).coll) ))) {
                        return(ss);
                }
        }
        return(NULL);
}
static void olcxShowTopApplClass() {
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        S_olSymbolsMenu *mms;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2354);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        { if (!(refs->act!=NULL)) internalCheckFail("refs->act!=NULL", "cxref.c", 2355);};
        mms = findSymbolCorrespondingToReference(refs->menuSym, refs->act);
        if (mms==NULL) {
                olcxGenNoReferenceSignal();
        } else {
                fprintf(ccOut, "*");
                printClassFqtNameFromClassNum(ccOut, mms->s.vApplClass);
        }
}
static void olcxShowTopType() {
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        S_olSymbolsMenu *mms;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2370);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        { if (!(refs->act!=NULL)) internalCheckFail("refs->act!=NULL", "cxref.c", 2371);};
        mms = findSymbolCorrespondingToReference(refs->menuSym, refs->act);
        if (mms==NULL) {
                olcxGenNoReferenceSignal();
        } else {
                fprintf(ccOut, "*%s",typesName[mms->s.b.symType]);
        }
}
static void olcxShowClassTree() {
        olcxPrintClassTree(s_olcxCurrentUser->ct.tree);
}
S_olSymbolsMenu *olCreateSpecialMenuItem(char *fieldName, int cfi,int storage){
        S_olSymbolsMenu *res;
        S_symbolRefItemBits bb;
        S_symbolRefItem ss;
        { (&bb)->symType = TypeDefault; (&bb)->storage = storage; (&bb)->scope = ScopeGlobal; (&bb)->accessFlags = 0x000; (&bb)->category = CatGlobal; (&bb)->htmlWasLn = 0;};
        { (&ss)->name = fieldName; (&ss)->fileHash = cxFileHashNumber(fieldName); (&ss)->vApplClass = cfi; (&ss)->vFunClass = cfi; (&ss)->b = bb; (&ss)->refs = NULL; (&ss)->next = NULL;};
        res = olCreateNewMenuItem(&ss, ss.vApplClass, ss.vFunClass, &s_noPos, UsageNone,
                                                          1, 1, 00500,
                                                          UsageUsed, 0);
        return(res);
}
static void olcxTopSymbolResolution() {
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2401);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (DEFAULT_VALUE==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        ss = NULL;
        if (refs!=NULL) {
                { S_olSymbolsMenu *_macrores; _macrores = (refs->menuSym); { S_olSymbolsMenu *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (htmlRefItemsOrderLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (refs->menuSym) = _macrores;};
                ss = refs->menuSym;
        }
        olcxPrintSelectionMenu(ss);
}
int itIsSameCxSymbol(S_symbolRefItem *p1, S_symbolRefItem *p2) {
        { if (p1 == p2) return(1); if (p1->b.category != p2->b.category) return(0); if (p1->b.symType!=TypeCppCollate && p2->b.symType!=TypeCppCollate && p1->b.symType!=p2->b.symType) return(0); if (p1->b.storage!=p2->b.storage) return(0);};
        if (strcmp(p1->name,p2->name)) return(0);
        return(1);
}
int itIsSameCxSymbolIncludingFunClass(S_symbolRefItem *p1, S_symbolRefItem *p2) {
        if (p1->vFunClass != p2->vFunClass) return(0);
        return(itIsSameCxSymbol(p1, p2));
}
int itIsSameCxSymbolIncludingApplClass(S_symbolRefItem *p1, S_symbolRefItem *p2) {
        if (p1->vApplClass != p2->vApplClass) return(0);
        return(itIsSameCxSymbol(p1, p2));
}
int olcxItIsSameCxSymbol(S_symbolRefItem *p1, S_symbolRefItem *p2) {
        int c, n1len, n2len;
        char *ss, *n1start, *n2start;
        { register int _c_; register char *_ss_; _ss_ = n1start = p1->name; while ((_c_= *_ss_)) { if (_c_ == '(') break; if (( _c_=='.' || _c_=='/' || _c_=='!' || _c_=='#' || _c_=='$')) n1start = _ss_+1; _ss_++ ; } n1len = _ss_ - n1start;};
        { register int _c_; register char *_ss_; _ss_ = n2start = p2->name; while ((_c_= *_ss_)) { if (_c_ == '(') break; if (( _c_=='.' || _c_=='/' || _c_=='!' || _c_=='#' || _c_=='$')) n2start = _ss_+1; _ss_++ ; } n2len = _ss_ - n2start;};
        if (n1len != n2len) return(0);
        if (strncmp(n1start, n2start, n1len)) return(0);
        return(1);
}
void olStackDeleteSymbol( S_olcxReferences *refs) {
        S_olcxReferences **rr;
        for( rr= &s_olcxCurrentUser->browserStack.root;
                        *rr!=NULL&&*rr!=refs;
                        rr= &(*rr)->previous
                ) ;
        { if (!(*rr != NULL)) internalCheckFail("*rr != NULL", "cxref.c", 2450);};
        deleteOlcxRefs(rr, &s_olcxCurrentUser->browserStack);
}
static void olcxGenInspectClassDefinitionRef(int classnum, char *refsuffix) {
        S_symbolRefItem mmm;
        char ccc[MAX_CX_SYMBOL_SIZE];
        javaGetClassNameFromFileNum(classnum, ccc, KEEP_SLASHES);
        { (&mmm.b)->symType = TypeStruct; (&mmm.b)->storage = StorageExtern; (&mmm.b)->scope = ScopeGlobal; (&mmm.b)->accessFlags = 0x000; (&mmm.b)->category = CatGlobal; (&mmm.b)->htmlWasLn = 0;};
        { (&mmm)->name = ccc; (&mmm)->fileHash = cxFileHashNumber(ccc); (&mmm)->vApplClass = s_noneFileIndex; (&mmm)->vFunClass = s_noneFileIndex; (&mmm)->b = mmm.b; (&mmm)->refs = NULL; (&mmm)->next = NULL;};
        olcxFindDefinitionAndGenGoto(&mmm);
}
static void olcxMenuInspectDef(S_olSymbolsMenu *menu, char *refsuffix,
                                                           int inspect) {
        S_olSymbolsMenu *ss;
        int line;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                line = 0 + ss->outOnLine;
                if (line == s_opt.olcxMenuSelectLineNum) goto breakl;
        }
breakl:
        if (ss == NULL) {
                olcxGenNoReferenceSignal();
        } else {
                if (inspect == INSPECT_DEF) {
                        if (ss->defpos.file>=0 && ss->defpos.file!=s_noneFileIndex) {
                                generateOnlineCxref(&ss->defpos, "#",
                                                                        UsageDefined, refsuffix, "");
                        } else if (! olcxBrowseSymbolInJavaDoc(&ss->s)) {
                                olcxGenNoReferenceSignal();
                        }
                } else {
                        olcxGenInspectClassDefinitionRef(ss->s.vApplClass, refsuffix);
                }
        }
}
static void olcxSymbolMenuInspectClass() {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2496);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxMenuInspectDef(refs->menuSym, refs->refsuffix, INSPECT_CLASS);
}
static void olcxSymbolMenuInspectDef() {
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2502);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        olcxMenuInspectDef(refs->menuSym, refs->refsuffix, INSPECT_DEF);
}
static void olcxClassTreeInspectDef() {
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2507);};
        olcxMenuInspectDef(s_olcxCurrentUser->ct.tree, "0:#", INSPECT_CLASS);
}
void olProcessSelectedReferences(
                S_olcxReferences *rstack,
                void (*referencesMapFun)(S_olcxReferences *rstack, S_olSymbolsMenu *ss)
        ) {
        S_olSymbolsMenu *ss, *sss;
        int fnum, nn;
        ss = rstack->menuSym;
        if (ss == NULL) return;
        { S_reference *_macrores; _macrores = (rstack->r); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (rstack->r) = _macrores;};
        for(ss=rstack->menuSym; ss!=NULL; ss=ss->next) {
                referencesMapFun(rstack, ss);
        }
        olcxSetCurrentRefsOnCaller( rstack);
        { S_reference *_macrores; _macrores = (rstack->r); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxListLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (rstack->r) = _macrores;};
}
void olcxRecomputeSelRefs( S_olcxReferences *refs ) {
        int num;
        olcxFreeReferences(refs->r); refs->r = NULL;
        olProcessSelectedReferences(refs, genOnLineReferences);
}
static void olcxMenuToggleSelect() {
        S_userOlcx *user;
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        int line,num;
        char ln[MAX_HTML_REF_LEN];
        char *cname;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2545);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        for(ss=refs->menuSym; ss!=NULL; ss=ss->next) {
                line = 0 + ss->outOnLine;
                if (line == s_opt.olcxMenuSelectLineNum) {
                        ss->selected = ss->selected ^ 1;
                        olcxRecomputeSelRefs( refs);
                        break;
                }
        }
        if (s_opt.xref2) {
                if (ss!=NULL) {
                        olcxPrintRefList( ";", refs);
                }
        } else {
                if (ss==NULL) {
                        olcxGenNoReferenceSignal();
                } else {
                        linkNamePrettyPrint(ln,ss->s.name,MAX_HTML_REF_LEN,SHORT_NAME);
                        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(
                                s_fileTab.tab[ss->s.vApplClass]->name), s_opt.nestedClassDisplaying);
                        sprintf(tmpBuff, "%s %s refs of \"%s\"",
                                        (ss->selected?"inserting":"removing"), cname, ln);
                        fprintf(ccOut,"*%s", tmpBuff);
                }
        }
}
static void olcxMenuSelectOnly() {
        S_userOlcx *user;
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss, *sel;
        S_reference *dref;
        int line,num,jd;
        char ttt[MAX_CX_SYMBOL_SIZE];
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2580);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        sel = NULL;
        for(ss=refs->menuSym; ss!=NULL; ss=ss->next) {
                ss->selected = 0;
                line = 0 + ss->outOnLine;
                if (line == s_opt.olcxMenuSelectLineNum) {
                        ss->selected = 1;
                        sel = ss;
                }
        }
        if (sel==NULL) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_BOTTOM_WARNING, "No Symbol", "\n");
                } else {
                        fprintf(ccOut,"*No symbol");
                }
                return;
        }
        olcxRecomputeSelRefs( refs);
        if (s_opt.xref2) {
                dref = getDefinitionRef(refs->r);
                if (dref != NULL) refs->act = dref;
                olcxPrintRefList(";", refs);
                if (dref == NULL) {
                        if (sel!=NULL && sel->s.vApplClass!=sel->s.vFunClass) {
                                sprintfSymbolLinkName(ttt, sel);
                                sprintf(tmpBuff,"Class %s does not define %s", javaGetShortClassNameFromFileNum_st(sel->s.vApplClass), ttt);
                                ppcGenRecordWithNumeric(PPC_BOTTOM_INFORMATION, PPCA_BEEP, 1, tmpBuff, "\n");
                        } else {
                                jd = olcxBrowseSymbolInJavaDoc(&sel->s);
                                if (jd==0) {
                                        ppcGenDefinitionNotFoundWarningAtBottom();
                                } else {
                                        ppcGenRecord(PPC_BOTTOM_INFORMATION, "Definition not found, loading javadoc.", "\n");
                                }
                        }
                } else {
                        ppcGenGotoPositionRecord(&refs->act->p);
                }
        } else {
                fprintf(ccOut, "*");
        }
}
static void unselectUsedSymbol(S_olSymbolsMenu *list, S_olSymbolsMenu *sym) {
        S_olSymbolsMenu *s;
        for(s=list; s!=NULL; s=s->next) {
                if (s->s.vFunClass == sym->s.vFunClass) {
                        s->selected = 0;
                }
        }
}
static void selectUnusedSymbols(S_olSymbolsMenu *mm, void *vflp, void *p2) {
        S_olSymbolsMenu *ss, *s;
        int used, atleastOneSelected, filter, *flp;
        flp = (int *)vflp;
        filter = *flp;
        for(ss=mm; ss!=NULL; ss=ss->next) {
                ss->visible = 1; ss->selected = 0;
        }
        if (mm->s.b.storage != StorageField && mm->s.b.storage != StorageMethod) {
                for(ss=mm; ss!=NULL; ss=ss->next) {
                        if (ss->defRefn!=0 && ss->refn==0) ss->selected = 1;
                }
                goto fini;
        }
        atleastOneSelected = 1;
        while (atleastOneSelected) {
                atleastOneSelected = 0;
                for(ss=mm; ss!=NULL; ss=ss->next) {
                        if (ss->selected==0 && ss->defRefn!=0) {
                                { if (!(ss->s.vFunClass == ss->s.vApplClass)) internalCheckFail("ss->s.vFunClass == ss->s.vApplClass", "cxref.c", 2654);};
                                used = 0;
                                for(s=mm; s!=NULL; s=s->next) {
                                        if (ss->s.vFunClass == s->s.vFunClass) {
                                                if (s->refn != 0) {
                                                        used = 1;
                                                        goto checked;
                                                }
                                        }
                                }
                                if (ss->s.b.storage == StorageMethod) {
                                        for(s=mm; s!=NULL; s=s->next) {
                                                if (s->s.vFunClass == s->s.vApplClass
                                                        && ss->s.vApplClass != s->s.vApplClass
                                                        && s->selected == 0
                                                        && isSmallerOrEqClass(ss->s.vApplClass, s->s.vApplClass)) {
                                                        used = 1;
                                                        goto checked;
                                                }
                                        }
                                }
                        checked:
                                if (! used) {
                                        atleastOneSelected = 1;
                                        ss->selected = 1;
                                }
                        }
                }
        }
 fini:
        for(ss=mm; ss!=NULL; ss=ss->next) {
                if (ss->selected) goto fini2;
        }
        for(ss=mm; ss!=NULL; ss=ss->next) {
                ss->visible = 0;
        }
 fini2:
        if (filter>0) {
                for(ss=mm; ss!=NULL; ss=ss->next) {
                        if (ss->selected == 0) ss->visible = 0;
                }
        }
        return;
}
static void olcxMenuSelectAll(int val) {
        S_userOlcx *user;
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2708);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (refs->command == OLO_GLOBAL_UNUSED) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_WARNING, "The browser does not display project unused symbols anymore","\n");
                }
        }
        for(ss=refs->menuSym; ss!=NULL; ss=ss->next) {
                if (ss->visible) ss->selected = val;
        }
        olcxRecomputeSelRefs( refs);
        if (s_opt.xref2) {
                olcxPrintRefList( ";", refs);
        } else {
                fprintf(ccOut, "*Done");
        }
}
static void setDefaultSelectedVisibleItems(S_olSymbolsMenu *menu,
                                                                                   unsigned ooVisible,
                                                                                   unsigned ooSelected
        ) {
        S_olSymbolsMenu *ss;
        int select, visible;
        unsigned ooBits;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                ooBits = ss->ooBits;
                visible = ooBitsGreaterOrEqual(ooBits, ooVisible);
                select = 0;
                if (visible) {
                        select=ooBitsGreaterOrEqual(ooBits, ooSelected);
                        if (ss->s.b.symType==TypeCppCollate) select=0;
                }
                ss->selected = select;
                ss->visible = visible;
        }
}
static int isSpecialConstructorOnlySelectionCase(int command) {
        if (command == OLO_PUSH) return(1);
        if (command == OLO_PUSH_ONLY) return(1);
        if (command == OLO_PUSH_AND_CALL_MACRO) return(1);
        if (command == OLO_ARG_MANIP) return(1);
        if (command == OLO_SAFETY_CHECK2) {
                S_olcxReferences *refs, *origrefs, *newrefs, *diffrefs;
                int pbflag=0;
                origrefs = newrefs = diffrefs = NULL;
                { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2755);}; refs = s_olcxCurrentUser->browserStack.top; if (refs==NULL || refs->previous==NULL || refs->previous->previous==NULL){ error(ERR_INTERNAL, "something goes wrong at safety check"); pbflag = 1; } else { newrefs = refs; diffrefs = refs->previous; origrefs = refs->previous->previous; }};
                { if (!(origrefs && newrefs && diffrefs)) internalCheckFail("origrefs && newrefs && diffrefs", "cxref.c", 2756);};
                if (pbflag) return(0);
                if (origrefs->command == OLO_ARG_MANIP) return(1);
        }
        return(0);
}
static void handleConstructorSpecialsInSelectingSymbolInMenu(
        S_olSymbolsMenu *menu, int command
        ) {
        S_olSymbolsMenu *s1, *s2, *ss, *dd;
        S_reference *dr1, *dr2;
        int ccc, sss, lll, vn;
        if (! ((s_language & (4)) != 0)) return;
        if (! isSpecialConstructorOnlySelectionCase(command)) return;
        s1 = NULL; s2 = NULL;
        vn = 0;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                if (ss->visible) {
                        if (vn==0) s1 = ss;
                        else if (vn==1) s2 = ss;
                        vn ++;
                }
        }
        if (vn == 2) {
                { if (!(s1 && s2)) internalCheckFail("s1 && s2", "cxref.c", 2782);};
                sss = s1->selected + s2->selected;
                ccc = (s1->s.b.storage==StorageConstructor) + (s2->s.b.storage==StorageConstructor);
                lll = (s1->s.b.symType==TypeStruct) + (s2->s.b.symType==TypeStruct);
                if (sss==2 && ccc==1 && lll==1) {
                        if (s1->s.b.symType==TypeStruct ) {
                                s1->selected = 0;
                                if (command == OLO_ARG_MANIP) s1->visible = 0;
                        } else if (s2->s.b.symType==TypeStruct ) {
                                s2->selected = 0;
                                if (command == OLO_ARG_MANIP) s2->visible = 0;
                        }
                }
        }
}
void dummyloop1(){}
void dummyloop2(){}
static void computeSubClassOfRelatedItemsOOBit(S_olSymbolsMenu *menu, int command) {
        S_olSymbolsMenu *s1, *s2;
        unsigned oov;
        int st, change;
        if (( command == OLO_RENAME || command == OLO_ENCAPSULATE || command == OLO_VIRTUAL2STATIC_PUSH || command == OLO_ARG_MANIP || command == OLO_PUSH_FOR_LOCALM || command == OLO_SAFETY_CHECK1 || command == OLO_SAFETY_CHECK2 || s_opt.manualResolve == RESOLVE_DIALOG_NEVER )) {
                change = 1;
                while (change) {
                        change = 0;
                        for(s1=menu; s1!=NULL; s1=s1->next) {
                                if ((s1->ooBits&00700) < 00100) goto nextrs1;
                                for(s2=menu; s2!=NULL; s2=s2->next) {
                                        st = ( (s2->s.b.storage==StorageField || ((s2->s.b.storage==StorageMethod || s2->s.b.storage==StorageConstructor) && (s2->s.b.accessFlags & 0x008))));
                                        if (st) goto nextrs2;
                                        oov = (s2->ooBits & 00700);
                                        if(oov >= 00100) goto nextrs2;
                                        if (isSmallerOrEqClass(s2->s.vApplClass, s1->s.vApplClass)) {
                                                s2->ooBits = ((s2->ooBits & ~00700)
                                                                          | 00100);
                                                change = 1;
                                        }
                                        if (isSmallerOrEqClass(s1->s.vApplClass, s2->s.vApplClass)) {
                                                s2->ooBits = ((s2->ooBits & ~00700)
                                                                          | 00100);
                                                change = 1;
                                        }
                                nextrs2:;
                                }
                        nextrs1:;
                        }
                }
        } else {
                for(s1=menu; s1!=NULL; s1=s1->next) {
                        if ((s1->ooBits&00700) < 00200) goto nexts1;
                        for(s2=menu; s2!=NULL; s2=s2->next) {
                                st = ( (s2->s.b.storage==StorageField || ((s2->s.b.storage==StorageMethod || s2->s.b.storage==StorageConstructor) && (s2->s.b.accessFlags & 0x008))));
                                if (st) goto nexts2;
                                oov = (s2->ooBits & 00700);
                                if(oov >= 00100) goto nexts2;
                                if (isSmallerOrEqClass(s2->s.vApplClass, s1->s.vApplClass)) {
                                        s2->ooBits = ((s2->ooBits & ~00700)
                                                                  | 00100);
                                }
                        nexts2:;
                        }
                nexts1:;
                }
        }
}
static void setSelectedVisibleItems(S_olSymbolsMenu *menu, int command, int filterLevel) {
        S_olSymbolsMenu *s1, *s2;
        int ccc, sss, lll;
        unsigned ooselected, oovisible;
        if (command == OLO_GLOBAL_UNUSED) {
                splitMenuPerSymbolsAndMap(menu, selectUnusedSymbols, &filterLevel, NULL);
                goto sfini;
        }
        if (command != OLO_CLASS_TREE) {
                computeSubClassOfRelatedItemsOOBit(menu, command);
        }
        if (command == OLO_MAYBE_THIS
                || command == OLO_NOT_FQT_REFS
                || command == OLO_NOT_FQT_REFS_IN_CLASS
                || command == OLO_USELESS_LONG_NAME
                || command == OLO_USELESS_LONG_NAME_IN_CLASS
                || command == OLO_PUSH_ALL_IN_METHOD
                || command == OLO_PUSH_NAME
                || command == OLO_PUSH_SPECIAL_NAME
                ) {
                oovisible = 0;
                ooselected = 0;
        } else if (( command == OLO_RENAME || command == OLO_ENCAPSULATE || command == OLO_VIRTUAL2STATIC_PUSH || command == OLO_ARG_MANIP || command == OLO_PUSH_FOR_LOCALM || command == OLO_SAFETY_CHECK1 || command == OLO_SAFETY_CHECK2 || s_opt.manualResolve == RESOLVE_DIALOG_NEVER )) {
                oovisible = s_opt.ooChecksBits;
                ooselected = (00100 | 02000);
        } else {
                if (s_olstringServed && s_olstringUsage == UsageMethodInvokedViaSuper) {
                        oovisible = s_menuFilterOoBits[filterLevel];
                        ooselected = (00500 | 03000);
                } else {
                        oovisible = s_menuFilterOoBits[filterLevel];
                        ooselected = (00300 | 02000);
                }
        }
        setDefaultSelectedVisibleItems(menu, oovisible, ooselected);
        handleConstructorSpecialsInSelectingSymbolInMenu(menu, command);
 sfini:
        return;
}
static void olcxMenuSelectPlusolcxMenuSelectFilterSet(int flevel) {
        S_userOlcx *user;
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        unsigned ooBits;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2926);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (DEFAULT_VALUE==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (refs!=NULL && flevel < MAX_MENU_FILTER_LEVEL && flevel >= 0) {
                if (refs->menuFilterLevel != flevel) {
                        refs->menuFilterLevel = flevel;
                        setSelectedVisibleItems(refs->menuSym, refs->command, refs->menuFilterLevel);
                        olcxRecomputeSelRefs(refs);
                }
        }
        if (refs!=NULL) {
                olcxPrintSelectionMenu(refs->menuSym);
                if (s_opt.xref2) {
                }
        }
        if (refs==NULL) {
                if (s_opt.xref2) {
                        olcxPrintSelectionMenu(NULL);
                        olcxPrintRefList(";", NULL);
                } else {
                        fprintf(ccOut, "=");
                }
        }
}
static void olcxReferenceFilterSet(int flevel) {
        S_userOlcx *user;
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss;
        unsigned usagelevel;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2958);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (DEFAULT_VALUE==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (refs!=NULL && flevel < MAX_REF_LIST_FILTER_LEVEL && flevel >= 0) {
                refs->refsFilterLevel = flevel;
        }
        if (s_opt.xref2) {
                if (refs!=NULL) olcxSetActReferenceToFirstVisible(refs, refs->act);
                olcxPrintRefList(";", refs);
        } else {
                fprintf(ccOut, "*");
        }
}
static S_olcxReferences *getNextTopStackItem(S_olcxReferencesStack *stack) {
        S_olcxReferences *rr, *nextrr;
        nextrr = NULL;
        rr = stack->root;
        while (rr!=NULL && rr!=stack->top) {
                nextrr = rr;
                rr = rr->previous;
        }
        { if (!(rr==stack->top)) internalCheckFail("rr==stack->top", "cxref.c", 2982);};
        return(nextrr);
}
static void olcxReferenceRePush() {
        S_userOlcx *user;
        char *tops;
        S_olcxReferences *refs,*rr,*nextrr;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 2990);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (DEFAULT_VALUE==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        nextrr = getNextTopStackItem(&s_olcxCurrentUser->browserStack);
        if (nextrr != NULL) {
                s_olcxCurrentUser->browserStack.top = nextrr;
                olcxGenGotoActReference(s_olcxCurrentUser->browserStack.top);
                olcxPrintSymbolName(s_olcxCurrentUser->browserStack.top);
        } else {
                if (s_opt.xref2) {
                        ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "You are on the top of browser stack.", "\n");
                } else {
                        fprintf(ccOut, "*** Complete stack, no pop-ed references");
                }
        }
}
static void olcxReferencePop() {
        S_userOlcx *user;
        char *tops;
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3011);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (refs->cpos.file != s_noneFileIndex) {
                generateOnlineCxref(&refs->cpos, "#", UsageUsed,
                                                        refs->refsuffix, "");
        } else {
                olcxGenNoReferenceSignal();
        }
        s_olcxCurrentUser->browserStack.top = refs->previous;
        olcxPrintSymbolName(s_olcxCurrentUser->browserStack.top);
}
void olcxPopOnly() {
        S_userOlcx *user;
        S_olcxReferences *refs;
        int previousIsList;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3027);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        if (!s_opt.xref2) fprintf(ccOut, "*");
        s_olcxCurrentUser->browserStack.top = refs->previous;
}
S_reference * olcxCopyRefList(S_reference *ll) {
        S_reference *rr, *res, *a, **aa;
        res = NULL; aa= &res;
        for(rr=ll; rr!=NULL; rr=rr->next) {
                { { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { a = NULL; } else { a = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (a==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { a = NULL; } else { a = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                *a = *rr;
                a->next = NULL;
                *aa = a;
                aa = &(a->next);
        }
        return(res);
}
static S_olSymbolsMenu *olcxCopyMenuSym(S_olSymbolsMenu *mm) {
        S_olSymbolsMenu *rr, *res, *a, **aa;
        char *nn;
        res = NULL; aa= &res;
        for(rr=mm; rr!=NULL; rr=rr->next) {
                { { int n = (1) * sizeof(S_olSymbolsMenu); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { a = NULL; } else { a = (S_olSymbolsMenu*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (a==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_olSymbolsMenu); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { a = NULL; } else { a = (S_olSymbolsMenu*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                *a = *rr;
                a->next = NULL;
                { { int n = (strlen(rr->s.name)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (nn==NULL) { freeOldestOlcx(); { int n = (strlen(rr->s.name)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                strcpy(a->s.name, rr->s.name);
                a->s.refs = olcxCopyRefList(rr->s.refs);
                a->s.next = NULL;
                a->markers = NULL;
                *aa = a;
                aa = &(a->next);
        }
        return(res);
}
static void safetyCheckAddDiffRef(S_reference *r, S_olcxReferences *diffrefs,
                                                                  int mode) {
        int prefixchar;
        prefixchar = ' ';
        if (diffrefs->r == NULL) {
                fprintf(ccOut, "%s", ";");
                prefixchar = '>';
        }
        if (mode == DIFF_MISSING_REF) {
                fprintf(ccOut, "%c %s:%d missing reference\n", prefixchar,
                                simpleFileNameFromFileNum(r->p.file), r->p.line);
        } else if (mode == DIFF_UNEXPECTED_REF) {
                fprintf(ccOut, "%c %s:%d unexpected new reference\n", prefixchar,
                                simpleFileNameFromFileNum(r->p.file), r->p.line);
        } else {
                { if (!(0)) internalCheckFail("0", "cxref.c", 3083);};
        }
        olcxAppendReference(r, diffrefs);
}
void olcxReferencesDiff( S_reference **anr1,
                                                        S_reference **aor2,
                                                        S_reference **diff
        ) {
        S_reference *r, *nr1, *or2, **dd;
        int mode;
        { S_reference *_macrores; _macrores = (*anr1); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*anr1) = _macrores;};
        { S_reference *_macrores; _macrores = (*aor2); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*aor2) = _macrores;};
        nr1 = *anr1; or2 = *aor2; dd = diff;
        *dd = NULL;
        while (nr1!=NULL && or2!=NULL) {
                if ((! ( ((nr1->p).file != (or2->p).file) || ((nr1->p).line != (or2->p).line) || ((nr1->p).coll != (or2->p).coll) ))) {
                        nr1 = nr1->next; or2=or2->next;
                } else {
                        if ((( (((nr1)->p).file < ((*or2).p).file) || (((nr1)->p).file==((*or2).p).file && ((nr1)->p).line < ((*or2).p).line) || (((nr1)->p).file==((*or2).p).file && ((nr1)->p).line==((*or2).p).line && ((nr1)->p).coll < ((*or2).p).coll) ))) {
                                *dd = olcxCopyReference(nr1);
                                dd = &(*dd)->next;
                                nr1=nr1->next;
                        } else {
                                *dd = olcxCopyReference(or2);
                                dd = &(*dd)->next;
                                or2=or2->next;
                        }
                }
        }
        if (nr1!=NULL || or2!=NULL) {
                if (nr1!=NULL) {
                        r = nr1;
                        mode = DIFF_UNEXPECTED_REF;
                } else {
                        r = or2;
                        mode = DIFF_MISSING_REF;
                }
                for(; r!=NULL; r=r->next) {
                        *dd = olcxCopyReference(r);
                        dd = &(*dd)->next;
                }
        }
}
static void safetyCheckDiff(S_reference **anr1,
                                                        S_reference **aor2,
                                                        S_olcxReferences *diffrefs
        ) {
        S_reference *r, *nr1, *or2;
        int mode;
        { S_reference *_macrores; _macrores = (*anr1); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*anr1) = _macrores;};
        { S_reference *_macrores; _macrores = (*aor2); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*aor2) = _macrores;};
        nr1 = *anr1; or2 = *aor2;
        while (nr1!=NULL && or2!=NULL) {
                if (nr1->p.file==or2->p.file && nr1->p.line==or2->p.line) {
                        nr1 = nr1->next; or2=or2->next;
                } else {
                        if ((( (((nr1)->p).file < ((*or2).p).file) || (((nr1)->p).file==((*or2).p).file && ((nr1)->p).line < ((*or2).p).line) || (((nr1)->p).file==((*or2).p).file && ((nr1)->p).line==((*or2).p).line && ((nr1)->p).coll < ((*or2).p).coll) ))) {
                                safetyCheckAddDiffRef(nr1, diffrefs, DIFF_UNEXPECTED_REF);
                                nr1=nr1->next;
                        } else {
                                safetyCheckAddDiffRef(or2, diffrefs, DIFF_MISSING_REF);
                                or2=or2->next;
                        }
                }
        }
        if (nr1!=NULL || or2!=NULL) {
                if (nr1!=NULL) {
                        r = nr1;
                        mode = DIFF_UNEXPECTED_REF;
                } else {
                        r = or2;
                        mode = DIFF_MISSING_REF;
                }
                for(; r!=NULL; r=r->next) {
                        safetyCheckAddDiffRef(r, diffrefs, mode);
                }
        }
        diffrefs->act = diffrefs->r;
        if (diffrefs->r!=NULL) {
                { if (!(diffrefs->menuSym)) internalCheckFail("diffrefs->menuSym", "cxref.c", 3164);};
                olcxAddReferencesToOlSymbolsMenu(diffrefs->menuSym, diffrefs->r, 0);
        }
}
int getFileNumberFromName(char *name) {
        char *nn;
        S_fileItem dd;
        int ii;
        nn = normalizeFileName(name, s_cwd);
        { (&dd)->name = nn; (&dd)->lastModif = 0; (&dd)->lastInspect = 0; (&dd)->lastUpdateMtime = 0; (&dd)->lastFullUpdateMtime = 0; (&dd)->b.cxLoading = 0; (&dd)->b.cxLoaded = 0; (&dd)->b.cxSaved = 0; (&dd)->b.commandLineEntered = 0; (&dd)->b.scheduledToProcess = 0; (&dd)->b.scheduledToUpdate = 0; (&dd)->b.fullUpdateIncludesProcessed = 0; (&dd)->b.isInterface = 0; (&dd)->b.isFromCxfile = 0; (&dd)->b.sourceFile = s_noneFileIndex; (&dd)->sups = NULL; (&dd)->infs = NULL; (&dd)->directEnclosingInstance = s_noneFileIndex; (&dd)->next = NULL;};
        if (idTabIsMember(&s_fileTab, &dd, &ii)) {
                return(ii);
        } else {
                return(s_noneFileIndex);
        }
}
static S_reference *olcxCreateFileShiftedRefListForCheck(S_reference *rr) {
        S_reference *res, *r, *tt, **resa;
        int ofn, nfn, fmline, lmline;
        if (s_opt.checkFileMovedFrom==NULL) return(NULL);
        if (s_opt.checkFileMovedTo==NULL) return(NULL);
        ofn = getFileNumberFromName(s_opt.checkFileMovedFrom);
        nfn = getFileNumberFromName(s_opt.checkFileMovedTo);
        if (ofn==s_noneFileIndex) return(NULL);
        if (nfn==s_noneFileIndex) return(NULL);
        fmline = s_opt.checkFirstMovedLine;
        lmline = s_opt.checkFirstMovedLine + s_opt.checkLinesMoved;
        res = NULL; resa = &res;
        for(r=rr; r!=NULL; r=r->next) {
                { { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { tt = NULL; } else { tt = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (tt==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_reference); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { tt = NULL; } else { tt = (S_reference*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                *tt = *r;
                if (tt->p.file==ofn && tt->p.line>=fmline && tt->p.line<lmline) {
                        tt->p.file = nfn;
                        tt->p.line = s_opt.checkNewLineNumber + (tt->p.line - fmline);
                }
                *resa=tt; tt->next=NULL; resa= &(tt->next);
        }
        { S_reference *_macrores; _macrores = (res); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (res) = _macrores;};
        return(res);
}
static void olcxSafetyCheck2() {
        S_olcxReferences *refs, *origrefs, *newrefs, *diffrefs;
        S_reference *rr,*rrd, *shifted;
        int pbflag=0;
        origrefs = newrefs = diffrefs = NULL;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3217);}; refs = s_olcxCurrentUser->browserStack.top; if (refs==NULL || refs->previous==NULL || refs->previous->previous==NULL){ error(ERR_INTERNAL, "something goes wrong at safety check"); pbflag = 1; } else { newrefs = refs; diffrefs = refs->previous; origrefs = refs->previous->previous; }};
        { if (!(origrefs && newrefs && diffrefs)) internalCheckFail("origrefs && newrefs && diffrefs", "cxref.c", 3218);};
        if (pbflag) return;
        shifted = olcxCreateFileShiftedRefListForCheck(origrefs->r);
        if (shifted != NULL) {
                safetyCheckDiff(&newrefs->r, &shifted, diffrefs);
                olcxFreeReferences(shifted);
        } else {
                safetyCheckDiff(&newrefs->r, &origrefs->r, diffrefs);
        }
        if (diffrefs->r == NULL) {
                s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
                s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
                s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
                fprintf(ccOut, "*Done. No conflicts detected.");
        } else {
                { if (!(diffrefs->menuSym)) internalCheckFail("diffrefs->menuSym", "cxref.c", 3234);};
                s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
                fprintf(ccOut, " ** Some misinterpreted references detected. Please, undo last refactoring.");
        }
        fflush(ccOut);
}
static int olRemoveCallerReference(S_olcxReferences *refs) {
  S_reference *rr, **rrr;
  { S_reference *_macrores; _macrores = (refs->r); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxReferenceInternalLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (refs->r) = _macrores;};
  for(rrr= &refs->r, rr=refs->r; rr!=NULL; rrr= &rr->next, rr=rr->next){
          if (! ( ((rr->p).file < (refs->cpos).file) || ((rr->p).file==(refs->cpos).file && (rr->p).line < (refs->cpos).line) || ((rr->p).file==(refs->cpos).file && (rr->p).line==(refs->cpos).line && (rr->p).coll < (refs->cpos).coll) )) break;
  }
  if (rr == NULL) return(0);
  if (! ( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared )) return(0);
  *rrr = rr->next;
  { { {}; olcxMemoryAllocatedBytes -= sizeof(S_reference); free((rr));};};
  return(1);
}
static void olEncapsulationSafetyCheck() {
        S_olcxReferences *refs;
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3258);};
        refs = s_olcxCurrentUser->browserStack.top;
        if (refs==NULL || refs->previous==NULL){
                error(ERR_INTERNAL,"something goes wrong at encapsulate safety check");
                return;
        }
        { if (!(s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top->previous!=NULL && s_olcxCurrentUser->browserStack.top->previous->previous!=NULL && s_olcxCurrentUser->browserStack.top->previous->previous->previous!=NULL)) internalCheckFail("s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top->previous!=NULL && s_olcxCurrentUser->browserStack.top->previous->previous!=NULL && s_olcxCurrentUser->browserStack.top->previous->previous->previous!=NULL", "cxref.c", 3265);};
        olRemoveCallerReference(s_olcxCurrentUser->browserStack.top);
        olRemoveCallerReference(s_olcxCurrentUser->browserStack.top->previous);
        olRemoveCallerReference(s_olcxCurrentUser->browserStack.top->previous->previous->previous);
        olcxAddReferences(refs->r, &s_olcxCurrentUser->browserStack.top->previous->r,
                                          (-1), 0);
        s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
        olcxSafetyCheck2();
}
static void olcxResetSuffix() {
        S_userOlcx *user;
        S_olcxReferences *refs;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3281);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        strncpy(refs->refsuffix, s_opt.olcxRefSuffix, MAX_OLCX_SUFF_SIZE-1);
        refs->refsuffix[MAX_OLCX_SUFF_SIZE-1] = 0;
        fprintf(ccOut,"* refs %s", refs->refsuffix);
}
static void olCompletionSelect() {
        S_userOlcx *user;
        S_olcxReferences *refs;
        S_olCompletion *rr;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3291);}; if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_CSELECT || s_opt.cxrefs==OLO_CGOTO || s_opt.cxrefs==OLO_CBROWSE || s_opt.cxrefs==OLO_TAG_SEARCH) { refs = s_olcxCurrentUser->completionsStack.top; } else { refs = s_olcxCurrentUser->browserStack.top; } if (CHECK_NULL==CHECK_NULL && refs == NULL) { if (s_opt.xref2) { ppcGenRecordWithNumeric(PPC_BOTTOM_WARNING, PPCA_BEEP, 1, "Empty stack","\n"); } else { fprintf(ccOut, "="); } return; }};
        rr = olCompletionNthLineRef(refs->cpls, s_opt.olcxGotoVal);
        if (rr==NULL) {
                error(ERR_ST, "selection out of range.");
                return;
        }
        if (s_opt.xref2) {
                { if (!(s_olcxCurrentUser->completionsStack.root!=NULL)) internalCheckFail("s_olcxCurrentUser->completionsStack.root!=NULL", "cxref.c", 3298);};
                ppcGenGotoPositionRecord(&s_olcxCurrentUser->completionsStack.root->cpos);
                if (rr->csymType==TypeNonImportedClass) {
                        ppcGenRecord(PPC_FQT_COMPLETION, rr->name, "\n");
                } else {
                        ppcGenRecord(PPC_SINGLE_COMPLETION, rr->name, "\n");
                }
        } else {
                generateOnlineCxref(&refs->cpos, "#", UsageUsed,
                                                        refs->refsuffix, rr->name);
        }
}
static void olcxReferenceSelectTagSearchItem(int refn) {
        S_olCompletion *rr,*rrr;
        S_symbolRefItemBits sb;
        int i,jdoc;
        S_olcxReferences *refs;
        char ttt[MAX_FUN_NAME_SIZE];
        { if (!(refn > 0)) internalCheckFail("refn > 0", "cxref.c", 3318);};
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3319);};
        { if (!(s_olcxCurrentUser->retrieverStack.top)) internalCheckFail("s_olcxCurrentUser->retrieverStack.top", "cxref.c", 3320);};
        refs = s_olcxCurrentUser->retrieverStack.top;
        rr = olCompletionNthLineRef(refs->cpls, refn);
        if (rr == NULL) {
                error(ERR_ST, "selection out of range.");
                return;
        }
        { if (!(s_olcxCurrentUser->retrieverStack.root!=NULL)) internalCheckFail("s_olcxCurrentUser->retrieverStack.root!=NULL", "cxref.c", 3327);};
        ppcGenGotoPositionRecord(&s_olcxCurrentUser->retrieverStack.root->cpos);
        sprintf(ttt, " %s", rr->name);
        ppcGenRecord(PPC_SINGLE_COMPLETION, ttt, "\n");
}
static void olCompletionBack() {
        S_olcxReferences *top;
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3335);};
        top = s_olcxCurrentUser->completionsStack.top;
        if (top != NULL && top->previous != NULL) {
                s_olcxCurrentUser->completionsStack.top = s_olcxCurrentUser->completionsStack.top->previous;
                ppcGenGotoPositionRecord(&s_olcxCurrentUser->completionsStack.top->cpos);
                printCompletionsList(0);
        }
}
static void olCompletionForward() {
        S_olcxReferences *top;
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3346);};
        top = getNextTopStackItem(&s_olcxCurrentUser->completionsStack);
        if (top != NULL) {
                s_olcxCurrentUser->completionsStack.top = top;
                ppcGenGotoPositionRecord(&s_olcxCurrentUser->completionsStack.top->cpos);
                printCompletionsList(0);
        }
}
static void olcxNoSymbolFoundErrorMessage() {
        if (s_opt.cxrefs == OLO_PUSH_NAME || s_opt.cxrefs == OLO_PUSH_SPECIAL_NAME) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_ERROR,"No symbol found.", "\n");
                } else {
                        fprintf(ccOut,"*** No symbol found.");
                }
        } else {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_ERROR,"No symbol found, please position the cursor on a program symbol.", "\n");
                } else {
                        fprintf(ccOut,"*** No symbol found, please position the cursor on a program symbol.");
                }
        }
}
static int olcxCheckSymbolExists() {
        if (s_olcxCurrentUser!=NULL
                && s_olcxCurrentUser->browserStack.top!=NULL
                && s_olcxCurrentUser->browserStack.top->menuSym==NULL
                ) {
                return(0);
        }
        return(1);
}
static S_olSymbolsMenu *firstVisibleSymbol( S_olSymbolsMenu *first ) {
        S_olSymbolsMenu *ss, *fvisible;
        fvisible = NULL;
        for(ss=first; ss!=NULL; ss=ss->next) {
                if (ss->visible) {
                        fvisible = ss;
                        break;
                }
        }
        return(fvisible);
}
static int staticallyLinkedSymbolMenu(S_olSymbolsMenu *menu) {
        S_olSymbolsMenu *fv;
        fv = firstVisibleSymbol(menu);
        if (( (fv->s.b.storage==StorageField || ((fv->s.b.storage==StorageMethod || fv->s.b.storage==StorageConstructor) && (fv->s.b.accessFlags & 0x008))))) {
                return(1);
        } else {
                return(0);
        }
}
int olcxShowSelectionMenu() {
        S_olSymbolsMenu *ss, *first, *fvisible;
        char *fname;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 3408);};
        if (s_opt.cxrefs == OLO_PUSH_FOR_LOCALM) {
                return(0);
        }
        if (s_opt.cxrefs == OLO_SAFETY_CHECK2) {
                return(0);
        }
        first = s_olcxCurrentUser->browserStack.top->menuSym;
        if (first == NULL) {
                return(0);
        }
        fvisible = firstVisibleSymbol( first);
        if (fvisible==NULL) {
                return(0);
        }
        first = NULL;
        if (s_opt.cxrefs==OLO_PUSH
                || s_opt.cxrefs==OLO_PUSH_ONLY
                || s_opt.cxrefs==OLO_PUSH_AND_CALL_MACRO
                || s_opt.cxrefs==OLO_RENAME
                || s_opt.cxrefs==OLO_ARG_MANIP
                || s_opt.cxrefs==OLO_PUSH_ENCAPSULATE_SAFETY_CHECK
                || ( (fvisible->s.b.storage==StorageField || ((fvisible->s.b.storage==StorageMethod || fvisible->s.b.storage==StorageConstructor) && (fvisible->s.b.accessFlags & 0x008))))) {
                for(ss=s_olcxCurrentUser->browserStack.top->menuSym; ss!=NULL; ss=ss->next) {
                        if (ss->selected) {
                                if (first == NULL) {
                                        first = ss;
                                } else if ( (! itIsSameCxSymbol(&first->s, &ss->s))
                                                        || first->s.vFunClass!=ss->s.vFunClass) {
                                        return(1);
                                }
                        }
                }
        } else {
                for(ss=s_olcxCurrentUser->browserStack.top->menuSym; ss!=NULL; ss=ss->next) {
                        if (ss->visible) {
                                if (first!=NULL) {
                                        return(1);
                                }
                                first = ss;
                        }
                }
        }
        return(0);
}
static int countSelectedItems(S_olSymbolsMenu *menu) {
        S_olSymbolsMenu *ss;
        int res;
        res = 0;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                if (ss->selected) res++;
        }
        return(res);
}
static int linkNamesHaveSameProfile(char *n1, char *n2) {
        char *p1, *p2;
        int diff;
        p1 = strchr(n1, '(');
        p2 = strchr(n2, '(');
        if (p1==NULL && p2==NULL) return(1);
        if (p1==NULL || p2==NULL) return(0);
        diff = strcmp(p1, p2);
        return(diff == 0);
}
static int refactoringLinkNameCorrespondance(char *n1, char *n2, int command) {
        return(1);
}
static S_olSymbolsMenu *safetyCheck2FindCorrMenuItem(S_olSymbolsMenu *item,
                                                                                                         S_olSymbolsMenu *menu,
                                                                                                         int command) {
        S_olSymbolsMenu *ss;
        for(ss=menu; ss!=NULL; ss=ss->next) {
                if (ss->selected
                        && ss->s.vApplClass == item->s.vApplClass
                        && ss->s.b.symType == item->s.b.symType
                        && ss->s.b.storage == item->s.b.storage
                        && refactoringLinkNameCorrespondance(ss->s.name, item->s.name,
                                                                                                 command)) {
                        return(ss);
                }
        }
        return(NULL);
}
static int scCompareVirtualHierarchies(S_olSymbolsMenu *origm,
                                                                           S_olSymbolsMenu *newm,
                                                                           int command) {
        S_olSymbolsMenu *ss, *oss;
        int count1, count2;
        int res;
        res = 0;
        count1 = countSelectedItems(origm);
        count2 = countSelectedItems(newm);
        if (count1 != count2) res = 1;
        for(ss=newm; ss!=NULL; ss=ss->next) {
                if (ss->selected) {
                        oss = safetyCheck2FindCorrMenuItem(ss, origm, command);
                        if (oss==NULL || oss->selected == 0) {
                                res = 1;
                                ss->selected = 0;
                        }
                }
        }
        return(res);
}
int safetyCheck2ShouldWarn() {
        int res,problem;
        S_olcxReferences *refs, *origrefs, *newrefs, *diffrefs;
        problem = 0;
        if (s_opt.cxrefs != OLO_SAFETY_CHECK2) return(0);
        if (! ((s_language & (4)) != 0)) return(0);
        origrefs = newrefs = diffrefs = NULL;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 3545);}; refs = s_olcxCurrentUser->browserStack.top; if (refs==NULL || refs->previous==NULL || refs->previous->previous==NULL){ error(ERR_INTERNAL, "something goes wrong at safety check"); problem = 1; } else { newrefs = refs; diffrefs = refs->previous; origrefs = refs->previous->previous; }};
        if (problem) return(0);
        { if (!(origrefs && newrefs && diffrefs)) internalCheckFail("origrefs && newrefs && diffrefs", "cxref.c", 3547);};
        if (staticallyLinkedSymbolMenu(origrefs->menuSym)) return(0);
        res = scCompareVirtualHierarchies(origrefs->menuSym, newrefs->menuSym,
                                                                          origrefs->command);
        if (res) {
                olcxRecomputeSelRefs(newrefs);
        }
        return(res);
}
static int olMenuHashFileNumLess(S_olSymbolsMenu *s1, S_olSymbolsMenu *s2) {
        int fi1, fi2;
        fi1 = cxFileHashNumber(s1->s.name);
        fi2 = cxFileHashNumber(s2->s.name);
        if (fi1 < fi2) return(1);
        if (fi1 > fi2) return(0);
        if (s1->s.b.category == CatLocal) return(1);
        if (s1->s.b.category == CatLocal) return(0);
        return(0);
}
void getLineColCursorPositionFromCommandLineOption( int *l, int *c ) {
        { if (!(s_opt.olcxlccursor!=NULL)) internalCheckFail("s_opt.olcxlccursor!=NULL", "cxref.c", 3571);};
        sscanf(s_opt.olcxlccursor,"%d:%d", l, c);
}
int getClassNumFromClassLinkName(char *name, int defaultResult) {
        int ii, clii;
        char cfname[MAX_FILE_NAME_SIZE];
        S_fileItem ffi;
        clii = defaultResult;
        { sprintf(cfname, "%c%s.class", ';', name); { if (!(strlen(cfname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(cfname)+1 < MAX_FILE_NAME_SIZE", "cxref.c", 3580);};};
        { (&ffi)->name = cfname; (&ffi)->lastModif = 0; (&ffi)->lastInspect = 0; (&ffi)->lastUpdateMtime = 0; (&ffi)->lastFullUpdateMtime = 0; (&ffi)->b.cxLoading = 0; (&ffi)->b.cxLoaded = 0; (&ffi)->b.cxSaved = 0; (&ffi)->b.commandLineEntered = 0; (&ffi)->b.scheduledToProcess = 0; (&ffi)->b.scheduledToUpdate = 0; (&ffi)->b.fullUpdateIncludesProcessed = 0; (&ffi)->b.isInterface = 0; (&ffi)->b.isFromCxfile = 0; (&ffi)->b.sourceFile = s_noneFileIndex; (&ffi)->sups = NULL; (&ffi)->infs = NULL; (&ffi)->directEnclosingInstance = s_noneFileIndex; (&ffi)->next = NULL;};
        if (idTabIsMember(&s_fileTab, &ffi, &ii)) clii = ii;
        return(clii);
}
static int olSpecialFieldCreateSelection(char *fieldName, int storage) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        S_symbol *rt;
        int ii, clii;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 3593);};
        rstack = s_olcxCurrentUser->browserStack.top;
        if (! ((s_language & (4)) != 0)) {
                rstack->hkSelectedSym = NULL;
                error(ERR_ST,"This function is available only in Java language");
                return(s_noneFileIndex);
        }
        { if (!(s_javaObjectSymbol && s_javaObjectSymbol->u.s)) internalCheckFail("s_javaObjectSymbol && s_javaObjectSymbol->u.s", "cxref.c", 3600);};
        clii = s_javaObjectSymbol->u.s->classFile;
        ss = rstack->hkSelectedSym;
        if (ss!=NULL && ss->next!=NULL) {
                if (ss->next->s.b.symType == TypeStruct) ss = ss->next;
        }
        if (ss != NULL) {
                if (ss->s.b.symType == TypeStruct) {
                        clii = getClassNumFromClassLinkName(ss->s.name, clii);
                } else {
                        if (s_opt.cxrefs == OLO_CLASS_TREE) {
                                { if (!(s_olcxCurrentUser->ct.baseClassIndex!=s_noneFileIndex)) internalCheckFail("s_olcxCurrentUser->ct.baseClassIndex!=s_noneFileIndex", "cxref.c", 3615);};
                                clii = s_olcxCurrentUser->ct.baseClassIndex;
                        } else {
                                if (ss->s.vApplClass!=s_noneFileIndex) clii = ss->s.vApplClass;
                        }
                }
        }
        olcxFreeResolutionMenu(ss);
        rstack->hkSelectedSym = olCreateSpecialMenuItem(fieldName, clii, storage);
        return(clii);
}
void olCreateSelectionMenu(int command) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        int fnum;
        { S_olSymbolsMenu *_macrores; _macrores = (s_olcxCurrentUser->browserStack.top->hkSelectedSym); { S_olSymbolsMenu *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (htmlRefItemsOrderLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (s_olcxCurrentUser->browserStack.top->hkSelectedSym) = _macrores;};
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 3638);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        if (ss == NULL) return;
        renameCollationSymbols(ss);
        { register S_olSymbolsMenu *tmpInList, *tmptmp; S_olSymbolsMenu *tmpOutList; tmpOutList = NULL; tmpInList = rstack->hkSelectedSym; while (tmpInList!=NULL) { tmptmp = tmpInList->next; tmpInList->next = NULL; { S_olSymbolsMenu **ptmp; { register S_olSymbolsMenu *tmp,**lStMp; tmp = *((&tmpOutList)); lStMp = (&tmpOutList); while (tmp!=NULL && olMenuHashFileNumLess(tmp, ((tmpInList)))) { lStMp = &(tmp->next); tmp = *lStMp; } ptmp = lStMp; }; {(tmpInList)->next = ((*ptmp)); (*ptmp) = tmpInList;}; }; tmpInList = tmptmp; } rstack->hkSelectedSym = tmpOutList;};
        ss = rstack->hkSelectedSym;
        while (ss!=NULL) {
                readOneAppropReferenceFile(ss->s.name, s_cxSymbolMenuCreationTab);
                fnum = cxFileHashNumber(ss->s.name);
                while (ss!=NULL && fnum==cxFileHashNumber(ss->s.name)) ss = ss->next;
        }
        refTabMap(&s_cxrefTab, mapCreateSelectionMenu);
        refTabMap(&s_cxrefTab, putOnLineLoadedReferences);
        setSelectedVisibleItems(rstack->menuSym, command, rstack->menuFilterLevel);
        { if (!(rstack->r==NULL)) internalCheckFail("rstack->r==NULL", "cxref.c", 3654);};
        olProcessSelectedReferences(rstack, genOnLineReferences);
        { S_olSymbolsMenu *_macrores; _macrores = (s_olcxCurrentUser->browserStack.top->menuSym); { S_olSymbolsMenu *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (htmlRefItemsOrderLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (s_olcxCurrentUser->browserStack.top->menuSym) = _macrores;};
}
int refOccursInRefs(S_reference *r, S_reference *list) {
        S_reference *place;
        { register S_reference *tmp; tmp = list; while (tmp!=NULL && (( (((tmp)->p).file < ((((*r))).p).file) || (((tmp)->p).file==((((*r))).p).file && ((tmp)->p).line < ((((*r))).p).line) || (((tmp)->p).file==((((*r))).p).file && ((tmp)->p).line==((((*r))).p).line && ((tmp)->p).coll < ((((*r))).p).coll) ))) tmp=tmp->next; place=tmp; };
        if (place==NULL || ( ( (((place)->p).file != ((*r).p).file) || (((place)->p).line != ((*r).p).line) || (((place)->p).coll != ((*r).p).coll) ))) return(0);
        return(1);
}
static void olcxSingleReferenceCheck1( S_symbolRefItem *p,
                                                                           S_olcxReferences *rstack,
                                                                           S_reference *r
        ) {
        S_reference *dr;
        int prefixchar;
        if (refOccursInRefs(r, rstack->r)) {
                prefixchar = ' ';
                if (s_olcxCurrentUser->browserStack.top->r == NULL) {
                        fprintf(ccOut,"%s",";");
                        prefixchar = '>';
                }
                fprintf(ccOut,"%c  %s:%d reference to '", prefixchar,
                                simpleFileNameFromFileNum(r->p.file), r->p.line);
                printSymbolLinkNameString(ccOut, p->name);
                fprintf(ccOut,"' lost\n");
                olcxAppendReference(r, s_olcxCurrentUser->browserStack.top);
        }
}
void olcxCheck1CxFileReference(S_symbolRefItem *ss, S_reference *r) {
        S_symbolRefItem *sss;
        S_olcxReferences *rstack;
        S_olSymbolsMenu *cms;
        int pushed;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 3723);};
        rstack = s_olcxCurrentUser->browserStack.top->previous;
        { if (!(rstack && rstack->menuSym)) internalCheckFail("rstack && rstack->menuSym", "cxref.c", 3725);};
        sss = &rstack->menuSym->s;
        pushed = itIsSymbolToPushOlRefences(ss, rstack, &cms, DEFAULT_VALUE);
        if ((!pushed) && olcxItIsSameCxSymbol(ss, sss)) {
                olcxSingleReferenceCheck1(ss, rstack, r);
        }
}
static void olcxProceedSafetyCheck1OnInloadedRefs(S_olcxReferences *rstack, S_olSymbolsMenu *ccms) {
        S_symbolRefItem *p;
        S_symbolRefItem *sss;
        S_reference *r, *dr;
        S_olSymbolsMenu *cms;
        int pushed;
        p = &ccms->s;
        { if (!(rstack && rstack->menuSym)) internalCheckFail("rstack && rstack->menuSym", "cxref.c", 3742);};
        sss = &rstack->menuSym->s;
        pushed = itIsSymbolToPushOlRefences(p, rstack, &cms, DEFAULT_VALUE);
        if ((! pushed) && olcxItIsSameCxSymbol(p, sss)) {
                for(r=p->refs; r!=NULL; r=r->next) {
                        olcxSingleReferenceCheck1( p, rstack, r);
                }
        }
}
void olcxPushSpecialCheckMenuSym(int pushCommand,char *symname) {
        S_olcxReferences *rstack;
        olcxSetCurrentUser(s_opt.user);
        olcxPushEmptyStackItem(&s_olcxCurrentUser->browserStack);
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 3759);};
        rstack = s_olcxCurrentUser->browserStack.top;
        rstack->hkSelectedSym = olCreateSpecialMenuItem(
                symname, s_noneFileIndex, StorageDefault);
        rstack->menuSym = olCreateSpecialMenuItem(
                symname, s_noneFileIndex, StorageDefault);
}
static void olcxSafetyCheckInit() {
        S_olcxReferences *rstack;
        { if (!(s_opt.cxrefs == OLO_SAFETY_CHECK_INIT)) internalCheckFail("s_opt.cxrefs == OLO_SAFETY_CHECK_INIT", "cxref.c", 3769);};
        olcxPushSpecialCheckMenuSym(s_opt.cxrefs,"  Conflicting References");
        fprintf(ccOut,"* safety checks initialized");
        fflush(ccOut);
}
static S_olSymbolsMenu *mmPreCheckGetFirstDefinitionReferenceAndItsSymbol(
        S_olSymbolsMenu *menuSym) {
        S_olSymbolsMenu *mm,*res;
        res = NULL;
        for(mm=menuSym; mm!=NULL; mm=mm->next) {
                if (mm->s.refs!=NULL && ( ( (mm->s.refs->usg.base)==UsageDefined || (mm->s.refs->usg.base)==UsageOLBestFitDefined) || (mm->s.refs->usg.base)==UsageDeclared ) &&
                        (res==NULL || ( ((mm->s.refs->p).file < (res->s.refs->p).file) || ((mm->s.refs->p).file==(res->s.refs->p).file && (mm->s.refs->p).line < (res->s.refs->p).line) || ((mm->s.refs->p).file==(res->s.refs->p).file && (mm->s.refs->p).line==(res->s.refs->p).line && (mm->s.refs->p).coll < (res->s.refs->p).coll) ))) {
                                res = mm;
                }
        }
        return(res);
}
static S_olSymbolsMenu *mmFindSymWithCorrespondingRef(S_reference *ref,
                                                                                                          S_olSymbolsMenu *osym,
                                                                                                          S_olcxReferences *refs,
                                                                                                          S_position *moveOffset
                                                                                                          ) {
        S_reference sr, *rr, *place;
        S_olSymbolsMenu *mm;
        sr = *ref;
        { { (&(sr.p))->file = (ref->p).file+(*moveOffset).file; (&(sr.p))->line = (ref->p).line+(*moveOffset).line; (&(sr.p))->coll = (ref->p).coll+(*moveOffset).coll;};};
        for(mm=refs->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->s.b.symType != osym->s.b.symType
                        && mm->s.b.symType != TypeInducedError) continue;
                { register S_reference *tmp; tmp = mm->s.refs; while (tmp!=NULL && (( (((tmp)->p).file < (((sr)).p).file) || (((tmp)->p).file==(((sr)).p).file && ((tmp)->p).line < (((sr)).p).line) || (((tmp)->p).file==(((sr)).p).file && ((tmp)->p).line==(((sr)).p).line && ((tmp)->p).coll < (((sr)).p).coll) ))) tmp=tmp->next; place=tmp; };
                if (place!=NULL && ! ( ( (((place)->p).file != ((sr).p).file) || (((place)->p).line != ((sr).p).line) || (((place)->p).coll != ((sr).p).coll) ))) {
                        return(mm);
                }
        }
        return(NULL);
}
int symbolsCorrespondWrtMoving(S_olSymbolsMenu *osym,
                                                                   S_olSymbolsMenu *nsym,
                                                                   int command) {
        int res;
        res = 0;
        switch (command) {
        case OLO_MM_PRE_CHECK:
                if (itIsSameCxSymbol(&osym->s, &nsym->s)
                        && osym->s.vApplClass == nsym->s.vApplClass) {
                        res = 1;
                }
                break;
        case OLO_PP_PRE_CHECK:
                if (itIsSameCxSymbol(&osym->s, &nsym->s)) {
                        if (osym->s.vApplClass == nsym->s.vApplClass) {
                                res = 1;
                        }
                        if (osym->s.b.storage == StorageField
                                && osym->s.vFunClass == nsym->s.vFunClass) {
                                res = 1;
                        }
                        if (osym->s.b.storage == StorageMethod) {
                                res = 1;
                        }
                }
                break;
        default:
                { if (!(0)) internalCheckFail("0", "cxref.c", 3846);};
        }
        if (nsym->s.b.symType == TypeInducedError) res = 1;
        return(res);
}
static int mmPreCheckMakeDifference(S_olcxReferences *origrefs,
                                                                        S_olcxReferences *newrefs,
                                                                        S_olcxReferences *diffrefs
        ) {
        S_olSymbolsMenu *osym, *nsym, *diffsym, *ofirstsym, *nfirstsym;
        S_reference *rr, *nsymrefs, *nrr, *drr, *ofirstref, *nfirstref;
        S_position moveOffset;
        int rfound;
        { (&moveOffset)->file = 0; (&moveOffset)->line = 0; (&moveOffset)->coll = 0;};
        ofirstsym = mmPreCheckGetFirstDefinitionReferenceAndItsSymbol(origrefs->menuSym);
        nfirstsym = mmPreCheckGetFirstDefinitionReferenceAndItsSymbol(newrefs->menuSym);
        if (ofirstsym!=NULL && nfirstsym!=NULL) {
                { if (!(ofirstsym->s.refs && nfirstsym->s.refs)) internalCheckFail("ofirstsym->s.refs && nfirstsym->s.refs", "cxref.c", 3867);};
                { { (&(moveOffset))->file = (nfirstsym->s.refs->p).file-(ofirstsym->s.refs->p).file; (&(moveOffset))->line = (nfirstsym->s.refs->p).line-(ofirstsym->s.refs->p).line; (&(moveOffset))->coll = (nfirstsym->s.refs->p).coll-(ofirstsym->s.refs->p).coll;};};
                if (moveOffset.coll!=0) {
                        error(ERR_ST, "method has to be moved into an empty line");
                        return(1);
                }
        }
        for(osym = origrefs->menuSym; osym!=NULL; osym=osym->next) {
                if (osym == ofirstsym) goto cont;
                if (osym->s.b.storage == StorageAuto) goto cont;
                if (osym->s.b.symType == TypeLabel) goto cont;
                if (isStrictlyEnclosingClass(osym->s.vFunClass, ofirstsym->s.vFunClass)) goto cont;
                diffsym = NULL;
                for(rr=osym->s.refs; rr!=NULL; rr=rr->next) {
                        nsym = mmFindSymWithCorrespondingRef(rr,osym,newrefs,&moveOffset);
                        if (nsym==NULL || ! symbolsCorrespondWrtMoving(osym, nsym, s_opt.cxrefs)) {
                                if (diffsym == NULL) {
                                        diffsym = olAddBrowsedSymbol(
                                                &osym->s, &diffrefs->menuSym, 1, 1,
                                                (03000|00300),
                                                USAGE_ANY, 0, &s_noPos, UsageNone);
                                }
                                olcxAddReferenceToOlSymbolsMenu(diffsym, rr, 0);
                        }
                }
        cont:;
        }
        return(0);
}
static void olcxMMPreCheck() {
        S_olcxReferences *diffrefs, *origrefs, *newrefs;
        S_symbolRefItem dri;
        int precheck;
        olcxSetCurrentUser(s_opt.user);
        olcxPushEmptyStackItem(&s_olcxCurrentUser->browserStack);
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 3913);};
        { if (!(s_opt.cxrefs == OLO_MM_PRE_CHECK || s_opt.cxrefs == OLO_PP_PRE_CHECK)) internalCheckFail("s_opt.cxrefs == OLO_MM_PRE_CHECK || s_opt.cxrefs == OLO_PP_PRE_CHECK", "cxref.c", 3914);};
        diffrefs = s_olcxCurrentUser->browserStack.top;
        { if (!(diffrefs && diffrefs->previous && diffrefs->previous->previous)) internalCheckFail("diffrefs && diffrefs->previous && diffrefs->previous->previous", "cxref.c", 3916);};
        newrefs = diffrefs->previous;
        origrefs = newrefs->previous;
        precheck = mmPreCheckMakeDifference(origrefs, newrefs, diffrefs);
        olStackDeleteSymbol(origrefs);
        olStackDeleteSymbol(newrefs);
        if (precheck==0) {
                if (diffrefs->menuSym!=NULL) {
                        fillTrivialSpecialRefItem(&dri, "  references missinterpreted after refactoring");
                        olAddBrowsedSymbol(&dri, &diffrefs->hkSelectedSym, 1, 1, 0,
                                USAGE_ANY, 0, &s_noPos, UsageNone);
                        olProcessSelectedReferences(diffrefs, genOnLineReferences);
                        olcxPrintRefList(";", diffrefs);
                } else {
                        olStackDeleteSymbol(diffrefs);
                        fprintf(ccOut,"* Method moving pre-check passed.");
                }
        }
        fflush(ccOut);
}
static void olcxSafetyCheck1() {
        S_olcxReferences *rstack;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4039);};
        { if (!(s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top->previous", "cxref.c", 4040);};
        { if (!(s_opt.cxrefs == OLO_SAFETY_CHECK1)) internalCheckFail("s_opt.cxrefs == OLO_SAFETY_CHECK1", "cxref.c", 4041);};
        rstack = s_olcxCurrentUser->browserStack.top->previous;
        olProcessSelectedReferences(rstack, olcxProceedSafetyCheck1OnInloadedRefs);
        if (s_olcxCurrentUser->browserStack.top->r == NULL) {
                fprintf(ccOut,"* check1 passed");
        } else {
                s_olcxCurrentUser->browserStack.top->act = s_olcxCurrentUser->browserStack.top->r;
                fprintf(ccOut," ** Shared references lost. Please, undo last refactoring\n");
        }
        fflush(ccOut);
}
static int refOccursInRefsCompareFileAndLineOnly(S_reference *rr,
                                                                                                 S_reference *list
        ) {
        S_reference *r;
        for(r=list; r!=NULL; r=r->next) {
                if (r->p.file==rr->p.file && r->p.line==rr->p.line) return(1);
        }
        return(0);
}
static void olcxTopReferencesIntersection() {
        S_olcxReferences *top1,*top2;
        S_olcxReferences *rstack;
        S_reference **r1,**r, *r2,*cr,*nr;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4071);};
        { if (!(s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top->previous", "cxref.c", 4072);};
        { if (!(s_opt.cxrefs == OLO_INTERSECTION)) internalCheckFail("s_opt.cxrefs == OLO_INTERSECTION", "cxref.c", 4073);};
        top1 = s_olcxCurrentUser->browserStack.top;
        top2 = s_olcxCurrentUser->browserStack.top->previous;
        r1 = & top1->r;
        while (*r1!=NULL) {
                r = r1; r1 = &(*r1)->next;
                if (! refOccursInRefsCompareFileAndLineOnly(*r, top2->r)) {
                        nr = *r1;
                        { { {}; olcxMemoryAllocatedBytes -= sizeof(S_reference); free((*r));};};
                        *r = nr;
                        r1 = r;
                }
        }
        top1->act = top1->r;
        fprintf(ccOut,"*");
}
static void olcxRemoveRefWinFromRefList( S_reference **r1,
                                                                                 int wdfile,
                                                                                 S_position *fp,
                                                                                 S_position *tp ) {
        S_reference **r, *cr, *nr;
        while (*r1!=NULL) {
                r = r1; r1 = &(*r1)->next;
                cr = *r;
                if (cr->p.file == wdfile
                        && ( ((*fp).file < (cr->p).file) || ((*fp).file==(cr->p).file && (*fp).line < (cr->p).line) || ((*fp).file==(cr->p).file && (*fp).line==(cr->p).line && (*fp).coll < (cr->p).coll) ) && ( ((cr->p).file < (*tp).file) || ((cr->p).file==(*tp).file && (cr->p).line < (*tp).line) || ((cr->p).file==(*tp).file && (cr->p).line==(*tp).line && (cr->p).coll < (*tp).coll) )) {
                        nr = *r1;
                        { { {}; olcxMemoryAllocatedBytes -= sizeof(S_reference); free((*r));};};
                        *r = nr;
                        r1 = r;
                }
        }
}
static void olcxTopReferencesRemoveWindow() {
        S_olcxReferences *top1;
        S_olcxReferences *rstack;
        S_olSymbolsMenu *mm;
        int wdfile;
        S_position fp, tp;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4122);};
        { if (!(s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top->previous", "cxref.c", 4123);};
        { if (!(s_opt.cxrefs == OLO_REMOVE_WIN)) internalCheckFail("s_opt.cxrefs == OLO_REMOVE_WIN", "cxref.c", 4124);};
        wdfile = getFileNumberFromName(s_opt.olcxWinDelFile);
        { (&fp)->file = wdfile; (&fp)->line = s_opt.olcxWinDelFromLine; (&fp)->coll = s_opt.olcxWinDelFromCol;};
        { (&tp)->file = wdfile; (&tp)->line = s_opt.olcxWinDelToLine; (&tp)->coll = s_opt.olcxWinDelToCol;};
        top1 = s_olcxCurrentUser->browserStack.top;
        olcxRemoveRefWinFromRefList(&top1->r, wdfile, &fp, &tp);
        for(mm=top1->menuSym; mm!=NULL; mm=mm->next) {
                olcxRemoveRefWinFromRefList(&mm->s.refs, wdfile, &fp, &tp);
        }
        top1->act = top1->r;
        fprintf(ccOut,"*");
}
char *getXrefEnvironmentValue( char *name ) {
        char *val;
        int i, n;
        val = NULL;
        n = s_opt.setGetEnv.num;
        for(i=0; i<n; i++) {
                if (strcmp(s_opt.setGetEnv.name[i], name)==0) {
                        val = s_opt.setGetEnv.value[i];
                        break;
                }
        }
        return(val);
}
static void olcxProcessGetRequest() {
        char *name, *val;
        int i,n;
        name = s_opt.getValue;
        val = getXrefEnvironmentValue( name);
        if (val != NULL) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_SET_INFO, expandSpecialFilePredefinedVariables_st(val), "\n");
                } else {
                        fprintf(ccOut,"*%s", expandSpecialFilePredefinedVariables_st(val));
                }
        } else {
                if (s_opt.xref2) {
                        sprintf(tmpBuff,"No \"-set %s <command>\" option specified for active project", name);
                } else {
                        sprintf(tmpBuff,"No \"-set %s <command>\" option specified for active project", name);
                }
                error(ERR_ST, tmpBuff);
        }
}
void olcxPrintPushingAction(int opt, int afterMenu) {
        switch(opt) {
        case OLO_PUSH:
                if (olcxCheckSymbolExists()) {
                        olcxOrderRefsAndGotoDefinition(afterMenu);
                } else {
                                olcxNoSymbolFoundErrorMessage();
                        olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
                }
                break;
        case OLO_PUSH_NAME:
                if (olcxCheckSymbolExists()) {
                        olcxOrderRefsAndGotoDefinition(afterMenu);
                } else {
                        olcxNoSymbolFoundErrorMessage();
                        olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
                }
                break;
        case OLO_PUSH_SPECIAL_NAME:
                { if (!(0)) internalCheckFail("0", "cxref.c", 4198);};
                break;
        case OLO_MENU_GO:
                if (olcxCheckSymbolExists()) {
                        olcxOrderRefsAndGotoFirst();
                } else {
                        olcxNoSymbolFoundErrorMessage();
                        olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
                }
                break;
        case OLO_GLOBAL_UNUSED:
        case OLO_LOCAL_UNUSED:
                break;
        case OLO_LIST:
                if (olcxCheckSymbolExists()) {
                        olcxReferenceList(";");
                } else {
                        olcxNoSymbolFoundErrorMessage();
                        olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
                }
                break;
        case OLO_USELESS_LONG_NAME:
        case OLO_USELESS_LONG_NAME_IN_CLASS:
        case OLO_PUSH_ENCAPSULATE_SAFETY_CHECK:
                olcxPushOnly();
                break;
        case OLO_PUSH_ONLY:
                if (olcxCheckSymbolExists()) {
                        olcxPushOnly();
                } else {
                        olcxNoSymbolFoundErrorMessage();
                        olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
                }
                break;
        case OLO_PUSH_AND_CALL_MACRO:
                if (olcxCheckSymbolExists()) {
                        olcxPushAndCallMacro();
                } else {
                        olcxNoSymbolFoundErrorMessage();
                        olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
                }
                break;
        case OLO_PUSH_FOR_LOCALM:
                if (olcxCheckSymbolExists()) olcxPushOnly();
                else olcxNoSymbolFoundErrorMessage();
                break;
        case OLO_MAYBE_THIS:
        case OLO_NOT_FQT_REFS: case OLO_NOT_FQT_REFS_IN_CLASS:
        case OLO_PUSH_ALL_IN_METHOD:
                if (olcxCheckSymbolExists()) olcxPushOnly();
                else olcxNoSymbolFoundErrorMessage();
                break;
        case OLO_RENAME: case OLO_VIRTUAL2STATIC_PUSH:
        case OLO_ARG_MANIP: case OLO_ENCAPSULATE:
                if (olcxCheckSymbolExists()) olcxRenameInit();
                else olcxNoSymbolFoundErrorMessage();
                break;
        case OLO_SAFETY_CHECK2:
                if (olcxCheckSymbolExists()) olcxSafetyCheck2();
                else olcxNoSymbolFoundErrorMessage();
                break;
        default:
                { if (!(0)) internalCheckFail("0", "cxref.c", 4261);};
        }
}
static void olcxCreateClassTree() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        olcxFreeResolutionMenu(s_olcxCurrentUser->ct.tree);
        s_olcxCurrentUser->ct.tree = NULL;
        olSpecialFieldCreateSelection(" [classTree]", StorageMethod);
        s_opt.ooChecksBits = (s_opt.ooChecksBits & ~00700);
        s_opt.ooChecksBits |= 00200;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4273);};
        rstack = s_olcxCurrentUser->browserStack.top;
        olCreateSelectionMenu(rstack->command);
        strcpy(s_olcxCurrentUser->ct.refsuffix, rstack->refsuffix);
        s_olcxCurrentUser->ct.tree = rstack->menuSym;
        rstack->menuSym = NULL;
        olcxPrintClassTree(s_olcxCurrentUser->ct.tree);
        for(ss=s_olcxCurrentUser->ct.tree; ss!=NULL; ss=ss->next) {
                olcxFreeReferences(ss->s.refs);
                ss->s.refs = NULL;
        }
        olStackDeleteSymbol(rstack);
}
void olcxPushSpecial(char *fieldName, int command) {
        int clii, line, col, nn;
        S_olcxReferences *refs;
        S_olSymbolsMenu *ss,*sss;
        S_position callerPos;
        clii = olSpecialFieldCreateSelection(fieldName,StorageField);
        olCreateSelectionMenu(s_olcxCurrentUser->browserStack.top->command);
        { if (!(s_javaObjectSymbol && s_javaObjectSymbol->u.s)) internalCheckFail("s_javaObjectSymbol && s_javaObjectSymbol->u.s", "cxref.c", 4297);};
        if (clii == s_javaObjectSymbol->u.s->classFile
                || command == OLO_MAYBE_THIS
                || command == OLO_NOT_FQT_REFS
                || command == OLO_NOT_FQT_REFS_IN_CLASS
                ) {
                refs = s_olcxCurrentUser->browserStack.top;
                for(ss=refs->menuSym; ss!=NULL; ss=ss->next) {
                        ss->visible = ss->selected = 1;
                }
                olProcessSelectedReferences(refs, genOnLineReferences);
                getLineColCursorPositionFromCommandLineOption( &line, &col);
                { (&callerPos)->file = s_input_file_number; (&callerPos)->line = line; (&callerPos)->coll = col;};
                olSetCallerPosition(&callerPos);
        }
}
static void olcxListSpecial(char *fieldName) {
        olcxPushSpecial(fieldName, s_opt.cxrefs);
        olcxPrintPushingAction(s_opt.cxrefs, DEFAULT_VALUE);
}
int isPushAllMethodsValidRefItem(S_symbolRefItem *ri) {
        if (ri->name[0]!=' ') return(1);
        if (ri->b.symType==TypeInducedError) return(1);
        return(0);
}
static void olPushAllReferencesInBetweenMapFun(S_symbolRefItem *ri,
                                                                                           void *ddd
        ) {
        S_reference *rr, *defRef;
        S_position defpos;
        S_olcxReferences *rstack;
        S_olSymbolsMenu *mm;
        S_pushAllInBetweenData *dd;
        int defusage,select,visible,ooBits,vlevel;
        dd = (S_pushAllInBetweenData *) ddd;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4339);};
        rstack = s_olcxCurrentUser->browserStack.top;
        if (! isPushAllMethodsValidRefItem(ri)) return;
        for(rr=ri->refs; rr!=NULL; rr=rr->next) {
                if (( ( ((char*)rr) >= ((char*)&cxMemory->b) + ((dd)->minMemi) && ((char*)rr) < ((char*)&cxMemory->b) + ((dd)->maxMemi) ) && ((rr)->usg.base < UsageMaxOLUsages) && rr->p.file != s_noneFileIndex && rr->p.file == s_input_file_number )) {
                        defRef = getDefinitionRef(ri->refs);
                        if (defRef!=NULL && ( ( (defRef->usg.base)==UsageDefined || (defRef->usg.base)==UsageOLBestFitDefined) || (defRef->usg.base)==UsageDeclared )) {
                                defpos = defRef->p;
                                defusage = defRef->usg.base;
                        } else {
                                defpos = s_noPos;
                                defusage = UsageNone;
                        }
                        select = visible = 1;
                        vlevel = 0;
                        ooBits = (03000 | 00300);
                        mm = olAddBrowsedSymbol(ri, &rstack->menuSym, select, visible, ooBits, USAGE_ANY, vlevel, &defpos, defusage);
                        { if (!(mm!=NULL)) internalCheckFail("mm!=NULL", "cxref.c", 4358);};
                        for(; rr!=NULL; rr=rr->next) {
                                if (( ( ((char*)rr) >= ((char*)&cxMemory->b) + ((dd)->minMemi) && ((char*)rr) < ((char*)&cxMemory->b) + ((dd)->maxMemi) ) && ((rr)->usg.base < UsageMaxOLUsages) && rr->p.file != s_noneFileIndex && rr->p.file == s_input_file_number )) {
                                        olcxAddReferenceNoUsageCheck(&mm->s.refs, rr, 0);
                                }
                        }
                        goto fini;
                }
        }
 fini:;
}
void olPushAllReferencesInBetween(int minMemi, int maxMemi) {
        S_pushAllInBetweenData rr;
        S_olcxReferences *rstack;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4376);};
        rstack = s_olcxCurrentUser->browserStack.top;
        { (&rr)->minMemi = minMemi; (&rr)->maxMemi = maxMemi;};
        refTabMap2(&s_cxrefTab, olPushAllReferencesInBetweenMapFun, &rr);
        olProcessSelectedReferences(rstack, genOnLineReferences);
}
static int tpCheckUnicityOfSymbol(char *fieldOrMethod) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4387);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        if (ss == NULL) {
                sprintf(tmpBuff,"No symbol selected, please position the cursor on a definition of a %s (on its name) before invoking this refactoring.", fieldOrMethod);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        if (ss->next != NULL) {
                error(ERR_ST,"Ambiguous symbol. You are probably trying to refactor a constructor or a native method. Xrefactory does not know to handle those cases, sorry.");
                return(0);
        }
        return(1);
}
static int tpCheckThatCurrentReferenceIsDefinition(char *fieldOrMethod) {
        S_olcxReferences *rstack;
        int found;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4405);};
        rstack = s_olcxCurrentUser->browserStack.top;
        if (rstack->act==NULL
                || ! ( ( (rstack->act->usg.base)==UsageDefined || (rstack->act->usg.base)==UsageOLBestFitDefined) || (rstack->act->usg.base)==UsageDeclared )) {
                sprintf(tmpBuff,"This refactoring requires cursor (point) to be positioned at the definition of a %s (on its name). Please move to the definition first.", fieldOrMethod);
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
static int tpCheckItIsAFieldOrMethod(int require, char *fieldOrMethod) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4420);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        if (ss->s.b.symType!=TypeDefault
                || (ss->s.b.storage!=StorageField && require==REQ_FIELD)
                || (ss->s.b.storage!=StorageMethod && require==REQ_METHOD)) {
                sprintf(tmpBuff, "This does not look like a %s, please position the cursor on a definition of a %s (on its name) before invoking this refactoring.",
                                fieldOrMethod, fieldOrMethod);
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
static int tpCheckStaticity(int require,char *fieldOrMethod) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        char ttt[MAX_CX_SYMBOL_SIZE];
        char *s;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4440);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "cxref.c", 4443);};
        if (require==REQ_STATIC && (ss->s.b.accessFlags & 0x008) == 0) {
                linkNamePrettyPrint(ttt, ss->s.name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
                sprintf(tmpBuff,"%c%s %s is not static, this refactoring requires a static %s.",
                                toupper(*fieldOrMethod), fieldOrMethod+1, ttt, fieldOrMethod);
                error(ERR_ST, tmpBuff);
                return(0);
        } else if (require==REQ_NONSTATIC && (ss->s.b.accessFlags & 0x008)) {
                linkNamePrettyPrint(ttt, ss->s.name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
                sprintf(tmpBuff,"%c%s %s is declared static, this refactoring requires a non static %s.",
                                toupper(*fieldOrMethod), fieldOrMethod+1, ttt, fieldOrMethod);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
static S_symbol *javaGetClassSymbolFromClassDotName(char *fqName) {
        S_symbol *res;
        char *dd, *sn;
        char ttt[MAX_CX_SYMBOL_SIZE];
        strcpy(ttt, fqName);
        dd = sn = ttt;
        while ((dd=strchr(dd,'.'))!=NULL) {
                *dd = '/';
                sn = dd+1;
        }
        res = javaFQTypeSymbolDefinition(sn, ttt);
        return(res);
}
S_symbol *getMoveTargetClass() {
        if (s_opt.moveTargetClass == NULL) {
                error(ERR_INTERNAL,"pull up/push down pre-check without setting target class");
                return(NULL);
        }
        return(javaGetClassSymbolFromClassDotName(s_opt.moveTargetClass));
}
static int tpCheckItIsAPackage(int req, char *classOrPack) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4485);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        if ((req==REQ_PACKAGE && ss->s.b.symType!=TypePackage) ||
                (req==REQ_CLASS && ss->s.b.symType!=TypeStruct)) {
                sprintf(tmpBuff, "This does not look like a %s name, please position the cursor on a %s name before invoking this refactoring.", classOrPack, classOrPack);
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
static int tpCheckPrintClassMovingType() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        S_tpCheckMoveClassData dd;
        char spack[MAX_FILE_NAME_SIZE];
        char tpack[MAX_FILE_NAME_SIZE];
        int transPackageMove;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4506);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "cxref.c", 4509);};
        if (ss->s.b.accessFlags & 0x008) {
                fprintf(ccOut,"*nested");
        } else {
                fprintf(ccOut,"*outer");
        }
        tpCheckFillMoveClassData(&dd, spack, tpack);
        if (dd.transPackageMove) {
                fprintf(ccOut, ";transpackage");
        }
        return(1);
}
static int tpCheckPrintSelectedSymbol() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4525);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        fprintf(ccOut,"*");
        printSymbolLinkName(ccOut, ss);
        return(1);
}
int javaGetSuperClassNumFromClassNum(int cn) {
        int res;
        S_chReference *cl;
        for(cl = s_fileTab.tab[cn]->sups; cl!=NULL; cl=cl->next) {
                res = cl->clas;
                if (! s_fileTab.tab[res]->b.isInterface) return(res);
        }
        return(s_noneFileIndex);
}
int javaIsSuperClass(int superclas, int clas) {
        int ss;
        for (ss=javaGetSuperClassNumFromClassNum(clas);
                 ss!=s_noneFileIndex && ss!=superclas;
                 ss=javaGetSuperClassNumFromClassNum(ss)) ;
        if (ss == superclas) return(1);
        return(0);
}
static int tpCheckPrintPushingDownMethodType() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss,*mm;
        S_symbol *target;
        int targetcn, srccn;
        fprintf(ccOut, "*** push_down_method trivial precheck passed.");
        return(1);
}
static void olTrivialRefactoringPreCheck(int refcode) {
        S_olcxReferences *tpchsymbol;
        olCreateSelectionMenu(s_olcxCurrentUser->browserStack.top->command);
        tpchsymbol = s_olcxCurrentUser->browserStack.top;
        switch (refcode) {
        case TPC_MOVE_FIELD:
                tpCheckUnicityOfSymbol("field") &&
                        tpCheckItIsAFieldOrMethod(REQ_FIELD, "field") &&
                        tpCheckThatCurrentReferenceIsDefinition("field") &&
                        fprintf(ccOut,"*** move_static_field trivial precheck passed.");
                break;
        case TPC_MOVE_STATIC_FIELD:
                tpCheckUnicityOfSymbol("field") &&
                        tpCheckItIsAFieldOrMethod(REQ_FIELD, "field") &&
                        tpCheckThatCurrentReferenceIsDefinition("field") &&
                        tpCheckStaticity(REQ_STATIC,"field") &&
                        fprintf(ccOut,"*** move_static_field trivial precheck passed.");
                break;
        case TPC_MOVE_STATIC_METHOD:
                tpCheckUnicityOfSymbol("method") &&
                        tpCheckItIsAFieldOrMethod(REQ_METHOD, "method") &&
                        tpCheckThatCurrentReferenceIsDefinition("method") &&
                        tpCheckStaticity(REQ_STATIC,"method") &&
                        fprintf(ccOut,"*** move_static_method trivial precheck passed.");
                break;
        case TPC_TURN_STATIC_METHOD_TO_DYN:
                tpCheckUnicityOfSymbol("method") &&
                        tpCheckItIsAFieldOrMethod(REQ_METHOD, "method") &&
                        tpCheckThatCurrentReferenceIsDefinition("method") &&
                        tpCheckStaticity(REQ_STATIC,"method") &&
                        fprintf(ccOut,"*** turn_static_method_to_dyn trivial precheck passed.");
                break;
        case TPC_TURN_DYN_METHOD_TO_STATIC:
                tpCheckUnicityOfSymbol("method") &&
                        tpCheckItIsAFieldOrMethod(REQ_METHOD, "method") &&
                        tpCheckThatCurrentReferenceIsDefinition("method") &&
                        tpCheckStaticity(REQ_NONSTATIC,"method") &&
                        tpCheckOuterScopeUsagesForDynToSt() &&
                        tpCheckSuperMethodReferencesForDynToSt() &&
                        fprintf(ccOut,"*** turn_static_method_to_dyn trivial precheck passed.");
                break;
        case TPC_PULL_UP_METHOD:
                tpCheckUnicityOfSymbol("method")
                && tpCheckItIsAFieldOrMethod(REQ_METHOD, "method")
                && tpCheckThatCurrentReferenceIsDefinition("method")
                && tpCheckStaticity(REQ_NONSTATIC,"method")
                && tpCheckTargetToBeDirectSubOrSupClass(REQ_SUPERCLASS,"superclass")
                && tpCheckSuperMethodReferencesForPullUp()
                && tpCheckMethodReferencesWithApplOnSuperClassForPullUp()
                && fprintf(ccOut,"*** pull_up_method trivial precheck passed.");
                break;
        case TPC_PUSH_DOWN_METHOD:
                tpCheckUnicityOfSymbol("method") &&
                        tpCheckItIsAFieldOrMethod(REQ_METHOD, "method") &&
                        tpCheckThatCurrentReferenceIsDefinition("method") &&
                        tpCheckStaticity(REQ_NONSTATIC,"method") &&
                        tpCheckTargetToBeDirectSubOrSupClass(REQ_SUBCLASS, "subclass") &&
                        tpCheckPrintPushingDownMethodType();
                break;
        case TPC_PUSH_DOWN_METHOD_POST_CHECK:
                tpCheckSuperMethodReferencesAfterPushDown() &&
                        fprintf(ccOut,"*** push_down_method trivial postcheck passed.");
                break;
        case TPC_PULL_UP_FIELD:
                tpCheckUnicityOfSymbol("field")
                && tpCheckItIsAFieldOrMethod(REQ_FIELD, "field")
                && tpCheckThatCurrentReferenceIsDefinition("field")
                && tpCheckStaticity(REQ_NONSTATIC,"field")
                && tpCheckTargetToBeDirectSubOrSupClass(REQ_SUPERCLASS,"superclass")
                && tpPullUpFieldLastPreconditions()
                && fprintf(ccOut,"*** pull_up_field trivial precheck passed.");
                break;
        case TPC_PUSH_DOWN_FIELD:
                tpCheckUnicityOfSymbol("field") &&
                        tpCheckItIsAFieldOrMethod(REQ_FIELD, "field") &&
                        tpCheckThatCurrentReferenceIsDefinition("field") &&
                        tpCheckStaticity(REQ_NONSTATIC,"field") &&
                        tpCheckTargetToBeDirectSubOrSupClass(REQ_SUBCLASS, "subclass") &&
                        tpPushDownFieldLastPreconditions() &&
                        fprintf(ccOut,"*** push_down_field trivial precheck passed.");
                break;
        case TPC_RENAME_PACKAGE:
                tpCheckUnicityOfSymbol("package") &&
                        tpCheckItIsAPackage(REQ_PACKAGE, "package") &&
                        tpCheckPrintSelectedSymbol();
                break;
        case TPC_RENAME_CLASS:
                tpCheckUnicityOfSymbol("class") &&
                        tpCheckItIsAPackage(REQ_CLASS, "class") &&
                        tpCheckPrintSelectedSymbol();
                break;
        case TPC_MOVE_CLASS:
                tpCheckUnicityOfSymbol("class") &&
                        tpCheckItIsAPackage(REQ_CLASS, "class") &&
                        tpCheckSourceIsNotInnerClass() &&
                        tpCheckMoveClassAccessibilities() &&
                        tpCheckPrintClassMovingType();
                break;
        case TPC_GET_LAST_IMPORT_LINE:
                if (s_opt.xref2) {
                        sprintf(tmpBuff, "%d", s_cps.lastImportLine);
                        ppcGenRecord(PPC_SET_INFO, tmpBuff, "\n");
                } else {
                        fprintf(ccOut,"*%d", s_cps.lastImportLine);
                }
                break;
        default:
                error(ERR_INTERNAL,"trivial precheck called with no valid check code");
        }
        olStackDeleteSymbol(tpchsymbol);
}
static void mainAnswerReferencePushingAction(int command) {
        S_olcxReferences *rstack;
        { if (!(creatingOlcxRefs())) internalCheckFail("creatingOlcxRefs()", "cxref.c", 4711);};
        olCreateSelectionMenu(command);
        if (s_opt.manualResolve == RESOLVE_DIALOG_ALLWAYS
                || safetyCheck2ShouldWarn()
                || (olcxShowSelectionMenu()
                        && s_opt.manualResolve != RESOLVE_DIALOG_NEVER)) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_DISPLAY_OR_UPDATE_BROWSER, "", "\n");
                } else {
                        olcxPrintSelectionMenu(s_olcxCurrentUser->browserStack.top->menuSym);
                }
        } else {
                { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4727);};
                rstack = s_olcxCurrentUser->browserStack.top;
                olcxPrintPushingAction(s_opt.cxrefs, DEFAULT_VALUE);
        }
}
static void mapAddLocalUnusedSymbolsToHkSelection(S_symbolRefItem *ss) {
        S_reference *rr, *dr;
        int used, thisFileSym;
        dr = NULL;
        used = 0;
        thisFileSym = 0;
        if (ss->b.category != CatLocal) return;
        for(rr = ss->refs; rr!=NULL; rr=rr->next) {
                if (( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared )) {
                        if (rr->p.file == s_input_file_number) {
                                if (( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined)) {
                                        dr = rr;
                                }
                                if (dr == NULL) dr = rr;
                        }
                } else {
                        used = 1;
                        break;
                }
        }
        if (used == 0 && dr!=NULL) {
                olAddBrowsedSymbol(ss,&s_olcxCurrentUser->browserStack.top->hkSelectedSym,
                                                   1,1,0,UsageDefined,0, &dr->p, dr->usg.base);
        }
}
void pushLocalUnusedSymbolsAction() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        int fnum;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4765);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss == NULL)) internalCheckFail("ss == NULL", "cxref.c", 4768);};
        refTabMap(&s_cxrefTab, mapAddLocalUnusedSymbolsToHkSelection);
        olCreateSelectionMenu(s_opt.cxrefs);
}
static void answerPushLocalUnusedSymbolsAction() {
        pushLocalUnusedSymbolsAction();
        { if (!(s_opt.xref2)) internalCheckFail("s_opt.xref2", "cxref.c", 4775);};
        ppcGenRecord(PPC_DISPLAY_OR_UPDATE_BROWSER, "", "\n");
}
static S_reference *getUsageRef(S_reference *rrr) {
        S_reference *res, *rr;
        res = NULL;
        for(rr=rrr; rr!=NULL; rr=rr->next) {
                if (((rr)->usg.base < UsageMaxOLUsages) && (! ( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared ))) {
                        res = rr;
                        break;
                }
        }
        return(res);
}
static void answerPushGlobalUnusedSymbolsAction() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        int fnum;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 4796);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss == NULL)) internalCheckFail("ss == NULL", "cxref.c", 4799);};
        scanReferenceFiles(s_opt.cxrefFileName, s_cxDeadCodeDetectionScanFunTab);
        olCreateSelectionMenu(s_opt.cxrefs);
        { if (!(s_opt.xref2)) internalCheckFail("s_opt.xref2", "cxref.c", 4802);};
        ppcGenRecord(PPC_DISPLAY_OR_UPDATE_BROWSER, "", "\n");
}
static void getCallerPositionFromCommandLineOption(S_position *opos) {
        int f,l,c;
        { if (!(opos!=NULL)) internalCheckFail("opos!=NULL", "cxref.c", 4808);};
        f = s_olOriginalFileNumber;
        getLineColCursorPositionFromCommandLineOption( &l, &c);
        { (opos)->file = f; (opos)->line = l; (opos)->coll = c;};
}
static void answerClassName(char *name) {
        char ttt[MAX_CX_SYMBOL_SIZE];
        if (*name!=0) {
                linkNamePrettyPrint(ttt, name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_SET_INFO, ttt, "\n");
                } else {
                        fprintf(ccOut,"*%s", ttt);
                }
        } else {
                error(ERR_ST, "Not inside a class. Can't get curent class.");
        }
}
static void pushSymbolByName(char *name) {
        S_olcxReferences *rstack;
        if (s_cache.cpi>0) {
                int spass;
                spass = s_currCppPass; s_currCppPass=1;
                recoverCachePointZero();
                s_currCppPass = spass;
        }
        rstack = s_olcxCurrentUser->browserStack.top;
        rstack->hkSelectedSym = olCreateSpecialMenuItem(
                name, s_noneFileIndex, StorageDefault);
        getCallerPositionFromCommandLineOption(&rstack->cpos);
}
void mainAnswerEditAction() {
        S_olcxReferences *rstack, *nextrr;
        int category,f,l,c,lc;
        S_position opos;
        char *ifname, *jdkcp;
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        { if (!(ccOut)) internalCheckFail("ccOut", "cxref.c", 4855);};
        switch (s_opt.cxrefs) {
        case OLO_CHECK_VERSION:
                { if (!(s_opt.checkVersion!=NULL)) internalCheckFail("s_opt.checkVersion!=NULL", "cxref.c", 4858);};
                if (strcmp(s_opt.checkVersion, XREF_VERSION_NUMBER)!=0) {
                        ppcGenRecord(PPC_VERSION_MISMATCH, XREF_VERSION_NUMBER, "\n");
                }
                break;
        case OLO_COMPLETION: case OLO_SEARCH:
                printCompletions(&s_completions);
                break;
        case OLO_EXTRACT:
                if (! s_cps.extractProcessedFlag) {
                        fprintf(ccOut,"*** No function/method enclosing selected block found **");
                }
                break;
        case OLO_TAG_SEARCH:
                getCallerPositionFromCommandLineOption(&opos);
                if (! s_opt.xref2) fprintf(ccOut,";");
                { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 4875);};
                olcxPushEmptyStackItem(&s_olcxCurrentUser->retrieverStack);
                s_olcxCurrentUser->retrieverStack.top->cpos = opos;
                if (containsWildCharacter(s_opt.olcxSearchString)) {
                        s_wildCharSearch = 1;
                } else {
                        s_wildCharSearch = 0;
                }
                if (s_opt.tagSearchSpecif==TSS_FULL_SEARCH) scanJarFilesForTagSearch();
                scanReferenceFiles(s_opt.cxrefFileName, s_cxSymbolSearchScanFunTab);
                printTagSearchResults();
                break;
        case OLO_TAG_SEARCH_BACK:
                olcxSetCurrentUser(s_opt.user);
                if (s_olcxCurrentUser->retrieverStack.top!=NULL &&
                        s_olcxCurrentUser->retrieverStack.top->previous!=NULL) {
                        s_olcxCurrentUser->retrieverStack.top = s_olcxCurrentUser->retrieverStack.top->previous;
                        ppcGenGotoPositionRecord(&s_olcxCurrentUser->retrieverStack.top->cpos);
                        printTagSearchResults();
                }
                break;
        case OLO_TAG_SEARCH_FORWARD:
                olcxSetCurrentUser(s_opt.user);
                nextrr = getNextTopStackItem(&s_olcxCurrentUser->retrieverStack);
                if (nextrr != NULL) {
                        s_olcxCurrentUser->retrieverStack.top = nextrr;
                        ppcGenGotoPositionRecord(&s_olcxCurrentUser->retrieverStack.top->cpos);
                        printTagSearchResults();
                }
                break;
        case OLO_ACTIVE_PROJECT:
                if (s_opt.project != NULL) {
                        if (s_opt.xref2) {
                                ppcGenRecord(PPC_SET_INFO, s_opt.project, "\n");
                        } else {
                                fprintf(ccOut,"*%s", s_opt.project);
                        }
                } else {
                        if (s_olOriginalComFileNumber == s_noneFileIndex) {
                                if (s_opt.xref2) {
                                        ppcGenRecord(PPC_ERROR, "No source file to identify project", "\n");
                                } else {
                                        fprintf(ccOut,"!** No source file to identify project");
                                }
                        } else {
                                ifname = s_fileTab.tab[s_olOriginalComFileNumber]->name;
                                searchDefaultOptionsFile(ifname, dffname, dffsect);
                                if (dffname[0]==0 || dffsect[0]==0) {
                                        if (s_opt.noErrors) {
                                                if (! s_opt.xref2) fprintf(ccOut,"^", ifname);
                                        } else {
                                                if (s_opt.xref2) {
                                                        ppcGenRecord(PPC_NO_PROJECT, ifname, "\n");
                                                } else {
                                                        fprintf(ccOut,"!** No project name matches %s", ifname);
                                                }
                                        }
                                } else {
                                        if (s_opt.xref2) {
                                                ppcGenRecord(PPC_SET_INFO, dffsect, "\n");
                                        } else {
                                                fprintf(ccOut,"*%s", dffsect);
                                        }
                                }
                        }
                }
                break;
        case OLO_JAVA_HOME:
                jdkcp = getJavaHome();
                if (s_opt.xref2) {
                        if (jdkcp==NULL) {
                                if (! s_opt.noErrors) {
                                        ppcGenRecord(PPC_ERROR, "Can't infer Java home", "\n");
                                }
                        } else {
                                ppcGenRecord(PPC_SET_INFO, jdkcp, "\n");
                        }
                } else {
                        if (jdkcp==NULL) {
                                if (s_opt.noErrors) {
                                        fprintf(ccOut,"^");
                                } else {
                                        fprintf(ccOut,"!* Can't find Java runtime library rt.jar", ifname);
                                }
                        } else {
                                fprintf(ccOut,"*%s", jdkcp);
                        }
                }
                break;
        case OLO_GET_ENV_VALUE:
                olcxProcessGetRequest();
                break;
        case OLO_PLUS: olcxReferencePlus();
                break;
        case OLO_MINUS: olcxReferenceMinus();
                break;
        case OLO_GOTO_DEF: olcxReferenceGotoDef();
                break;
        case OLO_GOTO_CALLER: olcxReferenceGotoCaller();
                break;
        case OLO_GOTO_CURRENT: olcxReferenceGotoCurrent();
                break;
        case OLO_GET_CURRENT_REFNUM: olcxReferenceGetCurrentRefn();
                break;
        case OLO_LIST_TOP: olcxListTopReferences(";");
                break;
        case OLO_SHOW_TOP: olcxShowTopSymbol();
                break;
        case OLO_SHOW_TOP_APPL_CLASS: olcxShowTopApplClass();
                break;
        case OLO_SHOW_TOP_TYPE: olcxShowTopType();
                break;
        case OLO_SHOW_CLASS_TREE: olcxShowClassTree();
                break;
        case OLO_TOP_SYMBOL_RES: olcxTopSymbolResolution();
                break;
        case OLO_CSELECT: olCompletionSelect();
                break;
        case OLO_COMPLETION_BACK: olCompletionBack();
                break;
        case OLO_COMPLETION_FORWARD: olCompletionForward();
                break;
        case OLO_GOTO: olcxReferenceGotoRef(s_opt.olcxGotoVal);
                break;
        case OLO_CGOTO: olcxReferenceGotoCompletion(s_opt.olcxGotoVal);
                break;
        case OLO_TAGGOTO: olcxReferenceGotoTagSearchItem(s_opt.olcxGotoVal);
                break;
        case OLO_TAGSELECT: olcxReferenceSelectTagSearchItem(s_opt.olcxGotoVal);
                break;
        case OLO_CBROWSE: olcxReferenceBrowseCompletion(s_opt.olcxGotoVal);
                break;
        case OLO_REF_FILTER_SET: olcxReferenceFilterSet(s_opt.filterValue);
                break;
        case OLO_REPUSH: olcxReferenceRePush();
                break;
        case OLO_POP: olcxReferencePop();
                break;
        case OLO_POP_ONLY: olcxPopOnly();
                break;
        case OLO_MENU_INSPECT_DEF: olcxSymbolMenuInspectDef();
                break;
        case OLO_MENU_INSPECT_CLASS: olcxSymbolMenuInspectClass();
                break;
        case OLO_MENU_SELECT: olcxMenuToggleSelect();
                break;
        case OLO_MENU_SELECT_ONLY: olcxMenuSelectOnly();
                break;
        case OLO_MENU_SELECT_ALL: olcxMenuSelectAll(1);
                break;
        case OLO_MENU_SELECT_NONE: olcxMenuSelectAll(0);
                break;
        case OLO_MENU_FILTER_SET:
                olcxMenuSelectPlusolcxMenuSelectFilterSet(s_opt.filterValue);
                break;
        case OLO_RESET_REF_SUFFIX: olcxResetSuffix();
                break;
        case OLO_SAFETY_CHECK_INIT: olcxSafetyCheckInit();
                break;
        case OLO_SAFETY_CHECK1: olcxSafetyCheck1();
                break;
        case OLO_MM_PRE_CHECK: case OLO_PP_PRE_CHECK:
                olcxMMPreCheck();
                break;
        case OLO_INTERSECTION: olcxTopReferencesIntersection();
                break;
        case OLO_REMOVE_WIN: olcxTopReferencesRemoveWindow();
                break;
        case OLO_MENU_GO:
                { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 5044);};
                rstack = s_olcxCurrentUser->browserStack.top;
                olcxPrintPushingAction(s_olcxCurrentUser->browserStack.top->command,
                                                           PUSH_AFTER_MENU);
                break;
        case OLO_CT_INSPECT_DEF: olcxClassTreeInspectDef();
                break;
        case OLO_CLASS_TREE: olcxCreateClassTree();
                break;
        case OLO_USELESS_LONG_NAME: case OLO_USELESS_LONG_NAME_IN_CLASS:
                olcxListSpecial(" redundant long names of the project");
                break;
        case OLO_MAYBE_THIS: olcxListSpecial("  method's \"maybe this\" dependencies");
                break;
        case OLO_NOT_FQT_REFS: case OLO_NOT_FQT_REFS_IN_CLASS:
                olcxListSpecial("  not fully qualified names");
                break;
        case OLO_SET_MOVE_TARGET:
                { if (!(!s_opt.xref2)) internalCheckFail("!s_opt.xref2", "cxref.c", 5063);};
                if (*s_cps.setTargetAnswerClass!=0) {
                        fprintf(ccOut,"*");
                        fprintf(ccOut, s_cps.setTargetAnswerClass);
                } else {
                        error(ERR_ST, "Not a valid target position. The cursor has to be on a place where a new field/method can be inserted.");
                }
                break;
        case OLO_SET_MOVE_CLASS_TARGET: case OLO_SET_MOVE_METHOD_TARGET:
                { if (!(s_opt.xref2)) internalCheckFail("s_opt.xref2", "cxref.c", 5074);};
                if (!s_cps.moveTargetApproved) {
                        ppcGenRecord(PPC_ERROR, "Invalid target place","\n");
                }
                break;
        case OLO_GET_CURRENT_CLASS:
                answerClassName(s_cps.currentClassAnswer);
                break;
        case OLO_GET_CURRENT_SUPER_CLASS:
                answerClassName(s_cps.setTargetAnswerClass);
                break;
        case OLO_GET_METHOD_COORD:
                if (s_cps.methodCoordEndLine!=0) {
                        fprintf(ccOut,"*%d", s_cps.methodCoordEndLine);
                } else {
                        error(ERR_ST, "No method found.");
                }
                break;
        case OLO_GET_CLASS_COORD:
                if (s_cps.classCoordEndLine!=0) {
                        fprintf(ccOut,"*%d", s_cps.classCoordEndLine);
                } else {
                        error(ERR_ST, "No class found.");
                }
                break;
        case OLO_GET_SYMBOL_TYPE:
                if (s_olstringServed) {
                        fprintf(ccOut,"*%s", s_olSymbolType);
                } else if (s_opt.noErrors) {
                        fprintf(ccOut,"*");
                } else {
                        error(ERR_ST, "No symbol found.");
                }
                olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
                break;
        case OLO_GOTO_PARAM_NAME:
                if (s_olstringServed && s_paramPosition.file != s_noneFileIndex) {
                        generateOnlineCxref(&s_paramPosition, "#",
                                                                UsageDefined, s_olcxCurrentUser->browserStack.top->refsuffix, "");
                        olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
                } else {
                        sprintf(tmpBuff, "Parameter %d not found.", s_opt.olcxGotoVal);
                        error(ERR_ST, tmpBuff);
                }
                break;
        case OLO_GET_PRIMARY_START:
                if (s_olstringServed && s_primaryStartPosition.file != s_noneFileIndex) {
                        generateOnlineCxref(&s_primaryStartPosition, "#",
                                                                UsageDefined, s_olcxCurrentUser->browserStack.top->refsuffix, "");
                        olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
                } else {
                        error(ERR_ST, "Begin of primary expression not found.");
                }
                break;
        case OLO_PUSH_ALL_IN_METHOD:
                olPushAllReferencesInBetween(s_cps.cxMemiAtMethodBeginning, s_cps.cxMemiAtMethodEnd);
                olcxPrintPushingAction(s_opt.cxrefs, 0);
                break;
        case OLO_TRIVIAL_PRECHECK:
                olTrivialRefactoringPreCheck(s_opt.trivialPreCheckCode);
                break;
        case OLO_ENCAPSULATE_SAFETY_CHECK:
                olEncapsulationSafetyCheck();
                break;
        case OLO_GET_AVAILABLE_REFACTORINGS:
                olGetAvailableRefactorings();
                olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
                break;
        case OLO_PUSH_NAME:
                pushSymbolByName(s_opt.pushName);
                mainAnswerReferencePushingAction(s_opt.cxrefs);
                break;
        case OLO_GLOBAL_UNUSED:
                answerPushGlobalUnusedSymbolsAction();
                break;
        case OLO_LOCAL_UNUSED:
                answerPushLocalUnusedSymbolsAction();
                break;
        case OLO_PUSH_SPECIAL_NAME:
                { if (!(0)) internalCheckFail("0", "cxref.c", 5155);};
                break;
        case OLO_ARG_MANIP:
                rstack = s_olcxCurrentUser->browserStack.top;
                { if (!(rstack!=NULL)) internalCheckFail("rstack!=NULL", "cxref.c", 5159);};
                if (rstack->hkSelectedSym == NULL ||
                        (((s_language & (4)) != 0) &&
                         rstack->hkSelectedSym->s.b.storage!=StorageMethod &&
                         rstack->hkSelectedSym->s.b.storage!=StorageConstructor)) {
                        sprintf(tmpBuff,"Cursor (point) has to be positioned on a method or contructor name before invocation of this refactoring, not on the parameter itself. Please move the cursor onto the method (contructor) name and reinvoke the refactoring.");
                        error(ERR_ST, tmpBuff);
                } else {
                        mainAnswerReferencePushingAction(s_opt.cxrefs);
                }
                break;
        default:
                mainAnswerReferencePushingAction(s_opt.cxrefs);
        }
        fflush(ccOut);
        s_input_file_name = NULL;
}
int byPassAcceptableSymbol(S_symbolRefItem *p) {
        int nlen,len;
        char *nn, *nnn;
        { register int _c_; register char *_ss_; _ss_ = nn = p->name; while ((_c_= *_ss_)) { if (_c_ == '(') break; if (( _c_=='.' || _c_=='/' || _c_=='!' || _c_=='#' || _c_=='$')) nn = _ss_+1; _ss_++ ; } len = _ss_ - nn;};
        { register int _c_; register char *_ss_; _ss_ = nnn = s_opt.browsedSymName; while ((_c_= *_ss_)) { if (_c_ == '(') break; if (( _c_=='.' || _c_=='/' || _c_=='!' || _c_=='#' || _c_=='$')) nnn = _ss_+1; _ss_++ ; } nlen = _ss_ - nnn;};
        if (len != nlen) return(0);
        if (strncmp(nn, nnn, len)) return(0);
        return(1);
}
static void oloPushByNameIfNothingPushed() {
        if (s_olcxCurrentUser!=NULL
                && s_olcxCurrentUser->browserStack.top!=NULL
                && s_olcxCurrentUser->browserStack.top->hkSelectedSym==NULL
                && s_olstring[0]!=0) {
                pushSymbolByName(s_olstring);
                mainAnswerReferencePushingAction(OLO_PUSH_NAME);
        }
        if (! olcxCheckSymbolExists()) {
                olcxNoSymbolFoundErrorMessage();
                olStackDeleteSymbol( s_olcxCurrentUser->browserStack.top);
        }
}
static int itIsSymbolToPushOlRefencesLess(S_olSymbolsMenu *ss, S_symbolRefItem *p) {
        return(olSymbolRefItemLess(&ss->s, p));
}
int itIsSymbolToPushOlRefences(S_symbolRefItem *p,
                                                           S_olcxReferences *rstack,
                                                           S_olSymbolsMenu **rss,
                                                           int checkSelFlag) {
        S_olSymbolsMenu *ss;
        for(ss=rstack->menuSym; ss!=NULL; ss=ss->next) {
                if ((ss->selected || checkSelFlag==DO_NOT_CHECK_IF_SELECTED)
                        && ss->s.vApplClass == p->vApplClass
                        && ss->s.vFunClass == p->vFunClass
                        && itIsSameCxSymbol(p, &ss->s)) {
                        *rss = ss;
                        if (( (ss->ooBits&00700)==00500)) {
                                return(2);
                        } else {
                                return(1);
                        }
                }
        }
        *rss = NULL;
        return(0);
}
void putOnLineLoadedReferences(S_symbolRefItem *p) {
        int ols, num, nn;
        S_olSymbolsMenu *cms;
        S_reference *r, *rr, **place;
        S_olSymbolsMenu *ss;
        ols = itIsSymbolToPushOlRefences(p,s_olcxCurrentUser->browserStack.top,
                                                                         &cms, DO_NOT_CHECK_IF_SELECTED);
        if (ols) {
                { if (!(cms)) internalCheckFail("cms", "cxref.c", 5243);};
                for(rr=p->refs; rr!=NULL; rr=rr->next) {
                        olcxAddReferenceToOlSymbolsMenu(cms, rr, (ols == 2));
                }
        }
}
void genOnLineReferences(S_olcxReferences *rstack, S_olSymbolsMenu *cms) {
        int ols, num;
        if (cms->selected) {
                { if (!(cms)) internalCheckFail("cms", "cxref.c", 5255);};
                olcxAddReferences(cms->s.refs, &rstack->r, (-1),
                                                  ( (cms->ooBits&00700)==00500));
        }
}
static int classCmp(int cl1, int cl2) {
        int res;
        res = isSmallerOrEqClassR(cl2, cl1, 1);
        if (res == 0) {
                res = - isSmallerOrEqClassR(cl1, cl2, 1);
        }
        return(res);
}
static unsigned olcxOoBits(S_olSymbolsMenu *ols, S_symbolRefItem *p) {
        unsigned ooBits;
        int olusage,vFunCl,olvFunCl,vApplCl,olvApplCl;
        ooBits = 0;
        { if (!(olcxItIsSameCxSymbol(&ols->s,p))) internalCheckFail("olcxItIsSameCxSymbol(&ols->s,p)", "cxref.c", 5276);};
        olvFunCl = ols->s.vFunClass;
        olvApplCl = ols->s.vApplClass;
        olusage = ols->olUsage;
        vFunCl = p->vFunClass;
        vApplCl = p->vApplClass;
        if (ols->s.b.symType!=TypeCppCollate) {
                if (ols->s.b.symType != p->b.symType) goto fini;
                if (ols->s.b.storage != p->b.storage) goto fini;
                if (ols->s.b.category != p->b.category) goto fini;
        }
        if (strcmp(ols->s.name,p->name)==0) {
                ooBits |= 03000;
        }
        if (((s_language & (2)) != 0) || ((s_language & (8)) != 0)
                || ( (ols->s.b.storage==StorageField || ((ols->s.b.storage==StorageMethod || ols->s.b.storage==StorageConstructor) && (ols->s.b.accessFlags & 0x008))))) {
                if (vFunCl == olvFunCl) ooBits |= 00500;
        } else {
                if (vApplCl == olvFunCl && vFunCl==olvFunCl) {
                        ooBits |= 00500;
                } else if (olcxVirtualyUsageAdequate(vApplCl, vFunCl, olusage, olvApplCl, olvFunCl)) {
                        ooBits |= 00400;
                } else if (vFunCl==olvFunCl) {
                        ooBits |= 00300;
                } else if (isSmallerOrEqClass(olvApplCl, vApplCl)
                        || isSmallerOrEqClass(vApplCl, olvApplCl)) {
                        ooBits |= 00200;
                }
        }
 fini:
        return(ooBits);
}
static unsigned ooBitsMax(unsigned oo1, unsigned oo2) {
        unsigned res;
        res = 0;
        if ((oo1&07000) > (oo2&07000)) {
                res |= (oo1&07000);
        } else {
                res |= (oo2&07000);
        }
        if ((oo1&00700) > (oo2&00700)) {
                res |= (oo1&00700);
        } else {
                res |= (oo2&00700);
        }
        return(res);
}
S_olSymbolsMenu *createSelectionMenu(S_symbolRefItem *p) {
        S_olSymbolsMenu *ss, *res;
        S_olcxReferences *rstack;
        S_position *defpos;
        unsigned ooBits, oo, flag;
        int select,visible,vlev,vlevel,defusage;
        res = NULL;
        rstack = s_olcxCurrentUser->browserStack.top;
        ooBits = 0; flag = 0; vlevel = 0;
        defpos = &s_noPos; defusage = UsageNone;
        for(ss=rstack->hkSelectedSym; ss!=NULL; ss=ss->next) {
                if (olcxItIsSameCxSymbol(p, &ss->s)) {
                        flag = 1;
                        oo = olcxOoBits(ss, p);
                        ooBits = ooBitsMax(oo, ooBits);
                        if (defpos->file == s_noneFileIndex) {
                                defpos = &ss->defpos;
                                defusage = ss->defUsage;
                        }
                        if (((s_language & (4)) != 0)) {
                                vlev = classCmp(ss->s.vApplClass, p->vApplClass);
                        } else {
                                vlev = 0;
                        }
                        if (vlevel==0 || ((vlevel>0)?(vlevel):(-(vlevel)))>((vlev>0)?(vlev):(-(vlev)))) vlevel = vlev;
                }
        }
        if (flag) {
                select = visible = 0;
                res = olAddBrowsedSymbol(p, &rstack->menuSym, select, visible, ooBits, USAGE_ANY, vlevel, defpos, defusage);
        }
        return(res);
}
void mapCreateSelectionMenu(S_symbolRefItem *p) {
        createSelectionMenu(p);
}
void olSetCallerPosition(S_position *pos) {
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "cxref.c", 5389);};
        s_olcxCurrentUser->browserStack.top->cpos = *pos;
}
S_olCompletion * olCompletionListPrepend( char *name,
                                                                                        char *fullText, char *vclass, int jindent,
                                                                                        S_symbol *s,
                                                                                        S_symbolRefItem *rr,
                                                                                        S_reference *dfref,
                                                                                        int cType,
                                                                                        int vFunClass,
                                                                                        S_olcxReferences *stack
        ) {
        S_olCompletion **place,*cc;
        char *ss,*nn, *fullnn, *vclnn;
        int i, category, scope, storage, slen, nlen;
        S_symbolRefItem sri;
        S_symbolRefItemBits srib;
        S_reference dref;
        { { int n = (1) * sizeof(S_olCompletion); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { cc = NULL; } else { cc = (S_olCompletion*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (cc==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_olCompletion); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { cc = NULL; } else { cc = (S_olCompletion*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        nlen = strlen(name);
        { { int n = (nlen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (nn==NULL) { freeOldestOlcx(); { int n = (nlen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { nn = NULL; } else { nn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        strcpy(nn, name);
        fullnn = NULL;
        if (fullText!=NULL) {
                { { int n = (strlen(fullText)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { fullnn = NULL; } else { fullnn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (fullnn==NULL) { freeOldestOlcx(); { int n = (strlen(fullText)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { fullnn = NULL; } else { fullnn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                strcpy(fullnn, fullText);
        }
        vclnn = NULL;
        if (vclass!=NULL) {
                { { int n = (strlen(vclass)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { vclnn = NULL; } else { vclnn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (vclnn==NULL) { freeOldestOlcx(); { int n = (strlen(vclass)+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { vclnn = NULL; } else { vclnn = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                strcpy(vclnn, vclass);
        }
        if (rr!=NULL) {
                slen = strlen(rr->name);
                { { int n = (slen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ss = NULL; } else { ss = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ss==NULL) { freeOldestOlcx(); { int n = (slen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ss = NULL; } else { ss = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                strcpy(ss, rr->name);
                { (&sri)->name = ss; (&sri)->fileHash = cxFileHashNumber(ss); (&sri)->vApplClass = rr->vApplClass; (&sri)->vFunClass = rr->vFunClass; (&sri)->b = rr->b; (&sri)->refs = NULL; (&sri)->next = NULL;};
                { (cc)->name = nn; (cc)->fullName = fullnn; (cc)->vclass = vclnn; (cc)->jindent = jindent; (cc)->lineCount = 1; (cc)->cat = rr->b.category; (cc)->csymType = cType; (cc)->ref = *dfref; (cc)->sym = sri; (cc)->next = NULL;};
        } else if (s==NULL) {
                dref = *dfref;
                dref.next = NULL;
                { (&srib)->symType = TypeUnknown; (&srib)->storage = StorageNone; (&srib)->scope = ScopeAuto; (&srib)->accessFlags = 0x000; (&srib)->category = CatLocal; (&srib)->htmlWasLn = 0;};
                { (&sri)->name = ""; (&sri)->fileHash = cxFileHashNumber(""); (&sri)->vApplClass = s_noneFileIndex; (&sri)->vFunClass = s_noneFileIndex; (&sri)->b = srib; (&sri)->refs = NULL; (&sri)->next = NULL;};
                { (cc)->name = nn; (cc)->fullName = fullnn; (cc)->vclass = vclnn; (cc)->jindent = jindent; (cc)->lineCount = 1; (cc)->cat = CatLocal; (cc)->csymType = cType; (cc)->ref = dref; (cc)->sym = sri; (cc)->next = NULL;};
        } else {
                getSymbolCxrefCategories(s, &category, &scope, &storage);
                slen = strlen(s->linkName);
                { { int n = (slen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ss = NULL; } else { ss = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (ss==NULL) { freeOldestOlcx(); { int n = (slen+1) * sizeof(char); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { ss = NULL; } else { ss = (char*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                strcpy(ss, s->linkName);
                { (&dref.usg)->base = UsageDefined; (&dref.usg)->requiredAccess = 0; (&dref.usg)->dummy = 0;};
                { (&dref)->usg = dref.usg; (&dref)->p = s->pos; (&dref)->next = NULL;};
                { (&srib)->symType = s->b.symType; (&srib)->storage = storage; (&srib)->scope = scope; (&srib)->accessFlags = s->b.accessFlags; (&srib)->category = category; (&srib)->htmlWasLn = 0;};
                { (&sri)->name = ss; (&sri)->fileHash = cxFileHashNumber(ss); (&sri)->vApplClass = vFunClass; (&sri)->vFunClass = vFunClass; (&sri)->b = srib; (&sri)->refs = NULL; (&sri)->next = NULL;};
                { (cc)->name = nn; (cc)->fullName = fullnn; (cc)->vclass = vclnn; (cc)->jindent = jindent; (cc)->lineCount = 1; (cc)->cat = category; (cc)->csymType = cType; (cc)->ref = dref; (cc)->sym = sri; (cc)->next = NULL;};
        }
        if (fullText!=NULL) {
                for(i=0; fullText[i]; i++) {
                        if (fullText[i] == '\n') cc->lineCount++;
                }
        }
        cc->next = stack->cpls;
        stack->cpls = cc;
        return(cc);
}
void olCompletionListReverse() {
        { register S_olCompletion *list,*tmp,*revlist; list = s_olcxCurrentUser->completionsStack.top->cpls; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } s_olcxCurrentUser->completionsStack.top->cpls = revlist;};
}
static int olTagSearchSortFunction(S_olCompletion *c1, S_olCompletion *c2) {
        return(strcmp(c1->name, c2->name) < 0);
}
static void tagSearchShortRemoveMultipleLines(S_olCompletion *list) {
        S_olCompletion *ll, *tmp;
        for(ll=list; ll!=NULL; ll=ll->next) {
        cont:
                if (ll->next!=NULL && strcmp(ll->name, ll->next->name)==0) {
                        tmp = ll->next;
                        ll->next = ll->next->next;
                        olcxFreeCompletion(tmp);
                        goto cont;
                }
        }
}
void tagSearchCompactShortResults() {
        { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "cxref.c", 5502);};
        { S_olCompletion *_macrores; _macrores = (s_olcxCurrentUser->retrieverStack.top->cpls); { S_olCompletion *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olTagSearchSortFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (s_olcxCurrentUser->retrieverStack.top->cpls) = _macrores;};
        if (s_opt.tagSearchSpecif==TSS_SEARCH_DEFS_ONLY_SHORT
                || s_opt.tagSearchSpecif==TSS_FULL_SEARCH_SHORT) {
                tagSearchShortRemoveMultipleLines(s_olcxCurrentUser->retrieverStack.top->cpls);
        }
}
void printTagSearchResults() {
        S_olCompletion *cc;
        int len1,len2,len3, len;
        char *ls;
        len1 = len2 = len3 = 0;
        tagSearchCompactShortResults();
        { if (!(s_olcxCurrentUser->retrieverStack.top)) internalCheckFail("s_olcxCurrentUser->retrieverStack.top", "cxref.c", 5517);};
        for(cc=s_olcxCurrentUser->retrieverStack.top->cpls; cc!=NULL; cc=cc->next) {
                ls = crTagSearchLineStatic(cc->name, &cc->ref.p,
                                                                   &len1, &len2, &len3);
        }
        if (s_opt.olineLen >= 50000) {
                if (len1 > MAX_TAG_SEARCH_INDENT) len1 = MAX_TAG_SEARCH_INDENT;
        } else {
                if (len1 > (s_opt.olineLen*MAX_TAG_SEARCH_INDENT_RATIO)/100) {
                        len1 = (s_opt.olineLen*MAX_TAG_SEARCH_INDENT_RATIO)/100;
                }
        }
        len = len1;
        if (s_opt.xref2) ppcGenRecordBegin(PPC_SYMBOL_LIST);
        { if (!(s_olcxCurrentUser->retrieverStack.top)) internalCheckFail("s_olcxCurrentUser->retrieverStack.top", "cxref.c", 5532);};
        for(cc=s_olcxCurrentUser->retrieverStack.top->cpls; cc!=NULL; cc=cc->next) {
                ls = crTagSearchLineStatic(cc->name, &cc->ref.p,
                                                                   &len1, &len2, &len3);
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_STRING_VALUE, ls, "\n");
                } else {
                        fprintf(ccOut,"%s\n", ls);
                }
                len1 = len;
        }
        if (s_opt.xref2) ppcGenRecordEnd(PPC_SYMBOL_LIST);
}
