
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
static S_editorUndo *s_refactoringStartPoint;
static int s_refactoryXrefEditSrvSubTaskFirstPassing = 1;
static char *s_refactoryEditSrvInitOptions[] = {
        "xref",
        "-xrefactory-II",
        "-task_regime_server",
        NULL,
};
static char *s_refactoryXrefInitOptions[] = {
        "xref",
        "-xrefactory-II",
        "-briefoutput",
        NULL,
};
static char *s_refactoryUpdateOption = "-fastupdate";
static int argnum(char **margv) {
        int res;
        char **aa;
        for(res=0, aa=margv; *margv!=NULL; res++,margv++) ;
        return(res);
}
int filter0(S_reference *rr, void *dummy) {
        if (rr->usg.base < UsageMaxOLUsages) return(1);
        return(0);
}
int filter1(S_reference *rr, void *dummy) {
        if (rr->usg.base < s_refListFilters[1]) return(1);
        return(0);
}
int filter2(S_reference *rr, void *dummy) {
        if (rr->usg.base < s_refListFilters[2]) return(1);
        return(0);
}
int filterBuffer(S_reference *rr, void *buffer) {
        S_editorBuffer *buff;
        buff = (S_editorBuffer *) buffer;
        if (rr->usg.base >= UsageMaxOLUsages) return(0);
        if (rr->p.file == buff->ftnum) return(1);
        return(0);
}
static void refactoringGenGUISynchronisation() {
}
static void refactorySetNargv(char *nargv[50],
                                                          S_editorBuffer *buf,
                                                          char *project,
                                                          S_editorMarker *point,
                                                          S_editorMarker *mark
        ) {
        static char optPoint[TMP_STRING_SIZE];
        static char optMark[TMP_STRING_SIZE];
        static char optXrefrc[MAX_FILE_NAME_SIZE];
        int i;
        i = 0;
        nargv[i] = "null";
        i++;
        if (s_ropt.xrefrc!=NULL) {
                sprintf(optXrefrc, "-xrefrc=%s", s_ropt.xrefrc);
                { if (!(strlen(optXrefrc)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(optXrefrc)+1 < MAX_FILE_NAME_SIZE", "refactory.c", 94);};
                nargv[i] = optXrefrc;
                i++;
        }
        if (s_ropt.eolConversion & 1) {
                nargv[i] = "-crlfconversion";
                i++;
        }
        if (s_ropt.eolConversion & 2) {
                nargv[i] = "-crconversion";
                i++;
        }
        if (project!=NULL) {
                nargv[i] = "-p";
                i++;
                nargv[i] = project;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 112);};
        if (point!=NULL) {
                sprintf(optPoint, "-olcursor=%d", point->offset);
                nargv[i] = optPoint;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 118);};
        if (mark!=NULL) {
                sprintf(optMark, "-olmark=%d", mark->offset);
                nargv[i] = optMark;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 124);};
        if (buf!=NULL) {
                { if (!(buf == point->buffer)) internalCheckFail("buf == point->buffer", "refactory.c", 127);};
                nargv[i] = buf->name;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 140);};
        if (s_ropt.user!=NULL) {
                nargv[i] = "-user";
                i++;
                nargv[i] = s_ropt.user;
                i++;
        }
        nargv[i] = NULL;
        i++;
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 150);};
}
static void dumpNargv(int argc, char **argv) {
        int i;
        tmpBuff[0]=0;
        for (i=0; i<argc; i++) {
                sprintf(tmpBuff+strlen(tmpBuff), " %s", argv[i]);
        }
        ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
}
static void refactoryUpdateReferences(char *project) {
        int i, nargc, refactoryXrefInitOptionsNum;
        S_editorBuffer bb;
        char *nargv[50];
        static S_options savedOptions;
        if (s_refactoryUpdateOption==NULL || *s_refactoryUpdateOption==0) {
                writeRelativeProgress(100);
                return;
        }
        ppcGenRecordBegin(PPC_UPDATE_REPORT);
        editorQuasySaveModifiedBuffers();
        copyOptions(&savedOptions, &s_opt);
        refactorySetNargv(nargv, NULL, project, NULL, NULL);
        nargc = argnum(nargv);
        refactoryXrefInitOptionsNum = argnum(s_refactoryXrefInitOptions);
        for(i=1; i<refactoryXrefInitOptionsNum; i++) {
                nargv[nargc++] = s_refactoryXrefInitOptions[i];
        }
        nargv[nargc++] = s_refactoryUpdateOption;
        s_currCppPass = (-1);
        mainTaskEntryInitialisations(nargc, nargv);
        mainCallXref(nargc, nargv);
        copyOptions(&s_opt, &savedOptions);
        ppcGenRecordEnd(PPC_UPDATE_REPORT);
        mainTaskEntryInitialisations(argnum(s_refactoryEditSrvInitOptions),
                                                                 s_refactoryEditSrvInitOptions);
        s_refactoryXrefEditSrvSubTaskFirstPassing = 1;
        return;
}
static void refactoryEditServerParseBuffer(char *project,
                                                                                   S_editorBuffer *buf,
                                                                                   S_editorMarker *point, S_editorMarker *mark,
                                                                                   char *pushOption, char *pushOption2
        ) {
        char *nargv[50];
        int nargc;
        s_currCppPass = (-1);
        { if (!(s_opt.taskRegime == RegimeEditServer)) internalCheckFail("s_opt.taskRegime == RegimeEditServer", "refactory.c", 228);};
        refactorySetNargv(nargv, buf, project, point, mark);
        nargc = argnum(nargv);
        if (pushOption!=NULL) {
                nargv[nargc++] = pushOption;
        }
        if (pushOption2!=NULL) {
                nargv[nargc++] = pushOption2;
        }
        mainCallEditServerInit(nargc, nargv);
        mainCallEditServer(argnum(s_refactoryEditSrvInitOptions),
                                           s_refactoryEditSrvInitOptions,
                                           nargc, nargv, &s_refactoryXrefEditSrvSubTaskFirstPassing);
}
static void refactoryBeInteractive() {
        int pargc;
        char **pargv;
        copyOptions(&s_cachedOptions, &s_opt);
        for(;;) {
                mainCloseOutputFile();
                ppcGenSynchroRecord();
                copyOptions(&s_opt, &s_cachedOptions);
                processOptions(argnum(s_refactoryEditSrvInitOptions),
                                           s_refactoryEditSrvInitOptions, INFILES_DISABLED);
                getPipedOptions(&pargc, &pargv);
                mainOpenOutputFile(s_ropt.outputFileName);
                if (pargc <= 1) break;
                mainCallEditServerInit(pargc, pargv);
                if (s_opt.continueRefactoring) break;
                mainCallEditServer(argnum(s_refactoryEditSrvInitOptions),
                                                   s_refactoryEditSrvInitOptions,
                                                   pargc, pargv, &s_refactoryXrefEditSrvSubTaskFirstPassing);
                mainAnswerEditAction();
        }
}
void refactoryDisplayResolutionDialog(char *message,int messageType,int continuation) {
        int pargc;
        char **pargv;
        strcpy(tmpBuff, message);
        formatOutputLine(tmpBuff, 10);
        ppcGenDisplaySelectionRecord(tmpBuff, messageType, continuation);
        refactoryBeInteractive();
}
static void refactoryPushReferences(S_editorBuffer *buf, S_editorMarker *point,
                                                                        char *pushOption, char *resolveMessage,
                                                                        int messageType
        ) {
        refactoryEditServerParseBuffer( s_ropt.project, buf, point,NULL, pushOption,NULL);
        { if (!(s_olcxCurrentUser!=NULL && s_olcxCurrentUser->browserStack.top!=NULL)) internalCheckFail("s_olcxCurrentUser!=NULL && s_olcxCurrentUser->browserStack.top!=NULL", "refactory.c", 293);};
        if (s_olcxCurrentUser->browserStack.top->hkSelectedSym==NULL) {
                error(ERR_INTERNAL, "no symbol found for refactoring push");
        }
        olCreateSelectionMenu(s_olcxCurrentUser->browserStack.top->command);
        if (resolveMessage!=NULL && olcxShowSelectionMenu()) {
                refactoryDisplayResolutionDialog( resolveMessage, messageType,CONTINUATION_ENABLED);
        }
}
static void refactorySafetyCheck(char *project, S_editorBuffer *buf, S_editorMarker *point) {
        refactoryUpdateReferences(s_ropt.project);
        refactoryEditServerParseBuffer( project, buf, point,NULL, "-olcxsafetycheck2",NULL);
        { if (!(s_olcxCurrentUser!=NULL && s_olcxCurrentUser->browserStack.top!=NULL)) internalCheckFail("s_olcxCurrentUser!=NULL && s_olcxCurrentUser->browserStack.top!=NULL", "refactory.c", 308);};
        if (s_olcxCurrentUser->browserStack.top->hkSelectedSym==NULL) {
                error(ERR_ST, "No symbol found for refactoring safety check");
        }
        olCreateSelectionMenu(s_olcxCurrentUser->browserStack.top->command);
        if (safetyCheck2ShouldWarn()) {
                if (((s_language & (4)) != 0)) {
                        sprintf(tmpBuff, "This is class hierarchy of given symbol as it will appear after the refactoring. It does not corresponf to the hierarchy before the refactoring. It is probable that the refactoring will not be behaviour preserving. If you are not sure about your action, you should abandon this refactoring!");
                } else {
                        sprintf(tmpBuff, "Those symbols will be refererred at this place after the refactoring. It is probable that the refactoring will not be behaviour preserving. If you are not sure about your action, you should abandon this refactoring!");
                }
                refactoryDisplayResolutionDialog(tmpBuff, PPCV_BROWSER_TYPE_WARNING,CONTINUATION_ENABLED);
        }
}
static char *refactoryGetIdentifierOnMarker_st(S_editorMarker *pos) {
        S_editorBuffer *buff;
        char *s, *e, *smax, *smin;
        static char res[TMP_STRING_SIZE];
        int reslen;
        buff = pos->buffer;
        { if (!(buff && buff->a.text && pos->offset<=buff->a.bufferSize)) internalCheckFail("buff && buff->a.text && pos->offset<=buff->a.bufferSize", "refactory.c", 329);};
        s = buff->a.text + pos->offset;
        smin = buff->a.text;
        smax = buff->a.text + buff->a.bufferSize;
        for(; s>=smin && (isalpha(*s) || isdigit(*s) || *s=='_' || *s=='$'); s--) ;
        for(s++; s<smax && isdigit(*s); s++) ;
        for(e=s; e<smax && (isalpha(*e) || isdigit(*e) || *e=='_' || *e=='$'); e++) ;
        reslen = e-s;
        { if (!(reslen < TMP_STRING_SIZE-1)) internalCheckFail("reslen < TMP_STRING_SIZE-1", "refactory.c", 339);};
        strncpy(res, s, reslen);
        res[reslen] = 0;
        return(res);
}
static void refactoryReplaceString(S_editorMarker *pos, int len, char *newVal) {
        char *bVal;
        bVal = pos->buffer->a.text + pos->offset;
        editorReplaceString(pos->buffer, pos->offset, len,
                                                newVal, strlen(newVal), &s_editorUndo);
}
static void refactoryCheckedReplaceString(S_editorMarker *pos, int len,
                                                                                  char *oldVal, char *newVal) {
        char *bVal;
        int check, i, d;
        bVal = pos->buffer->a.text + pos->offset;
        check = (strlen(oldVal)==len && strncmp(oldVal, bVal, len) == 0);
        if (check) {
                refactoryReplaceString(pos, len, newVal);
        } else {
                sprintf(tmpBuff, "checked replacement of %s to %s failed on ", oldVal, newVal);
                d = strlen(tmpBuff);
                for(i=0; i<len; i++) tmpBuff[d++] = bVal[i];
                tmpBuff[d++]=0;
                error(ERR_INTERNAL, tmpBuff);
        }
}
static void editorFreeSingleUndo(S_editorUndo *uu) {
        if (uu->u.replace.str!=NULL && uu->u.replace.strlen!=0) {
                switch (uu->operation) {
                case UNDO_REPLACE_STRING:
                        { {}; olcxMemoryAllocatedBytes -= uu->u.replace.strlen+1; free(uu->u.replace.str);};
                        break;
                case UNDO_RENAME_BUFFER:
                        { {}; olcxMemoryAllocatedBytes -= strlen(uu->u.rename.name)+1; free(uu->u.rename.name);};
                        break;
                case UNDO_MOVE_BLOCK:
                        break;
                default:
                        error(ERR_INTERNAL,"Unknown operation to undo");
                }
        }
        { {}; olcxMemoryAllocatedBytes -= sizeof(S_editorUndo); free(uu);};
}
static void editorFreeUndos(S_editorUndo *undos) {
        S_editorUndo *uu, *next;
        uu=undos;
        while (uu!=NULL) {
                next = uu->next;
                editorFreeSingleUndo(uu);
                uu = next;
        }
}
void editorApplyUndos(S_editorUndo *undos, S_editorUndo *until,
                                          S_editorUndo **undoundo, int gen) {
        S_editorUndo *uu, *next;
        S_editorMarker *m1, *m2;
        uu = undos;
        while (uu!=until && uu!=NULL) {
                switch (uu->operation) {
                case UNDO_REPLACE_STRING:
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenReplaceRecord(uu->buffer->name, uu->u.replace.offset,
                                                                        uu->buffer->a.text+uu->u.replace.offset,
                                                                        uu->u.replace.size, uu->u.replace.str);
                        }
                        editorReplaceString(uu->buffer, uu->u.replace.offset, uu->u.replace.size,
                                                                uu->u.replace.str, uu->u.replace.strlen, undoundo);
                        break;
                case UNDO_RENAME_BUFFER:
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenGotoOffsetPosition(uu->buffer->name, 0);
                                ppcGenRecord(PPC_MOVE_FILE_AS, uu->u.rename.name, "\n");
                        }
                        editorRenameBuffer(uu->buffer, uu->u.rename.name, undoundo);
                        break;
                case UNDO_MOVE_BLOCK:
                        m1 = editorCrNewMarker(uu->buffer, uu->u.moveBlock.offset);
                        m2 = editorCrNewMarker(uu->u.moveBlock.dbuffer, uu->u.moveBlock.doffset);
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenGotoMarkerRecord(m1);
                                ppcGenNumericRecord(PPC_REFACTORING_CUT_BLOCK,uu->u.moveBlock.size,"","\n");
                        }
                        editorMoveBlock(m2, m1, uu->u.moveBlock.size, undoundo);
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenGotoMarkerRecord(m1);
                                ppcGenRecord(PPC_REFACTORING_PASTE_BLOCK, "", "\n");
                        }
                        editorFreeMarker(m2);
                        editorFreeMarker(m1);
                        break;
                default:
                        error(ERR_INTERNAL,"Unknown operation to undo");
                }
                next = uu->next;
                editorFreeSingleUndo(uu);
                uu = next;
        }
        { if (!(uu==until)) internalCheckFail("uu==until", "refactory.c", 445);};
}
void editorUndoUntil(S_editorUndo *until, S_editorUndo **undoundo) {
        editorApplyUndos(s_editorUndo, until, undoundo, GEN_NO_OUTPUT);
        s_editorUndo = until;
}
static void refactoryAplyWholeRefactoringFromUndo() {
        S_editorUndo *redoTrack;
        redoTrack = NULL;
        editorUndoUntil(s_refactoringStartPoint, &redoTrack);
        editorApplyUndos(redoTrack, NULL, NULL, GEN_FULL_OUTPUT);
}
static void refactoryFatalErrorOnPosition(S_editorMarker *p, int errType, char *message) {
        S_editorUndo *redo;
        redo = NULL;
        editorUndoUntil(s_refactoringStartPoint, &redo);
        ppcGenGotoMarkerRecord(p);
        fatalError(errType, message, 65);
        editorApplyUndos(redo, NULL, &s_editorUndo, GEN_NO_OUTPUT);
}
static void refactoryRemoveNonCommentCode(S_editorMarker *m, int len) {
        int c, nn, n;
        char *s;
        S_editorMarker *mm;
        { if (!(m->buffer && m->buffer->a.text)) internalCheckFail("m->buffer && m->buffer->a.text", "refactory.c", 476);};
        s = m->buffer->a.text + m->offset;
        nn = len;
        mm = editorCrNewMarker(m->buffer, m->offset);
        if (m->offset + nn > m->buffer->a.bufferSize) {
                nn = m->buffer->a.bufferSize - m->offset;
        }
        n = 0;
        while(nn>0) {
                c = *s;
                if (c=='/' && nn>1 && *(s+1)=='*' && (nn<=2 || *(s+2)!='&')) {
                        refactoryReplaceString(mm, n, "");
                        s = mm->buffer->a.text + mm->offset;
                        s += 2; nn -= 2;
                        while (! (*s=='*' && *(s+1)=='/')) {s++; nn--;}
                        s += 2; nn -= 2;
                        mm->offset = s - mm->buffer->a.text;
                        n = 0;
                } else if (c=='/' && nn>1 && *(s+1)=='/' && (nn<=2 || *(s+2)!='&')) {
                        refactoryReplaceString(mm, n, "");
                        s = mm->buffer->a.text + mm->offset;
                        s += 2; nn -= 2;
                        while (*s!='\n') {s++; nn--;}
                        s += 1; nn -= 1;
                        mm->offset = s - mm->buffer->a.text;
                        n = 0;
                } else if (c=='"') {
                        s++; nn--; n++;
                        while (*s!='"' && nn>0) {
                                s++; nn--; n++;
                                if (*s=='\\') {
                                        s++; nn--; n++;
                                        s++; nn--; n++;
                                }
                        }
                } else {
                        s++; nn--; n++;
                }
        }
        if (n>0) {
                refactoryReplaceString(mm, n, "");
        }
        editorFreeMarker(mm);
}
static void refactoryMoveMarkerToTheEndOfDefinitionScope(S_editorMarker *mm) {
        int offset;
        offset = mm->offset;
        editorMoveMarkerToNonBlankOrNewline(mm, 1);
        if (mm->offset >= mm->buffer->a.bufferSize) {
                return;
        }
        if ((*(mm->buffer->a.text+mm->offset))=='/' && (*(mm->buffer->a.text+mm->offset+1))=='/') {
                if (s_ropt.commentMovingLevel == CM_NO_COMMENT) return;
                editorMoveMarkerToNewline(mm, 1);
                mm->offset ++;
        } else if ((*(mm->buffer->a.text+mm->offset))=='/' && (*(mm->buffer->a.text+mm->offset+1))=='*') {
                if (s_ropt.commentMovingLevel == CM_NO_COMMENT) return;
                mm->offset ++; mm->offset ++;
                while (mm->offset<mm->buffer->a.bufferSize &&
                           ((*(mm->buffer->a.text+mm->offset))!='*' || (*(mm->buffer->a.text+mm->offset+1))!='/')) {
                        mm->offset++;
                }
                if (mm->offset<mm->buffer->a.bufferSize) {
                        mm->offset ++;
                        mm->offset ++;
                }
                offset = mm->offset;
                editorMoveMarkerToNonBlankOrNewline(mm, 1);
                if ((*(mm->buffer->a.text+mm->offset))=='\n') mm->offset ++;
                else mm->offset = offset;
        } else if ((*(mm->buffer->a.text+mm->offset))=='\n') {
                mm->offset ++;
        } else {
                if (s_ropt.commentMovingLevel == CM_NO_COMMENT) return;
                mm->offset = offset;
        }
}
static int refactoryMarkerWRTCommentary(S_editorMarker *mm, int *comBeginOffset) {
        char *b, *s, *e, *mms;
        { if (!(mm->buffer && mm->buffer->a.text)) internalCheckFail("mm->buffer && mm->buffer->a.text", "refactory.c", 562);};
        s = mm->buffer->a.text;
        e = s + mm->buffer->a.bufferSize;
        mms = s + mm->offset;
        while(s<e && s<mms) {
                b = s;
                if (*s=='/' && (s+1)<e && *(s+1)=='*') {
                        s += 2;
                        while ((s+1)<e && ! (*s=='*' && *(s+1)=='/')) s++;
                        if (s+1<e) s += 2;
                        if (s>mms) {
                                *comBeginOffset = b-mm->buffer->a.text;
                                return(MARKER_IS_IN_STAR_COMMENT);
                        }
                } else if (*s=='/' && s+1<e && *(s+1)=='/') {
                        s += 2;
                        while (s<e && *s!='\n') s++;
                        if (s<e) s += 1;
                        if (s>mms) {
                                *comBeginOffset = b-mm->buffer->a.text;
                                return(MARKER_IS_IN_SLASH_COMMENT);
                        }
                } else if (*s=='"') {
                        s++;
                        while (s<e && *s!='"') {
                                s++;
                                if (*s=='\\') { s++; s++; }
                        }
                        if (s<e) s++;
                } else {
                        s++;
                }
        }
        return(MARKER_IS_IN_CODE);
}
static void refactoryMoveMarkerToTheBeginOfDefinitionScope(S_editorMarker *mm) {
        int theBeginningOffset, comBeginOffset, mp;
        int slashedCommentsProcessed, staredCommentsProcessed;
        slashedCommentsProcessed = staredCommentsProcessed = 0;
        for(;;) {
                theBeginningOffset = mm->offset;
                mm->offset --;
                editorMoveMarkerToNonBlankOrNewline(mm, -1);
                if ((*(mm->buffer->a.text+mm->offset))=='\n') {
                        theBeginningOffset = mm->offset+1;
                        mm->offset --;
                }
                if (s_ropt.commentMovingLevel == CM_NO_COMMENT) goto fini;
                editorMoveMarkerToNonBlank(mm, -1);
                mp = refactoryMarkerWRTCommentary(mm, &comBeginOffset);
                if (mp == MARKER_IS_IN_CODE) goto fini;
                else if (mp == MARKER_IS_IN_STAR_COMMENT) {
                        if (s_ropt.commentMovingLevel == CM_SINGLE_SLASHED) goto fini;
                        if (s_ropt.commentMovingLevel == CM_ALL_SLASHED) goto fini;
                        if (staredCommentsProcessed>0 && s_ropt.commentMovingLevel==CM_SINGLE_STARED) goto fini;
                        if (staredCommentsProcessed>0 && s_ropt.commentMovingLevel==CM_SINGLE_SLASHED_AND_STARED) goto fini;
                        staredCommentsProcessed ++;
                        mm->offset = comBeginOffset;
                }
                else if (mp == MARKER_IS_IN_SLASH_COMMENT) {
                        if (s_ropt.commentMovingLevel == CM_SINGLE_STARED) goto fini;
                        if (s_ropt.commentMovingLevel == CM_ALL_STARED) goto fini;
                        if (slashedCommentsProcessed>0 && s_ropt.commentMovingLevel==CM_SINGLE_SLASHED) goto fini;
                        if (slashedCommentsProcessed>0 && s_ropt.commentMovingLevel==CM_SINGLE_SLASHED_AND_STARED) goto fini;
                        slashedCommentsProcessed ++;
                        mm->offset = comBeginOffset;
                } else {
                        warning(ERR_INTERNAL, "A new commentary?");
                        goto fini;
                }
        }
 fini:
        mm->offset = theBeginningOffset;
}
static void refactoryRenameTo(S_editorMarker *pos, char *oldName, char *newName) {
        char *actName;
        int nlen;
        nlen = strlen(oldName);
        actName = refactoryGetIdentifierOnMarker_st(pos);
        { if (!(strcmp(actName, oldName)==0)) internalCheckFail("strcmp(actName, oldName)==0", "refactory.c", 648);};
        refactoryCheckedReplaceString(pos, nlen, oldName, newName);
}
static S_editorMarker *refactoryPointMark(S_editorBuffer *buf, int offset) {
        S_editorMarker *point;
        point = NULL;
        if (offset >= 0) {
                point = editorCrNewMarker(buf, offset);
        }
        return(point);
}
static S_editorMarker *refactoryGetPointFromRefactoryOptions(S_editorBuffer *buf) {
        { if (!(buf)) internalCheckFail("buf", "refactory.c", 661);};
        return(refactoryPointMark(buf, s_ropt.olCursorPos));
}
static S_editorMarker *refactoryGetMarkFromRefactoryOptions(S_editorBuffer *buf) {
        { if (!(buf)) internalCheckFail("buf", "refactory.c", 665);};
        return(refactoryPointMark(buf, s_ropt.olMarkPos));
}
static void refactoryPushMarkersAsReferences(S_editorMarkerList **markers,
                                                                                         S_olcxReferences *refs, char *sym) {
        S_olSymbolsMenu *mm;
        S_reference *r, *rr;
        rr = editorMarkersToReferences(markers);
        for(mm=refs->menuSym; mm!=NULL; mm=mm->next) {
                if (strcmp(mm->s.name, sym)==0) {
                        for(r=rr; r!=NULL; r=r->next) {
                                olcxAddReference(&mm->s.refs, r, 0);
                        }
                }
        }
        olcxFreeReferences(rr);
        olcxRecomputeSelRefs(refs);
}
static int validTargetPlace(S_editorMarker *target, char *checkOpt) {
        int res;
        res = 1;
        refactoryEditServerParseBuffer(s_ropt.project, target->buffer, target,NULL, checkOpt, NULL);
        if (!s_cps.moveTargetApproved) {
                res = 0;
                error(ERR_ST, "Invalid target place");
        }
        return(res);
}
static S_olSymbolsMenu *javaGetRelevantHkSelectedItem(S_symbolRefItem *ri) {
        S_olSymbolsMenu *ss;
        S_olcxReferences *rstack;
        rstack = s_olcxCurrentUser->browserStack.top;
        for(ss=rstack->hkSelectedSym; ss!=NULL; ss=ss->next) {
                if (itIsSameCxSymbol(ri, &ss->s)
                        && ri->vFunClass == ss->s.vFunClass) {
                        break;
                }
        }
        return(ss);
}
static void tpCheckFutureAccOfLocalReferences(S_symbolRefItem *ri, void *ddd) {
        S_reference *rr;
        S_olcxReferences *rstack;
        S_tpCheckMoveClassData *dd;
        char symclass[MAX_FILE_NAME_SIZE];
        int sclen, symclen;
        S_position *defpos;
    int defusage;
        S_olSymbolsMenu *ss;
        dd = (S_tpCheckMoveClassData *) ddd;
        { if (! isPushAllMethodsValidRefItem(ri)) return; if (ri->b.storage!=StorageField && ri->b.storage!=StorageMethod && ri->b.storage!=StorageConstructor) return; if (ri->b.accessFlags & 0x001) return; if (ri->b.accessFlags & 0x004) return; if (! (ri->b.accessFlags & 0x002)) { if (! dd->transPackageMove) return; }};
        ss = javaGetRelevantHkSelectedItem(ri);
        if (ss!=NULL) {
                for(rr=ri->refs; rr!=NULL; rr=rr->next) {
                        if (rr->p.file == s_input_file_number) {
                                if ((! ( ((char*)rr) >= ((char*)&cxMemory->b) + (dd->mm.minMemi) && ((char*)rr) < ((char*)&cxMemory->b) + (dd->mm.maxMemi) ))
                                        && ((rr)->usg.base < UsageMaxOLUsages)) {
                                        ss->selected = ss->visible = 1;
                                        break;
                                }
                        }
                }
        }
}
static void tpCheckMoveClassPutClassDefaultSymbols(S_symbolRefItem *ri, void *ddd) {
        S_reference *rr;
        S_olcxReferences *rstack;
        S_tpCheckMoveClassData *dd;
        char symclass[MAX_FILE_NAME_SIZE];
        int sclen, symclen;
        S_position *defpos;
    int defusage;
        dd = (S_tpCheckMoveClassData *) ddd;
        { if (! isPushAllMethodsValidRefItem(ri)) return; if (ri->b.storage!=StorageField && ri->b.storage!=StorageMethod && ri->b.storage!=StorageConstructor) return; if (ri->b.accessFlags & 0x001) return; if (ri->b.accessFlags & 0x004) return; if (! (ri->b.accessFlags & 0x002)) { if (! dd->transPackageMove) return; }};
        for(rr=ri->refs; rr!=NULL; rr=rr->next) {
                if (( ( ((char*)rr) >= ((char*)&cxMemory->b) + (((&dd->mm))->minMemi) && ((char*)rr) < ((char*)&cxMemory->b) + (((&dd->mm))->maxMemi) ) && ((rr)->usg.base < UsageMaxOLUsages) && rr->p.file != s_noneFileIndex && rr->p.file == s_input_file_number )) {
                        if (( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared )) {
                                rstack = s_olcxCurrentUser->browserStack.top;
                                olAddBrowsedSymbol(ri, &rstack->hkSelectedSym, 1, 1,
                                                                   0, UsageUsed, 0, &rr->p, rr->usg.base);
                                break;
                        }
                }
        }
}
static void tpCheckFutureAccessibilitiesOfSymbolsDefinedInsideMovedClass(
        S_tpCheckMoveClassData dd
        ) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss, **sss, *mm;
        S_reference *rr;
        int foundOutsideReference;
        rstack = s_olcxCurrentUser->browserStack.top;
        rstack->hkSelectedSym = olCreateSpecialMenuItem(
                "  Symbols Inaccessible After Class Moving", s_noneFileIndex, StorageDefault);
        refTabMap2(&s_cxrefTab, tpCheckMoveClassPutClassDefaultSymbols, &dd);
        olCreateSelectionMenu(rstack->command);
        for(ss=rstack->hkSelectedSym; ss!=NULL; ss=ss->next) {
                ss->selected = ss->visible = 0;
        }
        refTabMap2(&s_cxrefTab, tpCheckFutureAccOfLocalReferences, &dd);
        for(mm=rstack->menuSym; mm!=NULL; mm=mm->next) {
                ss = javaGetRelevantHkSelectedItem(&mm->s);
                if (ss!=NULL && (! ss->selected)) {
                        for(rr=mm->s.refs; rr!=NULL; rr=rr->next) {
                                if (rr->p.file != s_input_file_number) {
                                        ss->selected = ss->visible = 1;
                                        goto nextsym;
                                }
                        }
                }
        nextsym:;
        }
        sss= &rstack->menuSym;
        while (*sss!=NULL) {
                ss = javaGetRelevantHkSelectedItem(&(*sss)->s);
                if (ss!=NULL && ss->selected) {
                        sss= &(*sss)->next;
                } else {
                        *sss = olcxFreeSymbolMenuItem(*sss);
                }
        }
}
static void tpCheckDefaultAccessibilitiesMoveClass(S_symbolRefItem *ri, void *ddd) {
        S_reference *rr;
        S_olcxReferences *rstack;
        S_tpCheckMoveClassData *dd;
        char symclass[MAX_FILE_NAME_SIZE];
        int sclen, symclen;
        dd = (S_tpCheckMoveClassData *) ddd;
        { if (! isPushAllMethodsValidRefItem(ri)) return; if (ri->b.storage!=StorageField && ri->b.storage!=StorageMethod && ri->b.storage!=StorageConstructor) return; if (ri->b.accessFlags & 0x001) return; if (ri->b.accessFlags & 0x004) return; if (! (ri->b.accessFlags & 0x002)) { if (! dd->transPackageMove) return; }};
        javaGetClassNameFromFileNum(ri->vFunClass, symclass, 0);
        sclen = strlen(dd->sclass);
        symclen = strlen(symclass);
        if (sclen<=symclen && fnnCmp(dd->sclass, symclass, sclen)==0) return;
        for(rr=ri->refs; rr!=NULL; rr=rr->next) {
                if (( ( ((char*)rr) >= ((char*)&cxMemory->b) + (((&dd->mm))->minMemi) && ((char*)rr) < ((char*)&cxMemory->b) + (((&dd->mm))->maxMemi) ) && ((rr)->usg.base < UsageMaxOLUsages) && rr->p.file != s_noneFileIndex && rr->p.file == s_input_file_number )) {
                        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 833);};
                        rstack = s_olcxCurrentUser->browserStack.top;
                        olcxAddReference(&rstack->r, rr, 0);
                        break;
                }
        }
}
void tpCheckFillMoveClassData(S_tpCheckMoveClassData *dd,
                                                          char *spack, char *tpack
        ) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *sclass;
        char *targetfile, *srcfile;
        int transPackageMove;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 848);};
        rstack = s_olcxCurrentUser->browserStack.top;
        sclass = rstack->hkSelectedSym;
        { if (!(sclass)) internalCheckFail("sclass", "refactory.c", 851);};
        targetfile = s_opt.moveTargetFile;
        { if (!(targetfile)) internalCheckFail("targetfile", "refactory.c", 853);};
        srcfile = s_input_file_name;
        { if (!(srcfile)) internalCheckFail("srcfile", "refactory.c", 855);};
        javaGetPackageNameFromSourceFileName(srcfile, spack);
        javaGetPackageNameFromSourceFileName(targetfile, tpack);
        if (fnCmp(spack, tpack)==0) transPackageMove = 0;
        else transPackageMove = 1;
        { (dd)->mm.minMemi = s_cps.cxMemiAtClassBeginning; (dd)->mm.maxMemi = s_cps.cxMemiAtClassEnd; (dd)->spack = spack; (dd)->tpack = tpack; (dd)->transPackageMove = transPackageMove; (dd)->sclass = sclass->s.name;};
}
int tpCheckMoveClassAccessibilities() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *sclass, *ss, **sss;
        S_reference *rr;
        char *targetfile, *srcfile;
        S_tpCheckMoveClassData dd;
        char spack[MAX_FILE_NAME_SIZE];
        char tpack[MAX_FILE_NAME_SIZE];
        int transPackageMove;
        tpCheckFillMoveClassData(&dd, spack, tpack);
        olcxPushSpecialCheckMenuSym(s_opt.cxrefs,"  Symbols Inaccessible After Class Moving");
        refTabMap2(&s_cxrefTab, tpCheckDefaultAccessibilitiesMoveClass, &dd);
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 883);};
        rstack = s_olcxCurrentUser->browserStack.top;
        if (rstack->r!=NULL) {
                ss = rstack->menuSym;
                { if (!(ss)) internalCheckFail("ss", "refactory.c", 887);};
                ss->s.refs = olcxCopyRefList(rstack->r);
                rstack->act = rstack->r;
                if (s_ropt.refactoringRegime==RegimeRefactory) {
                        int firstPassing = 1;
                        refactoryDisplayResolutionDialog(
                                "Those references inside moved class are refering to symbols which will be  inaccessible  at  new  class  location. You  should  adjust  their accessibilities first.  (Each symbol is listed only once)",
                                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_DISABLED);
                        refactoryAskForReallyContinueConfirmation();
                }
                return(0);
        }
        olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
        olcxPushEmptyStackItem(&s_olcxCurrentUser->browserStack);
        tpCheckFutureAccessibilitiesOfSymbolsDefinedInsideMovedClass(dd);
        rstack = s_olcxCurrentUser->browserStack.top;
        if (rstack->menuSym!=NULL) {
                olcxRecomputeSelRefs(rstack);
                rstack->refsFilterLevel = RFilterDefinitions;
                if (s_ropt.refactoringRegime==RegimeRefactory) {
                        int firstPassing = 1;
                        refactoryDisplayResolutionDialog(
                                "Those symbols  defined inside moved  class and used outside  the class will be inaccessible  at new class location.  You  should adjust their accessibilities first.",
                                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_DISABLED);
                        refactoryAskForReallyContinueConfirmation();
                }
                return(0);
        }
        olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
        return(1);
}
int tpCheckSourceIsNotInnerClass() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        char *target;
        int thisclassi,deii;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 940);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 943);};
        thisclassi = getClassNumFromClassLinkName(ss->s.name, s_noneFileIndex);
        { if (!(s_fileTab.tab[thisclassi])) internalCheckFail("s_fileTab.tab[thisclassi]", "refactory.c", 948);};
        deii = s_fileTab.tab[thisclassi]->directEnclosingInstance;
        if (deii != -1 && deii != s_noneFileIndex && (ss->s.b.accessFlags&0x200)==0) {
                sprintf(tmpBuff, "This is  an inner class. Current  version of Xrefactory  can only move nested classes declared  'static' and top level classes.  If the class does  not depend  on its  enclosing instances,  you should  declare it 'static' and move it after.");
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
static void tpCheckSpecialReferencesMapFun(S_symbolRefItem *ri,
                                                                                                                void *ddd
        ) {
        S_reference *rr;
        S_tpCheckSpecialReferencesData *dd;
        S_chReference *cl;
        int scl;
        dd = (S_tpCheckSpecialReferencesData *) ddd;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 968);};
        if (strcmp(ri->name, dd->symbolToTest)!=0) return;
        for(rr=ri->refs; rr!=NULL; rr=rr->next) {
                if (( ((char*)rr) >= ((char*)&cxMemory->b) + (dd->mm.minMemi) && ((char*)rr) < ((char*)&cxMemory->b) + (dd->mm.maxMemi) ) ){
                        dd->foundSpecialRefItem = ri;
                        dd->foundSpecialR = rr;
                        if (ri->vFunClass == dd->classToTest) {
                                dd->foundRefToTestedClass = ri;
                        } else {
                                dd->foundRefNotToTestedClass = ri;
                        }
                        if (rr->usg.base == UsageMaybeQualifiedThis) {
                                dd->foundOuterScopeRef = rr;
                        }
                }
        }
}
static int tpCheckSuperMethodReferencesInit(S_tpCheckSpecialReferencesData *rr) {
        S_olSymbolsMenu *ss;
        S_chReference *cl;
        int scl;
        S_olcxReferences *rstack;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 997);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1000);};
        scl = javaGetSuperClassNumFromClassNum(ss->s.vApplClass);
        if (scl == s_noneFileIndex) {
                error(ERR_ST, "no super class, something is going wrong");
                return(0);
        }
        { (rr)->mm.minMemi = s_cps.cxMemiAtMethodBeginning; (rr)->mm.maxMemi = s_cps.cxMemiAtMethodEnd; (rr)->symbolToTest = "  \"super\" dot method references"; (rr)->classToTest = scl; (rr)->foundSpecialRefItem = NULL; (rr)->foundSpecialR = NULL; (rr)->foundRefToTestedClass = NULL; (rr)->foundRefNotToTestedClass = NULL; (rr)->foundOuterScopeRef = NULL;};
        refTabMap2(&s_cxrefTab, tpCheckSpecialReferencesMapFun, rr);
        return(1);
}
int tpCheckSuperMethodReferencesForPullUp() {
        S_tpCheckSpecialReferencesData rr;
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        int tmp;
        char tt[TMP_STRING_SIZE];
        char ttt[MAX_CX_SYMBOL_SIZE];
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1021);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1024);};
        tmp = tpCheckSuperMethodReferencesInit(&rr);
        if (! tmp) return(0);
        if (rr.foundRefToTestedClass!=NULL) {
                linkNamePrettyPrint(ttt, ss->s.name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
                javaGetClassNameFromFileNum(rr.foundRefToTestedClass->vFunClass, tt, DOTIFY_NAME);
                sprintf(tmpBuff,"'%s' invokes another method using the keyword \"super\" and this invocation is refering to class '%s', i.e. to the class where '%s' will be moved. In consequence, it is not possible to ensure behaviour preseving pulling-up of this method.", ttt, tt, ttt);
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
int tpCheckSuperMethodReferencesAfterPushDown() {
        S_tpCheckSpecialReferencesData rr;
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        int tmp;
        char tt[TMP_STRING_SIZE];
        char ttt[MAX_CX_SYMBOL_SIZE];
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1046);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1049);};
        tmp = tpCheckSuperMethodReferencesInit(&rr);
        if (! tmp) return(0);
        if (rr.foundRefToTestedClass!=NULL) {
                linkNamePrettyPrint(ttt, ss->s.name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
                sprintf(tmpBuff,"'%s' invokes another method using the keyword \"super\" and the invoked method is also defined in current class. After pushing down, the reference will be misrelated. In consequence, it is not possible to ensure behaviour preseving pushing-down of this method.", ttt);
                formatOutputLine(tmpBuff, 10);
                fprintf(ccOut,":[warning] %s", tmpBuff);
                return(0);
        }
        return(1);
}
int tpCheckSuperMethodReferencesForDynToSt() {
        S_tpCheckSpecialReferencesData rr;
        int tmp;
        tmp = tpCheckSuperMethodReferencesInit(&rr);
        if (! tmp) return(0);
        if (rr.foundSpecialRefItem!=NULL) {
                if (s_opt.xref2) ppcGenGotoPositionRecord(&rr.foundSpecialR->p);
                sprintf(tmpBuff,"This method invokes another method using the keyword \"super\". Current version of Xrefactory does not know how to make it static.");
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                return(0);
        }
        return(1);
}
int tpCheckOuterScopeUsagesForDynToSt() {
        S_tpCheckSpecialReferencesData rr;
        S_olSymbolsMenu *ss;
        S_olcxReferences *rstack;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1084);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1087);};
        { (&rr)->mm.minMemi = s_cps.cxMemiAtMethodBeginning; (&rr)->mm.maxMemi = s_cps.cxMemiAtMethodEnd; (&rr)->symbolToTest = "  method's \"maybe this\" dependencies"; (&rr)->classToTest = ss->s.vApplClass; (&rr)->foundSpecialRefItem = NULL; (&rr)->foundSpecialR = NULL; (&rr)->foundRefToTestedClass = NULL; (&rr)->foundRefNotToTestedClass = NULL; (&rr)->foundOuterScopeRef = NULL;};
        refTabMap2(&s_cxrefTab, tpCheckSpecialReferencesMapFun, &rr);
        if (rr.foundOuterScopeRef!=NULL) {
                sprintf(tmpBuff,"Inner class method is using symbols from outer scope. Current version of Xrefactory does not know how to make it static.");
                if (s_opt.xref2) {
                        ppcGenGotoPositionRecord(&rr.foundOuterScopeRef->p);
                        formatOutputLine(tmpBuff, 10);
                        ppcGenRecord(PPC_ERROR, tmpBuff, "\n");
                } else {
                        fprintf(ccOut, ":[warning] %s", tmpBuff);
                }
                return(0);
        }
        return(1);
}
int tpCheckMethodReferencesWithApplOnSuperClassForPullUp() {
        S_olcxReferences *rstack;
        S_reference *rr;
        S_olSymbolsMenu *ss,*mm;
        S_symbol *target;
        int targetcn, srccn;
        char ttt[MAX_CX_SYMBOL_SIZE];
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1120);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1123);};
        srccn = ss->s.vApplClass;
        target = getMoveTargetClass();
        { if (!(target!=NULL && target->u.s)) internalCheckFail("target!=NULL && target->u.s", "refactory.c", 1126);};
        targetcn = target->u.s->classFile;
        for (mm=rstack->menuSym; mm!=NULL; mm=mm->next) {
                if (itIsSameCxSymbol(&ss->s, &mm->s)) {
                        if (javaIsSuperClass(mm->s.vApplClass, srccn)) {
                                for (rr=mm->s.refs; rr!=NULL; rr=rr->next) {
                                        if ((! ( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared ))
                                                && rr->usg.base != UsageMethodInvokedViaSuper) {
                                                linkNamePrettyPrint(ttt, ss->s.name, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
                                                sprintf(tmpBuff,"%s is defined also in superclass and there are invocations syntactically refering to one of superclasses. Under some circumstances this may cause that pulling up of this method will not be behaviour preserving.", ttt);
                                                formatOutputLine(tmpBuff, 10);
                                                warning(ERR_ST, tmpBuff);
                                                return(0);
                                        }
                                }
                        }
                }
        }
        return(1);
}
int tpCheckTargetToBeDirectSubOrSupClass(int flag, char *subOrSuper) {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss;
        char ttt[TMP_STRING_SIZE];
        char tt[TMP_STRING_SIZE];
        char *s;
        S_chReference *cl;
        S_symbol *target;
        int res;
        res = 0;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1160);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1163);};
        target = getMoveTargetClass();
        if (target==NULL) {
                error(ERR_ST, "moving to NULL target class?");
                return(0);
        }
        readOneAppropReferenceFile(NULL, s_cxScanFunTabForClassHierarchy);
        { if (!(target->u.s!=NULL&&target->u.s->classFile!=s_noneFileIndex)) internalCheckFail("target->u.s!=NULL&&target->u.s->classFile!=s_noneFileIndex", "refactory.c", 1170);};
        if (flag == REQ_SUBCLASS) cl=s_fileTab.tab[ss->s.vApplClass]->infs;
        else cl=s_fileTab.tab[ss->s.vApplClass]->sups;
        for(; cl!=NULL; cl=cl->next) {
                if (cl->clas == target->u.s->classFile) {
                        res = 1;
                        break;
                }
        }
        if (res) return(res);
        javaGetClassNameFromFileNum(target->u.s->classFile, tt, DOTIFY_NAME);
        javaGetClassNameFromFileNum(ss->s.vApplClass, ttt, DOTIFY_NAME);
        sprintf(tmpBuff,"Class %s is not direct %s of %s. This refactoring provides moving to direct %ses only.", tt, subOrSuper, ttt, subOrSuper);
        formatOutputLine(tmpBuff, 10);
        error(ERR_ST,tmpBuff);
        return(0);
}
int tpPullUpFieldLastPreconditions() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss,*mm;
        char ttt[TMP_STRING_SIZE];
        char *s;
        S_chReference *cl;
        S_symbol *target;
        int pcharFlag;
        pcharFlag = 0;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1198);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1201);};
        target = getMoveTargetClass();
        { if (!(target!=NULL)) internalCheckFail("target!=NULL", "refactory.c", 1203);};
        { if (!(target->u.s!=NULL&&target->u.s->classFile!=s_noneFileIndex)) internalCheckFail("target->u.s!=NULL&&target->u.s->classFile!=s_noneFileIndex", "refactory.c", 1204);};
        for(mm=rstack->menuSym; mm!=NULL; mm=mm->next) {
                if (itIsSameCxSymbol(&ss->s,&mm->s)
                        && mm->s.vApplClass == target->u.s->classFile) goto cont2;
        }
        return(1);
 cont2:
        if (mm->s.refs == NULL) return(1);
        javaGetClassNameFromFileNum(target->u.s->classFile, ttt, DOTIFY_NAME);
        if (( ( (mm->s.refs->usg.base)==UsageDefined || (mm->s.refs->usg.base)==UsageOLBestFitDefined) || (mm->s.refs->usg.base)==UsageDeclared ) && mm->s.refs->next==NULL) {
                if (pcharFlag==0) {pcharFlag=1; fprintf(ccOut,":[warning] ");}
                sprintf(tmpBuff, "%s is yet defined in the superclass %s.  Pulling up will do nothing, but removing the definition from the subclass. You should be sure that both fields are initialized to the same value.", mm->s.name, ttt);
                formatOutputLine(tmpBuff, 10);
                warning(ERR_ST, tmpBuff);
                return(0);
        }
        sprintf(tmpBuff,"There are yet references of the field %s syntactically applied on the superclass %s, pulling up this field would cause confusion!", mm->s.name, ttt);
        formatOutputLine(tmpBuff, 10);
        error(ERR_ST, tmpBuff);
        return(0);
}
int tpPushDownFieldLastPreconditions() {
        S_olcxReferences *rstack;
        S_olSymbolsMenu *ss,*mm, *sourcesm, *targetsm;
        char ttt[TMP_STRING_SIZE];
        char *s;
        S_reference *rr;
        S_symbol *target;
        int thisclassi, pcharFlag, res;
        pcharFlag = 0; res = 1;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 1237);};
        rstack = s_olcxCurrentUser->browserStack.top;
        ss = rstack->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1240);};
        thisclassi = ss->s.vApplClass;
        target = getMoveTargetClass();
        { if (!(target!=NULL)) internalCheckFail("target!=NULL", "refactory.c", 1243);};
        { if (!(target->u.s!=NULL&&target->u.s->classFile!=s_noneFileIndex)) internalCheckFail("target->u.s!=NULL&&target->u.s->classFile!=s_noneFileIndex", "refactory.c", 1244);};
        sourcesm = targetsm = NULL;
        for(mm=rstack->menuSym; mm!=NULL; mm=mm->next) {
                if (itIsSameCxSymbol(&ss->s,&mm->s)) {
                        if (mm->s.vApplClass == target->u.s->classFile) targetsm = mm;
                        if (mm->s.vApplClass == thisclassi) sourcesm = mm;
                }
        }
        if (targetsm != NULL) {
                rr = getDefinitionRef(targetsm->s.refs);
                if (rr!=NULL && ( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared )) {
                        javaGetClassNameFromFileNum(target->u.s->classFile, ttt, DOTIFY_NAME);
                        sprintf(tmpBuff,"The field %s is yet defined in %s!",
                                        targetsm->s.name, ttt);
                        formatOutputLine(tmpBuff, 10);
                        error(ERR_ST, tmpBuff);
                        return(0);
                }
        }
        if (sourcesm != NULL) {
                if (sourcesm->s.refs!=NULL && sourcesm->s.refs->next!=NULL) {
                        javaGetClassNameFromFileNum(thisclassi, ttt, DOTIFY_NAME);
                        sprintf(tmpBuff, "There are several references of %s syntactically applied on %s. This may cause that the refactoring will not be behaviour preserving!", sourcesm->s.name, ttt);
                        formatOutputLine(tmpBuff, 10);
                        warning(ERR_ST, tmpBuff);
                        res = 0;
                }
        }
        return(res);
}
static int refactoryHandleSafetyCheckDifferenceLists(
        S_editorMarkerList *diff1, S_editorMarkerList *diff2, S_olcxReferences *diffrefs
        ) {
        int res, pbflag;
        S_olcxReferences *refs;
        S_olSymbolsMenu *mm;
        res = 1;
        if (diff1!=NULL || diff2!=NULL) {
                res = 0;
                for(mm=diffrefs->menuSym; mm!=NULL; mm=mm->next) {
                        mm->selected = mm->visible = 1;
                        mm->ooBits = 07777777;
                        olcxFreeReferences(mm->s.refs); mm->s.refs = NULL;
                }
                refactoryPushMarkersAsReferences(&diff1, diffrefs, "  Conflicting References");
                refactoryPushMarkersAsReferences(&diff2, diffrefs, "  Conflicting References");
                editorFreeMarkerListNotMarkers(diff1);
                editorFreeMarkerListNotMarkers(diff2);
                olcxPopOnly();
                if (s_ropt.theRefactoring == PPC_AVR_RENAME_PACKAGE) {
                        refactoryDisplayResolutionDialog(
"The package exists and is referenced in the original project. Renaming will join two packages without possibility of inverse refactoring",
                                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_ENABLED);
                } else {
                        refactoryDisplayResolutionDialog(
                                "Those references may be  misinterpreted after refactoring",
                                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_ENABLED);
                }
        }
        return(res);
}
static int refactoryMakeSafetyCheckAndUndo(
        S_editorBuffer *buf, S_editorMarker *point,
        S_editorMarkerList **occs, S_editorUndo *startPoint,
        S_editorUndo **redoTrack
        ) {
        int res, pbflag;
        S_editorMarkerList *chks, *dd;
        S_editorMarker *defin;
        S_reference *df1, *df2, *rr;
        S_editorMarkerList *diff1, *diff2;
        S_olcxReferences *refs, *origrefs, *newrefs, *diffrefs;
        S_olSymbolsMenu *mm;
        defin = point;
        olcxPushSpecialCheckMenuSym(OLO_SAFETY_CHECK_INIT, "  Conflicting References");
        refactorySafetyCheck( s_ropt.project, defin->buffer, defin);
        chks = editorReferencesToMarkers(s_olcxCurrentUser->browserStack.top->r,filter0, NULL);
        editorMarkersDifferences(occs, &chks, &diff1, &diff2);
        editorFreeMarkersAndMarkerList(chks);
        editorUndoUntil(startPoint, redoTrack);
        origrefs = newrefs = diffrefs = NULL;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "refactory.c", 1355);}; refs = s_olcxCurrentUser->browserStack.top; if (refs==NULL || refs->previous==NULL || refs->previous->previous==NULL){ error(ERR_INTERNAL, "something goes wrong at safety check"); pbflag = 1; } else { newrefs = refs; diffrefs = refs->previous; origrefs = refs->previous->previous; }};
        { if (!(origrefs!=NULL && newrefs!=NULL && diffrefs!=NULL)) internalCheckFail("origrefs!=NULL && newrefs!=NULL && diffrefs!=NULL", "refactory.c", 1356);};
        res = refactoryHandleSafetyCheckDifferenceLists(diff1, diff2, diffrefs);
        return(res);
}
void refactoryAskForReallyContinueConfirmation() {
        ppcGenRecord(PPC_ASK_CONFIRMATION,"The refactoring may change program behaviour, really continue?", "\n");
}
static void refactoryPreCheckThatSymbolRefsCorresponds(char *oldName, S_editorMarkerList *occs) {
        char *bVal, *cid;
        int check, off1, off2;
        S_editorMarkerList *ll;
        S_editorMarker *pos, *pp;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                pos = ll->d;
                cid = refactoryGetIdentifierOnMarker_st(pos);
                if (strcmp(cid, oldName)!=0) {
                        sprintf(tmpBuff,
                                   "something goes wrong: expecting %s\ninstead of %s at %s, offset:%d",
                                   oldName, cid, simpleFileName(getRealFileNameStatic(pos->buffer->name)),
                                   pos->offset);
                        error(ERR_INTERNAL, tmpBuff);
                        return;
                }
                off1 = pos->offset - 1;
                off2 = pos->offset + strlen(oldName) + 1;
                if (off1 < 0) off1 = 0;
                if (off2 >= pos->buffer->a.bufferSize) off2 = pos->buffer->a.bufferSize-1;
                pp = editorCrNewMarker(pos->buffer, off1);
                bVal = pos->buffer->a.text + off1;
                ppcGenPreCheckRecord(pp, off2-off1);
                editorFreeMarker(pp);
        }
}
static void refactoryMakeSyntaxPassOnSource(S_editorMarker *point) {
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                   point, NULL, "-olcxsyntaxpass",NULL);
        olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
}
static S_editorMarker *refactoryCrNewMarkerForExpressionBegin(S_editorMarker *d, int kind) {
        S_editorMarker *pp;
        S_editorBuffer *bb;
        S_position *pos;
        refactoryEditServerParseBuffer( s_ropt.project, d->buffer,
                                                                   d,NULL, "-olcxprimarystart",NULL);
        olStackDeleteSymbol(s_olcxCurrentUser->browserStack.top);
        if (kind == GET_PRIMARY_START) {
                pos = &s_primaryStartPosition;
        } else if (kind == GET_STATIC_PREFIX_START) {
                pos = &s_staticPrefixStartPosition;
        } else {
                pos = NULL;
                { if (!(0)) internalCheckFail("0", "refactory.c", 1413);};
        }
        if (pos->file == s_noneFileIndex) {
                if (kind == GET_STATIC_PREFIX_START) {
                        refactoryFatalErrorOnPosition(d, ERR_ST, "Can't determine static prefix. Maybe non-static reference to a static object? Make this invocation static before refactoring.");
                } else {
                        refactoryFatalErrorOnPosition(d, ERR_INTERNAL, "Can't determine beginning of primary expression");
                }
                return(NULL);
        } else {
                bb = editorGetOpenedAndLoadedBuffer(s_fileTab.tab[pos->file]->name);
                pp = editorCrNewMarker(bb, 0);
                editorMoveMarkerToLineCol(pp, pos->line, pos->coll);
                { if (!(pp->buffer == d->buffer)) internalCheckFail("pp->buffer == d->buffer", "refactory.c", 1426);};
                { if (!(pp->offset <= d->offset)) internalCheckFail("pp->offset <= d->offset", "refactory.c", 1427);};
                return(pp);
        }
}
static int refactoryShouldIMoveDirectoryNow(S_editorUndo *undoBase, char *dir) {
        S_editorUndo *uu;
        int dlen;
        dlen = strlen(dir);
        for(uu = s_editorUndo; uu!=NULL && uu!=undoBase; uu=uu->next) {
                if (uu->operation == UNDO_RENAME_BUFFER) {
                        if (fnnCmp(uu->u.rename.name, dir, dlen)==0
                                && (uu->u.rename.name[dlen] == '/'
                                        || uu->u.rename.name[dlen] == '\\')) {
                                return(0);
                        }
                }
        }
        return(1);
}
static void refactoryCheckedRenameBuffer(
        S_editorBuffer *buff, char *newName, S_editorUndo **undo
        ) {
        struct stat st;
        if (statb(newName, &st)==0) {
                sprintf(tmpBuff, "Renaming buffer %s to an existing file.\nCan I do this?", buff->name);
                ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
        }
        editorRenameBuffer(buff, newName, undo);
}
static void refactoryMoveFileAndDirForPackageRename(
        char *currentPath, S_editorUndo *undoBase, S_editorMarker *lld,
        char *symLinkName
        ) {
        char newfile[MAX_FILE_NAME_SIZE];
        char packdir[MAX_FILE_NAME_SIZE];
        char newpackdir[MAX_FILE_NAME_SIZE];
        char path[MAX_FILE_NAME_SIZE];
        int plen;
        strcpy(path, currentPath);
        plen = strlen(path);
        if (plen>0 && (path[plen-1]=='/'||path[plen-1]=='\\')) {
                plen--;
                path[plen]=0;
        }
        sprintf(packdir, "%s%c%s", path, SLASH, symLinkName);
        sprintf(newpackdir, "%s%c%s", path, SLASH, s_ropt.renameTo);
        javaSlashifyDotName(newpackdir+strlen(path));
        sprintf(newfile, "%s%s", newpackdir, lld->buffer->name+strlen(packdir));
        refactoryCheckedRenameBuffer(lld->buffer, newfile, &s_editorUndo);
}
static int refactoryRenamePackageFileMove(char *currentPath, S_editorMarkerList *ll,
                                                                                  char *symLinkName, int slnlen,
                                                                                  S_editorUndo *rpundo) {
        int res, plen;
        res = 0;
        plen = strlen(currentPath);
        if (fnnCmp(ll->d->buffer->name, currentPath, plen)==0
                && ll->d->buffer->name[plen] == SLASH
                && fnnCmp(ll->d->buffer->name+plen+1, symLinkName, slnlen)==0) {
                refactoryMoveFileAndDirForPackageRename( currentPath, rpundo, ll->d, symLinkName);
                res = 1;
                goto fini;
        }
 fini:
        return(res);
}
static void refactorySimplePackageRenaming(
        S_editorMarkerList *occs, S_editorMarker *point,
        char *symname,char *symLinkName, int symtype
        ) {
        char rtpack[MAX_FILE_NAME_SIZE];
        char rtprefix[MAX_FILE_NAME_SIZE];
        char *ss;
        int snlen, slnlen, mvfile;
        S_editorMarkerList *ll;
        S_editorMarker *pp;
        S_editorUndo *rpundo;
        snlen = strlen(symname);
        slnlen = strlen(symLinkName);
        strcpy(rtprefix, s_ropt.renameTo);
        ss = lastOccurenceInString(rtprefix, '.');
        if (ss == NULL) {
                strcpy(rtpack, rtprefix);
                rtprefix[0] = 0;
        } else {
                strcpy(rtpack, ss+1);
                *(ss+1)=0;
        }
        for(ll=occs; ll!=NULL; ll=ll->next) {
                pp = refactoryCrNewMarkerForExpressionBegin(ll->d, GET_STATIC_PREFIX_START);
                if (pp!=NULL) {
                        refactoryRemoveNonCommentCode(pp, ll->d->offset - pp->offset);
                        refactoryCheckedReplaceString(pp, snlen, symname, rtpack);
                        refactoryReplaceString(pp, 0, rtprefix);
                }
                editorFreeMarker(pp);
        }
        rpundo = s_editorUndo;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (ll->next == NULL || ll->next->d->buffer!=ll->d->buffer) {
                        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "refactory.c", 1540);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { mvfile = refactoryRenamePackageFileMove(currentPath, ll, symLinkName, slnlen, rpundo); if (mvfile) goto moved; }; currentPath += jmop_ind; currentPath++; }};
                moved:;
                }
        }
}
static void refactorySimpleRenaming(S_editorMarkerList *occs, S_editorMarker *point,
                                                                        char *symname,char *symLinkName, int symtype) {
        char nfile[MAX_FILE_NAME_SIZE];
        char *ss;
        S_editorMarkerList *ll;
        if (symtype == TypeStruct && ((s_language & (4)) != 0)
                && s_ropt.theRefactoring != PPC_AVR_RENAME_CLASS) {
                error(ERR_INTERNAL, "Use Rename Class to rename classes");
        }
        if (symtype == TypePackage && ((s_language & (4)) != 0)
                && s_ropt.theRefactoring != PPC_AVR_RENAME_PACKAGE) {
                error(ERR_INTERNAL, "Use Rename Package to rename packages");
        }
        if (s_ropt.theRefactoring == PPC_AVR_RENAME_PACKAGE) {
                refactorySimplePackageRenaming(occs, point, symname, symLinkName, symtype);
        } else {
                for(ll=occs; ll!=NULL; ll=ll->next) {
                        refactoryRenameTo(ll->d, symname, s_ropt.renameTo);
                }
                ppcGenGotoMarkerRecord(point);
                if (s_ropt.theRefactoring == PPC_AVR_RENAME_CLASS) {
                        if (strcmp(simpleFileNameWithoutSuffix_st(point->buffer->name), symname)==0) {
                                strcpy(nfile, point->buffer->name);
                                ss = lastOccurenceOfSlashOrAntiSlash(nfile);
                                if (ss==NULL) ss=nfile;
                                else ss++;
                                sprintf(ss, "%s.java", s_ropt.renameTo);
                                { if (!(strlen(nfile) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(nfile) < MAX_FILE_NAME_SIZE-1", "refactory.c", 1589);};
                                if (strcmp(nfile, point->buffer->name)!=0) {
                                        refactoryCheckedRenameBuffer(point->buffer, nfile, &s_editorUndo);
                                }
                        }
                }
        }
}
static S_editorMarkerList *refactoryGetReferences(
        S_editorBuffer *buf, S_editorMarker *point,
        char *resolveMessage, int messageType
        ) {
        S_editorMarkerList *occs;
        refactoryPushReferences( buf, point, "-olcxrename", resolveMessage,
                                                        messageType);
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym", "refactory.c", 1606);};
        occs = editorReferencesToMarkers(s_olcxCurrentUser->browserStack.top->r, filter0, NULL);
        return(occs);
}
static S_editorMarkerList *refactoryPushGetAndPreCheckReferences(
        S_editorBuffer *buf, S_editorMarker *point, char *nameOnPoint,
        char *resolveMessage, int messageType
        ) {
        S_editorMarkerList *occs;
        occs = refactoryGetReferences(buf, point, resolveMessage, messageType);
        refactoryPreCheckThatSymbolRefsCorresponds(nameOnPoint, occs);
        return(occs);
}
static S_editorMarker *refactoryFindModifierAndCrMarker(
        S_editorMarker *point, char *modifier, int limitIndex
        ) {
        int i, mlen, blen, mini;
        char *text;
        S_editorMarker *mm, *mb, *me;
        text = point->buffer->a.text;
        blen = point->buffer->a.bufferSize;
        mlen = strlen(modifier);
        refactoryMakeSyntaxPassOnSource(point);
        if (s_spp[limitIndex].file == s_noneFileIndex) {
                warning(ERR_INTERNAL, "cant get field declaration");
                mini = point->offset;
                while (mini>0 && text[mini]!='\n') mini --;
                i = point->offset;
        } else {
                mb = editorCrNewMarkerForPosition(&s_spp[limitIndex]);
                me = editorCrNewMarkerForPosition(&s_spp[limitIndex+2]);
                mini = mb->offset;
                i = me->offset;
                editorFreeMarker(mb);
                editorFreeMarker(me);
        }
        while (i>=mini) {
                if (strncmp(text+i, modifier, mlen)==0
                        && (i==0 || isspace(text[i-1]))
                        && (i+mlen==blen || isspace(text[i+mlen]))) {
                        mm = editorCrNewMarker(point->buffer, i);
                        return(mm);
                }
                i--;
        }
        return(NULL);
}
static void refactoryRemoveModifier(
        S_editorMarker *point, int limitIndex, char *modifier) {
        int i, j, mlen;
        char *text;
        S_editorMarker *mm;
        mlen = strlen(modifier);
        text = point->buffer->a.text;
        mm = refactoryFindModifierAndCrMarker(point, modifier, limitIndex);
        if (mm!=NULL) {
                i = mm->offset;
                for(j=i+mlen; isspace(text[j]); j++) ;
                refactoryReplaceString(mm, j-i, "");
        }
        editorFreeMarker(mm);
}
static void refactoryAddModifier(S_editorMarker *point, int limit, char *modifier) {
        char modifSpace[TMP_STRING_SIZE];
        S_editorMarker *mm;
        refactoryMakeSyntaxPassOnSource(point);
        if (s_spp[limit].file == s_noneFileIndex) {
                error(ERR_INTERNAL, "cant find beginning of field declaration");
        }
        mm = editorCrNewMarkerForPosition(&s_spp[limit]);
        sprintf(modifSpace, "%s ", modifier);
        refactoryReplaceString(mm, 0, modifSpace);
        editorFreeMarker(mm);
}
static void refactoryChangeAccessModifier(
        S_editorMarker *point, int limitIndex, char *modifier
        ) {
        S_editorMarker *mm;
        mm = refactoryFindModifierAndCrMarker(point, modifier, limitIndex);
        if (mm == NULL) {
                refactoryRemoveModifier(point, limitIndex, "private");
                refactoryRemoveModifier(point, limitIndex, "protected");
                refactoryRemoveModifier(point, limitIndex, "public");
                if (*modifier) refactoryAddModifier(point, limitIndex, modifier);
        } else {
                editorFreeMarker(mm);
        }
}
static void refactoryRestrictAccessibility(S_editorMarker *point, int limitIndex, int minAccess) {
        int accIndex, access;
        S_reference *rr;
        minAccess &= 0x007;
        for(accIndex=0; accIndex<3; accIndex++) {
                if (s_javaRequiredeAccessibilitiesTable[accIndex] == minAccess) break;
        }
        refactoryUpdateReferences(s_ropt.project);
        refactoryPushReferences(point->buffer, point, "-olcxrename", NULL, 0);
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->menuSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->menuSym", "refactory.c", 1717);};
        for(rr=s_olcxCurrentUser->browserStack.top->r; rr!=NULL; rr=rr->next) {
                if (! ( ( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined) || (rr->usg.base)==UsageDeclared )) {
                        if (rr->usg.requiredAccess < accIndex) {
                                accIndex = rr->usg.requiredAccess;
                        }
                }
        }
        olcxPopOnly();
        access = s_javaRequiredeAccessibilitiesTable[accIndex];
        if (access == 0x001) refactoryChangeAccessModifier(point, limitIndex, "public");
        else if (access == 0x004) refactoryChangeAccessModifier(point, limitIndex, "protected");
        else if (access == 0x000) refactoryChangeAccessModifier(point, limitIndex, "");
        else if (access == 0x002) refactoryChangeAccessModifier(point, limitIndex, "private");
        else error(ERR_INTERNAL, "No access modifier computed");
}
static void refactoryCheckForMultipleReferencesOnSinglePlace2( S_symbolRefItem *p,
                                                                                                                           S_olcxReferences *rstack,
                                                                                                                           S_reference *r
        ) {
        S_reference *dr;
        int prefixchar;
        if (refOccursInRefs(r, rstack->r)) {
                ppcGenGotoPositionRecord(&r->p);
                sprintf(tmpBuff, "The reference at this place refers to multiple symbols. The refactoring will probably damage your program. Do you really want to continue?");
                formatOutputLine(tmpBuff, 10);
                ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
        }
}
static void refactoryCheckForMultipleReferencesOnSinglePlace(S_olcxReferences *rstack, S_olSymbolsMenu *ccms) {
        S_symbolRefItem *p, *sss;
        S_reference *r;
        S_olSymbolsMenu *cms;
        int pushed;
        p = &ccms->s;
        { if (!(rstack && rstack->menuSym)) internalCheckFail("rstack && rstack->menuSym", "refactory.c", 1760);};
        sss = &rstack->menuSym->s;
        pushed = itIsSymbolToPushOlRefences(p, rstack, &cms, DEFAULT_VALUE);
        if ((! pushed) && olcxItIsSameCxSymbol(p, sss)) {
                for(r=p->refs; r!=NULL; r=r->next) {
                        refactoryCheckForMultipleReferencesOnSinglePlace2( p, rstack, r);
                }
        }
}
static void refactoryMultipleOccurencesSafetyCheck() {
        S_olcxReferences *rstack;
        { if (!(s_olcxCurrentUser!=NULL)) internalCheckFail("s_olcxCurrentUser!=NULL", "refactory.c", 1776);};
        rstack = s_olcxCurrentUser->browserStack.top;
        olProcessSelectedReferences(rstack, refactoryCheckForMultipleReferencesOnSinglePlace);
}
static void refactoryRename(S_editorBuffer *buf, S_editorMarker *point) {
        char nameOnPoint[TMP_STRING_SIZE];
        char *symLinkName, *message;
        int check, symtype;
        S_editorMarkerList *occs;
        S_editorUndo *undoStartPoint, *redoTrack;
        S_olSymbolsMenu *csym;
        if (s_ropt.renameTo == NULL) {
                error(ERR_ST, "this refactoring requires -renameto=<new name> option");
        }
        refactoryUpdateReferences(s_ropt.project);
        if (((s_language & (4)) != 0)) {
                message = "Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ";
        } else {
                message = "There are several symbols referred from this place. Continuing this refactoring will process selected symbols in once.";
        }
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 1804);};
        occs = refactoryPushGetAndPreCheckReferences(buf, point, nameOnPoint, message,PPCV_BROWSER_TYPE_INFO);
        csym = s_olcxCurrentUser->browserStack.top->hkSelectedSym;
        symtype = csym->s.b.symType;
        symLinkName = csym->s.name;
        undoStartPoint = s_editorUndo;
        if (!((s_language & (4)) != 0)) {
                refactoryMultipleOccurencesSafetyCheck();
        }
        refactorySimpleRenaming( occs, point,nameOnPoint,symLinkName, symtype);
        redoTrack = NULL;
        check = refactoryMakeSafetyCheckAndUndo(buf, point, &occs, undoStartPoint, &redoTrack);
        if (! check) {
                refactoryAskForReallyContinueConfirmation();
        }
        editorApplyUndos(redoTrack, NULL, NULL, GEN_FULL_OUTPUT);
        ppcGenGotoMarkerRecord(point);
        editorFreeMarkersAndMarkerList(occs);
        if (s_ropt.theRefactoring==PPC_AVR_RENAME_PACKAGE) {
                ppcGenRecord(PPC_INFORMATION, "\nDone.\nDo not forget to remove .class files of former package", "\n");
        } else if (s_ropt.theRefactoring==PPC_AVR_RENAME_CLASS
                && strcmp(simpleFileNameWithoutSuffix_st(point->buffer->name), s_ropt.renameTo)==0) {
                ppcGenRecord(PPC_INFORMATION, "\nDone.\nDo not forget to remove .class file of former class", "\n");
        }
}
void clearParamPositions() {
        s_paramPosition = s_noPos;
        s_paramBeginPosition = s_noPos;
        s_paramEndPosition = s_noPos;
}
static int refactoryGetParamNamePosition(S_editorMarker *pos, char *fname, int argn) {
        char pushOpt[TMP_STRING_SIZE];
        char *actName;
        int res;
        actName = refactoryGetIdentifierOnMarker_st(pos);
        clearParamPositions();
        { if (!(strcmp(actName, fname)==0)) internalCheckFail("strcmp(actName, fname)==0", "refactory.c", 1851);};
        sprintf(pushOpt, "-olcxgotoparname%d", argn);
        refactoryEditServerParseBuffer( s_ropt.project, pos->buffer, pos,NULL, pushOpt,NULL);
        olcxPopOnly();
        if (s_paramPosition.file != s_noneFileIndex) {
                res = 0;
        } else {
                res = 2;
        }
        return(res);
}
static int refactoryGetParamPosition(S_editorMarker *pos, char *fname, int argn) {
        char pushOpt[TMP_STRING_SIZE];
        char *actName;
        int res;
        actName = refactoryGetIdentifierOnMarker_st(pos);
        if (! (strcmp(actName, fname)==0
                   || strcmp(actName,"this")==0
                   || strcmp(actName,"super")==0)) {
                ppcGenGotoMarkerRecord(pos);
                sprintf(tmpBuff, "This reference is not pointing to the function/method name. Maybe a composed symbol. Sorry, do not know how to handle this case.");
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
        }
        clearParamPositions();
        sprintf(pushOpt, "-olcxgetparamcoord%d", argn);
        refactoryEditServerParseBuffer( s_ropt.project, pos->buffer, pos,NULL, pushOpt,NULL);
        olcxPopOnly();
        res = 0;
        if (s_paramBeginPosition.file == s_noneFileIndex
                || s_paramEndPosition.file == s_noneFileIndex
                || s_paramBeginPosition.file == -1
                || s_paramEndPosition.file == -1
                ) {
                ppcGenGotoMarkerRecord(pos);
                error(ERR_INTERNAL, "Can't get end of parameter");
                res = 2;
        }
        if (s_paramBeginPosition.file != s_paramEndPosition.file
                || s_paramBeginPosition.line > s_paramEndPosition.line
                || (s_paramBeginPosition.line == s_paramEndPosition.line
                        && s_paramBeginPosition.coll > s_paramEndPosition.coll)) {
                ppcGenGotoMarkerRecord(pos);
                sprintf(tmpBuff, "Something goes wrong at this occurence, can't get reasonable parameter limites");
                formatOutputLine(tmpBuff, 10);
                error(ERR_ST, tmpBuff);
                res = 2;
        }
        if (! ((s_language & (4)) != 0)) {
        }
        return(res);
}
static void dumpContext(S_editorMarker *mm) {
        int i, j, m;
        char tt[REFACTORING_TMP_STRING_SIZE];
        char *text;
        text = mm->buffer->a.text;
        sprintf(tt, "[dumping context at %s:%d]\n", mm->buffer->name, mm->offset);
        j = strlen(tt);
        i = mm->offset;
        i -= 50;
        if (i<0) i=0;
        while (i<mm->offset) {
                tt[j++] = text[i++];
        }
        sprintf(tt+j, "[MARKER]");
        j = strlen(tt);
        m = mm->offset+50;
        if (m>mm->buffer->a.bufferSize) m = mm->buffer->a.bufferSize;
        while (i<m) {
                tt[j++] = text[i++];
        }
        tt[j++]=0;
        ppcGenRecord(PPC_INFORMATION, tt, "\n");
}
static int refactoryAddStringAsParameter(S_editorMarker *pos, S_editorMarker *endm,
                                                                                  char *fname, int argn, char *param) {
        char *actName, *text;
        char pushOpt[TMP_STRING_SIZE];
        char par[REFACTORING_TMP_STRING_SIZE];
        char *sep1, *sep2;
        int ipos,rr,insertionOffset;
        S_editorMarker *mm;
        insertionOffset = -1;
        rr = refactoryGetParamPosition(pos, fname, argn);
        if (rr != 0) {
                error(ERR_INTERNAL, "Problem while adding parameter");
                return(insertionOffset);
        }
        text = pos->buffer->a.text;
        if (endm==NULL) {
                mm = editorCrNewMarkerForPosition(&s_paramBeginPosition);
        } else {
                mm = endm;
                { if (!(mm->buffer->ftnum == s_paramBeginPosition.file)) internalCheckFail("mm->buffer->ftnum == s_paramBeginPosition.file", "refactory.c", 1960);};
                editorMoveMarkerToLineCol(mm, s_paramBeginPosition.line, s_paramBeginPosition.coll);
        }
        sep1=""; sep2="";
        if ((! ( ((s_paramBeginPosition).file != (s_paramEndPosition).file) || ((s_paramBeginPosition).line != (s_paramEndPosition).line) || ((s_paramBeginPosition).coll != (s_paramEndPosition).coll) ))) {
                if (text[mm->offset] == '(') {
                        mm->offset ++;
                        sep1=""; sep2="";
                } else if (text[mm->offset] == ')') {
                        sep1=", "; sep2="";
                } else {
                        ppcGenGotoMarkerRecord(pos);
                        sprintf(tmpBuff, "Something goes wrong, probably different parameter coordinates at different cpp passes.");
                        formatOutputLine(tmpBuff, 10);
                        fatalError(ERR_INTERNAL, tmpBuff, 65);
                        { if (!(0)) internalCheckFail("0", "refactory.c", 1978);};
                }
        } else {
                if (text[mm->offset] == '(') {
                        sep1 = "";
                        sep2 = ", ";
                } else {
                        sep1 = " ";
                        sep2 = ",";
                }
                mm->offset ++;
        }
        sprintf(par, "%s%s%s", sep1, param, sep2);
        { if (!(strlen(param) < REFACTORING_TMP_STRING_SIZE-1)) internalCheckFail("strlen(param) < REFACTORING_TMP_STRING_SIZE-1", "refactory.c", 1992);};
        insertionOffset = mm->offset;
        refactoryReplaceString(mm, 0, par);
        if (endm == NULL) {
                editorFreeMarker(mm);
        }
        return(insertionOffset);
}
static int refactoryIsThisSymbolUsed(S_editorMarker *pos) {
        int refn;
        refactoryPushReferences( pos->buffer, pos, "-olcxpushforlm","Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ",PPCV_BROWSER_TYPE_INFO);
        { register S_reference *tmp; register int co=0; tmp = s_olcxCurrentUser->browserStack.top->r; while (tmp!=NULL) {++co; tmp = tmp->next; } refn = co; };
        olcxPopOnly();
        return(refn > 1);
}
static int refactoryIsParameterUsedExceptRecursiveCalls(S_editorMarker *ppos, S_editorMarker *fpos, char *fname) {
        return(refactoryIsThisSymbolUsed(ppos));
}
static void refactoryCheckThatParameterIsUnused(S_editorMarker *pos, char *fname,
                                                                                                int argn, int checkfor) {
        char *actName, *text;
        char pname[TMP_STRING_SIZE];
        int ipos,rr;
        S_editorMarker *mm;
        rr = refactoryGetParamNamePosition(pos, fname, argn);
        if (rr != 0) {
                ppcGenRecord(PPC_ASK_CONFIRMATION, "Can not parse parameter definition, continue anyway?", "\n");
                return;
        }
        mm = editorCrNewMarkerForPosition(&s_paramPosition);
        strncpy(pname, refactoryGetIdentifierOnMarker_st(mm), TMP_STRING_SIZE);
        pname[TMP_STRING_SIZE-1] = 0;
        text = pos->buffer->a.text;
        if (refactoryIsParameterUsedExceptRecursiveCalls(mm, pos, fname)) {
                if (checkfor==CHECK_FOR_ADD_PARAM) {
                        sprintf(tmpBuff, "parameter '%s' clashes with an existing symbol, continue anyway?", pname);
                        ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
                } else if (checkfor==CHECK_FOR_DEL_PARAM) {
                        sprintf(tmpBuff, "parameter '%s' is used, delete it anyway?", pname);
                        ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
                } else {
                        { if (!(0)) internalCheckFail("0", "refactory.c", 2042);};
                }
        }
        editorFreeMarker(mm);
}
static void refactoryAddParameter(S_editorMarker *pos, char *fname,
                                                                  int argn, int usage) {
        if (( ( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined) || (usage)==UsageDeclared )) {
                refactoryAddStringAsParameter(pos,NULL, fname, argn, s_ropt.refpar1);
                if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                        refactoryCheckThatParameterIsUnused(pos, fname, argn, CHECK_FOR_ADD_PARAM);
                }
        } else {
                refactoryAddStringAsParameter(pos,NULL, fname, argn, s_ropt.refpar2);
        }
}
static void refactoryDeleteParameter(S_editorMarker *pos, char *fname,
                                                                         int argn, int usage) {
        char *text;
        char pname[TMP_STRING_SIZE];
        int ipos, res;
        S_editorMarker *m1, *m2;
        res = refactoryGetParamPosition(pos, fname, argn);
        if (res != 0) return;
        m1 = editorCrNewMarkerForPosition(&s_paramBeginPosition);
        m2 = editorCrNewMarkerForPosition(&s_paramEndPosition);
        text = pos->buffer->a.text;
        if ((! ( ((s_paramBeginPosition).file != (s_paramEndPosition).file) || ((s_paramBeginPosition).line != (s_paramEndPosition).line) || ((s_paramBeginPosition).coll != (s_paramEndPosition).coll) ))) {
                if (text[m1->offset] == '(') {
                } else if (text[m1->offset] == ')') {
                } else {
                        fatalError(ERR_INTERNAL,"Something goes wrong, probably different parameter coordinates at different cpp passes.", 65);
                        { if (!(0)) internalCheckFail("0", "refactory.c", 2083);};
                }
                error(ERR_ST, "Parameter out of limit");
        } else {
                if (text[m1->offset] == '(') {
                        m1->offset ++;
                        if (text[m2->offset] == ',') {
                                m2->offset ++;
                        }
                        editorMoveMarkerToNonBlank(m2, 1);
                }
                if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                        refactoryCheckThatParameterIsUnused(pos, fname, argn, CHECK_FOR_DEL_PARAM);
                }
                { if (!(m1->offset <= m2->offset)) internalCheckFail("m1->offset <= m2->offset", "refactory.c", 2101);};
                refactoryReplaceString(m1, m2->offset - m1->offset, "");
        }
        editorFreeMarker(m1);
        editorFreeMarker(m2);
}
static void refactoryMoveParameter(S_editorMarker *pos, char *fname,
                                                                   int argFrom, int argTo) {
        char *actName, *text;
        char par[REFACTORING_TMP_STRING_SIZE];
        int ipos, res, plen;
        S_editorMarker *m1, *m2;
        res = refactoryGetParamPosition(pos, fname, argFrom);
        if (res != 0) return;
        m1 = editorCrNewMarkerForPosition(&s_paramBeginPosition);
        m2 = editorCrNewMarkerForPosition(&s_paramEndPosition);
        text = pos->buffer->a.text;
        plen = 0;
        par[plen]=0;
        if ((! ( ((s_paramBeginPosition).file != (s_paramEndPosition).file) || ((s_paramBeginPosition).line != (s_paramEndPosition).line) || ((s_paramBeginPosition).coll != (s_paramEndPosition).coll) ))) {
                if (text[m1->offset] == '(') {
                } else if (text[m1->offset] == ')') {
                } else {
                        fatalError(ERR_INTERNAL,"Something goes wrong, probably different parameter coordinates at different cpp passes.", 65);
                        { if (!(0)) internalCheckFail("0", "refactory.c", 2132);};
                }
                error(ERR_ST, "Parameter out of limit");
        } else {
                m1->offset++;
                editorMoveMarkerToNonBlank(m1, 1);
                m2->offset--;
                editorMoveMarkerToNonBlank(m2, -1);
                m2->offset++;
                { if (!(m1->offset <= m2->offset)) internalCheckFail("m1->offset <= m2->offset", "refactory.c", 2141);};
                plen = m2->offset - m1->offset;
                strncpy(par, (m1->buffer->a.text+m1->offset), plen);
                par[plen]=0;
                refactoryDeleteParameter(pos, fname, argFrom, UsageUsed);
                refactoryAddStringAsParameter(pos, NULL, fname, argTo, par);
        }
        editorFreeMarker(m1);
        editorFreeMarker(m2);
}
static void refactoryApplyParamManip(char *functionName, S_editorMarkerList *occs,
                                                                         int manip, int argn1, int argn2
        ) {
        S_editorMarkerList *ll;
        int progressi, progressn;
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (ll->usg.base != UsageUndefinedMacro) {
                        if (manip==PPC_AVR_ADD_PARAMETER) {
                                refactoryAddParameter(ll->d, functionName, argn1,
                                                                          ll->usg.base);
                        } else if (manip==PPC_AVR_DEL_PARAMETER) {
                                refactoryDeleteParameter(ll->d, functionName, argn1,
                                                                                 ll->usg.base);
                        } else if (manip==PPC_AVR_MOVE_PARAMETER) {
                                refactoryMoveParameter(ll->d, functionName,
                                                                           argn1, argn2
                                        );
                        } else {
                                error(ERR_INTERNAL, "unknown parameter manipulation");
                        }
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
}
static void refactoryApplyParameterManipulation(S_editorBuffer *buf, S_editorMarker *point,
                                                                                   int manip, int argn1, int argn2) {
        char nameOnPoint[TMP_STRING_SIZE];
        int check;
        S_editorMarkerList *occs, *ll, *chks, *diff1, *diff2;
        S_reference *df1, *df2, *rr;
        S_editorUndo *startPoint, *redoTrack;
        refactoryUpdateReferences(s_ropt.project);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        refactoryPushReferences( buf, point, "-olcxargmanip","Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ",PPCV_BROWSER_TYPE_INFO);
        occs = editorReferencesToMarkers(s_olcxCurrentUser->browserStack.top->r, filter0, NULL);
        startPoint = s_editorUndo;
        ppcGenGotoMarkerRecord(point);
        redoTrack = NULL;
        refactoryApplyParamManip(nameOnPoint, occs,
                                                          manip, argn1, argn2
);
        if (((s_language & (4)) != 0)) {
                check = refactoryMakeSafetyCheckAndUndo(buf, point, &occs, startPoint, &redoTrack);
                if (! check) refactoryAskForReallyContinueConfirmation();
                editorApplyUndos(redoTrack, NULL, &s_editorUndo, GEN_NO_OUTPUT);
        }
        editorFreeMarkersAndMarkerList(occs);
}
static void refactoryParameterManipulation(S_editorBuffer *buf, S_editorMarker *point,
                                                                                   int manip, int argn1, int argn2) {
        refactoryApplyParameterManipulation(buf, point, manip, argn1, argn2);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static int createMarkersForAllReferencesInRegions(
        S_olSymbolsMenu *menu, S_editorRegionList **regions
        ) {
        S_olSymbolsMenu *mm;
        int res, n, nn;
        res = 0;
        for(mm=menu; mm!=NULL; mm=mm->next) {
                { if (!(mm->markers==NULL)) internalCheckFail("mm->markers==NULL", "refactory.c", 2230);};
                if (mm->selected && mm->visible) {
                        mm->markers = editorReferencesToMarkers(mm->s.refs,filter0, NULL);
                        if (regions != NULL) {
                                editorRestrictMarkersToRegions(&mm->markers, regions);
                        }
                        { S_editorMarkerList *_macrores; _macrores = (mm->markers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (mm->markers) = _macrores;};
                        { register S_editorMarkerList *tmp; register int co=0; tmp = mm->markers; while (tmp!=NULL) {++co; tmp = tmp->next; } n = co; };
                        res += n;
                }
        }
        return(res);
}
static void refactoryApplyExpandShortNames(S_editorBuffer *buf, S_editorMarker *point) {
        S_olSymbolsMenu *mm;
        S_editorMarkerList *ppp;
        char fqtName[MAX_FILE_NAME_SIZE];
        char fqtNameDot[MAX_FILE_NAME_SIZE];
        char *shortName;
        int shortNameLen, n;
        refactoryEditServerParseBuffer( s_ropt.project, buf, point,NULL, "-olcxnotfqt",NULL);
        olcxPushSpecial("  not fully qualified names", OLO_NOT_FQT_REFS);
        createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, NULL);
        for(mm = s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        javaGetClassNameFromFileNum(mm->s.vApplClass, fqtName, DOTIFY_NAME);
                        javaDotifyClassName(fqtName);
                        sprintf(fqtNameDot, "%s.", fqtName);
                        shortName = javaGetShortClassName(fqtName);
                        shortNameLen = strlen(shortName);
                        if (isdigit(shortName[0])) {
                                goto cont;
                        }
                        for(ppp=mm->markers; ppp!=NULL; ppp=ppp->next) {
                                if (ppp->usg.base == UsageNonExpandableNotFQTNameInClassOrMethod) {
                                        ppcGenGotoMarkerRecord(ppp->d);
                                        sprintf(tmpBuff, "This occurence of %s would be misinterpreted after expansion to %s.\nNo action made at this place.", shortName, fqtName);
                                        warning(ERR_ST, tmpBuff);
                                } else if (ppp->usg.base == UsageNotFQFieldInClassOrMethod) {
                                        refactoryReplaceString(ppp->d, 0, fqtNameDot);
                                } else if (ppp->usg.base == UsageNotFQTypeInClassOrMethod) {
                                        refactoryCheckedReplaceString(ppp->d, shortNameLen, shortName, fqtName);
                                }
                        }
                }
        cont:;
                editorFreeMarkerListNotMarkers(mm->markers);
                mm->markers = NULL;
        }
}
static void refactoryExpandShortNames(S_editorBuffer *buf, S_editorMarker *point) {
        refactoryApplyExpandShortNames(buf, point);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static S_editorMarker *refactoryReplaceStaticPrefix(S_editorMarker *d, char *npref) {
        int ppoffset, npreflen;
        S_editorMarker *pp;
        char pdot[MAX_FILE_NAME_SIZE];
        pp = refactoryCrNewMarkerForExpressionBegin(d, GET_STATIC_PREFIX_START);
        if (pp==NULL) {
                pp = editorCrNewMarker(d->buffer, d->offset);
        } else {
                ppoffset = pp->offset;
                refactoryRemoveNonCommentCode(pp, d->offset-pp->offset);
                if (*npref!=0) {
                        npreflen = strlen(npref);
                        strcpy(pdot, npref);
                        pdot[npreflen] = '.'; pdot[npreflen+1]=0;
                        refactoryReplaceString(pp, 0, pdot);
                }
                pp->offset = ppoffset;
        }
        return(pp);
}
static void refactoryReduceLongReferencesInRegions(
        S_editorMarker *point,
        S_editorRegionList **regions
        ) {
        S_editorMarkerList *rli, *ri, *ro, *rr;
        S_editorRegionList *reg;
        S_editorMarker *pp;
        int progressi, progressn;
        refactoryEditServerParseBuffer(s_ropt.project, point->buffer, point,NULL,
                                                                        "-olcxuselesslongnames", "-olallchecks");
        olcxPushSpecial(" redundant long names of the project", OLO_USELESS_LONG_NAME);
        rli = editorReferencesToMarkers(s_olcxCurrentUser->browserStack.top->r, filter0, NULL);
        editorSplitMarkersWithRespectToRegions(&rli, regions, &ri, &ro);
        editorFreeMarkersAndMarkerList(ro); ro = NULL;
        s_progressFactor += 1;
        { register S_editorMarkerList *tmp; register int co=0; tmp = ri; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        for(rr=ri; rr!=NULL; rr=rr->next) {
                pp = refactoryReplaceStaticPrefix(rr->d, "");
                editorFreeMarker(pp);
                writeRelativeProgress((((progressi++)*100/progressn)/10)*10);
        }
        writeRelativeProgress(100);
}
static int refactoryIsTheImportUsed(S_editorMarker *point, int line, int coll) {
        char isymName[TMP_STRING_SIZE];
        S_olSymbolsMenu *mm;
        int res;
        strcpy(isymName, javaImportSymbolName_st(point->buffer->ftnum, line, coll));
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL,
                                                                        "-olcxpushfileunused", "-olallchecks");
        pushLocalUnusedSymbolsAction();
        res = 1;
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->visible && strcmp(mm->s.name, isymName)==0) {
                        res = 0;
                        goto fini1;
                }
        }
 fini1:
        olcxPopOnly();
        return(res);
}
static int refactoryPushFileUnimportedFqts(S_editorMarker *point, S_editorRegionList **regions) {
        char pushOpt[TMP_STRING_SIZE];
        int lastImportLine;
        sprintf(pushOpt, "-olcxpushspecialname=%s", "  unimported type");
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL,pushOpt, "-olallchecks");
        lastImportLine = s_cps.lastImportLine;
        olcxPushSpecial("  unimported type", OLO_PUSH_SPECIAL_NAME);
        createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, regions);
        return(lastImportLine);
}
static int refactoryImportNeeded(S_editorMarker *point, S_editorRegionList **regions, int vApplCl) {
        S_olSymbolsMenu *mm;
        int res;
        refactoryPushFileUnimportedFqts(point, regions);
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->s.vApplClass == vApplCl) {
                        res = 1;
                        goto fini;
                }
        }
        res = 0;
 fini:
        olcxPopOnly();
        return(res);
}
static int refactoryAddImport(S_editorMarker *point, S_editorRegionList **regions,
                                                          char *iname, int line, int vApplCl, int interactive) {
        char istat[MAX_CX_SYMBOL_SIZE];
        char icoll;
        char *ld1, *ld2, *ss;
        S_editorMarker *mm;
        int res;
        S_editorUndo *undoBase;
        S_editorRegionList *wholeBuffer;
        undoBase = s_editorUndo;
        sprintf(istat, "import %s;\n", iname);
        mm = editorCrNewMarker(point->buffer, 0);
        if (line > 1) {
                editorMoveMarkerToLineCol(mm, line-1, 0);
                if (strncmp((mm->buffer->a.text+mm->offset), "package", 7) == 0) {
                        editorMoveMarkerToLineCol(mm, line, 0);
                        refactoryReplaceString(mm, 0, "\n");
                        line ++;
                }
        }
        editorMoveMarkerToLineCol(mm, line, 0);
        refactoryReplaceString(mm, 0, istat);
        res = 1;
        ld1 = NULL;
        ld2 = istat + strlen("import");
        for(ss=ld2; *ss; ss++) {
                if (*ss == '.') {
                        ld1 = ld2;
                        ld2 = ss;
                }
        }
        if (ld1 == NULL) {
                error(ERR_INTERNAL, "can't find imported package");
        } else {
                icoll = ld1 - istat + 1;
                if (refactoryIsTheImportUsed(mm, line, icoll)) {
                        if (interactive == INTERACTIVE_YES) {
                                ppcGenRecord(PPC_WARNING,
                                                         "Sorry, adding this import would cause misinterpretation of\nsome of classes used elsewhere it the file.",
                                                         "\n");
                        }
                        res = 0;
                } else {
                        wholeBuffer = editorWholeBufferRegion(point->buffer);
                        refactoryReduceLongReferencesInRegions(point, &wholeBuffer);
                        editorFreeMarkersAndRegionList(wholeBuffer); wholeBuffer=NULL;
                        if (refactoryImportNeeded(point, regions, vApplCl)) {
                                if (interactive == INTERACTIVE_YES) {
                                        ppcGenRecord(PPC_WARNING,
                                                                 "Sorry, this import will not help to reduce class references.",
                                                                 "\n");
                                }
                                res = 0;
                        }
                }
        }
        if (res == 0) editorUndoUntil(undoBase, NULL);
        editorFreeMarker(mm);
        return(res);
}
static int isInDisabledList(S_disabledList *list, int file, int vApplCl) {
        S_disabledList *ll;
        for(ll=list; ll!=NULL; ll=ll->next) {
                if (ll->file == file && ll->clas == vApplCl) return(1);
        }
        return(0);
}
static int translatePassToAddImportAction(int pass) {
        switch (pass) {
        case 0: return(RC_IMPORT_ON_DEMAND);
        case 1: return(RC_IMPORT_SINGLE_TYPE);
        case 2: return(RC_CONTINUE);
        default: error(ERR_INTERNAL, "wrong code for noninteractive add import");
        }
        return(0);
}
static int refactoryInteractiveAskForAddImportAction(S_editorMarkerList *ppp, int defaultAction,
                                                                                                         char *fqtName
        ) {
        int action;
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(ppp->d);
        ppcGenNumericRecord(PPC_ADD_TO_IMPORTS_DIALOG,defaultAction,fqtName,"\n");
        refactoryBeInteractive();
        action = s_opt.continueRefactoring;
        return(action);
}
static void refactoryPerformReduceNamesAndAddImportsInSingleFile(
        S_editorMarker *point, S_editorRegionList **regions, int interactive
        ) {
        S_olSymbolsMenu *mm;
        S_editorMarkerList *ppp;
        S_editorRegionList *rl;
        S_editorBuffer *b;
        int action, keepAdding, succ, lastImportLine;
        int defaultAction, cfile;
        char fqtName[MAX_FILE_NAME_SIZE];
        char starName[MAX_FILE_NAME_SIZE];
        char *dd;
        S_disabledList *disabled, *dl;
        if (regions!=NULL && *regions!=NULL) {
                b = (*regions)->r.b->buffer;
                for(rl= *regions; rl!=NULL; rl=rl->next) {
                        if (rl->r.b->buffer != b || rl->r.e->buffer != b) {
                                { if (!(0 && "[refactoryPerformAddImportsInSingleFile] region list contains multiple buffers!")) internalCheckFail("0 && \"[refactoryPerformAddImportsInSingleFile] region list contains multiple buffers!\"", "refactory.c", 2526);};
                                break;
                        }
                }
        }
        refactoryReduceLongReferencesInRegions(point, regions);
        disabled = NULL;
        keepAdding = 1;
        while (keepAdding) {
                keepAdding = 0;
                lastImportLine = refactoryPushFileUnimportedFqts(point, regions);
                for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                        ppp=mm->markers;
                        defaultAction = s_ropt.defaultAddImportStrategy;
                        while (ppp!=NULL && keepAdding==0
                                   && !isInDisabledList(disabled, ppp->d->buffer->ftnum, mm->s.vApplClass)) {
                                cfile = ppp->d->buffer->ftnum;
                                javaGetClassNameFromFileNum(mm->s.vApplClass, fqtName, DOTIFY_NAME);
                                javaDotifyClassName(fqtName);
                                if (interactive == INTERACTIVE_YES) {
                                        action = refactoryInteractiveAskForAddImportAction(ppp,defaultAction,fqtName);
                                } else {
                                        action = translatePassToAddImportAction(defaultAction);
                                }
                                switch (action) {
                                case RC_IMPORT_ON_DEMAND:
                                        strcpy(starName, fqtName);
                                        dd = lastOccurenceInString(starName, '.');
                                        if (dd!=NULL) {
                                                sprintf(dd, ".*");
                                                keepAdding = refactoryAddImport(point, regions, starName,
                                                                                                                lastImportLine+1, mm->s.vApplClass,
                                                                                                                interactive);
                                        }
                                        defaultAction = NID_IMPORT_ON_DEMAND;
                                        break;
                                case RC_IMPORT_SINGLE_TYPE:
                                        keepAdding = refactoryAddImport(point, regions, fqtName,
                                                                                                        lastImportLine+1, mm->s.vApplClass,
                                                                                                        interactive);
                                        defaultAction = NID_SINGLE_TYPE_IMPORT;
                                        break;
                                case RC_CONTINUE:
                                        { { int n = (1) * sizeof(S_disabledList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { dl = NULL; } else { dl = (S_disabledList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (dl==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_disabledList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { dl = NULL; } else { dl = (S_disabledList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                                        { (dl)->file = cfile; (dl)->clas = mm->s.vApplClass; (dl)->next = disabled;};
                                        disabled = dl;
                                        defaultAction = NID_KEPP_FQT_NAME;
                                        break;
                                default:
                                        fatalError(ERR_INTERNAL, "wrong continuation code", 65);
                                }
                                if (defaultAction <= 1) defaultAction ++;
                        }
                        editorFreeMarkersAndMarkerList(mm->markers);
                        mm->markers = NULL;
                }
                olcxPopOnly();
        }
}
static void refactoryPerformReduceNamesAndAddImports(S_editorRegionList **regions, int interactive) {
        S_editorBuffer *cb;
        S_editorRegionList **cr, **cl, *ncr, **ocr;
        { S_editorRegionList *_macrores; _macrores = (*regions); { S_editorRegionList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorRegionListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*regions) = _macrores;};
        cr = regions;
        while (*cr!=NULL) {
                cl = cr;
                cb = (*cr)->r.b->buffer;
                while (*cr!=NULL && (*cr)->r.b->buffer == cb) cr = &(*cr)->next;
                ncr = *cr;
                *cr = NULL;
                refactoryPerformReduceNamesAndAddImportsInSingleFile((*cl)->r.b, cl, interactive);
                cr = cl;
                while (*cr!=NULL) cr = &(*cr)->next;
                *cr = ncr;
        }
}
static void refactoryReduceLongNamesInTheFile(S_editorBuffer *buf, S_editorMarker *point) {
        S_editorRegionList *wholeBuffer;
        wholeBuffer = editorWholeBufferRegion(buf);
        refactoryPerformReduceNamesAndAddImportsInSingleFile(point, &wholeBuffer, INTERACTIVE_NO);
        editorFreeMarkersAndRegionList(wholeBuffer);wholeBuffer=NULL;
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static void refactoryAddToImports(S_editorBuffer *buf, S_editorMarker *point) {
        S_editorMarker *bb, *ee;
        S_editorRegionList *reg;
        bb = editorDuplicateMarker(point);
        ee = editorDuplicateMarker(point);
        editorMoveMarkerBeyondIdentifier(bb, -1);
        editorMoveMarkerBeyondIdentifier(ee, 1);
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (reg==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (reg)->r.b = bb; (reg)->r.e = ee; (reg)->next = NULL;};
        refactoryPerformReduceNamesAndAddImportsInSingleFile(point, &reg, INTERACTIVE_YES);
        editorFreeMarkersAndRegionList(reg); reg=NULL;
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static void refactoryPushAllReferencesOfMethod(S_editorMarker *m1, char *specialOption) {
        refactoryEditServerParseBuffer( s_ropt.project, m1->buffer, m1,NULL, "-olcxpushallinmethod", specialOption);
        olPushAllReferencesInBetween(s_cps.cxMemiAtMethodBeginning, s_cps.cxMemiAtMethodEnd);
}
static void moveFirstElementOfMarkerList(S_editorMarkerList **l1, S_editorMarkerList **l2) {
        S_editorMarkerList *mm;
        if (*l1!=NULL) {
                mm = *l1;
                *l1 = (*l1)->next;
                mm->next = NULL;
                { if ((*l2)==NULL) *l2 = mm; else { register S_editorMarkerList *tempnsl; tempnsl = *l2; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = mm; } };
        }
}
static void refactoryShowSafetyCheckFailingDialog(S_editorMarkerList **totalDiff, char *message) {
        S_editorUndo *redo;
        redo = NULL;
        editorUndoUntil(s_refactoringStartPoint, &redo);
        olcxPushSpecialCheckMenuSym(OLO_SAFETY_CHECK_INIT, "  Conflicting References");
        refactoryPushMarkersAsReferences(totalDiff, s_olcxCurrentUser->browserStack.top,
                                                                         "  Conflicting References");
        refactoryDisplayResolutionDialog(message, PPCV_BROWSER_TYPE_WARNING, CONTINUATION_DISABLED);
        editorApplyUndos(redo, NULL, &s_editorUndo, GEN_NO_OUTPUT);
}
static void refactoryStaticMoveCheckCorrespondance(
        S_olSymbolsMenu *menu1, S_olSymbolsMenu *menu2, S_symbolRefItem *theMethod
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorMarkerList *diff1, *diff2, *totalDiff, *mmm;
        int problem;
        problem = 0;
        totalDiff = NULL;
        mm1=menu1;
        while (mm1!=NULL) {
                if (itIsSameCxSymbolIncludingFunClass(&mm1->s, theMethod)) goto cont;
                if (mm1->s.b.storage == StorageAuto) goto cont;
                if (mm1->s.b.symType == TypeLabel) goto cont;
                if (isStrictlyEnclosingClass(mm1->s.vFunClass, theMethod->vFunClass)) goto cont;
                for(mm2=menu2; mm2!=NULL; mm2=mm2->next) {
                        if (itIsSameCxSymbolIncludingApplClass(&mm1->s, &mm2->s)) break;
                }
                if (mm2==NULL) {
                        moveFirstElementOfMarkerList(&mm1->markers, &totalDiff);
                } else {
                        editorMarkersDifferences(&mm1->markers, &mm2->markers, &diff1, &diff2);
                        if (diff1!=NULL) {
                                moveFirstElementOfMarkerList(&diff1, &totalDiff);
                        } else {
                                moveFirstElementOfMarkerList(&diff2, &totalDiff);
                        }
                        editorFreeMarkersAndMarkerList(diff1);
                        editorFreeMarkersAndMarkerList(diff2);
                }
                editorFreeMarkersAndMarkerList(mm1->markers);
                mm1->markers = NULL;
        cont:
                mm1=mm1->next;
        }
        for(mm2=menu2; mm2!=NULL; mm2=mm2->next) {
                editorFreeMarkersAndMarkerList(mm2->markers);
                mm2->markers = NULL;
        }
        if (totalDiff!=NULL) {
                        refactoryShowSafetyCheckFailingDialog(&totalDiff,"Those references will be  misinterpreted after refactoring. Fix them first. (each symbol is reported only once)");
                editorFreeMarkersAndMarkerList(totalDiff); totalDiff=NULL;
                refactoryAskForReallyContinueConfirmation();
        }
}
static void refactoryPerformMovingOfStaticObjectAndMakeItPublic(
        S_editorMarker *mstart, S_editorMarker *point, S_editorMarker *mend,
        S_editorMarker *target, char fqtname[], unsigned *outAccessFlags,
        int check, int limitIndex
        ) {
        char nameOnPoint[TMP_STRING_SIZE];
        int size, ppoffset;
        S_olSymbolsMenu *mm1, *mm2;
        S_editorMarker *pp, *ppp, *movedEnd;
        S_editorMarkerList *occs, *ll, *ll2, *rli, *rll;
        S_editorRegionList *regions, *lll;
        S_symbolRefItem *theMethod;
        S_editorUndo *undoStartPoint;
        int progressi, progressn;
        movedEnd = editorDuplicateMarker(mend);
        movedEnd->offset --;
        size = mend->offset - mstart->offset;
        if (target->buffer == mstart->buffer
                && target->offset > mstart->offset
                && target->offset < mstart->offset+size) {
                ppcGenRecord(PPC_INFORMATION, "You can't move something into itself.", "\n");
                return;
        }
        refactoryApplyExpandShortNames(point->buffer, point);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 2782);};
        occs = refactoryGetReferences(point->buffer, point,"Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ",PPCV_BROWSER_TYPE_INFO);
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym", "refactory.c", 2784);};
        if (outAccessFlags!=NULL) {
                *outAccessFlags = s_olcxCurrentUser->browserStack.top->hkSelectedSym->s.b.accessFlags;
        }
        undoStartPoint = s_editorUndo;
        { S_editorMarkerList *_macrores; _macrores = (occs); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (occs) = _macrores;};
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        regions = NULL;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if ((! ( ( (ll->usg.base)==UsageDefined || (ll->usg.base)==UsageOLBestFitDefined) || (ll->usg.base)==UsageDeclared ))
                        && ll->usg.base!=UsageConstructorDefinition) {
                        pp = refactoryReplaceStaticPrefix(ll->d, fqtname);
                        ppp = editorCrNewMarker(ll->d->buffer, ll->d->offset);
                        editorMoveMarkerBeyondIdentifier(ppp, 1);
                        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (lll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                        { (lll)->r.b = pp; (lll)->r.e = ppp; (lll)->next = regions;};
                        regions = lll;
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
        size = mend->offset - mstart->offset;
        if (check==NO_CHECKS) {
                editorMoveBlock(target, mstart, size, &s_editorUndo);
                refactoryChangeAccessModifier(point, limitIndex, "public");
        } else {
                { if (!(s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top->hkSelectedSym!=NULL)) internalCheckFail("s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top->hkSelectedSym!=NULL", "refactory.c", 2813);};
                theMethod = &s_olcxCurrentUser->browserStack.top->hkSelectedSym->s;
                refactoryPushAllReferencesOfMethod(point, "-olallchecks");
                createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, NULL);
                editorMoveBlock(target, mstart, size, &s_editorUndo);
                refactoryChangeAccessModifier(point, limitIndex, "public");
                refactoryPushAllReferencesOfMethod(point, "-olallchecks");
                createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, NULL);
                { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous", "refactory.c", 2821);};
                mm1 = s_olcxCurrentUser->browserStack.top->previous->menuSym;
                mm2 = s_olcxCurrentUser->browserStack.top->menuSym;
                refactoryStaticMoveCheckCorrespondance(mm1, mm2, theMethod);
        }
        pp = editorDuplicateMarker(mstart);
        ppp = editorDuplicateMarker(movedEnd);
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (lll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (lll)->r.b = pp; (lll)->r.e = ppp; (lll)->next = regions;};
        regions = lll;
        refactoryPerformReduceNamesAndAddImports(&regions, INTERACTIVE_NO);
}
static S_editorMarker *getTargetFromOptions() {
        S_editorMarker *target;
        S_editorBuffer *tb;
        int tline;
        tb = editorFindFileCreate(normalizeFileName(s_ropt.moveTargetFile, s_cwd));
        target = editorCrNewMarker(tb, 0);
        sscanf(s_ropt.refpar1, "%d", &tline);
        editorMoveMarkerToLineCol(target, tline, 0);
        return(target);
}
static void refactoryGetMethodLimitsForMoving(S_editorMarker *point,
                                                                                          S_editorMarker **_mstart,
                                                                                          S_editorMarker **_mend,
                                                                                          int limitIndex
        ) {
        S_editorMarker *mstart, *mend;
        refactoryMakeSyntaxPassOnSource(point);
        if (s_spp[limitIndex].file==s_noneFileIndex || s_spp[limitIndex+1].file==s_noneFileIndex) {
                fatalError(ERR_INTERNAL, "Can't find declaration coordinates", 65);
        }
        mstart = editorCrNewMarkerForPosition(&s_spp[limitIndex]);
        mend = editorCrNewMarkerForPosition(&s_spp[limitIndex+1]);
        refactoryMoveMarkerToTheBeginOfDefinitionScope(mstart);
        refactoryMoveMarkerToTheEndOfDefinitionScope(mend);
        { if (!(mstart->buffer == mend->buffer)) internalCheckFail("mstart->buffer == mend->buffer", "refactory.c", 2867);};
        *_mstart = mstart;
        *_mend = mend;
}
static void refactoryGetNameOfTheClassAndSuperClass(S_editorMarker *point, char *ccname, char *supercname) {
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                        point,NULL, "-olcxcurrentclass",NULL);
        if (ccname != NULL) {
                if (s_cps.currentClassAnswer[0] == 0) {
                        fatalError(ERR_ST, "can't get class on point", 65);
                }
                strcpy(ccname, s_cps.currentClassAnswer);
                javaDotifyClassName(ccname);
        }
        if (supercname != NULL) {
                if (s_cps.currentSuperClassAnswer[0] == 0) {
                        fatalError(ERR_ST, "can't get superclass of class on point", 65);
                }
                strcpy(supercname, s_cps.currentSuperClassAnswer);
                javaDotifyClassName(supercname);
        }
}
static void refactoryMoveStaticFieldOrMethod(S_editorMarker *point, int limitIndex) {
        char targetFqtName[MAX_FILE_NAME_SIZE];
        int lines;
        unsigned accFlags;
        S_editorMarker *target, *mstart, *mend;
        target = getTargetFromOptions();
        if (! validTargetPlace(target, "-olcxmmtarget")) return;
        refactoryUpdateReferences(s_ropt.project);
        refactoryGetNameOfTheClassAndSuperClass(target, targetFqtName, NULL);
        refactoryGetMethodLimitsForMoving(point, &mstart, &mend, limitIndex);
        lines = editorCountLinesBetweenMarkers(mstart, mend);
        refactoryPerformMovingOfStaticObjectAndMakeItPublic(mstart, point, mend, target,
                                                                                                                targetFqtName,
                                                                                                                &accFlags, APPLY_CHECKS, limitIndex);
        refactoryRestrictAccessibility(point, limitIndex, accFlags);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
        ppcGenNumericRecord(PPC_INDENT, lines, "", "\n");
}
static void refactoryMoveStaticMethod(S_editorMarker *point) {
        refactoryMoveStaticFieldOrMethod(point, SPP_METHOD_DECLARATION_BEGIN_POSITION);
}
static void refactoryMoveStaticField(S_editorMarker *point) {
        refactoryMoveStaticFieldOrMethod(point, SPP_FIELD_DECLARATION_BEGIN_POSITION);
}
static void refactoryMoveField(S_editorMarker *point) {
        char targetFqtName[MAX_FILE_NAME_SIZE];
        char nameOnPoint[TMP_STRING_SIZE];
        char prefixDot[TMP_STRING_SIZE];
        int lines, size, check, accessFlags;
        S_editorMarker *target, *mstart, *mend, *movedEnd;
        S_editorMarkerList *occs, *noccs, *ll;
        S_editorMarker *pp, *ppp;
        S_editorRegionList *regions, *lll;
        S_editorUndo *undoStartPoint, *redoTrack;
        int progressi, progressn;
        target = getTargetFromOptions();
        if (s_ropt.refpar2!=NULL && *s_ropt.refpar2!=0) {
                sprintf(prefixDot, "%s.", s_ropt.refpar2);
        } else {
                sprintf(prefixDot, "");
        }
        if (! validTargetPlace(target, "-olcxmmtarget")) return;
        refactoryUpdateReferences(s_ropt.project);
        refactoryGetNameOfTheClassAndSuperClass(target, targetFqtName, NULL);
        refactoryGetMethodLimitsForMoving(point, &mstart, &mend, SPP_FIELD_DECLARATION_BEGIN_POSITION);
        lines = editorCountLinesBetweenMarkers(mstart, mend);
        movedEnd = editorDuplicateMarker(mend);
        movedEnd->offset --;
        size = mend->offset - mstart->offset;
        if (target->buffer == mstart->buffer
                && target->offset > mstart->offset
                && target->offset < mstart->offset+size) {
                ppcGenRecord(PPC_INFORMATION, "You can't move something into itself.", "\n");
                return;
        }
        refactoryApplyExpandShortNames(point->buffer, point);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 2976);};
        occs = refactoryGetReferences(point->buffer, point,"Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ",PPCV_BROWSER_TYPE_INFO);
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym", "refactory.c", 2978);};
        accessFlags = s_olcxCurrentUser->browserStack.top->hkSelectedSym->s.b.accessFlags;
        undoStartPoint = s_editorUndo;
        { S_editorMarkerList *_macrores; _macrores = (occs); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (occs) = _macrores;};
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        regions = NULL;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (! ( ( (ll->usg.base)==UsageDefined || (ll->usg.base)==UsageOLBestFitDefined) || (ll->usg.base)==UsageDeclared )) {
                        if (*prefixDot != 0) {
                                refactoryReplaceString(ll->d, 0, prefixDot);
                        }
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
        size = mend->offset - mstart->offset;
        editorMoveBlock(target, mstart, size, &s_editorUndo);
        pp = editorDuplicateMarker(mstart);
        ppp = editorDuplicateMarker(movedEnd);
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (lll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (lll)->r.b = pp; (lll)->r.e = ppp; (lll)->next = regions;};
        regions = lll;
        refactoryPerformReduceNamesAndAddImports(&regions, INTERACTIVE_NO);
        refactoryChangeAccessModifier(point, SPP_FIELD_DECLARATION_BEGIN_POSITION, "public");
        refactoryRestrictAccessibility(point, SPP_FIELD_DECLARATION_BEGIN_POSITION, accessFlags);
        redoTrack = NULL;
        check = refactoryMakeSafetyCheckAndUndo(point->buffer, point, &occs,
                                                                                        undoStartPoint, &redoTrack);
        if (! check) {
                refactoryAskForReallyContinueConfirmation();
        }
        editorApplyUndos(redoTrack, NULL, NULL, GEN_FULL_OUTPUT);
        ppcGenGotoMarkerRecord(point);
        ppcGenNumericRecord(PPC_INDENT, lines, "", "\n");
}
static void refactorySetMovingPrecheckStandardEnvironment(S_editorMarker *point, char *targetFqtName) {
        S_olSymbolsMenu *ss;
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                        point, NULL, "-olcxtrivialprecheck",NULL);
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 3030);};
        olCreateSelectionMenu(s_olcxCurrentUser->browserStack.top->command);
        s_opt.moveTargetFile = s_ropt.moveTargetFile;
        s_opt.moveTargetClass = targetFqtName;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->browserStack.top", "refactory.c", 3034);};
        ss = s_olcxCurrentUser->browserStack.top->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 3036);};
}
static void refactoryPerformMoveClass(S_editorMarker *point, S_editorMarker *target,
                                                                          S_editorMarker **outstart, S_editorMarker **outend
        ) {
        char spack[MAX_FILE_NAME_SIZE];
        char tpack[MAX_FILE_NAME_SIZE];
        char targetFqtName[MAX_FILE_NAME_SIZE];
        int i, targetIsNestedInClass;
        S_editorMarker *mm, *mstart, *mend;
        S_editorBuffer *tb;
        S_olSymbolsMenu *ss;
        S_tpCheckMoveClassData dd;
        *outstart = *outend = NULL;
        refactoryEditServerParseBuffer( s_ropt.project, target->buffer,
                                                                   target,NULL, "-olcxcurrentclass",NULL);
        if (s_cps.currentPackageAnswer[0] == 0) {
                error(ERR_ST, "Can't get target class or package");
                return;
        }
        if (s_cps.currentClassAnswer[0] == 0) {
                sprintf(targetFqtName, "%s", s_cps.currentPackageAnswer);
                targetIsNestedInClass = 0;
        } else {
                sprintf(targetFqtName, "%s", s_cps.currentClassAnswer);
                targetIsNestedInClass = 1;
        }
        javaDotifyClassName(targetFqtName);
        refactoryMakeSyntaxPassOnSource(point);
        if (s_spp[SPP_CLASS_DECLARATION_BEGIN_POSITION].file==s_noneFileIndex
                ||s_spp[SPP_CLASS_DECLARATION_END_POSITION].file==s_noneFileIndex) {
                fatalError(ERR_INTERNAL, "Can't find declaration coordinates", 65);
        }
        mstart = editorCrNewMarkerForPosition(&s_spp[SPP_CLASS_DECLARATION_BEGIN_POSITION]);
        mend = editorCrNewMarkerForPosition(&s_spp[SPP_CLASS_DECLARATION_END_POSITION]);
        refactoryMoveMarkerToTheBeginOfDefinitionScope(mstart);
        refactoryMoveMarkerToTheEndOfDefinitionScope(mend);
        { if (!(mstart->buffer == mend->buffer)) internalCheckFail("mstart->buffer == mend->buffer", "refactory.c", 3079);};
        *outstart = mstart;
        *outend = editorCrNewMarker(mend->buffer, mend->offset-1);
        refactorySetMovingPrecheckStandardEnvironment(point, targetFqtName);
        ss = s_olcxCurrentUser->browserStack.top->hkSelectedSym;
        tpCheckFillMoveClassData(&dd, spack, tpack);
        tpCheckSourceIsNotInnerClass();
        tpCheckMoveClassAccessibilities();
        refactoryPerformMovingOfStaticObjectAndMakeItPublic(mstart, point, mend, target, targetFqtName, NULL, NO_CHECKS, SPP_CLASS_DECLARATION_BEGIN_POSITION);
        (*outend)->offset++;
        if (ss->s.b.accessFlags & 0x008) {
                if (! targetIsNestedInClass) {
                        refactoryRemoveModifier(point, SPP_CLASS_DECLARATION_BEGIN_POSITION, "static");
                }
        } else {
                if (targetIsNestedInClass) {
                        refactoryAddModifier(point, SPP_CLASS_DECLARATION_BEGIN_POSITION, "static");
                }
        }
        if (dd.transPackageMove) {
                refactoryChangeAccessModifier(point, SPP_CLASS_DECLARATION_BEGIN_POSITION, "public");
        }
}
static void refactoryMoveClass(S_editorMarker *point) {
        S_editorMarker *target, *mstart, *mend;
        int linenum;
        target = getTargetFromOptions();
        if (! validTargetPlace(target, "-olcxmctarget")) return;
        refactoryUpdateReferences(s_ropt.project);
        refactoryPerformMoveClass(point, target, &mstart, &mend);
        linenum = editorCountLinesBetweenMarkers(mstart, mend);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
        ppcGenNumericRecord(PPC_INDENT, linenum, "", "\n");
        ppcGenRecord(PPC_INFORMATION, "\nDone.\nDo not forget to remove .class files of former class.", "\n");
}
static void refactoryGetPackageNameFromMarkerFileName(S_editorMarker *target, char *tclass) {
        char *dd;
        strcpy(tclass, javaCutSourcePathFromFileName(target->buffer->name));
        dd = lastOccurenceInString(tclass, '.');
        if (dd!=NULL) *dd=0;
        dd = lastOccurenceOfSlashOrAntiSlash(tclass);
        if (dd!=NULL) {
                *dd=0;
                javaDotifyFileName(tclass);
        } else {
                *tclass = 0;
        }
}
static void refactoryInsertPackageStatToNewFile(S_editorMarker *src, S_editorMarker *target) {
        char tclass[MAX_FILE_NAME_SIZE];
        char sclass[MAX_FILE_NAME_SIZE];
        char pack[MAX_FILE_NAME_SIZE];
        char *dd, *sdd;
        refactoryGetPackageNameFromMarkerFileName(target, tclass);
        if (tclass[0] == 0) {
                sprintf(pack, "\n");
        } else {
                sprintf(pack, "package %s;\n", tclass);
        }
        sprintf(pack+strlen(pack), "\n\n");
        refactoryReplaceString(target, 0, pack);
        target->offset --;
}
static void refactoryMoveClassToNewFile(S_editorMarker *point) {
        S_editorMarker *target, *mstart, *mend, *npoint;
        S_editorBuffer *buff, *buf;
        int linenum;
        char *dd;
        buff = point->buffer;
        refactoryUpdateReferences(s_ropt.project);
        target = getTargetFromOptions();
        refactoryInsertPackageStatToNewFile(point, target);
        refactoryPerformMoveClass(point, target, &mstart, &mend);
        if (mstart==NULL || mend==NULL) return;
        linenum = editorCountLinesBetweenMarkers(mstart, mend);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
        ppcGenNumericRecord(PPC_INDENT, linenum, "", "\n");
        npoint = editorCrNewMarker(buff, 0);
        refactoryEditServerParseBuffer(s_ropt.project, npoint->buffer, npoint,NULL, "-olcxpushspecialname=", NULL);
        if (s_spp[SPP_LAST_TOP_LEVEL_CLASS_POSITION].file == s_noneFileIndex) {
                ppcGenGotoMarkerRecord(npoint);
                ppcGenRecord(PPC_KILL_BUFFER_REMOVE_FILE, "This file does not contain classes anymore, can I remove it?", "\n");
        }
        ppcGenRecord(PPC_INFORMATION, "\nDone.\nDo not forget to remove .class files of former class.", "\n");
}
static void refactoryMoveAllClassesToNewFile(S_editorMarker *point) {
}
static void refactoryAddCopyOfMarkerToList(S_editorMarkerList **ll, S_editorMarker *mm, S_usageBits *usage) {
        S_editorMarker *nn;
        S_editorMarkerList *lll;
        nn = editorCrNewMarker(mm->buffer, mm->offset);
        { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (lll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (lll)->d = nn; (lll)->usg = *usage; (lll)->next = *ll;};
        *ll = lll;
}
static void refactoryTurnDynamicToStatic(S_editorMarker *point) {
        char nameOnPoint[TMP_STRING_SIZE];
        char primary[REFACTORING_TMP_STRING_SIZE];
        char fqstaticname[REFACTORING_TMP_STRING_SIZE];
        char fqthis[REFACTORING_TMP_STRING_SIZE];
        char pardecl[REFACTORING_TMP_STRING_SIZE];
        char parusage[REFACTORING_TMP_STRING_SIZE];
        char cid[TMP_STRING_SIZE];
        int plen, ppoffset, poffset;
        int progressi, progressj, progressn;
        S_editorMarker *pp, *ppp, *nparamdefpos;
        S_editorMarkerList *ll, *markers, *occs, *allrefs;
        S_editorMarkerList *npoccs, *npadded, *diff1, *diff2;
        S_editorRegionList *regions, **reglast, *lll;
        S_olSymbolsMenu *csym, *mm;
        S_editorUndo *undoStartPoint;
        S_usageBits defusage;
        nparamdefpos = NULL;
        refactoryUpdateReferences(s_ropt.project);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 3254);};
        occs = refactoryPushGetAndPreCheckReferences(point->buffer, point, nameOnPoint,
                                                                                                 "If  you see  this  message it  is  highly probable  that turning  this virtual  method into  static will  not be  behaviour  preserving! This refactoring is  behaviour preserving only  if the method does  not use mechanism of virtual invocations. In this dialog you should select the application classes which are refering to the method which will become static. If  you can't unambiguously determine those  references do not continue in this refactoring!",
                                                                                                 PPCV_BROWSER_TYPE_WARNING);
        editorFreeMarkersAndMarkerList(occs);
        if (! tpCheckOuterScopeUsagesForDynToSt()) return;
        if (! tpCheckSuperMethodReferencesForDynToSt()) return;
        csym = s_olcxCurrentUser->browserStack.top->hkSelectedSym;
        javaGetClassNameFromFileNum(csym->s.vFunClass, fqstaticname, DOTIFY_NAME);
        javaDotifyClassName(fqstaticname);
        sprintf(pardecl, "%s %s", fqstaticname, s_ropt.refpar1);
        sprintf(fqstaticname+strlen(fqstaticname), ".");
        progressn = progressi = 0;
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        mm->markers = editorReferencesToMarkers(mm->s.refs, filter0, NULL);
                        { S_editorMarkerList *_macrores; _macrores = (mm->markers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (mm->markers) = _macrores;};
                        { register S_editorMarkerList *tmp; register int co=0; tmp = mm->markers; while (tmp!=NULL) {++co; tmp = tmp->next; } progressj = co; };
                        progressn += progressj;
                }
        }
        undoStartPoint = s_editorUndo;
        regions = NULL; reglast = &regions; allrefs = NULL;
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        javaGetClassNameFromFileNum(mm->s.vApplClass, fqthis, DOTIFY_NAME);
                        javaDotifyClassName(fqthis);
                        sprintf(fqthis+strlen(fqthis), ".this");
                        for(ll=mm->markers; ll!=NULL; ll=ll->next) {
                                refactoryAddCopyOfMarkerToList(&allrefs, ll->d, &ll->usg);
                                pp = NULL;
                                if (( ( (ll->usg.base)==UsageDefined || (ll->usg.base)==UsageOLBestFitDefined) || (ll->usg.base)==UsageDeclared )) {
                                        pp = editorCrNewMarker(ll->d->buffer, ll->d->offset);
                                        pp->offset = refactoryAddStringAsParameter(ll->d, ll->d, nameOnPoint,
                                                                                                                           1, pardecl);
                                        nparamdefpos = editorCrNewMarker(pp->buffer, pp->offset+strlen(pardecl)-strlen(s_ropt.refpar1));
                                } else {
                                        pp = refactoryCrNewMarkerForExpressionBegin(ll->d, GET_PRIMARY_START);
                                        { if (!(pp!=NULL)) internalCheckFail("pp!=NULL", "refactory.c", 3298);};
                                        ppoffset = pp->offset;
                                        plen = ll->d->offset - pp->offset;
                                        strncpy(primary, (pp->buffer->a.text+pp->offset), plen);
                                        while (plen>0 && primary[plen-1]!='.') plen--;
                                        if (plen>0) {
                                                primary[plen-1] = 0;
                                        } else {
                                                if (javaLinkNameIsAnnonymousClass(mm->s.name)) {
                                                        strcpy(primary, "this");
                                                } else {
                                                        strcpy(primary, fqthis);
                                                }
                                        }
                                        refactoryReplaceString(pp, ll->d->offset-pp->offset, fqstaticname);
                                        refactoryAddStringAsParameter(ll->d, ll->d, nameOnPoint, 1, primary);
                                        pp->offset = ppoffset;
                                }
                                ppp = editorCrNewMarker(ll->d->buffer, ll->d->offset);
                                editorMoveMarkerBeyondIdentifier(ppp, 1);
                                { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (lll==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { lll = NULL; } else { lll = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                                { (lll)->r.b = pp; (lll)->r.e = ppp; (lll)->next = NULL;};
                                *reglast = lll;
                                reglast = &lll->next;
                                writeRelativeProgress((progressi++)*100/progressn);
                        }
                        editorFreeMarkersAndMarkerList(mm->markers);
                        mm->markers = NULL;
                }
        }
        writeRelativeProgress(100);
        s_olcxCurrentUser->browserStack.top = s_olcxCurrentUser->browserStack.top->previous;
        sprintf(parusage, "%s.", s_ropt.refpar1);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL, "-olcxmaybethis",NULL);
        olcxPushSpecial("  method's \"maybe this\" dependencies", OLO_MAYBE_THIS);
        progressn = progressi = 0;
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym", "refactory.c", 3341);};
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        mm->markers = editorReferencesToMarkers(mm->s.refs, filter0, NULL);
                        { S_editorMarkerList *_macrores; _macrores = (mm->markers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (mm->markers) = _macrores;};
                        { register S_editorMarkerList *tmp; register int co=0; tmp = mm->markers; while (tmp!=NULL) {++co; tmp = tmp->next; } progressj = co; };
                        progressn += progressj;
                }
        }
        npadded = NULL;
        { (&defusage)->base = UsageDefined; (&defusage)->requiredAccess = 0; (&defusage)->dummy = 0;};
        refactoryAddCopyOfMarkerToList(&npadded, nparamdefpos, &defusage);
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        for(ll=mm->markers; ll!=NULL; ll=ll->next) {
                                if (ll->usg.base == UsageMaybeQualifThisInClassOrMethod) {
                                        editorUndoUntil(undoStartPoint,NULL);
                                        ppcGenGotoMarkerRecord(ll->d);
                                        error(ERR_ST, "The method is using qualified this to access enclosed instance. Do not know how to make it static.");
                                        return;
                                } else if (ll->usg.base == UsageMaybeThisInClassOrMethod) {
                                        strncpy(cid, refactoryGetIdentifierOnMarker_st(ll->d), TMP_STRING_SIZE);
                                        cid[TMP_STRING_SIZE-1]=0;
                                        poffset = ll->d->offset;
                                        if (strcmp(cid, "this")==0 || strcmp(cid, "super")==0) {
                                                pp = refactoryReplaceStaticPrefix(ll->d, "");
                                                poffset = pp->offset;
                                                editorFreeMarker(pp);
                                                refactoryCheckedReplaceString(ll->d, 4, cid, s_ropt.refpar1);
                                        } else {
                                                refactoryReplaceString(ll->d, 0, parusage);
                                        }
                                        ll->d->offset = poffset;
                                        refactoryAddCopyOfMarkerToList(&npadded, ll->d, &ll->usg);
                                }
                                writeRelativeProgress((progressi++)*100/progressn);
                        }
                }
        }
        writeRelativeProgress(100);
        refactoryAddModifier(point, SPP_METHOD_DECLARATION_BEGIN_POSITION, "static");
        refactoryPerformReduceNamesAndAddImports(&regions, INTERACTIVE_NO);
        editorFreeMarkersAndRegionList(regions); regions=NULL;
        npoccs = refactoryGetReferences(
                nparamdefpos->buffer, nparamdefpos,
                "Internal problem, during new parameter resolution",
                PPCV_BROWSER_TYPE_WARNING);
        editorMarkersDifferences(&npoccs, &npadded, &diff1, &diff2);
        { if ((diff1)==NULL) diff1 = diff2; else { register S_editorMarkerList *tempnsl; tempnsl = diff1; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = diff2; } }; diff2=NULL;
        if (diff1!=NULL) {
                ppcGenGotoMarkerRecord(point);
                refactoryShowSafetyCheckFailingDialog( &diff1, "The new parameter conflicts with existing symbols");
        }
        if (npoccs != NULL && npoccs->next == NULL) {
                if (( (npoccs->usg.base)==UsageDefined || (npoccs->usg.base)==UsageOLBestFitDefined)) {
                        refactoryApplyParamManip(nameOnPoint, allrefs, PPC_AVR_DEL_PARAMETER, 1, 1);
                }
        }
        editorFreeMarkersAndMarkerList(allrefs); allrefs=NULL;
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static int noSpaceChar(int c) {return(! isspace(c));}
static void dumpRefernces(S_reference *rr) {
        S_reference *r;
        fprintf(dumpOut, "[dump]");
        for(r=rr; r!=NULL; r=r->next) {
                fprintf(dumpOut,"%s:%d:%d\n", s_fileTab.tab[r->p.file]->name, r->p.line, r->p.coll);
        }
        fprintf(dumpOut, "\n\n");
}
static void refactoryPushMethodSymbolsPlusThoseWithClearedRegion(
        S_editorMarker *m1, S_editorMarker *m2
        ) {
        char spaces[REFACTORING_TMP_STRING_SIZE];
        S_editorUndo *undoMark;
        int slen;
        { if (!(m1->buffer == m2->buffer)) internalCheckFail("m1->buffer == m2->buffer", "refactory.c", 3444);};
        undoMark = s_editorUndo;
        refactoryPushAllReferencesOfMethod(m1,NULL);
        slen = m2->offset-m1->offset;
        { if (!(slen>=0 && slen<REFACTORING_TMP_STRING_SIZE)) internalCheckFail("slen>=0 && slen<REFACTORING_TMP_STRING_SIZE", "refactory.c", 3448);};
        memset(spaces, ' ', slen);
        spaces[slen]=0;
        refactoryReplaceString(m1, slen, spaces);
        refactoryPushAllReferencesOfMethod(m1,NULL);
        editorUndoUntil(undoMark,NULL);
}
static int refactoryIsMethodPartRedundant(
        S_editorMarker *m1, S_editorMarker *m2
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorUndo *undoMark;
        S_reference *diff;
        S_editorMarkerList *lll, *ll;
        int slen, res;
        refactoryPushMethodSymbolsPlusThoseWithClearedRegion(m1, m2);
        res = 1;
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous", "refactory.c", 3467);};
        mm1 = s_olcxCurrentUser->browserStack.top->menuSym;
        mm2 = s_olcxCurrentUser->browserStack.top->previous->menuSym;
        while (mm1!=NULL && mm2!=NULL && res!=0) {
                olcxReferencesDiff(&mm1->s.refs, &mm2->s.refs, &diff);
                if (diff!=NULL) {
                        lll = editorReferencesToMarkers(diff, filter0, NULL);
                        { S_editorMarkerList *_macrores; _macrores = (lll); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (lll) = _macrores;};
                        for (ll=lll; ll!=NULL; ll=ll->next) {
                                { if (!(ll->d->buffer == m1->buffer)) internalCheckFail("ll->d->buffer == m1->buffer", "refactory.c", 3478);};
                                if (editorMarkerLess(ll->d, m1) || editorMarkerLessOrEq(m2, ll->d)) {
                                        res=0;
                                }
                        }
                        editorFreeMarkersAndMarkerList(lll);
                        olcxFreeReferences(diff);
                }
                mm1 = mm1->next;
                mm2 = mm2->next;
        }
        olcxPopOnly();
        olcxPopOnly();
        return(res);
}
static void refactoryRemoveMethodPartIfRedundant(S_editorMarker *m, int len) {
        S_editorMarker *mm;
        mm = editorCrNewMarker(m->buffer, m->offset+len);
        if (refactoryIsMethodPartRedundant(m, mm)) {
                refactoryReplaceString(m, len, "");
        }
        editorFreeMarker(mm);
}
static int isMethodBeg(int c) {return(c=='{');}
static int staticToDynCanBeThisOccurence(S_editorMarker *pp, char *param, int *rlen) {
        char *pp2;
        S_editorMarker *mm;
        int res = 0;
        mm = editorCrNewMarker(pp->buffer, pp->offset);
        pp2 = strchr(param, '.');
        if (pp2==NULL) {
                *rlen = strlen(param);
                res = strcmp(refactoryGetIdentifierOnMarker_st(pp), param)==0;
                goto fini;
        }
        if (strncmp(refactoryGetIdentifierOnMarker_st(mm), param, pp2-param)!=0) goto fini;
        mm->offset += (pp2-param);
        editorMoveMarkerToNonBlank(mm, 1);
        if (*((mm->buffer->a.text+mm->offset)) != '.') goto fini;
        mm->offset ++;
        editorMoveMarkerToNonBlank(mm, 1);
        if (strcmp(refactoryGetIdentifierOnMarker_st(mm), pp2+1)!=0) goto fini;
        *rlen = mm->offset - pp->offset + strlen(pp2+1);
        res = 1;
 fini:
        editorFreeMarker(mm);
        return(res);
}
static void refactoryTurnStaticToDynamic(S_editorMarker *point) {
        char nameOnPoint[TMP_STRING_SIZE];
        char param[REFACTORING_TMP_STRING_SIZE];
        char tparam[REFACTORING_TMP_STRING_SIZE];
        char testi[REFACTORING_TMP_STRING_SIZE];
        int plen, tplen, rlen, res, argn, bi;
        int classnum, parclassnum;
        int progressi, progressn;
        S_editorMarker *mm, *m1, *m2, *pp;
        S_editorMarkerList *ll, *occs, *poccs;
        S_editorUndo *checkPoint;
        refactoryUpdateReferences(s_ropt.project);
        argn = 0;
        sscanf(s_ropt.refpar1, "%d", &argn);
        { if (!(argn!=0)) internalCheckFail("argn!=0", "refactory.c", 3552);};
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        res = refactoryGetParamNamePosition(point, nameOnPoint, argn);
        if (res != 0) {
                ppcGenGotoMarkerRecord(point);
                error(ERR_INTERNAL, "Can't determine position of parameter");
                return;
        }
        mm = editorCrNewMarkerForPosition(&s_paramPosition);
        if (s_ropt.refpar2[0]!=0) {
                sprintf(param, "%s.%s", refactoryGetIdentifierOnMarker_st(mm), s_ropt.refpar2);
        } else {
                sprintf(param, "%s", refactoryGetIdentifierOnMarker_st(mm));
        }
        plen = strlen(param);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                   point,NULL, "-olcxcurrentclass",NULL);
        if (s_cps.currentClassAnswer[0] == 0) {
                error(ERR_INTERNAL, "Can't get current class");
                return;
        }
        classnum = getClassNumFromClassLinkName(s_cps.currentClassAnswer, s_noneFileIndex);
        if (classnum==s_noneFileIndex) {
                error(ERR_INTERNAL, "Problem when getting current class");
                return;
        }
        checkPoint = s_editorUndo;
        pp = editorCrNewMarker(point->buffer, point->offset);
        res = editorRunWithMarkerUntil(pp, isMethodBeg, 1);
        if (! res) {
                error(ERR_INTERNAL, "Can't find beginning of method");
                return;
        }
        pp->offset ++;
        sprintf(testi, "xxx(%s)", param);
        bi = pp->offset + 3 + plen;
        editorReplaceString(pp->buffer, pp->offset, 0, testi, strlen(testi), &s_editorUndo);
        pp->offset = bi;
        refactoryEditServerParseBuffer( s_ropt.project, pp->buffer,
                                                                   pp,NULL, "-olcxgetsymboltype","-noerrors");
        s_opt.noErrors = 0;
        if (! s_olstringServed) {
                error(ERR_ST, "Can't infer type for parameter/field");
                return;
        }
        parclassnum = getClassNumFromClassLinkName(s_olSymbolClassType, s_noneFileIndex);
        if (parclassnum==s_noneFileIndex) {
                error(ERR_INTERNAL, "Problem when getting parameter/field class");
                return;
        }
        if (! isSmallerOrEqClass(parclassnum, classnum)) {
                error(ERR_ST, "Type of parameter.field must be current class or its subclass");
                return;
        }
        editorUndoUntil(checkPoint, NULL);
        editorFreeMarker(pp);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 3619);};
        occs = refactoryPushGetAndPreCheckReferences(point->buffer, point, nameOnPoint,"Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ",PPCV_BROWSER_TYPE_INFO);
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (! ( ( (ll->usg.base)==UsageDefined || (ll->usg.base)==UsageOLBestFitDefined) || (ll->usg.base)==UsageDeclared )) {
                        res = refactoryGetParamPosition(ll->d, nameOnPoint, argn);
                        if (res == 0) {
                                m1 = editorCrNewMarkerForPosition(&s_paramBeginPosition);
                                m1->offset ++;
                                editorRunWithMarkerUntil(m1, noSpaceChar, 1);
                                m2 = editorCrNewMarkerForPosition(&s_paramEndPosition);
                                m2->offset --;
                                editorRunWithMarkerUntil(m2, noSpaceChar, -1);
                                m2->offset ++;
                                tplen = m2->offset - m1->offset;
                                { if (!(tplen < REFACTORING_TMP_STRING_SIZE-1)) internalCheckFail("tplen < REFACTORING_TMP_STRING_SIZE-1", "refactory.c", 3635);};
                                strncpy(tparam, (m1->buffer->a.text+m1->offset), tplen);
                                tparam[tplen] = 0;
                                if (strcmp(tparam, "this")!=0) {
                                        if (s_ropt.refpar2[0]!=0) {
                                                sprintf(tparam+strlen(tparam), ".%s", s_ropt.refpar2);
                                        }
                                        pp = refactoryReplaceStaticPrefix(ll->d, tparam);
                                        editorFreeMarker(pp);
                                }
                                editorFreeMarker(m2);
                                editorFreeMarker(m1);
                        }
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
        refactoryRemoveModifier(point, SPP_METHOD_DECLARATION_BEGIN_POSITION, "static");
        poccs = refactoryGetReferences(
                mm->buffer, mm,
                "Select classes in left window. Those classes will be processed during refactoring. It is highly recommended to process whole hierarchy of related classes at once. Unselection of any class and its exclusion from refactoring may cause changes in your program behaviour. ", PPCV_BROWSER_TYPE_INFO
                );
        for(ll=poccs; ll!=NULL; ll=ll->next) {
                if (! ( ( (ll->usg.base)==UsageDefined || (ll->usg.base)==UsageOLBestFitDefined) || (ll->usg.base)==UsageDeclared )) {
                        if (ll->d->offset+plen <= ll->d->buffer->a.bufferSize
                                && staticToDynCanBeThisOccurence(ll->d, param, &rlen)) {
                                refactoryReplaceString(ll->d, rlen, "this");
                                refactoryRemoveMethodPartIfRedundant(ll->d, strlen("this."));
                        }
                }
        }
        if (! refactoryIsThisSymbolUsed(mm)) {
                refactoryApplyParameterManipulation(point->buffer, point, PPC_AVR_DEL_PARAMETER, argn, 0);
        } else {
                writeRelativeProgress(100);
        }
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static void refactoryExtractMethod(S_editorMarker *point, S_editorMarker *mark) {
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point, mark,
                                                                        "-olcxextract", NULL);
}
static void refactoryExtractMacro(S_editorMarker *point, S_editorMarker *mark) {
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point, mark,
                                                                        "-olcxextract", "-olexmacro");
}
static S_reference *refactoryCheckEncapsulateGetterSetterForExistingMethods(char *mname) {
        S_olSymbolsMenu *mm, *hk;
        char clist[REFACTORING_TMP_STRING_SIZE];
        char cn[TMP_STRING_SIZE];
        S_reference *rr, *anotherDefinition;
        clist[0] = 0;
        { if (!(s_olcxCurrentUser->browserStack.top)) internalCheckFail("s_olcxCurrentUser->browserStack.top", "refactory.c", 3711);};
        { if (!(s_olcxCurrentUser->browserStack.top->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top->hkSelectedSym", "refactory.c", 3712);};
        { if (!(s_olcxCurrentUser->browserStack.top->menuSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top->menuSym", "refactory.c", 3713);};
        anotherDefinition = NULL;
        hk = s_olcxCurrentUser->browserStack.top->hkSelectedSym;
        for(mm=s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (itIsSameCxSymbol(&mm->s, &hk->s) && mm->defRefn != 0) {
                        if (mm->s.vFunClass==hk->s.vFunClass) {
                                for(rr=mm->s.refs; rr!=NULL; rr=rr->next) {
                                        if (( (rr->usg.base)==UsageDefined || (rr->usg.base)==UsageOLBestFitDefined)) {
                                                if (( ((rr->p).file != (hk->defpos).file) || ((rr->p).line != (hk->defpos).line) || ((rr->p).coll != (hk->defpos).coll) )) {
                                                        anotherDefinition = rr;
                                                        goto refbreak;
                                                }
                                        }
                                }
                        refbreak:;
                        } else {
                                if (isSmallerOrEqClass(mm->s.vFunClass, hk->s.vFunClass)
                                        || isSmallerOrEqClass(hk->s.vFunClass, mm->s.vFunClass)) {
                                        linkNamePrettyPrint(cn,
                                                                                getShortClassNameFromClassNum_st(mm->s.vFunClass),
                                                                                TMP_STRING_SIZE,
                                                                                SHORT_NAME);
                                        if (substringIndex(clist, cn) == -1) {
                                                sprintf(clist+strlen(clist), " %s", cn);
                                        }
                                }
                        }
                }
        }
        if (clist[0] != 0) {
                sprintf(tmpBuff,
                                "The method %s is also defined in following related classes: %s. Its definition in  current class may  (under some  circumstance) change  your program behaviour. Do you really  want to continue in this refactoring?", mname, clist);
                formatOutputLine(tmpBuff, 10);
                ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
        }
        if (anotherDefinition!=NULL) {
                sprintf(tmpBuff, "The method %s is yet defined in this class. Xrefactory will not generate new method. Continue anyway?", mname);
                formatOutputLine(tmpBuff, 10);
                ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
        }
        return(anotherDefinition);
}
static void refactoryAddMethodToForbiddenRegions(S_reference *methodRef,
                                                                                                 S_editorRegionList **forbiddenRegions
        ) {
        S_editorMarker *mm, *mb, *me;
        S_editorRegionList *reg;
        mm = editorCrNewMarkerForPosition(&methodRef->p);
        refactoryMakeSyntaxPassOnSource(mm);
        mb = editorCrNewMarkerForPosition(&s_spp[SPP_METHOD_DECLARATION_BEGIN_POSITION]);
        me = editorCrNewMarkerForPosition(&s_spp[SPP_METHOD_DECLARATION_END_POSITION]);
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (reg==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (reg)->r.b = mb; (reg)->r.e = me; (reg)->next = *forbiddenRegions;};
        *forbiddenRegions = reg;
        editorFreeMarker(mm);
}
static void refactoryPerformEncapsulateField(S_editorMarker *point,
                                                                                         S_editorRegionList **forbiddenRegions
        ) {
        char nameOnPoint[TMP_STRING_SIZE];
        char upcasedName[TMP_STRING_SIZE];
        char getter[TMP_STRING_SIZE];
        char setter[TMP_STRING_SIZE];
        char cclass[TMP_STRING_SIZE];
        char getterBody[REFACTORING_TMP_STRING_SIZE];
        char setterBody[REFACTORING_TMP_STRING_SIZE];
        char declarator[REFACTORING_TMP_STRING_SIZE];
        char *scclass;
        int nameOnPointLen, declLen, indlines, indoffset;
        S_reference *anotherGetter, *anotherSetter;
        unsigned accFlags;
        S_editorMarkerList *ll, *occs, *insiders, *outsiders;
        S_editorMarker *mm, *eqm, *ee, *db, *dte, *dtb, *de, *mb, *me;
        S_editorMarker *getterm, *setterm, *tbeg, *tend;
        S_editorUndo *beforeInsertionUndo;
        S_editorRegionList *reg;
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        nameOnPointLen = strlen(nameOnPoint);
        { if (!(nameOnPointLen < TMP_STRING_SIZE-1)) internalCheckFail("nameOnPointLen < TMP_STRING_SIZE-1", "refactory.c", 3797);};
        occs = refactoryPushGetAndPreCheckReferences(point->buffer, point, nameOnPoint,
                                                                                                 "If you see this screen, then probably something is going wrong. You are refactoring a virtual method when only statically linked symbol is required. It is strongly recommended to cancel the refactoring. ",
                                                                                                 PPCV_BROWSER_TYPE_WARNING);
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (ll->usg.base == UsageAddrUsed) {
                        ppcGenGotoMarkerRecord(ll->d);
                        sprintf(tmpBuff, "There is a combined l-value reference of the field. Current version of Xrefactory doesn't  know how  to encapsulate such  assignment. Please, turn it into simple assignment (i.e. field = field 'op' ...;) first.");
                        formatOutputLine(tmpBuff, 10);
                        error(ERR_ST, tmpBuff);
                        return;
                }
        }
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->hkSelectedSym", "refactory.c", 3811);};
        accFlags = s_olcxCurrentUser->browserStack.top->hkSelectedSym->s.b.accessFlags;
        cclass[0] = 0; scclass = cclass;
        if (accFlags&0x008) {
                refactoryGetNameOfTheClassAndSuperClass(point, cclass, NULL);
                scclass = lastOccurenceInString(cclass, '.');
                if (scclass == NULL) scclass = cclass;
                else scclass ++;
        }
        strcpy(upcasedName, nameOnPoint);
        upcasedName[0] = toupper(upcasedName[0]);
        sprintf(getter, "get%s", upcasedName);
        sprintf(setter, "set%s", upcasedName);
        refactoryMakeSyntaxPassOnSource(point);
        db = editorCrNewMarkerForPosition(&s_spp[SPP_FIELD_DECLARATION_BEGIN_POSITION]);
        dtb = editorCrNewMarkerForPosition(&s_spp[SPP_FIELD_DECLARATION_TYPE_BEGIN_POSITION]);
        dte = editorCrNewMarkerForPosition(&s_spp[SPP_FIELD_DECLARATION_TYPE_END_POSITION]);
        de = editorCrNewMarkerForPosition(&s_spp[SPP_FIELD_DECLARATION_END_POSITION]);
        refactoryMoveMarkerToTheEndOfDefinitionScope(de);
        { if (!(dtb->buffer == dte->buffer)) internalCheckFail("dtb->buffer == dte->buffer", "refactory.c", 3834);};
        { if (!(dtb->offset <= dte->offset)) internalCheckFail("dtb->offset <= dte->offset", "refactory.c", 3835);};
        declLen = dte->offset - dtb->offset;
        strncpy(declarator, (dtb->buffer->a.text+dtb->offset), declLen);
        declarator[declLen] = 0;
        sprintf(getterBody, "public %s%s %s() {\nreturn(%s);\n}\n",
                        ((accFlags&0x008)?"static ":""),
                        declarator, getter, nameOnPoint);
        sprintf(setterBody, "public %s%s %s(%s %s) {\n%s.%s = %s;\nreturn(%s);\n}\n",
                        ((accFlags&0x008)?"static ":""),
                        declarator, setter, declarator, nameOnPoint,
                        ((accFlags&0x008)?scclass:"this"),
                        nameOnPoint, nameOnPoint, nameOnPoint);
        beforeInsertionUndo = s_editorUndo;
        if ((*(de->buffer->a.text+de->offset-1)) != '\n') refactoryReplaceString(de, 0, "\n");
        tbeg = editorDuplicateMarker(de);
        tbeg->offset --;
        getterm = setterm = NULL;
        getterm = editorCrNewMarker(de->buffer, de->offset-1);
        refactoryReplaceString(de, 0, getterBody);
        getterm->offset += substringIndex(getterBody, getter)+1;
        if ((accFlags & 0x010) == 0) {
                setterm = editorCrNewMarker(de->buffer, de->offset-1);
                refactoryReplaceString(de, 0, setterBody);
                setterm->offset += substringIndex(setterBody, setter)+1;
        }
        tbeg->offset ++;
        tend = editorDuplicateMarker(de);
        anotherGetter = anotherSetter = NULL;
        refactoryPushReferences(getterm->buffer, getterm, "-olcxrename", NULL, 0);
        anotherGetter = refactoryCheckEncapsulateGetterSetterForExistingMethods(getter);
        editorFreeMarker(getterm);
        if ((accFlags & 0x010) == 0) {
                refactoryPushReferences(setterm->buffer, setterm, "-olcxrename", NULL, 0);
                anotherSetter = refactoryCheckEncapsulateGetterSetterForExistingMethods(setter);
                editorFreeMarker(setterm);
        }
        if (anotherGetter!=NULL || anotherSetter!=NULL) {
                if (anotherGetter!=NULL) {
                        refactoryAddMethodToForbiddenRegions(anotherGetter, forbiddenRegions);
                }
                if (anotherSetter!=NULL) {
                        refactoryAddMethodToForbiddenRegions(anotherSetter, forbiddenRegions);
                }
                editorUndoUntil(beforeInsertionUndo, &s_editorUndo);
                de->offset = tbeg->offset;
                if ((*(de->buffer->a.text+de->offset-1)) != '\n') refactoryReplaceString(de, 0, "\n");
                tbeg->offset --;
                if (! anotherGetter) {
                        refactoryReplaceString(de, 0, getterBody);
                }
                if ((accFlags & 0x010) == 0 && ! anotherSetter) {
                        refactoryReplaceString(de, 0, setterBody);
                }
                tend->offset = de->offset;
                tbeg->offset ++;
        }
        if ((accFlags & 0x010) == 0) olcxPopOnly();
        olcxPopOnly();
        editorSplitMarkersWithRespectToRegions(&occs, forbiddenRegions, &insiders, &outsiders);
        for(ll=outsiders; ll!=NULL; ll=ll->next) {
                if (ll->usg.base == UsageLvalUsed) {
                        refactoryMakeSyntaxPassOnSource(ll->d);
                        if (s_spp[SPP_ASSIGNMENT_OPERATOR_POSITION].file == s_noneFileIndex) {
                                error(ERR_INTERNAL, "Can't get assignment coordinates");
                        } else {
                                eqm = editorCrNewMarkerForPosition(&s_spp[SPP_ASSIGNMENT_OPERATOR_POSITION]);
                                ee = editorCrNewMarkerForPosition(&s_spp[SPP_ASSIGNMENT_END_POSITION]);
                                refactoryCheckedReplaceString(ll->d, nameOnPointLen, nameOnPoint, "");
                                refactoryReplaceString(ll->d, 0, setter);
                                refactoryReplaceString(ll->d, 0, "(");
                                editorRemoveBlanks(ll->d, 1, &s_editorUndo);
                                refactoryCheckedReplaceString(eqm, 1, "=", "");
                                editorRemoveBlanks(eqm, 0, &s_editorUndo);
                                refactoryReplaceString(ee, 0, ")");
                                ee->offset --;
                                editorRemoveBlanks(ee, -1, &s_editorUndo);
                                editorFreeMarker(eqm);
                                editorFreeMarker(ee);
                        }
                } else if (! ( ( (ll->usg.base)==UsageDefined || (ll->usg.base)==UsageOLBestFitDefined) || (ll->usg.base)==UsageDeclared )) {
                        refactoryCheckedReplaceString(ll->d, nameOnPointLen, nameOnPoint, "");
                        refactoryReplaceString(ll->d, 0, getter);
                        refactoryReplaceString(ll->d, 0, "()");
                }
        }
        refactoryRestrictAccessibility(point, SPP_FIELD_DECLARATION_BEGIN_POSITION, 0x002);
        indoffset = tbeg->offset;
        indlines = editorCountLinesBetweenMarkers(tbeg, tend);
        refactoryAplyWholeRefactoringFromUndo();
        de->offset = indoffset;
        ppcGenGotoMarkerRecord(de);
        ppcGenNumericRecord(PPC_INDENT, indlines, "", "\n");
        ppcGenGotoMarkerRecord(point);
}
static void refactorySelfEncapsulateField(S_editorMarker *point) {
        S_editorRegionList *forbiddenRegions;
        forbiddenRegions = NULL;
        refactoryUpdateReferences(s_ropt.project);
        refactoryPerformEncapsulateField(point, &forbiddenRegions);
}
static void refactoryEncapsulateField(S_editorMarker *point) {
        S_editorRegionList *forbiddenRegions;
        S_editorMarker *cb, *ce;
        refactoryUpdateReferences(s_ropt.project);
        refactoryMakeSyntaxPassOnSource(point);
        if (s_spp[SPP_CLASS_DECLARATION_BEGIN_POSITION].file == s_noneFileIndex
                || s_spp[SPP_CLASS_DECLARATION_END_POSITION].file == s_noneFileIndex) {
                fatalError(ERR_INTERNAL, "can't deetrmine class coordinates", 65);
        }
        cb = editorCrNewMarkerForPosition(&s_spp[SPP_CLASS_DECLARATION_BEGIN_POSITION]);
        ce = editorCrNewMarkerForPosition(&s_spp[SPP_CLASS_DECLARATION_END_POSITION]);
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { forbiddenRegions = NULL; } else { forbiddenRegions = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (forbiddenRegions==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { forbiddenRegions = NULL; } else { forbiddenRegions = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (forbiddenRegions)->r.b = cb; (forbiddenRegions)->r.e = ce; (forbiddenRegions)->next = NULL;};
        refactoryPerformEncapsulateField(point, &forbiddenRegions);
}
static S_olSymbolsMenu *refactoryFindSymbolCorrespondingToReferenceWrtPullUpPushDown(
        S_olSymbolsMenu *menu2, S_olSymbolsMenu *mm1, S_editorMarkerList *rr1
        ) {
        S_olSymbolsMenu *mm2;
        S_editorMarkerList *rr2;
        for(mm2=menu2; mm2!=NULL; mm2=mm2->next) {
                if (mm1->s.b.symType!=mm2->s.b.symType && mm2->s.b.symType!=TypeInducedError) continue;
                for(rr2=mm2->markers; rr2!=NULL; rr2=rr2->next) {
                        if ((rr1->d->buffer==rr2->d->buffer && rr1->d->offset==rr2->d->offset)) goto breakrr2;
                }
        breakrr2:
                if (rr2!=NULL && symbolsCorrespondWrtMoving(mm1, mm2, OLO_PP_PRE_CHECK)) {
                        goto breakmm2;;
                }
        }
 breakmm2:
        return(mm2);
}
static int refactoryIsMethodPartRedundantWrtPullUpPushDown(
        S_editorMarker *m1, S_editorMarker *m2
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorUndo *undoMark;
        S_reference *diff;
        S_editorMarkerList *rr1;
        S_editorMarker *mmin, *mmax;
        int slen, res;
        S_editorRegionList *regions, *reg;
        S_editorBuffer *buf;
        { if (!(m1->buffer == m2->buffer)) internalCheckFail("m1->buffer == m2->buffer", "refactory.c", 4015);};
        regions = NULL;
        buf = m1->buffer;
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (reg==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (reg)->r.b = editorCrMarkerForBufferBegin(buf); (reg)->r.e = editorDuplicateMarker(m1); (reg)->next = regions;};
        regions = reg;
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (reg==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { reg = NULL; } else { reg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (reg)->r.b = editorDuplicateMarker(m2); (reg)->r.e = editorCrMarkerForBufferEnd(buf); (reg)->next = regions;};
        regions = reg;
        refactoryPushMethodSymbolsPlusThoseWithClearedRegion(m1, m2);
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous", "refactory.c", 4033);};
        mm1 = s_olcxCurrentUser->browserStack.top->menuSym;
        mm2 = s_olcxCurrentUser->browserStack.top->previous->menuSym;
        createMarkersForAllReferencesInRegions(mm1, &regions);
        createMarkersForAllReferencesInRegions(mm2, &regions);
        res = 1;
        while (mm1!=NULL) {
                for(rr1=mm1->markers; rr1!=NULL; rr1=rr1->next) {
                        if (refactoryFindSymbolCorrespondingToReferenceWrtPullUpPushDown(mm2, mm1, rr1)==NULL) {
                                res = 0;
                                goto fini;
                        }
                }
                mm1=mm1->next;
        }
 fini:
        editorFreeMarkersAndRegionList(regions);
        olcxPopOnly();
        olcxPopOnly();
        return(res);
}
static S_editorMarkerList *refactoryPullUpPushDownDifferences(
        S_olSymbolsMenu *menu1, S_olSymbolsMenu *menu2, S_symbolRefItem *theMethod
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorMarkerList *rr, *rr1, *rr2, *diff;
        diff = NULL;
        mm1 = menu1;
        while (mm1!=NULL) {
                if (itIsSameCxSymbolIncludingFunClass(&mm1->s, theMethod)) goto cont;
                if (mm1->s.b.storage == StorageAuto) goto cont;
                if (mm1->s.b.symType == TypeLabel) goto cont;
                if (isStrictlyEnclosingClass(mm1->s.vFunClass, theMethod->vFunClass)) goto cont;
                for(rr1=mm1->markers; rr1!=NULL; rr1=rr1->next) {
                        mm2 = refactoryFindSymbolCorrespondingToReferenceWrtPullUpPushDown(menu2, mm1, rr1);
                        if (mm2==NULL) {
                                { { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (rr==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorMarkerList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { rr = NULL; } else { rr = (S_editorMarkerList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
                                { (rr)->d = editorDuplicateMarker(rr1->d); (rr)->usg = rr1->usg; (rr)->next = diff;};
                                diff = rr;
                        }
                }
        cont:
                mm1=mm1->next;
        }
        return(diff);
}
static void refactoryPullUpPushDownCheckCorrespondance(
        S_olSymbolsMenu *menu1, S_olSymbolsMenu *menu2, S_symbolRefItem *theMethod
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorMarkerList *rr, *rr1, *rr2, *diff;
        diff = refactoryPullUpPushDownDifferences(menu1, menu2, theMethod);
        if (diff!=NULL) {
                refactoryShowSafetyCheckFailingDialog(&diff, "Those references will be  misinterpreted after refactoring");
                editorFreeMarkersAndMarkerList(diff); diff=NULL;
                refactoryAskForReallyContinueConfirmation();
        }
}
static void refactoryReduceParenthesesAroundExpression(S_editorMarker *mm, char *expression) {
        S_editorMarker *lp, *rp, *eb, *ee;
        int elen;
        refactoryMakeSyntaxPassOnSource(mm);
        if (s_spp[SPP_PARENTHESED_EXPRESSION_LPAR_POSITION].file != s_noneFileIndex) {
                { if (!(s_spp[SPP_PARENTHESED_EXPRESSION_RPAR_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_PARENTHESED_EXPRESSION_RPAR_POSITION].file != s_noneFileIndex", "refactory.c", 4108);};
                { if (!(s_spp[SPP_PARENTHESED_EXPRESSION_BEGIN_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_PARENTHESED_EXPRESSION_BEGIN_POSITION].file != s_noneFileIndex", "refactory.c", 4109);};
                { if (!(s_spp[SPP_PARENTHESED_EXPRESSION_END_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_PARENTHESED_EXPRESSION_END_POSITION].file != s_noneFileIndex", "refactory.c", 4110);};
                elen = strlen(expression);
                lp = editorCrNewMarkerForPosition(&s_spp[SPP_PARENTHESED_EXPRESSION_LPAR_POSITION]);
                rp = editorCrNewMarkerForPosition(&s_spp[SPP_PARENTHESED_EXPRESSION_RPAR_POSITION]);
                eb = editorCrNewMarkerForPosition(&s_spp[SPP_PARENTHESED_EXPRESSION_BEGIN_POSITION]);
                ee = editorCrNewMarkerForPosition(&s_spp[SPP_PARENTHESED_EXPRESSION_END_POSITION]);
                if (ee->offset - eb->offset == elen && strncmp((eb->buffer->a.text+eb->offset), expression, elen)==0) {
                        refactoryReplaceString(lp, 1, "");
                        refactoryReplaceString(rp, 1, "");
                }
                editorFreeMarker(lp);
                editorFreeMarker(rp);
                editorFreeMarker(eb);
                editorFreeMarker(ee);
        }
}
static void refactoryRemoveRedundantParenthesesAroundThisOrSuper(S_editorMarker *mm, char *keyword) {
        S_editorMarker *lp, *rp, *eb, *ee;
        char *ss;
        ss = refactoryGetIdentifierOnMarker_st(mm);
        if (strcmp(ss, keyword)==0) {
                refactoryReduceParenthesesAroundExpression(mm, keyword);
        }
}
static void refactoryReduceCastedThis(S_editorMarker *mm, char *superFqtName) {
        S_editorMarker *lp, *rp, *eb, *ee, *tb, *te, *rr, *dd;
        char *ss;
        int superFqtLen, castExprLen;
        char castExpr[MAX_FILE_NAME_SIZE];
        superFqtLen = strlen(superFqtName);
        ss = refactoryGetIdentifierOnMarker_st(mm);
        if (strcmp(ss,"this")==0) {
                refactoryMakeSyntaxPassOnSource(mm);
                if (s_spp[SPP_CAST_LPAR_POSITION].file != s_noneFileIndex) {
                        { if (!(s_spp[SPP_CAST_RPAR_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_CAST_RPAR_POSITION].file != s_noneFileIndex", "refactory.c", 4146);};
                        { if (!(s_spp[SPP_CAST_EXPRESSION_BEGIN_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_CAST_EXPRESSION_BEGIN_POSITION].file != s_noneFileIndex", "refactory.c", 4147);};
                        { if (!(s_spp[SPP_CAST_EXPRESSION_END_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_CAST_EXPRESSION_END_POSITION].file != s_noneFileIndex", "refactory.c", 4148);};
                        lp = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_LPAR_POSITION]);
                        rp = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_RPAR_POSITION]);
                        tb = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_TYPE_BEGIN_POSITION]);
                        te = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_TYPE_END_POSITION]);
                        eb = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_EXPRESSION_BEGIN_POSITION]);
                        ee = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_EXPRESSION_END_POSITION]);
                        rp->offset ++;
                        if (ee->offset - eb->offset == 4 ) {
                                if (refactoryIsMethodPartRedundantWrtPullUpPushDown(lp, rp)) {
                                        refactoryReplaceString(lp, rp->offset-lp->offset, "");
                                } else if (te->offset - tb->offset == superFqtLen
                                                   && strncmp((tb->buffer->a.text+tb->offset), superFqtName, superFqtLen) == 0) {
                                        rr = editorDuplicateMarker(ee);
                                        editorMoveMarkerToNonBlank(rr, 1);
                                        if ((*(rr->buffer->a.text+rr->offset)) == ')') {
                                                dd = editorDuplicateMarker(rr);
                                                dd->offset ++;
                                                editorMoveMarkerToNonBlank(dd, 1);
                                                if ((*(dd->buffer->a.text+dd->offset)) == '.') {
                                                        castExprLen = ee->offset - lp->offset;
                                                        strncpy(castExpr, (lp->buffer->a.text+lp->offset), castExprLen);
                                                        castExpr[castExprLen]=0;
                                                        refactoryReduceParenthesesAroundExpression(mm, castExpr);
                                                        refactoryReplaceString(lp, ee->offset-lp->offset, "super");
                                                }
                                                editorFreeMarker(dd);
                                        }
                                        editorFreeMarker(rr);
                                }
                        }
                        editorFreeMarker(lp);
                        editorFreeMarker(rp);
                        editorFreeMarker(tb);
                        editorFreeMarker(te);
                        editorFreeMarker(eb);
                        editorFreeMarker(ee);
                }
        }
}
static int refactoryIsThereACastOfThis(S_editorMarker *mm) {
        S_editorMarker *eb, *ee;
        char *ss;
        int res;
        res = 0;
        ss = refactoryGetIdentifierOnMarker_st(mm);
        if (strcmp(ss,"this")==0) {
                refactoryMakeSyntaxPassOnSource(mm);
                if (s_spp[SPP_CAST_LPAR_POSITION].file != s_noneFileIndex) {
                        { if (!(s_spp[SPP_CAST_RPAR_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_CAST_RPAR_POSITION].file != s_noneFileIndex", "refactory.c", 4199);};
                        { if (!(s_spp[SPP_CAST_EXPRESSION_BEGIN_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_CAST_EXPRESSION_BEGIN_POSITION].file != s_noneFileIndex", "refactory.c", 4200);};
                        { if (!(s_spp[SPP_CAST_EXPRESSION_END_POSITION].file != s_noneFileIndex)) internalCheckFail("s_spp[SPP_CAST_EXPRESSION_END_POSITION].file != s_noneFileIndex", "refactory.c", 4201);};
                        eb = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_EXPRESSION_BEGIN_POSITION]);
                        ee = editorCrNewMarkerForPosition(&s_spp[SPP_CAST_EXPRESSION_END_POSITION]);
                        if (ee->offset - eb->offset == 4 ) {
                                res = 1;
                        }
                        editorFreeMarker(eb);
                        editorFreeMarker(ee);
                }
        }
        return(res);
}
static void refactoryReduceRedundantCastedThissInMethod(
        S_editorMarker *point, S_editorRegionList **methodreg
        ) {
        S_editorMarkerList *ll;
        S_editorMarker *lp, *rp, *eb, *ee;
        S_olSymbolsMenu *mm;
        char superFqtName[MAX_FILE_NAME_SIZE];
        char *ss;
        refactoryGetNameOfTheClassAndSuperClass(point, NULL, superFqtName);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL, "-olcxmaybethis",NULL);
        olcxPushSpecial("  method's \"maybe this\" dependencies", OLO_MAYBE_THIS);
        createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, methodreg);
        for(mm = s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        for(ll=mm->markers; ll!=NULL; ll=ll->next) {
                                ss = refactoryGetIdentifierOnMarker_st(ll->d);
                                if (strcmp(ss,"this")==0) {
                                        refactoryReduceCastedThis(ll->d, superFqtName);
                                        refactoryRemoveRedundantParenthesesAroundThisOrSuper(ll->d, "this");
                                }
                        }
                }
        }
}
static void refactoryExpandThissToCastedThisInTheMethod(
        S_editorMarker *point,
        char *thiscFqtName, char *supercFqtName,
        S_editorRegionList *methodreg
        ) {
        char thisCast[MAX_FILE_NAME_SIZE];
        char superCast[MAX_FILE_NAME_SIZE];
        char *ss;
        S_editorMarkerList *ll;
        S_olSymbolsMenu *mm;
        sprintf(thisCast, "((%s)this)", thiscFqtName);
        sprintf(superCast, "((%s)this)", supercFqtName);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL, "-olcxmaybethis",NULL);
        olcxPushSpecial("  method's \"maybe this\" dependencies", OLO_MAYBE_THIS);
        createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, &methodreg);
        for(mm = s_olcxCurrentUser->browserStack.top->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        for(ll=mm->markers; ll!=NULL; ll=ll->next) {
                                ss = refactoryGetIdentifierOnMarker_st(ll->d);
                                if (strcmp(ss,"this")==0) {
                                        if (! refactoryIsThereACastOfThis(ll->d)) {
                                                refactoryCheckedReplaceString(ll->d, 4, "this", "");
                                                refactoryReplaceString(ll->d, 0, thisCast);
                                        }
                                } else if (strcmp(ss,"super")==0) {
                                        refactoryCheckedReplaceString(ll->d, 5, "super", "");
                                        refactoryReplaceString(ll->d, 0, superCast);
                                }
                        }
                }
        }
}
static void refactoryPushDownPullUp(S_editorMarker *point, int direction, int limitIndex) {
        char sourceFqtName[MAX_FILE_NAME_SIZE];
        char superFqtName[MAX_FILE_NAME_SIZE];
        char targetFqtName[MAX_FILE_NAME_SIZE];
        char *ss;
        int lines, size;
        S_editorMarker *target, *mstart, *mend, *movedEnd, *pp, *ppp;
        S_editorMarkerList *ll;
        S_editorRegionList *methodreg, *lll;
        S_olSymbolsMenu *mm, *mm1, *mm2;
        S_symbolRefItem *theMethod;
        target = getTargetFromOptions();
        if (! validTargetPlace(target, "-olcxmmtarget")) return;
        refactoryUpdateReferences(s_ropt.project);
        refactoryGetNameOfTheClassAndSuperClass(point, sourceFqtName, superFqtName);
        refactoryGetNameOfTheClassAndSuperClass(target, targetFqtName, NULL);
        refactoryGetMethodLimitsForMoving(point, &mstart, &mend, limitIndex);
        lines = editorCountLinesBetweenMarkers(mstart, mend);
        refactorySetMovingPrecheckStandardEnvironment(point, targetFqtName);
        if (limitIndex == SPP_METHOD_DECLARATION_BEGIN_POSITION) {
                if (direction == PULLING_UP) {
                        if (! (tpCheckTargetToBeDirectSubOrSupClass(REQ_SUPERCLASS, "superclass")
                                   && tpCheckSuperMethodReferencesForPullUp()
                                   && tpCheckMethodReferencesWithApplOnSuperClassForPullUp())) {
                                fatalError(ERR_INTERNAL, "A trivial precondition failed", 65);
                        }
                } else {
                        if (! (tpCheckTargetToBeDirectSubOrSupClass(REQ_SUBCLASS, "subclass"))) {
                                fatalError(ERR_INTERNAL, "A trivial precondition failed", 65);
                        }
                }
        } else {
                if (direction == PULLING_UP) {
                        if (! (tpCheckTargetToBeDirectSubOrSupClass(REQ_SUPERCLASS, "superclass")
                                   && tpPullUpFieldLastPreconditions())) {
                                fatalError(ERR_INTERNAL, "A trivial precondition failed", 65);
                        }
                } else {
                        if (! (tpCheckTargetToBeDirectSubOrSupClass(REQ_SUBCLASS, "subclass")
                                && tpPushDownFieldLastPreconditions())) {
                                fatalError(ERR_INTERNAL, "A trivial precondition failed", 65);
                        }
                }
        }
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { methodreg = NULL; } else { methodreg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (methodreg==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { methodreg = NULL; } else { methodreg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (methodreg)->r.b = mstart; (methodreg)->r.e = mend; (methodreg)->next = NULL;};
        refactoryExpandThissToCastedThisInTheMethod(point, sourceFqtName, superFqtName, methodreg);
        movedEnd = editorDuplicateMarker(mend);
        movedEnd->offset --;
        refactoryApplyExpandShortNames(point->buffer, point);
        size = mend->offset - mstart->offset;
        refactoryPushAllReferencesOfMethod(point, "-olallchecks");
        createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, NULL);
        { if (!(s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top->hkSelectedSym!=NULL)) internalCheckFail("s_olcxCurrentUser->browserStack.top!=NULL && s_olcxCurrentUser->browserStack.top->hkSelectedSym!=NULL", "refactory.c", 4345);};
        theMethod = &s_olcxCurrentUser->browserStack.top->hkSelectedSym->s;
        editorMoveBlock(target, mstart, size, &s_editorUndo);
        pp = editorDuplicateMarker(mstart);
        ppp = editorDuplicateMarker(movedEnd);
        ppp->offset ++;
        { { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { methodreg = NULL; } else { methodreg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; while (methodreg==NULL) { freeOldestOlcx(); { int n = (1) * sizeof(S_editorRegionList); if (n+olcxMemoryAllocatedBytes > SIZE_olcxMemory) { methodreg = NULL; } else { methodreg = (S_editorRegionList*) malloc(n); olcxMemoryAllocatedBytes += n; {}; }}; }};
        { (methodreg)->r.b = pp; (methodreg)->r.e = ppp; (methodreg)->next = NULL;};
        refactoryPushAllReferencesOfMethod(point, "-olallchecks");
        createMarkersForAllReferencesInRegions(s_olcxCurrentUser->browserStack.top->menuSym, NULL);
        { if (!(s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous)) internalCheckFail("s_olcxCurrentUser->browserStack.top && s_olcxCurrentUser->browserStack.top->previous", "refactory.c", 4359);};
        mm1 = s_olcxCurrentUser->browserStack.top->previous->menuSym;
        mm2 = s_olcxCurrentUser->browserStack.top->menuSym;
        refactoryPullUpPushDownCheckCorrespondance(mm1, mm2, theMethod);
        if (limitIndex == SPP_METHOD_DECLARATION_BEGIN_POSITION) {
                if (direction == PUSHING_DOWN) {
                        refactorySetMovingPrecheckStandardEnvironment(point, targetFqtName);
                        if (! tpCheckSuperMethodReferencesAfterPushDown()) {
                                fatalError(ERR_INTERNAL, "A trivial precondition failed", 65);
                        }
                }
        }
        refactoryReduceRedundantCastedThissInMethod(point, &methodreg);
        refactoryPerformReduceNamesAndAddImports(&methodreg, INTERACTIVE_NO);
        refactoryAplyWholeRefactoringFromUndo();
}
static void refactoryPullUpField(S_editorMarker *point) {
        refactoryPushDownPullUp(point, PULLING_UP , SPP_FIELD_DECLARATION_BEGIN_POSITION);
}
static void refactoryPullUpMethod(S_editorMarker *point) {
        refactoryPushDownPullUp(point, PULLING_UP , SPP_METHOD_DECLARATION_BEGIN_POSITION);
}
static void refactoryPushDownField(S_editorMarker *point) {
        refactoryPushDownPullUp(point, PUSHING_DOWN , SPP_FIELD_DECLARATION_BEGIN_POSITION);
}
static void refactoryPushDownMethod(S_editorMarker *point) {
        refactoryPushDownPullUp(point, PUSHING_DOWN , SPP_METHOD_DECLARATION_BEGIN_POSITION);
}
static char * refactoryComputeUpdateOptionForSymbol(S_editorMarker *point) {
        S_editorMarkerList *occs, *o;
        S_olSymbolsMenu *csym;
        int hasHeaderReferenceFlag, scope, cat, multiFileRefsFlag, fn;
        int symtype, storage, accflags;
        char *res;
        { if (!(point!=NULL && point->buffer!=NULL)) internalCheckFail("point!=NULL && point->buffer!=NULL", "refactory.c", 4417);};
        mainSetLanguage(point->buffer->name, &s_language);
        hasHeaderReferenceFlag = 0;
        multiFileRefsFlag = 0;
        occs = refactoryGetReferences(point->buffer, point, NULL, PPCV_BROWSER_TYPE_WARNING);
        csym = s_olcxCurrentUser->browserStack.top->hkSelectedSym;
        scope = csym->s.b.scope;
        cat = csym->s.b.category;
        symtype = csym->s.b.symType;
        storage = csym->s.b.storage;
        accflags = csym->s.b.accessFlags;
        if (occs == NULL) {
                fn = s_noneFileIndex;
        } else {
                { if (!(occs->d!=NULL && occs->d->buffer!=NULL)) internalCheckFail("occs->d!=NULL && occs->d->buffer!=NULL", "refactory.c", 4432);};
                fn = occs->d->buffer->ftnum;
        }
        for(o=occs; o!=NULL; o=o->next) {
                { if (!(o->d!=NULL && o->d->buffer!=NULL)) internalCheckFail("o->d!=NULL && o->d->buffer!=NULL", "refactory.c", 4436);};
                { if (!(s_fileTab.tab[o->d->buffer->ftnum]!=NULL)) internalCheckFail("s_fileTab.tab[o->d->buffer->ftnum]!=NULL", "refactory.c", 4437);};
                if (fn != o->d->buffer->ftnum) {
                        multiFileRefsFlag = 1;
                }
                if (! s_fileTab.tab[o->d->buffer->ftnum]->b.commandLineEntered) {
                        hasHeaderReferenceFlag = 1;
                }
        }
        if (((s_language & (4)) != 0)) {
                if (cat == CatLocal) {
                        res = "";
                } else if (symtype==TypeDefault
                                   && (storage == StorageMethod || storage == StorageField)
                                   && ((accflags & 0x002) != 0)
                        ) {
                        res = "";
                } else {
                        res = "-fastupdate";
                }
        } else {
                if (cat == CatLocal) {
                        res = "";
                } else if (hasHeaderReferenceFlag) {
                        res = "-update";
                } else if (scope==ScopeAuto || scope==ScopeFile) {
                        if (multiFileRefsFlag) {
                                error(ERR_INTERNAL, "something goes wrong, a local symbol is used in several files", 65);
                                res = "-update";
                        } else {
                                res = "";
                        }
                } else if (! multiFileRefsFlag) {
                        res = "";
                } else {
                        res = "-fastupdate";
                }
        }
        editorFreeMarkersAndMarkerList(occs);
        occs = NULL;
        olcxPopOnly();
 fini:
        return(res);
}
void mainRefactory(int argc, char **argv) {
        int fArgCount;
        char *file, *fff;
        char ifile[MAX_FILE_NAME_SIZE];
        S_editorBuffer *buf;
        S_editorMarker *point, *mark;
        copyOptions(&s_ropt, &s_opt);
        copyOptions(&s_cachedOptions, &s_opt);
        s_ropt.cxrefs = OLO_LIST;
        mainOpenOutputFile(s_ropt.outputFileName);
        editorLoadAllOpenedBufferFiles();
        editorQuasySaveModifiedBuffers();
        if (s_ropt.project==NULL) {
                fatalError(ERR_ST, "You have to specify active project with -p option",
                                   65);
        }
        fArgCount = 0; fff = getInputFile(&fArgCount);
        if (fff==NULL) {
                file = NULL;
        } else {
                strcpy(ifile, fff);
                file = ifile;
        }
        buf = NULL;
        if (file==NULL) fatalError(ERR_ST, "no input file", 65);
        if (file!=NULL) buf = editorFindFile(file);
        point = refactoryGetPointFromRefactoryOptions(buf);
        mark = refactoryGetMarkFromRefactoryOptions(buf);
        s_refactoringStartPoint = s_editorUndo;
        mainTaskEntryInitialisations(argnum(s_refactoryEditSrvInitOptions),
                                                                 s_refactoryEditSrvInitOptions);
        s_refactoryXrefEditSrvSubTaskFirstPassing = 1;
        s_progressFactor = 1;
        if (s_ropt.theRefactoring==PPC_AVR_RENAME_SYMBOL
                || s_ropt.theRefactoring==PPC_AVR_RENAME_CLASS
                || s_ropt.theRefactoring==PPC_AVR_RENAME_PACKAGE) {
                s_progressFactor = 3;
                s_refactoryUpdateOption = refactoryComputeUpdateOptionForSymbol(point);
                refactoryRename(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_EXPAND_NAMES) {
                s_progressFactor = 1;
                refactoryExpandShortNames(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_REDUCE_NAMES) {
                s_progressFactor = 1;
                refactoryReduceLongNamesInTheFile(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS) {
                s_progressFactor = 2;
                refactoryReduceLongNamesInTheFile(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_ADD_TO_IMPORT) {
                s_progressFactor = 2;
                refactoryAddToImports(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_ADD_PARAMETER
                           || s_ropt.theRefactoring==PPC_AVR_DEL_PARAMETER
                           || s_ropt.theRefactoring==PPC_AVR_MOVE_PARAMETER) {
                s_progressFactor = 3;
                s_refactoryUpdateOption = refactoryComputeUpdateOptionForSymbol(point);
                mainSetLanguage(file, &s_language);
                if (((s_language & (4)) != 0)) s_progressFactor ++;
                refactoryParameterManipulation(buf, point, s_ropt.theRefactoring,
                                                                           s_ropt.olcxGotoVal, s_ropt.parnum2);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_FIELD) {
                s_progressFactor = 6;
                refactoryMoveField(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_STATIC_FIELD) {
                s_progressFactor = 4;
                refactoryMoveStaticField(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_STATIC_METHOD) {
                s_progressFactor = 4;
                refactoryMoveStaticMethod(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_CLASS) {
                s_progressFactor = 3;
                refactoryMoveClass(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_CLASS_TO_NEW_FILE) {
                s_progressFactor = 3;
                refactoryMoveClassToNewFile(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE) {
                s_progressFactor = 3;
                refactoryMoveAllClassesToNewFile(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_PULL_UP_METHOD) {
                s_progressFactor = 2;
                refactoryPullUpMethod(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_PULL_UP_FIELD) {
                s_progressFactor = 2;
                refactoryPullUpField(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_PUSH_DOWN_METHOD) {
                s_progressFactor = 2;
                refactoryPushDownMethod(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_PUSH_DOWN_FIELD) {
                s_progressFactor = 2;
                refactoryPushDownField(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC) {
                s_progressFactor = 6;
                refactoryTurnStaticToDynamic(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC) {
                s_progressFactor = 4;
                refactoryTurnDynamicToStatic(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_EXTRACT_METHOD) {
                s_progressFactor = 1;
                refactoryExtractMethod(point, mark);
        } else if (s_ropt.theRefactoring==PPC_AVR_EXTRACT_MACRO) {
                s_progressFactor = 1;
                refactoryExtractMacro(point, mark);
        } else if (s_ropt.theRefactoring==PPC_AVR_SELF_ENCAPSULATE_FIELD) {
                s_progressFactor = 3;
                refactorySelfEncapsulateField(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_ENCAPSULATE_FIELD) {
                s_progressFactor = 3;
                refactoryEncapsulateField(point);
        } else {
                error(ERR_INTERNAL, "unknown refactoring");
        }
        writeRelativeProgress(0);
        writeRelativeProgress(100);
        if (s_progressOffset != s_progressFactor) {
                sprintf(tmpBuff, "s_progressOffset (%d) != s_progressFactor (%d)", s_progressOffset, s_progressFactor);
                ppcGenRecord(PPC_DEBUG_INFORMATION, tmpBuff, "\n");
        }
        editorQuasySaveModifiedBuffers();
        mainCloseOutputFile();
        ppcGenSynchroRecord();
        s_opt.taskRegime = RegimeUndefined;
}
