
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2003.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#ifdef __OS2__
#include <os2.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(__APPLE__)
#include <sys/malloc.h>
#else
#if (! defined(__FreeBSD__)) || (__FreeBSD__ < 5)
#include <malloc.h>
#endif
#endif
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
        S_extRecFindStr *erfs;
        S_bb_int bbinteger;
        S_bb_unsigned bbunsign;
        S_bb_symbol bbsymbol;
        S_bb_symbolList bbsymbolList;
        S_bb_typeModifiers bbtypeModif;
        S_bb_typeModifiersList bbtypeModifList;
        S_bb_freeTrail bbtrail;
        S_bb_idIdent bbidIdent;
        S_bb_idIdentList bbidlist;
        S_bb_exprTokenType bbexprType;
        S_bb_intPair bbintpair;
        S_bb_whileExtractData bbwhiledata;
        S_bb_position bbposition;
        S_bb_unsPositionPair bbunsPositionPair;
        S_bb_symbolPositionPair bbsymbolPositionPair;
        S_bb_symbolPositionLstPair bbsymbolPositionLstPair;
        S_bb_positionLst bbpositionLst;
        S_bb_typeModifiersListPositionLstPair bbtypeModifiersListPositionLstPair;
        S_bb_nestedConstrTokenType bbnestedConstrTokenType;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
static char * XREF_VERSION_NUMBER = "1.6.7";
static char * XREF_FILE_VERSION_NUMBER = "1.6.0";
static char * PPC_NO_TAG = "-- no tag --";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_FULL_MULTIPLE_COMPLETIONS = "full-completions";
static char * PPC_ALL_COMPLETIONS = "all-completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_CALL_MACRO = "macro";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_ADD_TO_IMPORTS_DIALOG = "add-to-imports-dialog";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_NO_SYMBOL = "no-symbol-found";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_BOTTOM_WARNING = "bottom-warning";
static char * PPC_ERROR = "error";
static char * PPC_LICENSE_ERROR = "license-error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_KILL_BUFFER_REMOVE_FILE = "kill-buffer-remove-file";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "str";
static char * PPC_INT_VALUE = "int";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_LEVEL = "lev";
static char * PPCA_VCLASS = "vcl";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static char * PPCA_SYMBOL = "symbol";
static char * PPCA_BEEP = "beep";
static char * PPCA_NUMBER = "number";
static char * PPCA_NO_FOCUS = "nofocus";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 00;
static int PPC_AVR_RENAME_SYMBOL = 10;
static int PPC_AVR_RENAME_CLASS = 20;
static int PPC_AVR_RENAME_PACKAGE = 30;
static int PPC_AVR_ADD_PARAMETER = 40;
static int PPC_AVR_DEL_PARAMETER = 50;
static int PPC_AVR_MOVE_PARAMETER = 60;
static int PPC_AVR_MOVE_STATIC_FIELD = 70;
static int PPC_AVR_MOVE_STATIC_METHOD = 80;
static int PPC_AVR_MOVE_FIELD = 90;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 100;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 110;
static int PPC_AVR_PULL_UP_FIELD = 120;
static int PPC_AVR_PULL_UP_METHOD = 130;
static int PPC_AVR_PUSH_DOWN_FIELD = 140;
static int PPC_AVR_PUSH_DOWN_METHOD = 150;
static int PPC_AVR_MOVE_CLASS = 160;
static int PPC_AVR_MOVE_CLASS_TO_NEW_FILE = 170;
static int PPC_AVR_MOVE_ALL_CLASSES_TO_NEW_FILE = 180;
static int PPC_AVR_ENCAPSULATE_FIELD = 190;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 200;
static int PPC_AVR_ADD_TO_IMPORT = 210;
static int PPC_AVR_EXTRACT_METHOD = 220;
static int PPC_AVR_EXTRACT_FUNCTION = 230;
static int PPC_AVR_EXTRACT_MACRO = 240;
static int PPC_AVR_REDUCE_NAMES = 250;
static int PPC_AVR_EXPAND_NAMES = 260;
static int PPC_AVR_ADD_ALL_POSSIBLE_IMPORTS = 270;
static int PPC_AVR_SET_MOVE_TARGET = 280;
static int PPC_AVR_UNDO = 290;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 300;
static char * PPC_SET_PROJECT = "set-project";
struct maTab {
        int size;
        int numberOfElements;
        S_macroArgTabElem **tab;
};
extern void maTabInit ();
extern void maTabNAInit ();
extern int maTabIsMember ();
void maTabSet ();
extern void maTabAdd ();
extern void maTabFree ();
extern void maTabMap ();
extern void maTabMap2 ();
extern void maTabMap4 ();
extern void maTabMap3 ();
void maTabNAInit(struct maTab *t, int size) {
        int i;
        t->numberOfElements = 0;
        t->size = size;
        memset(t->tab, 0, sizeof(S_macroArgTabElem*)*t->size);
}
void maTabInit(struct maTab *t, int size) {
        int i;
        {t->tab = (S_macroArgTabElem **) stackMemoryAlloc((size)*sizeof(S_macroArgTabElem *)); };
        maTabNAInit(t, size);
}
int maTabIsMember(
                                        struct maTab *t,
                                        S_macroArgTabElem *elem,
                                        int *position
                        ) {
        unsigned posid;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashtab.tc", 57);};
        while (t->tab[posid] != NULL) {
                if ((strcmp(t->tab[posid]->name,elem->name)==0)) {
                        *position = posid;
                        return(1);
                }
                posid=(posid+211) % t->size;
        }
        *position = posid;
        return(0);
}
void maTabSet (
                                        struct maTab *t,
                                        S_macroArgTabElem *elem,
                                        int position
                                ) {
    if (t->tab[position]==NULL) {
                t->numberOfElements ++;
            if ((t->numberOfElements * 9) / 8 >= t->size) {
          fatalError(ERR_ST, "[hashAdd] file table overflowed", 65);
            }
        }
    t->tab[position] = elem;
}
void maTabAdd (
                                        struct maTab *t,
                                        S_macroArgTabElem *elem,
                                        int *position
                                ) {
  if (! maTabIsMember(t,elem,position)) {
        maTabSet (t,elem,*position);
  }
}
void maTabFree(struct maTab *t) {
        { };
}
void maTabMap(
                                        struct maTab *t,
                                        void (*fun)(S_macroArgTabElem *)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i]);
        }
}
void maTabMap2(
                                        struct maTab *t,
                                        void (*fun)(S_macroArgTabElem *, void *),
                                        void *a
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i], a);
        }
}
void maTabMap4(
                                        struct maTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *a,
                                        void *b
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(i, a, b);
        }
}
void maTabMap3(
                                        struct maTab *t,
                                        void (*fun)(S_macroArgTabElem *, int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i], i);
        }
}
static struct maTab s_maTab;
static char ppMemory[SIZE_ppMemory];
static int ppMemoryi=0;
S_position s_yyPositionBuf[YYBUFFERED_ID_INDEX];
int s_yyPositionBufi = 0;
static void prependMacroArgument ();
static int macroCallExpand ();
void initAllInputs() {
        mbMemoryi=0;
        inStacki=0;
        macStacki=0;
        s_ifEvaluation = 0;
        s_cxRefFlag = 0;
        maTabNAInit(&s_maTab, MAX_MACRO_ARGS);
        ppMemoryi=0;
        s_olstring[0]=0;
        s_olstringFound = 0;
        s_olstringServed = 0;
        s_olstringInMbody = NULL;
        s_upLevelFunctionCompletionType = NULL;
        s_structRecordCompletionType = NULL;
}
char *placeIdent() {
        static char tt[MAX_HTML_REF_LEN];
        char fn[MAX_FILE_NAME_SIZE];
        char mm[MAX_HTML_REF_LEN];
        int s;
        if (cFile.fileName!=NULL) {
                if (s_opt.xref2 && s_opt.taskRegime!=RegimeEditServer) {
                        strcpy(fn, getRealFileNameStatic(normalizeFileName(cFile.fileName, s_cwd)));
                        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE", "yylex.c", 93);};
                        sprintf(mm, "%s:%d", simpleFileName(fn),cFile.lineNumber);
                        { if (!(strlen(mm) < MAX_HTML_REF_LEN)) internalCheckFail("strlen(mm) < MAX_HTML_REF_LEN", "yylex.c", 95);};
                        sprintf(tt,"<A HREF=\"file://%s#%d\" %s=%d>%s</A>", fn, cFile.lineNumber, PPCA_LEN, strlen(mm), mm);
                } else {
                        sprintf(tt,"%s:%d ",simpleFileName(getRealFileNameStatic(cFile.fileName)),cFile.lineNumber);
                }
                s = strlen(tt);
                { if (!(s<MAX_HTML_REF_LEN)) internalCheckFail("s<MAX_HTML_REF_LEN", "yylex.c", 101);};
                return(tt);
        }
        return("");
}
static void dpnewline(int n) {
        int i;
        if (s_opt.debug) {
                for(i=1; i<=n; i++) {
                        fprintf(dumpOut,"\n%s:%d ", cFile.fileName, cFile.lineNumber+i);
                        fflush(dumpOut);
                }
        }
}
int addFileTabItem(char *name, int *fileNumber) {
        int ii,len,res;
        char *fname,*nn;
        struct fileItem ffi, *ffii;
        res = 0;
        nn = normalizeFileName(name,s_cwd);
        { (&ffi)->name = nn; (&ffi)->lastModif = 0; (&ffi)->lastInspect = 0; (&ffi)->lastUpdateMtime = 0; (&ffi)->lastFullUpdateMtime = 0; (&ffi)->b.cxLoading = 0; (&ffi)->b.cxLoaded = 0; (&ffi)->b.cxSaved = 0; (&ffi)->b.commandLineEntered = 0; (&ffi)->b.scheduledToProcess = 0; (&ffi)->b.scheduledToUpdate = 0; (&ffi)->b.fullUpdateIncludesProcessed = 0; (&ffi)->b.isInterface = 0; (&ffi)->b.isFromCxfile = 0; (&ffi)->b.sourceFile = s_noneFileIndex; (&ffi)->sups = NULL; (&ffi)->infs = NULL; (&ffi)->directEnclosingInstance = s_noneFileIndex; (&ffi)->next = NULL;};
        if (idTabIsMember(&s_fileTab, &ffi, fileNumber)) return(0);
        len = strlen(nn);
        {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "yylex.c", 133);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(len+1)*sizeof(char) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } fname = (char*) (ftMemory + ftMemoryi); ftMemoryi += (len+1)*sizeof(char);};};
        strcpy(fname, nn);
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 135);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(1)*sizeof(S_fileItem) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } ffii = (S_fileItem*) (ftMemory + ftMemoryi); ftMemoryi += (1)*sizeof(S_fileItem);};};};
        { (ffii)->name = fname; (ffii)->lastModif = 0; (ffii)->lastInspect = 0; (ffii)->lastUpdateMtime = 0; (ffii)->lastFullUpdateMtime = 0; (ffii)->b.cxLoading = 0; (ffii)->b.cxLoaded = 0; (ffii)->b.cxSaved = 0; (ffii)->b.commandLineEntered = 0; (ffii)->b.scheduledToProcess = 0; (ffii)->b.scheduledToUpdate = 0; (ffii)->b.fullUpdateIncludesProcessed = 0; (ffii)->b.isInterface = 0; (ffii)->b.isFromCxfile = 0; (ffii)->b.sourceFile = s_noneFileIndex; (ffii)->sups = NULL; (ffii)->infs = NULL; (ffii)->directEnclosingInstance = s_noneFileIndex; (ffii)->next = NULL;};
        idTabAdd(&s_fileTab, ffii, &ii);
        testFileModifTime(ii);
        *fileNumber = ii;
        return(1);
}
void getOrCreateFileInfo(char *ss, int *fileNumber, char **fileName) {
        int ii,len,newFileFlag,cxloading;
        char *ff;
        struct fileItem *ffii;
        if (ss==NULL) {
                *fileNumber = ii = s_noneFileIndex;
                *fileName = s_fileTab.tab[ii]->name;
        } else {
                newFileFlag = addFileTabItem(ss, &ii);
                *fileNumber = ii;
                *fileName = s_fileTab.tab[ii]->name;
                testFileModifTime(ii);
                cxloading = s_fileTab.tab[ii]->b.cxLoading;
                if (newFileFlag) {
                        cxloading = 1;
                } else if (s_opt.update==UP_FAST_UPDATE) {
                        if (s_fileTab.tab[ii]->b.scheduledToProcess) {
                                cxloading = 1;
                        }
                } else if (s_opt.update==UP_FULL_UPDATE) {
                        if (s_fileTab.tab[ii]->b.scheduledToUpdate) {
                                cxloading = 1;
                        }
                } else {
                        cxloading = 1;
                }
                if (s_fileTab.tab[ii]->b.cxSaved==1 && ! s_opt.multiHeadRefsCare) {
                        cxloading = 0;
                }
                if (((s_language & (4)) != 0)) {
                        if (s_jsl!=NULL || s_javaPreScanOnly) {
                                cxloading = s_fileTab.tab[ii]->b.cxLoading;
                        }
                }
                s_fileTab.tab[ii]->b.cxLoading = cxloading;
        }
}
void setOpenFileInfo(char *ss) {
        int ii;
        char *ff;
        getOrCreateFileInfo(ss, &ii, &ff);
        cFile.lb.cb.fileNumber = ii;
        cFile.fileName = ff;
}
void ppMemInit() {
        {{ { if (!((MAX_MACRO_ARGS) >= 0)) internalCheckFail("(MAX_MACRO_ARGS) >= 0", "yylex.c", 200);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(MAX_MACRO_ARGS)*sizeof(struct macroArgTabElem *) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } s_maTab.tab = (struct macroArgTabElem **) (ppmMemory + ppmMemoryi); ppmMemoryi += (MAX_MACRO_ARGS)*sizeof(struct macroArgTabElem *);};};
        maTabNAInit(&s_maTab, MAX_MACRO_ARGS);
        ppMemoryi = 0;
}
void initInput(FILE *ff, S_editorBuffer *buffer, char *prepend, char *name) {
        int plen, bsize, filepos;
        char *bbase;
        plen = strlen(prepend);
        if (buffer!=NULL) {
                { if (!(plen < buffer->a.allocatedFreePrefixSize)) internalCheckFail("plen < buffer->a.allocatedFreePrefixSize", "yylex.c", 212);};
                strncpy(buffer->a.text-plen, prepend, plen);
                bbase = buffer->a.text-plen;
                bsize = buffer->a.bufferSize+plen;
                filepos = buffer->a.bufferSize;
                { if (!(bbase > buffer->a.allocatedBlock)) internalCheckFail("bbase > buffer->a.allocatedBlock", "yylex.c", 217);};
        } else {
                { if (!(plen < CHAR_BUFF_SIZE)) internalCheckFail("plen < CHAR_BUFF_SIZE", "yylex.c", 220);};
                strcpy(cFile.lb.cb.a,prepend);
                bbase = cFile.lb.cb.a;
                bsize = plen;
                filepos = 0;
        }
        { (&cFile)->fileName = name; (&cFile)->lineNumber = 0; (&cFile)->ifDeep = 0; (&cFile)->ifstack = NULL; (&cFile)->lb.cc = NULL; (&cFile)->lb.fin = NULL; (&cFile)->lb.posi = 0; (&cFile)->lb.cb.cc = bbase; (&cFile)->lb.cb.fin = bbase+bsize; (&cFile)->lb.cb.ff = ff; (&cFile)->lb.cb.filePos = filepos; (&cFile)->lb.cb.fileNumber = s_noneFileIndex; (&cFile)->lb.cb.lineNum = 0; (&cFile)->lb.cb.lineBegin = bbase; (&cFile)->lb.cb.collumnOffset = 0; (&cFile)->lb.cb.isAtEOF = 0; (&cFile)->lb.cb.inputMethod = INPUT_DIRECT; (&cFile)->lb.cb.zipStream.next_in = NULL; (&cFile)->lb.cb.zipStream.avail_in = 0; (&cFile)->lb.cb.zipStream.total_in = 0; (&cFile)->lb.cb.zipStream.next_out = NULL; (&cFile)->lb.cb.zipStream.avail_out = 0; (&cFile)->lb.cb.zipStream.total_out = 0; (&cFile)->lb.cb.zipStream.msg = NULL; (&cFile)->lb.cb.zipStream.state = NULL; (&cFile)->lb.cb.zipStream.zalloc = NULL; (&cFile)->lb.cb.zipStream.zfree = NULL; (&cFile)->lb.cb.zipStream.opaque = NULL; (&cFile)->lb.cb.zipStream.data_type = 0; (&cFile)->lb.cb.zipStream.adler = 0; (&cFile)->lb.cb.zipStream.reserved = 0;};
        setOpenFileInfo(name);
        { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};};
        s_ifEvaluation = 0;
}
static void testCxrefCompletionId(int *llex, char *idd, S_position *pos) {
        int line,val,len,lex,res=0;
        unsigned h;
        lex = *llex;
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 352);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (lex==447) {
                        s_cache.activeCache = 0;
                        s_olstringServed = 1;
                        if (s_language == 4) {
                                makeJavaCompletions(idd, strlen(idd), pos);
                        }
                        else if (s_language == 8) {
                                makeYaccCompletions(idd, strlen(idd), pos);
                        }
                        else {
                                makeCCompletions(idd, strlen(idd), pos);
                        }
                        lex = 440;
                }
        }
        *llex = lex;
}
static void processLine() {
        char ss[TMP_STRING_SIZE];
        int i,lex,l,h,v=0,len;
        S_position pos;
        char ch,*cc;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 389);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        if (lex != 441) return;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 393);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 411);};
endOfFile:;
}
static void fillIncludeSymbolItem( S_symbol *ss,
                                                                   int filenum, S_position *pos
        ){
        { (&ss->b)->record = 0; (&ss->b)->isSingleImported = 0; (&ss->b)->accessFlags = 0; (&ss->b)->javaSourceLoaded = 0; (&ss->b)->javaFileLoaded = 0; (&ss->b)->symType = TypeCppInclude; (&ss->b)->storage = StorageDefault; (&ss->b)->npointers = 0;};
        { (ss)->name = "%%%i"; (ss)->linkName = "%%%i"; (ss)->pos = *pos; (ss)->b = ss->b; (ss)->u.type = NULL; (ss)->next = NULL;};
}
void addThisFileDefineIncludeReference(int filenum) {
        S_position dpos;
        S_symbol ss;
        { (&dpos)->file = filenum; (&dpos)->line = 1; (&dpos)->coll = 0;};
        fillIncludeSymbolItem( &ss,filenum, &dpos);
        addCxReference(&ss, &dpos, UsageDefined, filenum, filenum);
}
void addIncludeReference(int filenum, S_position *pos) {
        S_position dpos;
        S_symbol ss;
        fillIncludeSymbolItem( &ss, filenum, pos);
        addCxReference(&ss, pos, UsageUsed, filenum, filenum);
}
static void addIncludeReferences(int filenum, S_position *pos) {
        addIncludeReference(filenum, pos);
        addThisFileDefineIncludeReference(filenum);
}
void pushNewInclude(FILE *f, S_editorBuffer *buffer, char *name, char *prepend) {
        if (cInput.margExpFlag == II_CACHE) {
                {s_cache.cc = cInput.cc;};
        } else {
                { cFile.lb.cc = cInput.cc;};
        }
        inStack[inStacki] = cFile;
        if (inStacki+1 >= INSTACK_SIZE) {
                fatalError(ERR_ST,"too deep nesting in includes", 65);
        }
        inStacki ++;
        initInput(f, buffer, prepend, name);
        cacheInclude(cFile.lb.cb.fileNumber);
}
void popInclude() {
        { if (!(s_fileTab.tab[cFile.lb.cb.fileNumber])) internalCheckFail("s_fileTab.tab[cFile.lb.cb.fileNumber]", "yylex.c", 470);};
        if (s_fileTab.tab[cFile.lb.cb.fileNumber]->b.cxLoading) {
                s_fileTab.tab[cFile.lb.cb.fileNumber]->b.cxLoaded = 1;
        }
        charBuffClose(&cFile.lb.cb);
        if (inStacki != 0) {
                cFile = inStack[--inStacki];
                if (inStacki == 0 && s_cache.cc!=NULL) {
                        { (&cInput)->cc = s_cache.cc; (&cInput)->fin = s_cache.cfin; (&cInput)->a = s_cache.lb; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_CACHE;};
                } else {
                        { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};};
                }
        }
}
static FILE *openInclude(char pchar, char *name, char **fileName) {
        S_editorBuffer *er;
        FILE *r;
        S_stringList *ll;
        char wcp[MAX_OPTION_LEN];
        char nn[MAX_FILE_NAME_SIZE];
        char rdir[MAX_FILE_NAME_SIZE];
        char *nnn;
        int nnlen,dlen,fdlen,nmlen,len,ii;
        er = NULL; r = NULL;
        nmlen = strlen(name);
        copyDir(rdir, cFile.fileName, &fdlen);
        if (pchar!='<') {
                strcpy(nn,normalizeFileName(name, rdir));
                er = editorFindFile(nn);
                if (er==NULL) r = fopen(nn,"r");
        }
        for (ll=s_opt.includeDirs; ll!=NULL && er==NULL && r==NULL; ll=ll->next) {
                strcpy(nn, normalizeFileName(ll->d, rdir));
                expandWildCharactersInOnePath(nn, wcp, MAX_OPTION_LEN);
                { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(wcp!=NULL)) internalCheckFail("wcp!=NULL", "yylex.c", 508);}; jmop_pp = wcp; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { strcpy(nn, currentPath); dlen = strlen(nn); if (dlen>0 && nn[dlen-1]!=SLASH) { nn[dlen] = SLASH; dlen++; } strcpy(nn+dlen, name); nnlen = dlen+nmlen; nn[nnlen]=0; er = editorFindFile(nn); if (er==NULL) r = fopen(nn,"r"); if (er!=NULL || r!=NULL) goto found; }; currentPath += jmop_ind; currentPath++; }};
        }
        if (er==NULL && r==NULL) return(NULL);
 found:
        nnn = normalizeFileName(nn, s_cwd);
        strcpy(nn,nnn);
        pushNewInclude(r, er, nn, "\n");
        return(stdin);
}
static void processInclude2(S_position *ipos, char pchar, char *iname) {
        char *fname;
        FILE *nyyin;
        nyyin = openInclude(pchar, iname, &fname);
        if (nyyin == NULL) {
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 539);};
                if (s_opt.taskRegime!=RegimeEditServer) warning(ERR_CANT_OPEN, iname);
        } else if ((s_opt.taskRegime!=RegimeGenerate)) {
                addIncludeReferences(cFile.lb.cb.fileNumber, ipos);
        }
}
static void processInclude(S_position *ipos) {
        FILE *nyyin;
        char *fname;
        char *ccc, *cc2;
        int lex,l,h,v,len;
        S_position pos;
        { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 553);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc2 = cInput.cc; } cc2 = cInput.cc; GetLexToken(lex,cInput.cc);};
        ccc = cInput.cc;
        if (lex == 445) {
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                if (macStacki != 0) {
                        error(ERR_INTERNAL,"include directive in macro body?");
{ if (!(0)) internalCheckFail("0", "yylex.c", 559);};
                        cInput = macStack[0];
                        macStacki = 0;
                }
                processInclude2(ipos, *ccc, ccc+1);
        } else {
                cInput.cc = cc2;
                lex = yylex();
                if (lex == 445) {
                        cInput = macStack[0];
                        macStacki = 0;
                        processInclude2(ipos, '\"', yytext);
                } else if (lex == '<') {
                        warning(ERR_ST,"Include <> after macro expansion not yet implemented, sorry\n\tuse \"\" instead");
                }
        }
        return;
 endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 578);};
 endOfFile:;
}
static void addMacroToTabs(S_symbol *pp, char *name) {
        int ii,mm;
        S_symbol *memb;
        mm = symTabIsMember(s_symTab,pp,&ii,&memb);
        if (mm) {
                { if (s_opt.debug) {fprintf(dumpOut,": masking macro %s\n",name);fflush(dumpOut);}};
        } else {
                { if (s_opt.debug) {fprintf(dumpOut,": adding macro %s\n",name);fflush(dumpOut);}};
        }
        symTabSet(s_symTab,pp,ii);
}
static void setMacArgName(S_macroArgTabElem *arg, void *at) {
        char ** argTab;
        argTab = (char**)at;
        { if (!(arg->order>=0)) internalCheckFail("arg->order>=0", "yylex.c", 609);};
        argTab[arg->order] = arg->name;
}
static void handleMacroDefinitionParameterPositions(int argi, S_position *macpos,
                                                                                                        S_position *parpos1,
                                                                                                        S_position *pos, S_position *parpos2,
                                                                                                        int final
        ) {
        if ((s_opt.cxrefs == OLO_GOTO_PARAM_NAME || s_opt.cxrefs == OLO_GET_PARAM_COORDINATES)
                && (! ( ((*macpos).file != (s_cxRefPos).file) || ((*macpos).line != (s_cxRefPos).line) || ((*macpos).coll != (s_cxRefPos).coll) ))) {
                if (final) {
                        if (argi==0) {
                                setParamPositionForFunctionWithoutParams(parpos1);
                        } else if (argi < s_opt.olcxGotoVal) {
                                setParamPositionForParameterBeyondRange(parpos2);
                        }
                } else if (argi == s_opt.olcxGotoVal) {
                        s_paramPosition = *pos;
                        s_paramBeginPosition = *parpos1;
                        s_paramEndPosition = *parpos2;
                }
        }
}
static void handleMacroUsageParameterPositions(int argi, S_position *macpos,
                                                                                           S_position *parpos1, S_position *parpos2,
                                                                                           int final
        ) {
        if (s_opt.cxrefs == OLO_GET_PARAM_COORDINATES
                && (! ( ((*macpos).file != (s_cxRefPos).file) || ((*macpos).line != (s_cxRefPos).line) || ((*macpos).coll != (s_cxRefPos).coll) ))) {
                if (final) {
                        if (argi==0) {
                                setParamPositionForFunctionWithoutParams(parpos1);
                        } else if (argi < s_opt.olcxGotoVal) {
                                setParamPositionForParameterBeyondRange(parpos2);
                        }
                } else if (argi == s_opt.olcxGotoVal) {
                        s_paramBeginPosition = *parpos1;
                        s_paramEndPosition = *parpos2;
                }
        }
}
static void processDefine(int argFlag) {
        int i,lex,l,h,v;
        int bodyReadingFlag = 0;
        int j,sizei,ii,msize,argi,ellipsis,len;
        S_symbol *pp;
        S_macroArgTabElem *maca,mmaca;
        S_macroBody *macbody;
        S_position pos, macpos, ppb1, ppb2, *parpos1, *parpos2, *tmppp;
        char ch,*cc,*mname,*aname,*mbody,*mLinkName,*mm,*fromcc,*tocc,*ddd;
        char **argNames, *argLinkName;
        sizei= -1;
        msize=0;argi=0;pp=NULL;macbody=NULL;mname=mbody=NULL;
        {ppMemoryi = 0;};
        ppb1 = s_noPos;
        ppb2 = s_noPos;
        parpos1 = &ppb1;
        parpos2 = &ppb2;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 673);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
        cc = cInput.cc;
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((macpos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((macpos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((macpos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((macpos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((macpos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((macpos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((macpos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((macpos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((macpos),cInput.cc); } };
        testCxrefCompletionId(&lex,cc,&macpos);
        if (lex != 440) return;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 678);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pp = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        { (&pp->b)->record = 0; (&pp->b)->isSingleImported = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeMacro; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
        { (pp)->name = NULL; (pp)->linkName = NULL; (pp)->pos = macpos; (pp)->b = pp->b; (pp)->u.mbody = NULL; (pp)->next = NULL;};
        setGlobalFileDepNames(cc, pp, MEM_PP);
        mname = pp->name;
        maTabNAInit(&s_maTab,s_maTab.size);
        argi = -1;
        if (argFlag) {
                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 687);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 687);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((*parpos2),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((*parpos2),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((*parpos2),cInput.cc); } };
                *parpos1 = *parpos2;
                if (lex != '(') goto errorlab;
                argi ++;
                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 692);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 692);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                if (lex != ')') {
                        for(;;) {
                                cc = aname = cInput.cc;
                                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                                ellipsis = 0;
                                if (lex == 440 ) {
                                        aname = cc;
                                } else if (lex == 283) {
                                        aname = s_cppVarArgsName;
                                        pos = macpos;
                                        ellipsis = 1;
                                } else goto errorlab;
                                {{ { if (!((strlen(aname)+1) >= 0)) internalCheckFail("(strlen(aname)+1) >= 0", "yylex.c", 705);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(aname)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mm = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(aname)+1)*sizeof(char);};};
                                strcpy(mm,aname);
                                sprintf(tmpBuff, "%x-%x%c%s", pos.file, pos.line,
                                                '!', aname);
                                {{ { if (!((strlen(tmpBuff)+1) >= 0)) internalCheckFail("(strlen(tmpBuff)+1) >= 0", "yylex.c", 709);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(tmpBuff)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } argLinkName = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(tmpBuff)+1)*sizeof(char);};};
                                strcpy(argLinkName, tmpBuff);
                                {{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 711);}; ppMemoryi = ((char*)(((char*)(ppMemory+ppMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppMemory+ppMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppMemory; if (ppMemoryi+(1)*sizeof(S_macroArgTabElem) >= SIZE_ppMemory) { fatalError(ERR_NO_MEMORY,"ppMemory", 65); } maca = (S_macroArgTabElem*) (ppMemory + ppMemoryi); ppMemoryi += (1)*sizeof(S_macroArgTabElem);};};
                                { (maca)->name = mm; (maca)->linkName = argLinkName; (maca)->order = argi;};
                                maTabAdd(&s_maTab, maca, &ii);
                                argi ++;
                                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 715);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 715);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                                tmppp=parpos1; parpos1=parpos2; parpos2=tmppp;
                                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((*parpos2),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((*parpos2),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((*parpos2),cInput.cc); } };
                                if (! ellipsis) {
                                        addTrivialCxReference(s_maTab.tab[ii]->linkName, TypeMacroArg,StorageDefault,
                                                                                  &pos, UsageDefined);
                                        handleMacroDefinitionParameterPositions(argi, &macpos, parpos1, &pos, parpos2, 0);
                                }
                                if (lex == 283) {
                                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 725);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 725);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((*parpos2),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((*parpos2),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((*parpos2),cInput.cc); } };
                                }
                                if (lex == ')') break;
                                if (lex != ',') break;
                                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 730);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 730);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                        }
                        handleMacroDefinitionParameterPositions(argi, &macpos, parpos1, &s_noPos, parpos2, 1);
                } else {
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((*parpos2),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((*parpos2),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((*parpos2),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((*parpos2),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((*parpos2),cInput.cc); } };
                        handleMacroDefinitionParameterPositions(argi, &macpos, parpos1, &s_noPos, parpos2, 1);
                }
        }
        msize = MACRO_UNIT_SIZE;
        sizei = 0;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 741);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_macroBody) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } macbody = (S_macroBody*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_macroBody);};};};
        {{ { if (!((msize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(msize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 742);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(msize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mbody = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (msize+MAX_LEXEM_SIZE)*sizeof(char);};};
        bodyReadingFlag = 1;
        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 744);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 744);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
        cc = cInput.cc;
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        while (lex != '\n') {
                while(sizei<msize && lex != '\n') {
                        { (&mmaca)->name = cc; (&mmaca)->linkName = NULL; (&mmaca)->order = 0;};
                        if (lex==440 && maTabIsMember(&s_maTab,&mmaca,&ii)){
                                addTrivialCxReference(s_maTab.tab[ii]->linkName, TypeMacroArg,StorageDefault,
                                                                          &pos, UsageUsed);
                                ddd = mbody+sizei;
                                PutLexToken(448, ddd);
                                PutLexInt(s_maTab.tab[ii]->order, ddd);
                                PutLexPosition(pos.file, pos.line,pos.coll,ddd);
                                sizei = ddd - mbody;
                        } else {
                                if (lex==447
                                        || (lex == 440 &&
                                                (! ( ((pos).file != (s_cxRefPos).file) || ((pos).line != (s_cxRefPos).line) || ((pos).coll != (s_cxRefPos).coll) )))) {
                                        s_cache.activeCache = 0;
                                        s_olstringFound = 1; s_olstringInMbody = pp->linkName;
                                }
                                ddd = mbody+sizei;
                                PutLexToken(lex, ddd);
                                for(; cc<cInput.cc; ddd++,cc++)*ddd= *cc;
                                sizei = ddd - mbody;
                        }
                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 771);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 771);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                        cc = cInput.cc;
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                }
                if (lex != '\n') {
                        msize += MACRO_UNIT_SIZE;
                        {{ { if (!(((char *)(mbody)) + (msize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(mbody)) + (msize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 777);}; ppmMemoryi = ((char*)mbody) - ppmMemory; { { if (!((msize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(msize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 777);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(msize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mbody = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (msize+MAX_LEXEM_SIZE)*sizeof(char);};};};
                }
        }
endOfBody:
        { if (!(sizei>=0)) internalCheckFail("sizei>=0", "yylex.c", 782);};
        {{ { if (!(((char *)(mbody)) + (msize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(mbody)) + (msize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 783);}; ppmMemoryi = ((char*)mbody) - ppmMemory; { { if (!((sizei) >= 0)) internalCheckFail("(sizei) >= 0", "yylex.c", 783);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(sizei)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mbody = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (sizei)*sizeof(char);};};};
        msize = sizei;
        if (argi > 0) {
                {{ { if (!((argi) >= 0)) internalCheckFail("(argi) >= 0", "yylex.c", 787);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(argi)*sizeof(char*) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } argNames = (char**) (ppmMemory + ppmMemoryi); ppmMemoryi += (argi)*sizeof(char*);};};
                memset(argNames,0,argi*sizeof(char*));
                maTabMap2(&s_maTab, setMacArgName, argNames);
        } else argNames = NULL;
        { (macbody)->argn = argi; (macbody)->size = msize; (macbody)->name = mname; (macbody)->args = argNames; (macbody)->body = mbody;};
        pp->u.mbody = macbody;
        addMacroToTabs(pp,mname);
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 795);};
        if ((s_opt.taskRegime!=RegimeGenerate)) {
                addCxReference(pp, &macpos, UsageDefined,s_noneFileIndex, s_noneFileIndex);
        }
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 800);};
endOfFile:
        if (bodyReadingFlag) goto endOfBody;
        return;
errorlab:
        return;
}
void addMacroDefinedByOption(char *opt) {
        char *name,*cc,*body,*nopt;
        S_symbol *pp;
        S_macroBody *macbody;
        int size,args;
        {{ { if (!((strlen(opt)+3) >= 0)) internalCheckFail("(strlen(opt)+3) >= 0", "yylex.c", 815);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(opt)+3)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } nopt = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(opt)+3)*sizeof(char);};};
        strcpy(nopt,opt);
        name = cc = nopt;
        while (isalpha(*cc) || isdigit(*cc) || *cc == '_') cc++;
        args = 0;
        if (*cc == '=') {
                *cc = ' ';
        } else if (*cc==0) {
                *cc++ = ' ';
                *cc++ = '1';
                *cc = 0;
        } else if (*cc=='(') {
                args = 1;
        }
        initInput(NULL, NULL,nopt,NULL);
        cFile.lineNumber = 1;
        processDefine(args);
}
static void processUnDefine() {
        int lex,l,h,v,ii,len;
        char *cc;
        S_position pos;
        S_symbol dd,*pp,*memb;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 841);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
        cc = cInput.cc;
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        testCxrefCompletionId(&lex,cc,&pos);
        if ((lex==440 || lex==449 || lex==447)) {
                { if (s_opt.debug) {fprintf(dumpOut,": undef macro %s\n",cc);fflush(dumpOut);}};
                { (&dd.b)->record = 0; (&dd.b)->isSingleImported = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeMacro; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                { (&dd)->name = cc; (&dd)->linkName = cc; (&dd)->pos = pos; (&dd)->b = dd.b; (&dd)->u.mbody = NULL; (&dd)->next = NULL;};
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 849);};
                if (symTabIsMember(s_symTab, &dd, &ii, &memb)) {
                        if ((s_opt.taskRegime!=RegimeGenerate)) {
                                addCxReference(memb, &pos, UsageUndefinedMacro,s_noneFileIndex, s_noneFileIndex);
                        }
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 856);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pp = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
                        { (&pp->b)->record = 0; (&pp->b)->isSingleImported = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeMacro; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
                        { (pp)->name = memb->name; (pp)->linkName = memb->linkName; (pp)->pos = pos; (pp)->b = pp->b; (pp)->u.mbody = NULL; (pp)->next = NULL;};
                        pp->u.mbody = NULL;
                        addMacroToTabs(pp,memb->name);
                }
        }
        while (lex != '\n') {{ char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 864);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };}
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 866);};
endOfFile:;
        return;
}
static void processIf();
enum deleteUntilReturn {
        UNTIL_NOTHING,
        UNTIL_ENDIF,
        UNTIL_ELIF,
        UNTIL_ELSE,
};
static void genCppIfElseReference(int level, S_position *pos, int usage) {
        char ttt[TMP_STRING_SIZE];
        S_position dp;
        S_cppIfStack *ss;
        if (level > 0) {
          {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 887);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_cppIfStack) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ss = (S_cppIfStack*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_cppIfStack);};};};
          { (ss)->pos = *pos; (ss)->next = cFile.ifstack;};
          cFile.ifstack = ss;
        }
        if (cFile.ifstack!=NULL) {
          dp = cFile.ifstack->pos;
          sprintf(ttt,"CppIf%x-%x-%d", dp.file, dp.coll, dp.line);
          addTrivialCxReference(ttt, TypeCppIfElse,StorageDefault, pos, usage);
          if (level < 0) cFile.ifstack = cFile.ifstack->next;
        }
}
static int cppDeleteUntilEndElse(int untilEnd) {
        int lex,l,h,v,len;
        int deep;
        int el;
        S_position pos;
        deep = 1;
        while (deep > 0) {
                { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 906);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                if (lex==419 || lex==417 || lex==418) {
                        genCppIfElseReference(1, &pos, UsageDefined);
                        deep++;
                } else if (lex == 421) {
                        deep--;
                        genCppIfElseReference(-1, &pos, UsageUsed);
                } else if (lex == 422) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        if (deep == 1 && !untilEnd) {
                                { if (s_opt.debug) {fprintf(dumpOut,"#elif ");fflush(dumpOut);}};
                                return(UNTIL_ELIF);
                        }
                } else if (lex == 420) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        if (deep == 1 && !untilEnd) {
                                { if (s_opt.debug) {fprintf(dumpOut,"#else\n");fflush(dumpOut);}};
                                return(UNTIL_ELSE);
                        }
                }
        }
        { if (s_opt.debug) {fprintf(dumpOut,"#endif\n");fflush(dumpOut);}};
        return(UNTIL_ENDIF);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 930);};
endOfFile:;
        if (s_opt.taskRegime!=RegimeEditServer) {
                warning(ERR_ST,"end of file in cpp conditional");
        }
        return(UNTIL_ENDIF);
}
static void execCppIf(int deleteSource) {
        int onElse;
        if (deleteSource==0) cFile.ifDeep ++;
        else {
                onElse = cppDeleteUntilEndElse(0);
                if (onElse==UNTIL_ELSE) {
                        cFile.ifDeep ++;
                } else if (onElse==UNTIL_ELIF) processIf();
        }
}
static void processIfdef(int isIfdef) {
        int lex,l,h,v;
        int i,ii,mm,len;
        char nn[MACRO_NAME_SIZE];
        S_symbol pp,*memb;
        char ch,*cc,nnn;
        S_position pos;
        int deleteSrc;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 958);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
        cc = cInput.cc;
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        testCxrefCompletionId(&lex,cc,&pos);
        if (! (lex==440 || lex==449 || lex==447)) return;
        { (&pp.b)->record = 0; (&pp.b)->isSingleImported = 0; (&pp.b)->accessFlags = 0; (&pp.b)->javaSourceLoaded = 0; (&pp.b)->javaFileLoaded = 0; (&pp.b)->symType = TypeMacro; (&pp.b)->storage = StorageNone; (&pp.b)->npointers = 0;};
        { (&pp)->name = cc; (&pp)->linkName = cc; (&pp)->pos = s_noPos; (&pp)->b = pp.b; (&pp)->u.mbody = NULL; (&pp)->next = NULL;};
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 965);};
        mm = symTabIsMember(s_symTab,&pp,&ii,&memb);
        if (mm && memb->u.mbody==NULL) mm = 0;
        if (mm) {
                if ((s_opt.taskRegime!=RegimeGenerate)) {
                        addCxReference(memb,&pos,UsageUsed,s_noneFileIndex,s_noneFileIndex);
                }
                if (isIfdef) {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifdef (true)\n");fflush(dumpOut);}};
                        deleteSrc = 0;
                } else {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifndef (false)\n");fflush(dumpOut);}};
                        deleteSrc = 1;
                }
        } else {
                if (isIfdef) {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifdef (false)\n");fflush(dumpOut);}};
                        deleteSrc = 1;
                } else {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifndef (true)\n");fflush(dumpOut);}};
                        deleteSrc = 0;
                }
        }
        execCppIf(deleteSrc);
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 990);};
endOfFile:;
}
int cexpyylex() {
        int l,v,lex,par,ii,res,mm,len;
        char *cc;
        unsigned h;
        S_symbol dd,*memb;
        S_position pos;
        lex = yylex();
        if ((lex==440 || lex==449 || lex==447)) {
                lex = cexpTranslateToken(441, 0);
        } else if (lex == 429) {
                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1007);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1007);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                cc = cInput.cc;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                if (lex == '(') {
                        par = 1;
                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1012);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1012);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                        cc = cInput.cc;
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                } else {
                        par = 0;
                }
                if (! (lex==440 || lex==449 || lex==447)) return(0);
                { (&dd.b)->record = 0; (&dd.b)->isSingleImported = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeMacro; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                { (&dd)->name = cc; (&dd)->linkName = cc; (&dd)->pos = s_noPos; (&dd)->b = dd.b; (&dd)->u.mbody = NULL; (&dd)->next = NULL;};
                { if (s_opt.debug) {fprintf(dumpOut,"(%s) ",dd.name);fflush(dumpOut);}};
                mm = symTabIsMember(s_symTab,&dd,&ii,&memb);
                if (mm && memb->u.mbody == NULL) mm = 0;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1024);};
                if ((s_opt.taskRegime!=RegimeGenerate)) {
                        if (mm) addCxReference(&dd, &pos, UsageUsed,s_noneFileIndex, s_noneFileIndex);
                }
                res = cexpTranslateToken(441, mm);
                if (par) {
                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1031);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; while (lex == 446) { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1031);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};}; }};
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                        if (lex != ')' && s_opt.taskRegime!=RegimeEditServer) {
                                warning(ERR_ST,"missing ')' after defined( ");
                        }
                }
                lex = res;
        } else {
                lex = cexpTranslateToken(lex, uniyylval->bbinteger.d);
        }
        return(lex);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1042);};
endOfFile:;
        return(0);
}
static void processIf() {
        int res=1,lex;
        s_ifEvaluation = 1;
        { if (s_opt.debug) {fprintf(dumpOut,": #if ");fflush(dumpOut);}};
        res = cexpyyparse();
        do lex = yylex(); while (lex != '\n');
        s_ifEvaluation = 0;
        execCppIf(! res);
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1056);};
endOfFile:;
}
static int processCppConstruct(int lex) {
        int l,v,len;
        unsigned h;
        S_position pos;
        char *fname,*mname;
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        switch (lex) {
        case 415:
                processInclude(&pos);
                break;
        case 426:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processDefine(0);
                break;
        case 416:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processDefine(1);
                break;
        case 423:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processUnDefine();
                break;
        case 417:
                genCppIfElseReference(1, &pos, UsageDefined);
                processIfdef(1);
                break;
        case 418:
                genCppIfElseReference(1, &pos, UsageDefined);
                processIfdef(0);
                break;
        case 419:
                genCppIfElseReference(1, &pos, UsageDefined);
                processIf();
                break;
        case 422:
                { if (s_opt.debug) {fprintf(dumpOut,"#elif ");fflush(dumpOut);}};
                if (cFile.ifDeep) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        cFile.ifDeep --;
                        cppDeleteUntilEndElse(1);
                } else if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"unmatched #elif");
                }
                break;
        case 420:
                { if (s_opt.debug) {fprintf(dumpOut,"#else\n");fflush(dumpOut);}};
                if (cFile.ifDeep) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        cFile.ifDeep --;
                        cppDeleteUntilEndElse(1);
                } else if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"unmatched #else");
                }
                break;
        case 421:
                { if (s_opt.debug) {fprintf(dumpOut,"#endif\n");fflush(dumpOut);}};
                if (cFile.ifDeep) {
                        cFile.ifDeep --;
                        genCppIfElseReference(-1, &pos, UsageUsed);
                } else if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"unmatched #endif");
                }
                break;
        case 424:
                { if (s_opt.debug) {fprintf(dumpOut,"#pragma\n");fflush(dumpOut);}};
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1137);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
                while (lex != '\n') {{ if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1138);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};}
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                break;
        case 425:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processLine();
                { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1144);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
                while (lex != '\n') {{ if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1145);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};}
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(l,cInput.cc); if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(v,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                break;
        default: { if (!(0)) internalCheckFail("0", "yylex.c", 1148);};
        }
        return(1);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1151);};
endOfFile:
        return(0);
}
static int cyclicCall(S_macroBody *mb) {
        struct lexInput *ll;
        char *name;
        int i;
        name = mb->name;
        if (cInput.macname != NULL && !strcmp(name,cInput.macname)) return(1);
        for(i=0; i<macStacki; i++) {
                ll = &macStack[i];
                if (ll->macname != NULL && !strcmp(name,ll->macname)) return(1);
        }
        return(0);
}
static int macroCallExpansion( char *cc2, int lex, S_position *pos ) {
        S_symbol sd, *memb;
        int ii;
        if (lex == 440) {
                { (&sd.b)->record = 0; (&sd.b)->isSingleImported = 0; (&sd.b)->accessFlags = 0; (&sd.b)->javaSourceLoaded = 0; (&sd.b)->javaFileLoaded = 0; (&sd.b)->symType = TypeMacro; (&sd.b)->storage = StorageNone; (&sd.b)->npointers = 0;};
                { (&sd)->name = cc2; (&sd)->linkName = cc2; (&sd)->pos = s_noPos; (&sd)->b = sd.b; (&sd)->u.mbody = NULL; (&sd)->next = NULL;};
                if (symTabIsMember(s_symTab,&sd,&ii,&memb)) {
                        if (macroCallExpand(memb,pos)) return(1);
                }
        }
        return(0);
}
static void expandMacroArgument(S_lexInput *argb) {
        S_lexInput expArg;
        S_symbol sd,*memb;
        char *buf,*cc,*cc2,*bcc, *tbcc;
        int nn,ii,lex,line,val,bsize,nnr,failedMacroExpansion,len;
        S_position pos;
        unsigned hash;
        { { if (!(macStacki < MACSTACK_SIZE-1)) internalCheckFail("macStacki < MACSTACK_SIZE-1", "yylex.c", 1214);}; macStack[macStacki++] = cInput; cInput = *argb; cInput.cc = cInput.a; cInput.margExpFlag = II_MACRO;};
        cInput.margExpFlag = II_MACRO_ARG;
        bsize = MACRO_UNIT_SIZE;
        {{ { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1217);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        bcc = buf;
        for(;;) {
        nextLexem:
                { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1221);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);};
                cc2 = cInput.cc;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                nn = ((char*)cInput.cc) - cc;
                { if (!(nn >= 0)) internalCheckFail("nn >= 0", "yylex.c", 1225);};
                memcpy(bcc, cc, nn);
                failedMacroExpansion = 0;
                if (lex == 440) {
                        { (&sd.b)->record = 0; (&sd.b)->isSingleImported = 0; (&sd.b)->accessFlags = 0; (&sd.b)->javaSourceLoaded = 0; (&sd.b)->javaFileLoaded = 0; (&sd.b)->symType = TypeMacro; (&sd.b)->storage = StorageNone; (&sd.b)->npointers = 0;};
                        { (&sd)->name = cc2; (&sd)->linkName = cc2; (&sd)->pos = s_noPos; (&sd)->b = sd.b; (&sd)->u.mbody = NULL; (&sd)->next = NULL;};
                        if (symTabIsMember(s_symTab,&sd,&ii,&memb)) {
                                if (macroCallExpand(memb,&pos)) goto nextLexem;
                                else failedMacroExpansion = 1;
                        }
                }
                if (failedMacroExpansion) {
                        tbcc = bcc;
                        { if (!(memb!=NULL)) internalCheckFail("memb!=NULL", "yylex.c", 1242);};
                        if (memb->u.mbody!=NULL && cyclicCall(memb->u.mbody)) PutLexToken(449, tbcc);
                }
                bcc += nn;
                { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1247);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1247);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
endOfMacArg:
        cInput = macStack[--macStacki];
        {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1251);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bcc-buf) >= 0)) internalCheckFail("(bcc-buf) >= 0", "yylex.c", 1251);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bcc-buf)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bcc-buf)*sizeof(char);};};};
        { (argb)->cc = buf; (argb)->fin = bcc; (argb)->a = buf; (argb)->macname = NULL; (argb)->margExpFlag = II_NORMAL;};
        return;
endOfFile:
        { if (!(0)) internalCheckFail("0", "yylex.c", 1255);};
}
static void cxAddCollateReference( char *sym, char *cs, S_position *pos ) {
        char ttt[TMP_STRING_SIZE];
        S_position pps;
        strcpy(ttt,sym);
        { if (!(cs>=sym && cs-sym<TMP_STRING_SIZE)) internalCheckFail("cs>=sym && cs-sym<TMP_STRING_SIZE", "yylex.c", 1262);};
        sprintf(ttt+(cs-sym), "%c%c%s", '#',
                        '#', cs);
        pps = *pos;
        addTrivialCxReference(ttt, TypeCppCollate,StorageDefault, &pps, UsageDefined);
}
static void collate(char **albcc, char **abcc, char *buf, int *absize,
                                        char **ancc, S_lexInput *actArgs) {
        char *lbcc,*bcc,*cc,*ccfin,*cc0,*ncc,*cc1,*occ;
        int line, val, lex, nlex, len1, bsize, nlt,len;
        S_position pos,respos;
        unsigned hash;
        ncc = *ancc;
        lbcc = *albcc;
        bcc = *abcc;
        bsize = *absize;
        val=0;
        if (NextLexToken(lbcc) == 448) {
                bcc = lbcc;
                GetLexToken(lex,lbcc);
                { if (!(lex==448)) internalCheckFail("lex==448", "yylex.c", 1286);};
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=lbcc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((respos),tmpcc); lbcc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=lbcc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((respos),tmpcc); lbcc = tmpcc; } else if (lex == 446) { GetLexToken(line,lbcc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,lbcc); GetLexPosition((respos),lbcc); GetLexInt(len,lbcc); } else if (lex == 444 || lex == 443) { GetLexPosition((respos),lbcc); GetLexInt(len,lbcc); } else if (lex == 448) { GetLexInt(val,lbcc); GetLexPosition((respos),lbcc); } else if (lex == 450) { GetLexInt(val,lbcc); GetLexPosition((respos),lbcc); GetLexInt(len,lbcc); } } else if (lex>414 && lex<427) { GetLexPosition((respos),lbcc); } else if (lex == '\n' && (0)) { GetLexPosition((respos),lbcc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((respos),lbcc); } };
                cc = actArgs[val].a; ccfin = actArgs[val].fin;
                lbcc = NULL;
                while (cc < ccfin) {
                        cc0 = cc;
                        GetLexToken(lex, cc);
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((respos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((respos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cc); GetLexPosition((respos),cc); GetLexInt(len,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((respos),cc); GetLexInt(len,cc); } else if (lex == 448) { GetLexInt(val,cc); GetLexPosition((respos),cc); } else if (lex == 450) { GetLexInt(val,cc); GetLexPosition((respos),cc); GetLexInt(len,cc); } } else if (lex>414 && lex<427) { GetLexPosition((respos),cc); } else if (lex == '\n' && (0)) { GetLexPosition((respos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((respos),cc); } };
                        lbcc = bcc;
                        { if (!(cc>=cc0)) internalCheckFail("cc>=cc0", "yylex.c", 1295);};
                        memcpy(bcc, cc0, cc-cc0);
                        bcc += cc-cc0;
                        { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1298);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1298);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                }
        }
        if (NextLexToken(ncc) == 448) {
                GetLexToken(lex, ncc);
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); ncc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); ncc = tmpcc; } else if (lex == 446) { GetLexToken(line,ncc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,ncc); GetLexPosition((pos),ncc); GetLexInt(len,ncc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),ncc); GetLexInt(len,ncc); } else if (lex == 448) { GetLexInt(val,ncc); GetLexPosition((pos),ncc); } else if (lex == 450) { GetLexInt(val,ncc); GetLexPosition((pos),ncc); GetLexInt(len,ncc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),ncc); } else if (lex == '\n' && (0)) { GetLexPosition((pos),ncc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),ncc); } };
                cc = actArgs[val].a; ccfin = actArgs[val].fin;
        } else {
                cc = ncc;
                GetLexToken(lex, ncc);
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); ncc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); ncc = tmpcc; } else if (lex == 446) { GetLexToken(line,ncc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,ncc); GetLexPosition((pos),ncc); GetLexInt(len,ncc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),ncc); GetLexInt(len,ncc); } else if (lex == 448) { GetLexInt(val,ncc); GetLexPosition((pos),ncc); } else if (lex == 450) { GetLexInt(val,ncc); GetLexPosition((pos),ncc); GetLexInt(len,ncc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),ncc); } else if (lex == '\n' && (0)) { GetLexPosition((pos),ncc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),ncc); } };
                ccfin = ncc;
        }
        if (lbcc!=NULL && cc < ccfin && (NextLexToken(lbcc)==440 || NextLexToken(lbcc)==449 || NextLexToken(lbcc)==447)) {
                nlex = NextLexToken(cc);
                if ((nlex==440 || nlex==449 || nlex==447) || nlex == 441
                                        || nlex == 442 || nlex == 443
                                        || nlex == 444 ) {
                        len1 = strlen(lbcc+2);
                        GetLexToken(lex, cc);
                        occ = cc;
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((respos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((respos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cc); GetLexPosition((respos),cc); GetLexInt(len,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((respos),cc); GetLexInt(len,cc); } else if (lex == 448) { GetLexInt(val,cc); GetLexPosition((respos),cc); } else if (lex == 450) { GetLexInt(val,cc); GetLexPosition((respos),cc); GetLexInt(len,cc); } } else if (lex>414 && lex<427) { GetLexPosition((respos),cc); } else if (lex == '\n' && (0)) { GetLexPosition((respos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((respos),cc); } };
                        bcc = lbcc + 2 + len1;
                        { if (!(*bcc==0)) internalCheckFail("*bcc==0", "yylex.c", 1325);};
                        if ((lex==440 || lex==449 || lex==447)) {
                                strcpy(bcc,occ);
                                respos.coll --;
                                { if (!(respos.coll>=0)) internalCheckFail("respos.coll>=0", "yylex.c", 1331);};
                                cxAddCollateReference( lbcc+2, bcc, &respos);
                                respos.coll ++;
                        } else {
                                NextLexPosition(respos,bcc+1);
                                sprintf(bcc,"%d",val);
                                cxAddCollateReference( lbcc+2, bcc, &respos);
                        }
                        bcc += strlen(bcc);
                        { if (!(*bcc==0)) internalCheckFail("*bcc==0", "yylex.c", 1340);};
                        bcc++;
                        PutLexPosition(respos.file,respos.line,respos.coll,bcc);
                }
        }
        { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1345);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1345);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        while (cc<ccfin) {
                cc0 = cc;
                GetLexToken(lex, cc);
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cc); GetLexPosition((pos),cc); GetLexInt(len,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cc); GetLexInt(len,cc); } else if (lex == 448) { GetLexInt(val,cc); GetLexPosition((pos),cc); } else if (lex == 450) { GetLexInt(val,cc); GetLexPosition((pos),cc); GetLexInt(len,cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cc); } else if (lex == '\n' && (0)) { GetLexPosition((pos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cc); } };
                lbcc = bcc;
                { if (!(cc>=cc0)) internalCheckFail("cc>=cc0", "yylex.c", 1351);};
                memcpy(bcc, cc0, cc-cc0);
                bcc += cc-cc0;
                { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1354);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1354);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
        *albcc = lbcc;
        *abcc = bcc;
        *ancc = ncc;
        *absize = bsize;
}
static void macArgsToString(char *res, struct lexInput *lb) {
        char *cc, *lcc, *bcc;
        int v,h,c,lv,lex,len;
        S_position pos;
        bcc = res;
        *bcc = 0;
        c=0; v=0;
        cc = lb->a;
        while (cc < lb->fin) {
                GetLexToken(lex,cc);
                lcc = cc;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(lv,cc); if (c) { if(s_opt.debug) dpnewline(lv); cFile.lineNumber += lv; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cc); GetLexPosition((pos),cc); GetLexInt(len,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cc); GetLexInt(len,cc); } else if (lex == 448) { GetLexInt(v,cc); GetLexPosition((pos),cc); } else if (lex == 450) { GetLexInt(v,cc); GetLexPosition((pos),cc); GetLexInt(len,cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cc); } else if (lex == '\n' && (c)) { GetLexPosition((pos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cc); } };
                if ((lex==440 || lex==449 || lex==447)) {
                        sprintf(bcc, "%s", lcc);
                        bcc+=strlen(bcc);
                } else if (lex==445) {
                        sprintf(bcc,"\"%s\"", lcc);
                        bcc+=strlen(bcc);
                } else if (lex==441) {
                        sprintf(bcc,"%d", v);
                        bcc+=strlen(bcc);
                } else if (lex < 256) {
                        sprintf(bcc,"%c",lex);
                        bcc+=strlen(bcc);
                }
        }
}
static void crMacroBody(S_lexInput *macBody,
                                                S_macroBody *mb,
                                                struct lexInput *actArgs,
                                                int actArgn
                                                ) {
        char *cc,*cc0,*cfin,*bcc,*lbcc;
        char *cc2,*c2fin;
        int i,lex,line,val,len,rsize,bsize,lexlen;
        S_position pos, hpos;
        unsigned hash;
        char *buf,*buf2,*res;
        val=0;
        bsize = MACRO_UNIT_SIZE;
        {{ { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1410);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        cc = mb->body;
        cfin = mb->body + mb->size;
        bcc = buf;
        lbcc = NULL;
        while (cc < cfin) {
                cc0 = cc;
                GetLexToken(lex, cc);
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cc); GetLexPosition((pos),cc); GetLexInt(lexlen,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cc); GetLexInt(lexlen,cc); } else if (lex == 448) { GetLexInt(val,cc); GetLexPosition((pos),cc); } else if (lex == 450) { GetLexInt(val,cc); GetLexPosition((pos),cc); GetLexInt(lexlen,cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cc); } else if (lex == '\n' && (0)) { GetLexPosition((pos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cc); } };
                if (lex==428 && lbcc!=NULL && cc<cfin) {
                        collate(&lbcc,&bcc,buf,&bsize,&cc,actArgs);
                } else {
                        lbcc = bcc;
                        { if (!(cc>=cc0)) internalCheckFail("cc>=cc0", "yylex.c", 1423);};
                        memcpy(bcc, cc0, cc-cc0);
                        bcc += cc-cc0;
                }
                { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1427);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1427);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
        {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1429);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bcc-buf) >= 0)) internalCheckFail("(bcc-buf) >= 0", "yylex.c", 1429);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bcc-buf)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bcc-buf)*sizeof(char);};};};
        for(i=0;i<actArgn; i++) {
                expandMacroArgument(&actArgs[i]);
        }
        bsize = MACRO_UNIT_SIZE;
        {{ { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1439);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        cc = buf;
        cfin = bcc;
        bcc = buf2;
        while (cc < cfin) {
                cc0 = cc;
                GetLexToken(lex, cc);
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((hpos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((hpos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cc); GetLexPosition((hpos),cc); GetLexInt(lexlen,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((hpos),cc); GetLexInt(lexlen,cc); } else if (lex == 448) { GetLexInt(val,cc); GetLexPosition((hpos),cc); } else if (lex == 450) { GetLexInt(val,cc); GetLexPosition((hpos),cc); GetLexInt(lexlen,cc); } } else if (lex>414 && lex<427) { GetLexPosition((hpos),cc); } else if (lex == '\n' && (0)) { GetLexPosition((hpos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((hpos),cc); } };
                if (lex == 448) {
                        len = actArgs[val].fin - actArgs[val].a;
                        { while (bcc + len >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1449);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1449);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                        memcpy(bcc, actArgs[val].a, len);
                        bcc += len;
                } else if (lex=='#' && cc<cfin && NextLexToken(cc)==448) {
                        GetLexToken(lex, cc);
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cc); if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cc); GetLexPosition((pos),cc); GetLexInt(lexlen,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cc); GetLexInt(lexlen,cc); } else if (lex == 448) { GetLexInt(val,cc); GetLexPosition((pos),cc); } else if (lex == 450) { GetLexInt(val,cc); GetLexPosition((pos),cc); GetLexInt(lexlen,cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cc); } else if (lex == '\n' && (0)) { GetLexPosition((pos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cc); } };
                        { if (!(lex == 448)) internalCheckFail("lex == 448", "yylex.c", 1455);};
                        PutLexToken(445, bcc);
                        { while (bcc + MACRO_UNIT_SIZE >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1457);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1457);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                        macArgsToString(bcc, &actArgs[val]);
                        len = strlen(bcc)+1;
                        bcc += len;
                        PutLexPosition(hpos.file, hpos.line, hpos.coll, bcc);
                        if (len >= MACRO_UNIT_SIZE-15) {
                                error(ERR_INTERNAL,"size of #macro_argument exceeded MACRO_UNIT_SIZE");
                        }
                } else {
                        { while (bcc + (cc0-cc) >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1466);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1466);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                        { if (!(cc>=cc0)) internalCheckFail("cc>=cc0", "yylex.c", 1467);};
                        memcpy(bcc, cc0, cc-cc0);
                        bcc += cc-cc0;
                }
                { while (bcc + 0 >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1471);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1471);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
        {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1473);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bcc-buf2) >= 0)) internalCheckFail("(bcc-buf2) >= 0", "yylex.c", 1473);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bcc-buf2)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bcc-buf2)*sizeof(char);};};};
        { (macBody)->cc = buf2; (macBody)->fin = bcc; (macBody)->a = buf2; (macBody)->macname = mb->name; (macBody)->margExpFlag = II_MACRO;};
}
static void getActMacroArgument(char *cc,
                                                                int *llex,
                                                                S_position *mpos,
                                                                S_position **parpos1,
                                                                S_position **parpos2,
                                                                S_lexInput *actArg,
                                                                S_macroBody *mb,
                                                                int actArgi
                                                                ) {
        char *buf,*bcc;
        int i,line,val,len, poffset;
        S_position pos, *tmppp;
        unsigned h;
        int bufsize,actsize,lex,deep;
        lex = *llex;
        bufsize = MACRO_ARG_UNIT_SIZE;
        deep = 0;
        {{ { if (!((bufsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bufsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1511);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bufsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bufsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        bcc = buf;
        poffset = 0;
        while (((lex != ',' || actArgi+1==mb->argn) && lex != ')') || deep > 0) {
                if (lex == '(') deep ++;
                if (lex == ')') deep --;
                for(;cc < cInput.cc; cc++,bcc++) *bcc = *cc;
                if (bcc-buf >= bufsize) {
                        bufsize += MACRO_ARG_UNIT_SIZE;
                        {{ { if (!(((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE-MACRO_ARG_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE-MACRO_ARG_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1525);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bufsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bufsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1525);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bufsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bufsize+MAX_LEXEM_SIZE)*sizeof(char);};};};
                }
                { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1528);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);}; while (lex == 446 || lex == '\n') { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1528);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);}; }};
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition(((**parpos2)),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition(((**parpos2)),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition(((**parpos2)),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition(((**parpos2)),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition(((**parpos2)),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition(((**parpos2)),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition(((**parpos2)),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition(((**parpos2)),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition(((**parpos2)),cInput.cc); } };
                if ((lex == ',' || lex == ')') && deep == 0) {
                        poffset ++;
                        handleMacroUsageParameterPositions(actArgi+poffset, mpos, *parpos1, *parpos2, 0);
                        **parpos1= **parpos2;
                }
        }
        if (0) {
endOfFile:;
endOfMacArg:;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1539);};
                if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"[getActMacroArgument] unterminated macro call");
                }
        }
        {{ { if (!(((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1544);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bcc-buf) >= 0)) internalCheckFail("(bcc-buf) >= 0", "yylex.c", 1544);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bcc-buf)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bcc-buf)*sizeof(char);};};};
        { (actArg)->cc = buf; (actArg)->fin = bcc; (actArg)->a = buf; (actArg)->macname = cInput.macname; (actArg)->margExpFlag = II_NORMAL;};
        *llex = lex;
        return;
}
static struct lexInput *getActualMacroArguments(S_macroBody *mb, S_position *mpos,
                                                                                                S_position *lparpos) {
        char *cc;
        int i,lex,line,val,len;
        S_position pos, ppb1, ppb2, *parpos1, *parpos2;
        unsigned h;
        int actArgi = 0;
        struct lexInput *actArgs;
        ppb1 = *lparpos;
        ppb2 = *lparpos;
        parpos1 = &ppb1;
        parpos2 = &ppb2;
        {{ { if (!((mb->argn) >= 0)) internalCheckFail("(mb->argn) >= 0", "yylex.c", 1562);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(mb->argn)*sizeof(struct lexInput) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } actArgs = (struct lexInput*) (ppmMemory + ppmMemoryi); ppmMemoryi += (mb->argn)*sizeof(struct lexInput);};};
        { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1563);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);}; while (lex == 446 || lex == '\n') { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1563);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);}; }};
        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
        if (lex == ')') {
                *parpos2 = pos;
                handleMacroUsageParameterPositions(0, mpos, parpos1, parpos2, 1);
        } else {
                for(;;) {
                        getActMacroArgument(cc,&lex, mpos, &parpos1, &parpos2,
                                                                &actArgs[actArgi], mb, actArgi);
                        actArgi ++ ;
                        if (lex != ',' || actArgi >= mb->argn) break;
                        { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1574);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);}; while (lex == 446 || lex == '\n') { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1574);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);}; }};
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                }
        }
        if (actArgi!=0) {
                handleMacroUsageParameterPositions(actArgi, mpos, parpos1, parpos2, 1);
        }
        for(;actArgi < mb->argn; actArgi++) {
                { (&actArgs[actArgi])->cc = NULL; (&actArgs[actArgi])->fin = NULL; (&actArgs[actArgi])->a = NULL; (&actArgs[actArgi])->macname = NULL; (&actArgs[actArgi])->margExpFlag = II_NORMAL;};
        }
        return(actArgs);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1586);};
endOfFile:
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1588);};
        if (s_opt.taskRegime!=RegimeEditServer) {
                warning(ERR_ST,"[getActualMacroArguments] unterminated macro call");
        }
        return(NULL);
}
static void addMacroBaseUsageRef( S_symbol *mdef) {
        int ii,rr;
        S_symbolRefItem ppp,*memb;
        S_reference *r;
        S_position basePos;
        { (&basePos)->file = s_input_file_number; (&basePos)->line = 0; (&basePos)->coll = 0;};
        { (&ppp.b)->symType = TypeMacro; (&ppp.b)->storage = StorageDefault; (&ppp.b)->scope = ScopeGlobal; (&ppp.b)->accessFlags = mdef->b.accessFlags; (&ppp.b)->category = CatGlobal; (&ppp.b)->htmlWasLn = 0;};
        { (&ppp)->name = mdef->linkName; (&ppp)->fileHash = cxFileHashNumber(mdef->linkName); (&ppp)->vApplClass = s_noneFileIndex; (&ppp)->vFunClass = s_noneFileIndex; (&ppp)->b = ppp.b; (&ppp)->refs = NULL; (&ppp)->next = NULL;};
        rr = refTabIsMember(&s_cxrefTab, &ppp, &ii, &memb);
        r = NULL;
        if (rr) {
                for(r=memb->refs; r!=NULL; r=r->next) {
                        if (r->usg.base == UsageMacroBaseFileUsage) break;
                }
        }
        if (rr==0 || r==NULL) {
                addCxReference(mdef,&basePos,UsageMacroBaseFileUsage,
                                                          s_noneFileIndex, s_noneFileIndex);
        }
}
static int macroCallExpand(S_symbol *mdef, S_position *mpos) {
        int i,lex,line,val,len;
        char *cc2,*freeBase;
        S_position pos, lparpos;
        unsigned h;
        struct lexInput *actArgs,macInput,*father,macBody;
        S_macroBody *mb;
        cc2 = cInput.cc;
        mb = mdef->u.mbody;
        if (mb == NULL) return(0);
        if (macStacki == 0) {
                {{mbMemoryi = 0;};};
        }
        if (cyclicCall(mb)) return(0);
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "yylex.c", 1639);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(0)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } freeBase = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (0)*sizeof(char);};};
        if (mb->argn >= 0) {
                { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1641);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc2 = cInput.cc; } cc2 = cInput.cc; GetLexToken(lex,cInput.cc);}; while (lex == 446 || lex == '\n') { { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1641);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc2 = cInput.cc; } cc2 = cInput.cc; GetLexToken(lex,cInput.cc);}; }};
                if (lex != '(') {
                        cInput.cc = cc2;
                        return(0);
                }
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((lparpos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((lparpos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((lparpos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((lparpos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((lparpos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((lparpos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((lparpos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((lparpos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((lparpos),cInput.cc); } };
                actArgs = getActualMacroArguments(mb, mpos, &lparpos);
        } else {
                actArgs = NULL;
        }
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1651);};
        if ((s_opt.taskRegime!=RegimeGenerate)) {
                addCxReference(mdef,mpos,UsageUsed,s_noneFileIndex, s_noneFileIndex);
                if (s_opt.taskRegime == RegimeXref) addMacroBaseUsageRef(mdef);
        }
        crMacroBody(&macBody,mb,actArgs,mb->argn);
        { { if (!(macStacki < MACSTACK_SIZE-1)) internalCheckFail("macStacki < MACSTACK_SIZE-1", "yylex.c", 1658);}; macStack[macStacki++] = cInput; cInput = macBody; cInput.cc = cInput.a; cInput.margExpFlag = II_MACRO;};
        {{ { if (!((freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi)) internalCheckFail("(freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi", "yylex.c", 1660);}; ppmMemoryi = ((char*)(freeBase))-ppmMemory;};};
        return(1);
endOfMacArg:
        cInput.cc = cc2;
        {{ { if (!((freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi)) internalCheckFail("(freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi", "yylex.c", 1666);}; ppmMemoryi = ((char*)(freeBase))-ppmMemory;};};
        return(0);
endOfFile:
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1669);};
        if (s_opt.taskRegime!=RegimeEditServer) {
                warning(ERR_ST,"[macroCallExpand] unterminated macro call");
        }
        cInput.cc = cc2;
        {{ { if (!((freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi)) internalCheckFail("(freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi", "yylex.c", 1674);}; ppmMemoryi = ((char*)(freeBase))-ppmMemory;};};
        return(0);
}
int lexBufDump(struct lexBuf *lb) {
        char *cc;
        int v,h,c,lv,lex,len;
        S_position pos;
        c=0;
        fprintf(dumpOut,"\nlexbufdump [start] \n"); fflush(dumpOut);
        cc = lb->cc;
        while (cc < lb->fin) {
                GetLexToken(lex,cc);
                if (lex==440 || lex==449) {
                        fprintf(dumpOut,"%s ",cc);
                } else if (lex==447) {
                        fprintf(dumpOut,"!%s! ",cc);
                } else if (lex < 256) {
                        fprintf(dumpOut,"%c ",lex);fflush(dumpOut);
                } else if (s_tokenName[lex]==NULL){
                        fprintf(dumpOut,"?%d? ",lex);fflush(dumpOut);
                } else {
                        fprintf(dumpOut,"%s ",s_tokenName[lex]);fflush(dumpOut);
                }
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cc = tmpcc; } else if (lex == 446) { GetLexToken(lv,cc); if (c) { if(s_opt.debug) dpnewline(lv); cFile.lineNumber += lv; } } else if (lex == 441 || lex == 442) { GetLexInt(v,cc); GetLexPosition((pos),cc); GetLexInt(len,cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cc); GetLexInt(len,cc); } else if (lex == 448) { GetLexInt(v,cc); GetLexPosition((pos),cc); } else if (lex == 450) { GetLexInt(v,cc); GetLexPosition((pos),cc); GetLexInt(len,cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cc); } else if (lex == '\n' && (c)) { GetLexPosition((pos),cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cc); } };
        }
        fprintf(dumpOut,"lexbufdump [stop]\n");fflush(dumpOut);
        return(0);
}
int cachedInputPass(int cpoint, char **cfrom) {
        int lex,line,i,val,res,len;
        S_position pos;
        unsigned h,lsize,compsize;
        char *cc,*cto,*ccc;
        { if (!(cpoint > 0)) internalCheckFail("cpoint > 0", "yylex.c", 1712);};
        cto = s_cache.cp[cpoint].lbcc;
        ccc = *cfrom;
        res = 1;
        while (ccc < cto) {
                { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1717);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);};
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (1) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (1)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                compsize = lsize = cInput.cc-cc;
                { if (!(compsize >= 0)) internalCheckFail("compsize >= 0", "yylex.c", 1720);};
                if (memcmp(cc, ccc, compsize)) {
                        cInput.cc = cc;
                        res = 0;
                        break;
                }
                if ((lex==440 || lex==449 || lex==447) || (lex>414&&lex<427)) {
                        if (pos.file==s_cxRefPos.file && pos.line >= s_cxRefPos.line) {
                                cInput.cc = cc;
                                res = 0;
                                break;
                        }
                }
                ccc += lsize;
        }
endOfFile:
cantCache:
        { cFile.lb.cc = cInput.cc;};
        *cfrom = ccc;
        return(res);
endOfMacArg:
        { if (!(0)) internalCheckFail("0", "yylex.c", 1742);};
}
static char charText[2]={0,0};
static char constant[50];
static int processCIdent(unsigned hashval, char *id, S_position *idposa) {
        int lex,line,i,val,len;
        S_symbol *sd,*memb;
        memb = NULL;
        for(sd=s_symTab->tab[hashval]; sd!=NULL; sd=sd->next) {
                if (strcmp(sd->name, id) == 0) {
                        if (memb == NULL) memb = sd;
                        { if (sd->b.symType == TypeKeyword) { { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = sd->name; (uniyylval->bbidIdent.d)->sd = sd; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = sd->name; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);}; if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { char ttt[TMP_STRING_SIZE]; sprintf(ttt,"%s-%x", sd->name, idposa->file); addTrivialCxReference(ttt, TypeKeyword,StorageDefault, idposa, UsageUsed); } return(sd->u.keyWordVal); }};
                        if (sd->b.symType == TypeDefinedOp && s_ifEvaluation) {
                                return(429);
                        }
                        if (sd->b.symType == TypeDefault) {
                                { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = sd->name; (uniyylval->bbidIdent.d)->sd = sd; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = sd->name; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);};
                                if (sd->b.storage == StorageTypedef) {
                                        return(257);
                                } else {
                                        return(440);
                                }
                        }
                }
        }
        if (memb == NULL) id = stackMemoryPushString(id);
        else id = memb->name;
        { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = id; (uniyylval->bbidIdent.d)->sd = memb; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = id; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);};
        return(440);
}
static int processJavaIdent(unsigned hashval, char *id, S_position *idposa) {
        int lex,line,i,val,len;
        S_symbol *sd,*memb;
        memb = NULL;
        for(sd=s_symTab->tab[hashval]; sd!=NULL; sd=sd->next) {
                if (strcmp(sd->name, id) == 0) {
                        if (memb == NULL) memb = sd;
                        { if (sd->b.symType == TypeKeyword) { { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = sd->name; (uniyylval->bbidIdent.d)->sd = sd; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = sd->name; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);}; if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { char ttt[TMP_STRING_SIZE]; sprintf(ttt,"%s-%x", sd->name, idposa->file); addTrivialCxReference(ttt, TypeKeyword,StorageDefault, idposa, UsageUsed); } return(sd->u.keyWordVal); }};
                        if (sd->b.symType == TypeDefault) {
                                { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = sd->name; (uniyylval->bbidIdent.d)->sd = sd; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = sd->name; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);};
                                return(440);
                        }
                }
        }
        if (memb == NULL) id = stackMemoryPushString(id);
        else id = memb->name;
        { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = id; (uniyylval->bbidIdent.d)->sd = memb; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = id; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);};
        return(440);
}
static int processCccIdent(unsigned hashval, char *id, S_position *idposa) {
        int lex,line,i,val,len;
        S_symbol *sd,*memb;
        memb = NULL;
        for(sd=s_symTab->tab[hashval]; sd!=NULL; sd=sd->next) {
                if (strcmp(sd->name, id) == 0) {
                        if (memb == NULL) memb = sd;
                        { if (sd->b.symType == TypeKeyword) { { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = sd->name; (uniyylval->bbidIdent.d)->sd = sd; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = sd->name; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);}; if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { char ttt[TMP_STRING_SIZE]; sprintf(ttt,"%s-%x", sd->name, idposa->file); addTrivialCxReference(ttt, TypeKeyword,StorageDefault, idposa, UsageUsed); } return(sd->u.keyWordVal); }};
                        if (sd->b.symType == TypeDefinedOp && s_ifEvaluation) {
                                return(429);
                        }
                        break;
                }
        }
        if (memb == NULL) id = stackMemoryPushString(id);
        else id = memb->name;
        { uniyylval->bbidIdent.d = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->bbidIdent.d)->name = id; (uniyylval->bbidIdent.d)->sd = memb; (uniyylval->bbidIdent.d)->p = *idposa;}; yytext = id; uniyylval->bbidIdent.b = *idposa; uniyylval->bbidIdent.e = *idposa; uniyylval->bbidIdent.e.coll += strlen(yytext);};
        return(440);
}
static void actionOnBlockMarker() {
        if (s_opt.cxrefs == OLO_SET_MOVE_TARGET) {
                s_cps.setTargetAnswerClass[0] = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_cp.function == NULL) {
                                if (s_javaStat!=NULL) {
                                        if (s_javaStat->thisClass==NULL) {
                                                sprintf(s_cps.setTargetAnswerClass, " %s", s_javaThisPackageName);
                                        } else {
                                                strcpy(s_cps.setTargetAnswerClass, s_javaStat->thisClass->linkName);
                                        }
                                }
                        }
                }
        } else if (s_opt.cxrefs == OLO_SET_MOVE_CLASS_TARGET) {
                s_cps.moveTargetApproved = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_cp.function == NULL) {
                                if (s_javaStat!=NULL) {
                                        s_cps.moveTargetApproved = 1;
                                }
                        }
                }
        } else if (s_opt.cxrefs == OLO_SET_MOVE_METHOD_TARGET) {
                s_cps.moveTargetApproved = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_cp.function == NULL) {
                                if (s_javaStat!=NULL) {
                                        if (s_javaStat->thisClass!=NULL) {
                                                s_cps.moveTargetApproved = 1;
                                        }
                                }
                        }
                }
        } else if (s_opt.cxrefs == OLO_EXTRACT) {
                extractActionOnBlockMarker();
        } else {
                s_cps.currentPackageAnswer[0] = 0;
                s_cps.currentClassAnswer[0] = 0;
                s_cps.currentSuperClassAnswer[0] = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_javaStat!=NULL) {
                                strcpy(s_cps.currentPackageAnswer, s_javaThisPackageName);
                                if (s_javaStat->thisClass!=NULL) {
                                        { if (!(s_javaStat->thisClass->u.s)) internalCheckFail("s_javaStat->thisClass->u.s", "yylex.c", 1886);};
                                        strcpy(s_cps.currentClassAnswer, s_javaStat->thisClass->linkName);
                                        if (s_javaStat->thisClass->u.s->super!=NULL) {
                                                { if (!(s_javaStat->thisClass->u.s->super->d)) internalCheckFail("s_javaStat->thisClass->u.s->super->d", "yylex.c", 1889);};
                                                strcpy(s_cps.currentSuperClassAnswer, s_javaStat->thisClass->u.s->super->d->linkName);
                                        }
                                }
                        }
                }
                s_cp.parserPassedMarker = 1;
        }
}
int yylex() {
        int lex,line,i,val,len;
        S_position pos,idpos;
        char *cc;
        unsigned h;
        len = 0;
 nextYylex:
        { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1920);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } cc = cInput.cc; } cc = cInput.cc; GetLexToken(lex,cInput.cc);};
 contYylex:
        if (lex < 256) {
                if (lex == '\n') {
                        if (s_ifEvaluation) {
                                cInput.cc = cc;
                        } else {
                                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                                for(;;) {
                                        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1929);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } lastlexcc = cInput.cc; } lastlexcc = cInput.cc; GetLexToken(lex,cInput.cc);};};
                                        if (lex<=414 || lex>=427) goto contYylex;
                                        if (processCppConstruct(lex) == 0) goto endOfFile;
                                }
                        }
                } else {
                        { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                        { uniyylval->bbposition.d = pos; uniyylval->bbposition.b = pos; uniyylval->bbposition.e = pos; uniyylval->bbposition.e.coll += s_tokenLength[lex];};
                }
                yytext = charText;
                charText[0] = lex;
                goto finish;
        }
        if (lex==440 || lex==449) {
                register char *id;
                register unsigned h;
                int ii;
                S_symbol *sd,dd,*memb;
                h = 0;
                id = yytext = cInput.cc;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((idpos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((idpos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((idpos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((idpos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((idpos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((idpos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((idpos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((idpos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((idpos),cInput.cc); } };
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1950);};
                if (s_opt.taskRegime == RegimeEditServer) {
                        testCxrefCompletionId(&lex,yytext,&idpos);
                }
                { (&dd.b)->record = 0; (&dd.b)->isSingleImported = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeMacro; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                { (&dd)->name = yytext; (&dd)->linkName = yytext; (&dd)->pos = s_noPos; (&dd)->b = dd.b; (&dd)->u.mbody = NULL; (&dd)->next = NULL;};
                if ((!((s_language & (4)) != 0))
                        && lex!=449
                        && symTabIsMember(s_symTab,&dd,&ii,&memb)) {
                        id = memb->name;
                        if (macroCallExpand(memb,&idpos)) goto nextYylex;
                }
                h = h % s_symTab->size;
                if(((s_language & (2)) != 0)||((s_language & (8)) != 0)) lex=processCIdent(h,id,&idpos);
                else if (((s_language & (4)) != 0)) lex = processJavaIdent(h, id, &idpos);
                else if (((s_language & (16)) != 0)) lex = processCccIdent(h, id, &idpos);
                else { if (!(0)) internalCheckFail("0", "yylex.c", 1971);};
                goto finish;
        }
        if (lex == 432) {
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                actionOnBlockMarker();
                goto nextYylex;
        }
        if (lex < 439) {
                yytext = s_tokenName[lex];
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                { uniyylval->bbposition.d = pos; uniyylval->bbposition.b = pos; uniyylval->bbposition.e = pos; uniyylval->bbposition.e.coll += s_tokenLength[lex];};
                goto finish;
        }
        if (lex == 446) {
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                goto nextYylex;
        }
        if (lex == 441 || lex == 442) {
                val=0;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                sprintf(constant,"%d",val);
                { uniyylval->bbinteger.d = val; uniyylval->bbinteger.b = pos; uniyylval->bbinteger.e = pos; uniyylval->bbinteger.e.coll += len;};
                yytext = constant;
                goto finish;
        }
        if (lex == 443 || lex == 444) {
                yytext = "'fltp constant'";
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                { uniyylval->bbposition.d = pos; uniyylval->bbposition.b = pos; uniyylval->bbposition.e = pos; uniyylval->bbposition.e.coll += len;};
                goto finish;
        }
        if (lex == 445) {
                yytext = cInput.cc;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                { uniyylval->bbposition.d = pos; uniyylval->bbposition.b = pos; uniyylval->bbposition.e = pos; uniyylval->bbposition.e.coll += strlen(yytext);};
                goto finish;
        }
        if (lex == 450) {
                val=0;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                sprintf(constant,"'%c'",val);
                { uniyylval->bbinteger.d = val; uniyylval->bbinteger.b = pos; uniyylval->bbinteger.e = pos; uniyylval->bbinteger.e.coll += len;};
                yytext = constant;
                goto finish;
        }
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 2017);};
        if (s_opt.taskRegime == RegimeEditServer) {
                yytext = cInput.cc;
                { if (lex > 439) { if ((lex==440 || lex==449 || lex==447)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 445) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; GetLexPosition((pos),tmpcc); cInput.cc = tmpcc; } else if (lex == 446) { GetLexToken(line,cInput.cc); if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 441 || lex == 442) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 444 || lex == 443) { GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } else if (lex == 448) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); } else if (lex == 450) { GetLexInt(val,cInput.cc); GetLexPosition((pos),cInput.cc); GetLexInt(len,cInput.cc); } } else if (lex>414 && lex<427) { GetLexPosition((pos),cInput.cc); } else if (lex == '\n' && (macStacki == 0)) { GetLexPosition((pos),cInput.cc); if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else { GetLexPosition((pos),cInput.cc); } };
                if (lex == 447) {
                        testCxrefCompletionId(&lex,yytext,&pos);
                        while (inStacki != 0) popInclude();
                        goto endOfFile;
                }
        }
        goto endOfFile;
 finish:
        { if (s_opt.debug) {fprintf(dumpOut,"%s ",yytext);fflush(dumpOut);}};
        s_lastReturnedLexem = lex;
        return(lex);
 endOfMacArg:
        { if (!(0)) internalCheckFail("0", "yylex.c", 2040);};
 endOfFile:
        if ((!((s_language & (4)) != 0)) && inStacki != 0) {
                popInclude();
                poseCachePoint(1);
                goto nextYylex;
        }
        return(0);
}
